/*
	Copyright (c) Microsoft Corporation.  All rights reserved.
*/

/*
	Your use of this file is governed by the Microsoft Services Agreement http://go.microsoft.com/fwlink/?LinkId=266419.
*/

/*
* @overview es6-promise - a tiny implementation of Promises/A+.
* @copyright Copyright (c) 2014 Yehuda Katz, Tom Dale, Stefan Penner and contributors (Conversion to ES6 API by Jake Archibald)
* @license   Licensed under MIT license
*            See https://raw.githubusercontent.com/jakearchibald/es6-promise/master/LICENSE
* @version   2.3.0
*/


// Sources:
// osfweb: 16.0\11619.10000
// runtime: 16.0.11617.30000
// core: 16.0\11620.10000
// host: 16.0\11620.10000

var __extends=this&&this.__extends||function(b,a){for(var c in a)if(a.hasOwnProperty(c))b[c]=a[c];function d(){this.constructor=b}b.prototype=a===null?Object.create(a):(d.prototype=a.prototype,new d)},OfficeExt;(function(b){var a=function(){function a(){}a.prototype.isMsAjaxLoaded=function(){if(typeof Sys!=="undefined"&&typeof Type!=="undefined"&&Sys.StringBuilder&&typeof Sys.StringBuilder==="function"&&Type.registerNamespace&&typeof Type.registerNamespace==="function"&&Type.registerClass&&typeof Type.registerClass==="function"&&typeof Function._validateParams==="function"&&Sys.Serialization&&Sys.Serialization.JavaScriptSerializer&&typeof Sys.Serialization.JavaScriptSerializer.serialize==="function")return true;else return false};a.prototype.loadMsAjaxFull=function(b){var a=(window.location.protocol.toLowerCase()==="https:"?"https:":"http:")+"//ajax.aspnetcdn.com/ajax/3.5/MicrosoftAjax.js";OSF.OUtil.loadScript(a,b)};Object.defineProperty(a.prototype,"msAjaxError",{"get":function(){if(this._msAjaxError==null&&this.isMsAjaxLoaded())this._msAjaxError=Error;return this._msAjaxError},"set":function(a){this._msAjaxError=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"msAjaxString",{"get":function(){if(this._msAjaxString==null&&this.isMsAjaxLoaded())this._msAjaxString=String;return this._msAjaxString},"set":function(a){this._msAjaxString=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"msAjaxDebug",{"get":function(){if(this._msAjaxDebug==null&&this.isMsAjaxLoaded())this._msAjaxDebug=Sys.Debug;return this._msAjaxDebug},"set":function(a){this._msAjaxDebug=a},enumerable:true,configurable:true});return a}();b.MicrosoftAjaxFactory=a})(OfficeExt||(OfficeExt={}));var OsfMsAjaxFactory=new OfficeExt.MicrosoftAjaxFactory,OSF=OSF||{},OfficeExt;(function(b){var a=function(){function a(a){this._internalStorage=a}a.prototype.getItem=function(a){try{return this._internalStorage&&this._internalStorage.getItem(a)}catch(b){return null}};a.prototype.setItem=function(b,a){try{this._internalStorage&&this._internalStorage.setItem(b,a)}catch(c){}};a.prototype.clear=function(){try{this._internalStorage&&this._internalStorage.clear()}catch(a){}};a.prototype.removeItem=function(a){try{this._internalStorage&&this._internalStorage.removeItem(a)}catch(b){}};a.prototype.getKeysWithPrefix=function(d){var b=[];try{for(var e=this._internalStorage&&this._internalStorage.length||0,a=0;a<e;a++){var c=this._internalStorage.key(a);c.indexOf(d)===0&&b.push(c)}}catch(f){}return b};return a}();b.SafeStorage=a})(OfficeExt||(OfficeExt={}));OSF.XdmFieldName={ConversationUrl:"ConversationUrl",AppId:"AppId"};OSF.WindowNameItemKeys={BaseFrameName:"baseFrameName",HostInfo:"hostInfo",XdmInfo:"xdmInfo",SerializerVersion:"serializerVersion",AppContext:"appContext"};OSF.OUtil=function(){var h=-1,m="&_xdm_Info=",k="&_serializer_version=",l="_xdm_",p="_serializer_version=",d="#",j="&",a="class",g={},o=3e4,c=null,f=null,b=+new Date;function n(){var a=2147483647*Math.random();a^=b^(new Date).getMilliseconds()<<Math.floor(Math.random()*(31-10));return a.toString(16)}function e(){if(!c){try{var a=window.sessionStorage}catch(b){a=null}c=new OfficeExt.SafeStorage(a)}return c}function i(e){for(var c=[],b=[],f=e.length,a,d=0;d<f;d++){a=e[d];if(a.tabIndex)if(a.tabIndex>0)b.push(a);else a.tabIndex===0&&c.push(a);else c.push(a)}b=b.sort(function(d,c){var a=d.tabIndex-c.tabIndex;if(a===0)a=b.indexOf(d)-b.indexOf(c);return a});return[].concat(b,c)}return{set_entropy:function(a){if(typeof a=="string")for(var c=0;c<a.length;c+=4){for(var e=0,d=0;d<4&&c+d<a.length;d++)e=(e<<8)+a.charCodeAt(c+d);b^=e}else if(typeof a=="number")b^=a;else b^=2147483647*Math.random();b&=2147483647},extend:function(b,a){var c=function(){};c.prototype=a.prototype;b.prototype=new c;b.prototype.constructor=b;b.uber=a.prototype;if(a.prototype.constructor===Object.prototype.constructor)a.prototype.constructor=a},setNamespace:function(b,a){if(a&&b&&!a[b])a[b]={}},unsetNamespace:function(b,a){if(a&&b&&a[b])delete a[b]},serializeSettings:function(b){var d={};for(var c in b){var a=b[c];try{if(JSON)a=JSON.stringify(a,function(a,b){return OSF.OUtil.isDate(this[a])?OSF.DDA.SettingsManager.DateJSONPrefix+this[a].getTime()+OSF.DDA.SettingsManager.DataJSONSuffix:b});else a=Sys.Serialization.JavaScriptSerializer.serialize(a);d[c]=a}catch(e){}}return d},deserializeSettings:function(b){var d={};b=b||{};for(var c in b){var a=b[c];try{if(JSON)a=JSON.parse(a,function(c,a){var b;if(typeof a==="string"&&a&&a.length>6&&a.slice(0,5)===OSF.DDA.SettingsManager.DateJSONPrefix&&a.slice(-1)===OSF.DDA.SettingsManager.DataJSONSuffix){b=new Date(parseInt(a.slice(5,-1)));if(b)return b}return a});else a=Sys.Serialization.JavaScriptSerializer.deserialize(a,true);d[c]=a}catch(e){}}return d},loadScript:function(c,d,e){if(c&&d){var i=window.document,a=g[c];if(!a){var b=i.createElement("script");b.type="text/javascript";a={loaded:false,pendingCallbacks:[d],timer:null};g[c]=a;var f=function(){if(a.timer!=null){clearTimeout(a.timer);delete a.timer}a.loaded=true;for(var c=a.pendingCallbacks.length,b=0;b<c;b++){var d=a.pendingCallbacks.shift();d()}},h=function(){delete g[c];if(a.timer!=null){clearTimeout(a.timer);delete a.timer}for(var d=a.pendingCallbacks.length,b=0;b<d;b++){var e=a.pendingCallbacks.shift();e()}};if(b.readyState)b.onreadystatechange=function(){if(b.readyState=="loaded"||b.readyState=="complete"){b.onreadystatechange=null;f()}};else b.onload=f;b.onerror=h;e=e||o;a.timer=setTimeout(h,e);b.setAttribute("crossOrigin","anonymous");b.src=c;i.getElementsByTagName("head")[0].appendChild(b)}else if(a.loaded)d();else a.pendingCallbacks.push(d)}},loadCSS:function(c){if(c){var b=window.document,a=b.createElement("link");a.type="text/css";a.rel="stylesheet";a.href=c;b.getElementsByTagName("head")[0].appendChild(a)}},parseEnum:function(b,c){var a=c[b.trim()];if(typeof a=="undefined"){OsfMsAjaxFactory.msAjaxDebug.trace("invalid enumeration string:"+b);throw OsfMsAjaxFactory.msAjaxError.argument("str");}return a},delayExecutionAndCache:function(){var a={calc:arguments[0]};return function(){if(a.calc){a.val=a.calc.apply(this,arguments);delete a.calc}return a.val}},getUniqueId:function(){h=h+1;return h.toString()},formatString:function(){var a=arguments,b=a[0];return b.replace(/{(\d+)}/gm,function(d,b){var c=parseInt(b,10)+1;return a[c]===undefined?"{"+b+"}":a[c]})},generateConversationId:function(){return[n(),n(),(+new Date).toString()].join("_")},getFrameName:function(a){return l+a+this.generateConversationId()},addXdmInfoAsHash:function(b,a){return OSF.OUtil.addInfoAsHash(b,m,a,false)},addSerializerVersionAsHash:function(b,a){return OSF.OUtil.addInfoAsHash(b,k,a,true)},addInfoAsHash:function(b,g,c,i){b=b.trim()||"";var f=b.split(d),h=f.shift(),e=f.join(d),a;if(i)a=[g,encodeURIComponent(c),e].join("");else a=[e,g,c].join("");return[h,d,a].join("")},parseHostInfoFromWindowName:function(a,b){return OSF.OUtil.parseInfoFromWindowName(a,b,OSF.WindowNameItemKeys.HostInfo)},parseXdmInfo:function(b){var a=OSF.OUtil.parseXdmInfoWithGivenFragment(b,window.location.hash);if(!a)a=OSF.OUtil.parseXdmInfoFromWindowName(b,window.name);return a},parseXdmInfoFromWindowName:function(a,b){return OSF.OUtil.parseInfoFromWindowName(a,b,OSF.WindowNameItemKeys.XdmInfo)},parseXdmInfoWithGivenFragment:function(a,b){return OSF.OUtil.parseInfoWithGivenFragment(m,l,false,a,b)},parseSerializerVersion:function(b){var a=OSF.OUtil.parseSerializerVersionWithGivenFragment(b,window.location.hash);if(isNaN(a))a=OSF.OUtil.parseSerializerVersionFromWindowName(b,window.name);return a},parseSerializerVersionFromWindowName:function(a,b){return parseInt(OSF.OUtil.parseInfoFromWindowName(a,b,OSF.WindowNameItemKeys.SerializerVersion))},parseSerializerVersionWithGivenFragment:function(a,b){return parseInt(OSF.OUtil.parseInfoWithGivenFragment(k,p,true,a,b))},parseInfoFromWindowName:function(g,h,f){try{var a=JSON.parse(h),b=a!=null?a[f]:null,c=e();if(!g&&c&&a!=null){var d=a[OSF.WindowNameItemKeys.BaseFrameName]+f;if(b)c.setItem(d,b);else b=c.getItem(d)}return b}catch(i){return null}},parseInfoWithGivenFragment:function(m,i,k,h,l){var d=l.split(m),a=d.length>1?d[d.length-1]:null;if(k&&a!=null){if(a.indexOf(j)>=0)a=a.split(j)[0];a=decodeURIComponent(a)}var b=e();if(!h&&b){var c=window.name.indexOf(i);if(c>-1){var f=window.name.indexOf(";",c);if(f==-1)f=window.name.length;var g=window.name.substring(c,f);if(a)b.setItem(g,a);else a=b.getItem(g)}}return a},getConversationId:function(){var b=window.location.search,a=null;if(b){var c=b.indexOf("&");a=c>0?b.substring(1,c):b.substr(1);if(a&&a.charAt(a.length-1)==="="){a=a.substring(0,a.length-1);if(a)a=decodeURIComponent(a)}}return a},getInfoItems:function(b){var a=b.split("$");if(typeof a[1]=="undefined")a=b.split("|");if(typeof a[1]=="undefined")a=b.split("%7C");return a},getXdmFieldValue:function(e,d){var b="",c=OSF.OUtil.parseXdmInfo(d);if(c){var a=OSF.OUtil.getInfoItems(c);if(a!=undefined&&a.length>=3)switch(e){case OSF.XdmFieldName.ConversationUrl:b=a[2];break;case OSF.XdmFieldName.AppId:b=a[1];break}}return b},validateParamObject:function(d,c,e){var a=Function._validateParams(arguments,[{name:"params",type:Object,mayBeNull:false},{name:"expectedProperties",type:Object,mayBeNull:false},{name:"callback",type:Function,mayBeNull:true}]);if(a)throw a;for(var b in c){a=Function._validateParameter(d[b],c[b],b);if(a)throw a;}},writeProfilerMark:function(a){if(window.msWriteProfilerMark){window.msWriteProfilerMark(a);OsfMsAjaxFactory.msAjaxDebug.trace(a)}},outputDebug:function(a){typeof OsfMsAjaxFactory!=="undefined"&&OsfMsAjaxFactory.msAjaxDebug&&OsfMsAjaxFactory.msAjaxDebug.trace&&OsfMsAjaxFactory.msAjaxDebug.trace(a)},defineNondefaultProperty:function(d,e,a,b){a=a||{};for(var f in b){var c=b[f];if(a[c]==undefined)a[c]=true}Object.defineProperty(d,e,a);return d},defineNondefaultProperties:function(c,a,d){a=a||{};for(var b in a)OSF.OUtil.defineNondefaultProperty(c,b,a[b],d);return c},defineEnumerableProperty:function(c,b,a){return OSF.OUtil.defineNondefaultProperty(c,b,a,["enumerable"])},defineEnumerableProperties:function(b,a){return OSF.OUtil.defineNondefaultProperties(b,a,["enumerable"])},defineMutableProperty:function(c,b,a){return OSF.OUtil.defineNondefaultProperty(c,b,a,["writable","enumerable","configurable"])},defineMutableProperties:function(b,a){return OSF.OUtil.defineNondefaultProperties(b,a,["writable","enumerable","configurable"])},finalizeProperties:function(c,b){b=b||{};for(var e=Object.getOwnPropertyNames(c),g=e.length,d=0;d<g;d++){var f=e[d],a=Object.getOwnPropertyDescriptor(c,f);if(!a.get&&!a.set)a.writable=b.writable||false;a.configurable=b.configurable||false;a.enumerable=b.enumerable||true;Object.defineProperty(c,f,a)}return c},mapList:function(a,c){var b=[];if(a)for(var d in a)b.push(c(a[d]));return b},listContainsKey:function(b,c){for(var a in b)if(c==a)return true;return false},listContainsValue:function(a,b){for(var c in a)if(b==a[c])return true;return false},augmentList:function(a,b){var d=a.push?function(c,b){a.push(b)}:function(c,b){a[c]=b};for(var c in b)d(c,b[c])},redefineList:function(a,b){for(var d in a)delete a[d];for(var c in b)a[c]=b[c]},isArray:function(a){return Object.prototype.toString.apply(a)==="[object Array]"},isFunction:function(a){return Object.prototype.toString.apply(a)==="[object Function]"},isDate:function(a){return Object.prototype.toString.apply(a)==="[object Date]"},addEventListener:function(a,b,c){if(a.addEventListener)a.addEventListener(b,c,false);else if(Sys.Browser.agent===Sys.Browser.InternetExplorer&&a.attachEvent)a.attachEvent("on"+b,c);else a["on"+b]=c},removeEventListener:function(a,b,c){if(a.removeEventListener)a.removeEventListener(b,c,false);else if(Sys.Browser.agent===Sys.Browser.InternetExplorer&&a.detachEvent)a.detachEvent("on"+b,c);else a["on"+b]=null},getCookieValue:function(b){var a=RegExp(b+"[^;]+").exec(document.cookie);return a.toString().replace(/^[^=]+./,"")},xhrGet:function(d,c,b){var a;try{a=new XMLHttpRequest;a.onreadystatechange=function(){if(a.readyState==4)if(a.status==200)c(a.responseText);else b(a.status)};a.open("GET",d,true);a.send()}catch(e){b(e)}},xhrGetFull:function(f,d,e,b){var a,c=d;try{a=new XMLHttpRequest;a.onreadystatechange=function(){if(a.readyState==4)if(a.status==200)e(a,c);else b(a.status)};a.open("GET",f,true);a.send()}catch(g){b(g)}},encodeBase64:function(c){if(!c)return c;var n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",l=[],b=[],h=0,j,g,i,d,e,f,a,m=c.length;do{j=c.charCodeAt(h++);g=c.charCodeAt(h++);i=c.charCodeAt(h++);a=0;d=j&255;e=j>>8;f=g&255;b[a++]=d>>2;b[a++]=(d&3)<<4|e>>4;b[a++]=(e&15)<<2|f>>6;b[a++]=f&63;if(!isNaN(g)){d=g>>8;e=i&255;f=i>>8;b[a++]=d>>2;b[a++]=(d&3)<<4|e>>4;b[a++]=(e&15)<<2|f>>6;b[a++]=f&63}if(isNaN(g))b[a-1]=64;else if(isNaN(i)){b[a-2]=64;b[a-1]=64}for(var k=0;k<a;k++)l.push(n.charAt(b[k]))}while(h<m);return l.join("")},getSessionStorage:function(){return e()},getLocalStorage:function(){if(!f){try{var a=window.localStorage}catch(b){a=null}f=new OfficeExt.SafeStorage(a)}return f},convertIntToCssHexColor:function(b){var a="#"+(Number(b)+16777216).toString(16).slice(-6);return a},attachClickHandler:function(a,b){a.onclick=function(a){b()};a.ontouchend=function(a){b();a.preventDefault()}},getQueryStringParamValue:function(a,c){var d=Function._validateParams(arguments,[{name:"queryString",type:String,mayBeNull:false},{name:"paramName",type:String,mayBeNull:false}]);if(d){OsfMsAjaxFactory.msAjaxDebug.trace("OSF_Outil_getQueryStringParamValue: Parameters cannot be null.");return""}var b=new RegExp("[\\?&]"+c+"=([^&#]*)","i");if(!b.test(a)){OsfMsAjaxFactory.msAjaxDebug.trace("OSF_Outil_getQueryStringParamValue: The parameter is not found.");return""}return b.exec(a)[1]},isiOS:function(){return window.navigator.userAgent.match(/(iPad|iPhone|iPod)/g)?true:false},isChrome:function(){return window.navigator.userAgent.indexOf("Chrome")>0&&!OSF.OUtil.isEdge()},isEdge:function(){return window.navigator.userAgent.indexOf("Edge")>0},isIE:function(){return window.navigator.userAgent.indexOf("Trident")>0},isFirefox:function(){return window.navigator.userAgent.indexOf("Firefox")>0},shallowCopy:function(a){if(a==null)return null;else if(!(a instanceof Object))return a;else if(Array.isArray(a)){for(var d=[],c=0;c<a.length;c++)d.push(a[c]);return d}else{var e=a.constructor();for(var b in a)if(a.hasOwnProperty(b))e[b]=a[b];return e}},createObject:function(a){var c=null;if(a){c={};for(var d=a.length,b=0;b<d;b++)c[a[b].name]=a[b].value}return c},addClass:function(b,c){if(!OSF.OUtil.hasClass(b,c)){var d=b.getAttribute(a);if(d)b.setAttribute(a,d+" "+c);else b.setAttribute(a,c)}},removeClass:function(c,d){if(OSF.OUtil.hasClass(c,d)){var b=c.getAttribute(a),e=new RegExp("(\\s|^)"+d+"(\\s|$)");b=b.replace(e,"");c.setAttribute(a,b)}},hasClass:function(d,c){var b=d.getAttribute(a);return b&&b.match(new RegExp("(\\s|^)"+c+"(\\s|$)"))},focusToFirstTabbable:function(a,e){var c,d=false,b,f=function(a){d=true},g=function(c,a,b){if(a<0||a>c)return-1;else if(a===0&&b)return-1;else if(a===c-1&&!b)return-1;if(b)return a-1;else return a+1};a=i(a);c=e?a.length-1:0;if(a.length===0)return null;while(!d&&c>=0&&c<a.length){b=a[c];window.focus();b.addEventListener("focus",f);b.focus();b.removeEventListener("focus",f);c=g(a.length,c,e);if(!d&&b===document.activeElement)d=true}if(d)return b;else return null},focusToNextTabbable:function(b,k,h){var f,a,d=false,c,g=function(a){d=true},j=function(b,c){for(var a=0;a<b.length;a++)if(b[a]===c)return a;return-1},e=function(c,a,b){if(a<0||a>c)return-1;else if(a===0&&b)return-1;else if(a===c-1&&!b)return-1;if(b)return a-1;else return a+1};b=i(b);f=j(b,k);a=e(b.length,f,h);if(a<0)return null;while(!d&&a>=0&&a<b.length){c=b[a];c.addEventListener("focus",g);c.focus();c.removeEventListener("focus",g);a=e(b.length,a,h);if(!d&&c===document.activeElement)d=true}if(d)return c;else return null}}}();OSF.OUtil.Guid=function(){var a=["0","1","2","3","4","5","6","7","8","9","a","b","c","d","e","f"];return{generateNewGuid:function(){for(var c="",d=+new Date,b=0;b<32&&d>0;b++){if(b==8||b==12||b==16||b==20)c+="-";c+=a[d%16];d=Math.floor(d/16)}for(;b<32;b++){if(b==8||b==12||b==16||b==20)c+="-";c+=a[Math.floor(Math.random()*16)]}return c}}}();window.OSF=OSF;OSF.OUtil.setNamespace("OSF",window);OSF.MessageIDs={FetchBundleUrl:0,LoadReactBundle:1,LoadBundleSuccess:2,LoadBundleError:3};OSF.AppName={Unsupported:0,Excel:1,Word:2,PowerPoint:4,Outlook:8,ExcelWebApp:16,WordWebApp:32,OutlookWebApp:64,Project:128,AccessWebApp:256,PowerpointWebApp:512,ExcelIOS:1024,Sway:2048,WordIOS:4096,PowerPointIOS:8192,Access:16384,Lync:32768,OutlookIOS:65536,OneNoteWebApp:131072,OneNote:262144,ExcelWinRT:524288,WordWinRT:1048576,PowerpointWinRT:2097152,OutlookAndroid:4194304,OneNoteWinRT:8388608,ExcelAndroid:8388609,VisioWebApp:8388610,OneNoteIOS:8388611,WordAndroid:8388613,PowerpointAndroid:8388614,Visio:8388615,OneNoteAndroid:4194305};OSF.InternalPerfMarker={DataCoercionBegin:"Agave.HostCall.CoerceDataStart",DataCoercionEnd:"Agave.HostCall.CoerceDataEnd"};OSF.HostCallPerfMarker={IssueCall:"Agave.HostCall.IssueCall",ReceiveResponse:"Agave.HostCall.ReceiveResponse",RuntimeExceptionRaised:"Agave.HostCall.RuntimeExecptionRaised"};OSF.AgaveHostAction={Select:0,UnSelect:1,CancelDialog:2,InsertAgave:3,CtrlF6In:4,CtrlF6Exit:5,CtrlF6ExitShift:6,SelectWithError:7,NotifyHostError:8,RefreshAddinCommands:9,PageIsReady:10,TabIn:11,TabInShift:12,TabExit:13,TabExitShift:14,EscExit:15,F2Exit:16,ExitNoFocusable:17,ExitNoFocusableShift:18,MouseEnter:19,MouseLeave:20,UpdateTargetUrl:21,InstallCustomFunctions:22,SendTelemetryEvent:23,UninstallCustomFunctions:24};OSF.SharedConstants={NotificationConversationIdSuffix:"_ntf"};OSF.DialogMessageType={DialogMessageReceived:0,DialogParentMessageReceived:1,DialogClosed:12006};OSF.OfficeAppContext=function(y,u,p,n,r,v,q,t,x,i,w,k,j,m,g,f,e,d,h,b,c,s,o,a,l){this._id=y;this._appName=u;this._appVersion=p;this._appUILocale=n;this._dataLocale=r;this._docUrl=v;this._clientMode=q;this._settings=t;this._reason=x;this._osfControlType=i;this._eToken=w;this._correlationId=k;this._appInstanceId=j;this._touchEnabled=m;this._commerceAllowed=g;this._appMinorVersion=f;this._requirementMatrix=e;this._hostCustomMessage=d;this._hostFullVersion=h;this._isDialog=false;this._clientWindowHeight=b;this._clientWindowWidth=c;this._addinName=s;this._appDomains=o;this._dialogRequirementMatrix=a;this._featureGates=l;this.get_id=function(){return this._id};this.get_appName=function(){return this._appName};this.get_appVersion=function(){return this._appVersion};this.get_appUILocale=function(){return this._appUILocale};this.get_dataLocale=function(){return this._dataLocale};this.get_docUrl=function(){return this._docUrl};this.get_clientMode=function(){return this._clientMode};this.get_bindings=function(){return this._bindings};this.get_settings=function(){return this._settings};this.get_reason=function(){return this._reason};this.get_osfControlType=function(){return this._osfControlType};this.get_eToken=function(){return this._eToken};this.get_correlationId=function(){return this._correlationId};this.get_appInstanceId=function(){return this._appInstanceId};this.get_touchEnabled=function(){return this._touchEnabled};this.get_commerceAllowed=function(){return this._commerceAllowed};this.get_appMinorVersion=function(){return this._appMinorVersion};this.get_requirementMatrix=function(){return this._requirementMatrix};this.get_dialogRequirementMatrix=function(){return this._dialogRequirementMatrix};this.get_hostCustomMessage=function(){return this._hostCustomMessage};this.get_hostFullVersion=function(){return this._hostFullVersion};this.get_isDialog=function(){return this._isDialog};this.get_clientWindowHeight=function(){return this._clientWindowHeight};this.get_clientWindowWidth=function(){return this._clientWindowWidth};this.get_addinName=function(){return this._addinName};this.get_appDomains=function(){return this._appDomains};this.get_featureGates=function(){return this._featureGates}};OSF.OsfControlType={DocumentLevel:0,ContainerLevel:1};OSF.ClientMode={ReadOnly:0,ReadWrite:1};OSF.OUtil.setNamespace("Microsoft",window);OSF.OUtil.setNamespace("Office",Microsoft);OSF.OUtil.setNamespace("Client",Microsoft.Office);OSF.OUtil.setNamespace("WebExtension",Microsoft.Office);Microsoft.Office.WebExtension.InitializationReason={Inserted:"inserted",DocumentOpened:"documentOpened"};Microsoft.Office.WebExtension.ValueFormat={Unformatted:"unformatted",Formatted:"formatted"};Microsoft.Office.WebExtension.FilterType={All:"all"};Microsoft.Office.WebExtension.Parameters={BindingType:"bindingType",CoercionType:"coercionType",ValueFormat:"valueFormat",FilterType:"filterType",Columns:"columns",SampleData:"sampleData",GoToType:"goToType",SelectionMode:"selectionMode",Id:"id",PromptText:"promptText",ItemName:"itemName",FailOnCollision:"failOnCollision",StartRow:"startRow",StartColumn:"startColumn",RowCount:"rowCount",ColumnCount:"columnCount",Callback:"callback",AsyncContext:"asyncContext",Data:"data",Rows:"rows",OverwriteIfStale:"overwriteIfStale",FileType:"fileType",EventType:"eventType",Handler:"handler",SliceSize:"sliceSize",SliceIndex:"sliceIndex",ActiveView:"activeView",Status:"status",PlatformType:"platformType",HostType:"hostType",ForceConsent:"forceConsent",ForceAddAccount:"forceAddAccount",AuthChallenge:"authChallenge",Reserved:"reserved",Tcid:"tcid",Xml:"xml",Namespace:"namespace",Prefix:"prefix",XPath:"xPath",Text:"text",ImageLeft:"imageLeft",ImageTop:"imageTop",ImageWidth:"imageWidth",ImageHeight:"imageHeight",TaskId:"taskId",FieldId:"fieldId",FieldValue:"fieldValue",ServerUrl:"serverUrl",ListName:"listName",ResourceId:"resourceId",ViewType:"viewType",ViewName:"viewName",GetRawValue:"getRawValue",CellFormat:"cellFormat",TableOptions:"tableOptions",TaskIndex:"taskIndex",ResourceIndex:"resourceIndex",CustomFieldId:"customFieldId",Url:"url",MessageHandler:"messageHandler",Width:"width",Height:"height",RequireHTTPs:"requireHTTPS",MessageToParent:"messageToParent",DisplayInIframe:"displayInIframe",MessageContent:"messageContent",HideTitle:"hideTitle",UseDeviceIndependentPixels:"useDeviceIndependentPixels",PromptBeforeOpen:"promptBeforeOpen",EnforceAppDomain:"enforceAppDomain",AppCommandInvocationCompletedData:"appCommandInvocationCompletedData",Base64:"base64",FormId:"formId"};OSF.OUtil.setNamespace("DDA",OSF);OSF.DDA.DocumentMode={ReadOnly:1,ReadWrite:0};OSF.DDA.PropertyDescriptors={AsyncResultStatus:"AsyncResultStatus"};OSF.DDA.EventDescriptors={};OSF.DDA.ListDescriptors={};OSF.DDA.UI={};OSF.DDA.getXdmEventName=function(b,a){if(a==Microsoft.Office.WebExtension.EventType.BindingSelectionChanged||a==Microsoft.Office.WebExtension.EventType.BindingDataChanged||a==Microsoft.Office.WebExtension.EventType.DataNodeDeleted||a==Microsoft.Office.WebExtension.EventType.DataNodeInserted||a==Microsoft.Office.WebExtension.EventType.DataNodeReplaced)return b+"_"+a;else return a};OSF.DDA.MethodDispId={dispidMethodMin:64,dispidGetSelectedDataMethod:64,dispidSetSelectedDataMethod:65,dispidAddBindingFromSelectionMethod:66,dispidAddBindingFromPromptMethod:67,dispidGetBindingMethod:68,dispidReleaseBindingMethod:69,dispidGetBindingDataMethod:70,dispidSetBindingDataMethod:71,dispidAddRowsMethod:72,dispidClearAllRowsMethod:73,dispidGetAllBindingsMethod:74,dispidLoadSettingsMethod:75,dispidSaveSettingsMethod:76,dispidGetDocumentCopyMethod:77,dispidAddBindingFromNamedItemMethod:78,dispidAddColumnsMethod:79,dispidGetDocumentCopyChunkMethod:80,dispidReleaseDocumentCopyMethod:81,dispidNavigateToMethod:82,dispidGetActiveViewMethod:83,dispidGetDocumentThemeMethod:84,dispidGetOfficeThemeMethod:85,dispidGetFilePropertiesMethod:86,dispidClearFormatsMethod:87,dispidSetTableOptionsMethod:88,dispidSetFormatsMethod:89,dispidExecuteRichApiRequestMethod:93,dispidAppCommandInvocationCompletedMethod:94,dispidCloseContainerMethod:97,dispidGetAccessTokenMethod:98,dispidGetAuthContextMethod:99,dispidOpenBrowserWindow:102,dispidCreateDocumentMethod:105,dispidInsertFormMethod:106,dispidDisplayRibbonCalloutAsyncMethod:109,dispidGetSelectedTaskMethod:110,dispidGetSelectedResourceMethod:111,dispidGetTaskMethod:112,dispidGetResourceFieldMethod:113,dispidGetWSSUrlMethod:114,dispidGetTaskFieldMethod:115,dispidGetProjectFieldMethod:116,dispidGetSelectedViewMethod:117,dispidGetTaskByIndexMethod:118,dispidGetResourceByIndexMethod:119,dispidSetTaskFieldMethod:120,dispidSetResourceFieldMethod:121,dispidGetMaxTaskIndexMethod:122,dispidGetMaxResourceIndexMethod:123,dispidCreateTaskMethod:124,dispidAddDataPartMethod:128,dispidGetDataPartByIdMethod:129,dispidGetDataPartsByNamespaceMethod:130,dispidGetDataPartXmlMethod:131,dispidGetDataPartNodesMethod:132,dispidDeleteDataPartMethod:133,dispidGetDataNodeValueMethod:134,dispidGetDataNodeXmlMethod:135,dispidGetDataNodesMethod:136,dispidSetDataNodeValueMethod:137,dispidSetDataNodeXmlMethod:138,dispidAddDataNamespaceMethod:139,dispidGetDataUriByPrefixMethod:140,dispidGetDataPrefixByUriMethod:141,dispidGetDataNodeTextMethod:142,dispidSetDataNodeTextMethod:143,dispidMessageParentMethod:144,dispidSendMessageMethod:145,dispidExecuteFeature:146,dispidQueryFeature:147,dispidMethodMax:147};OSF.DDA.EventDispId={dispidEventMin:0,dispidInitializeEvent:0,dispidSettingsChangedEvent:1,dispidDocumentSelectionChangedEvent:2,dispidBindingSelectionChangedEvent:3,dispidBindingDataChangedEvent:4,dispidDocumentOpenEvent:5,dispidDocumentCloseEvent:6,dispidActiveViewChangedEvent:7,dispidDocumentThemeChangedEvent:8,dispidOfficeThemeChangedEvent:9,dispidDialogMessageReceivedEvent:10,dispidDialogNotificationShownInAddinEvent:11,dispidDialogParentMessageReceivedEvent:12,dispidObjectDeletedEvent:13,dispidObjectSelectionChangedEvent:14,dispidObjectDataChangedEvent:15,dispidContentControlAddedEvent:16,dispidActivationStatusChangedEvent:32,dispidRichApiMessageEvent:33,dispidAppCommandInvokedEvent:39,dispidOlkItemSelectedChangedEvent:46,dispidOlkRecipientsChangedEvent:47,dispidOlkAppointmentTimeChangedEvent:48,dispidOlkRecurrenceChangedEvent:49,dispidOlkAttachmentsChangedEvent:50,dispidOlkEnhancedLocationsChangedEvent:51,dispidOlkInfobarClickedEvent:52,dispidTaskSelectionChangedEvent:56,dispidResourceSelectionChangedEvent:57,dispidViewSelectionChangedEvent:58,dispidDataNodeAddedEvent:60,dispidDataNodeReplacedEvent:61,dispidDataNodeDeletedEvent:62,dispidEventMax:63};OSF.DDA.ErrorCodeManager=function(){var a={};return{getErrorArgs:function(c){var b=a[c];if(!b)b=a[this.errorCodes.ooeInternalError];else{if(!b.name)b.name=a[this.errorCodes.ooeInternalError].name;if(!b.message)b.message=a[this.errorCodes.ooeInternalError].message}return b},addErrorMessage:function(c,b){a[c]=b},errorCodes:{ooeSuccess:0,ooeChunkResult:1,ooeCoercionTypeNotSupported:1e3,ooeGetSelectionNotMatchDataType:1001,ooeCoercionTypeNotMatchBinding:1002,ooeInvalidGetRowColumnCounts:1003,ooeSelectionNotSupportCoercionType:1004,ooeInvalidGetStartRowColumn:1005,ooeNonUniformPartialGetNotSupported:1006,ooeGetDataIsTooLarge:1008,ooeFileTypeNotSupported:1009,ooeGetDataParametersConflict:1010,ooeInvalidGetColumns:1011,ooeInvalidGetRows:1012,ooeInvalidReadForBlankRow:1013,ooeUnsupportedDataObject:2e3,ooeCannotWriteToSelection:2001,ooeDataNotMatchSelection:2002,ooeOverwriteWorksheetData:2003,ooeDataNotMatchBindingSize:2004,ooeInvalidSetStartRowColumn:2005,ooeInvalidDataFormat:2006,ooeDataNotMatchCoercionType:2007,ooeDataNotMatchBindingType:2008,ooeSetDataIsTooLarge:2009,ooeNonUniformPartialSetNotSupported:2010,ooeInvalidSetColumns:2011,ooeInvalidSetRows:2012,ooeSetDataParametersConflict:2013,ooeCellDataAmountBeyondLimits:2014,ooeSelectionCannotBound:3e3,ooeBindingNotExist:3002,ooeBindingToMultipleSelection:3003,ooeInvalidSelectionForBindingType:3004,ooeOperationNotSupportedOnThisBindingType:3005,ooeNamedItemNotFound:3006,ooeMultipleNamedItemFound:3007,ooeInvalidNamedItemForBindingType:3008,ooeUnknownBindingType:3009,ooeOperationNotSupportedOnMatrixData:3010,ooeInvalidColumnsForBinding:3011,ooeSettingNameNotExist:4e3,ooeSettingsCannotSave:4001,ooeSettingsAreStale:4002,ooeOperationNotSupported:5e3,ooeInternalError:5001,ooeDocumentReadOnly:5002,ooeEventHandlerNotExist:5003,ooeInvalidApiCallInContext:5004,ooeShuttingDown:5005,ooeUnsupportedEnumeration:5007,ooeIndexOutOfRange:5008,ooeBrowserAPINotSupported:5009,ooeInvalidParam:5010,ooeRequestTimeout:5011,ooeInvalidOrTimedOutSession:5012,ooeInvalidApiArguments:5013,ooeOperationCancelled:5014,ooeWorkbookHidden:5015,ooeTooManyIncompleteRequests:5100,ooeRequestTokenUnavailable:5101,ooeActivityLimitReached:5102,ooeCustomXmlNodeNotFound:6e3,ooeCustomXmlError:6100,ooeCustomXmlExceedQuota:6101,ooeCustomXmlOutOfDate:6102,ooeNoCapability:7e3,ooeCannotNavTo:7001,ooeSpecifiedIdNotExist:7002,ooeNavOutOfBound:7004,ooeElementMissing:8e3,ooeProtectedError:8001,ooeInvalidCellsValue:8010,ooeInvalidTableOptionValue:8011,ooeInvalidFormatValue:8012,ooeRowIndexOutOfRange:8020,ooeColIndexOutOfRange:8021,ooeFormatValueOutOfRange:8022,ooeCellFormatAmountBeyondLimits:8023,ooeMemoryFileLimit:11e3,ooeNetworkProblemRetrieveFile:11001,ooeInvalidSliceSize:11002,ooeInvalidCallback:11101,ooeInvalidWidth:12e3,ooeInvalidHeight:12001,ooeNavigationError:12002,ooeInvalidScheme:12003,ooeAppDomains:12004,ooeRequireHTTPS:12005,ooeWebDialogClosed:12006,ooeDialogAlreadyOpened:12007,ooeEndUserAllow:12008,ooeEndUserIgnore:12009,ooeNotUILessDialog:12010,ooeCrossZone:12011,ooeNotSSOAgave:13e3,ooeSSOUserNotSignedIn:13001,ooeSSOUserAborted:13002,ooeSSOUnsupportedUserIdentity:13003,ooeSSOInvalidResourceUrl:13004,ooeSSOInvalidGrant:13005,ooeSSOClientError:13006,ooeSSOServerError:13007,ooeAddinIsAlreadyRequestingToken:13008,ooeSSOUserConsentNotSupportedByCurrentAddinCategory:13009,ooeSSOConnectionLost:13010,ooeResourceNotAllowed:13011,ooeSSOUnsupportedPlatform:13012,ooeAccessDenied:13990,ooeGeneralException:13991},initializeErrorMessages:function(b){a[OSF.DDA.ErrorCodeManager.errorCodes.ooeCoercionTypeNotSupported]={name:b.L_InvalidCoercion,message:b.L_CoercionTypeNotSupported};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeGetSelectionNotMatchDataType]={name:b.L_DataReadError,message:b.L_GetSelectionNotSupported};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeCoercionTypeNotMatchBinding]={name:b.L_InvalidCoercion,message:b.L_CoercionTypeNotMatchBinding};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidGetRowColumnCounts]={name:b.L_DataReadError,message:b.L_InvalidGetRowColumnCounts};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeSelectionNotSupportCoercionType]={name:b.L_DataReadError,message:b.L_SelectionNotSupportCoercionType};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidGetStartRowColumn]={name:b.L_DataReadError,message:b.L_InvalidGetStartRowColumn};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeNonUniformPartialGetNotSupported]={name:b.L_DataReadError,message:b.L_NonUniformPartialGetNotSupported};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeGetDataIsTooLarge]={name:b.L_DataReadError,message:b.L_GetDataIsTooLarge};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeFileTypeNotSupported]={name:b.L_DataReadError,message:b.L_FileTypeNotSupported};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeGetDataParametersConflict]={name:b.L_DataReadError,message:b.L_GetDataParametersConflict};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidGetColumns]={name:b.L_DataReadError,message:b.L_InvalidGetColumns};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidGetRows]={name:b.L_DataReadError,message:b.L_InvalidGetRows};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidReadForBlankRow]={name:b.L_DataReadError,message:b.L_InvalidReadForBlankRow};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeUnsupportedDataObject]={name:b.L_DataWriteError,message:b.L_UnsupportedDataObject};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeCannotWriteToSelection]={name:b.L_DataWriteError,message:b.L_CannotWriteToSelection};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeDataNotMatchSelection]={name:b.L_DataWriteError,message:b.L_DataNotMatchSelection};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeOverwriteWorksheetData]={name:b.L_DataWriteError,message:b.L_OverwriteWorksheetData};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeDataNotMatchBindingSize]={name:b.L_DataWriteError,message:b.L_DataNotMatchBindingSize};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSetStartRowColumn]={name:b.L_DataWriteError,message:b.L_InvalidSetStartRowColumn};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidDataFormat]={name:b.L_InvalidFormat,message:b.L_InvalidDataFormat};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeDataNotMatchCoercionType]={name:b.L_InvalidDataObject,message:b.L_DataNotMatchCoercionType};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeDataNotMatchBindingType]={name:b.L_InvalidDataObject,message:b.L_DataNotMatchBindingType};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeSetDataIsTooLarge]={name:b.L_DataWriteError,message:b.L_SetDataIsTooLarge};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeNonUniformPartialSetNotSupported]={name:b.L_DataWriteError,message:b.L_NonUniformPartialSetNotSupported};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSetColumns]={name:b.L_DataWriteError,message:b.L_InvalidSetColumns};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSetRows]={name:b.L_DataWriteError,message:b.L_InvalidSetRows};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeSetDataParametersConflict]={name:b.L_DataWriteError,message:b.L_SetDataParametersConflict};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeSelectionCannotBound]={name:b.L_BindingCreationError,message:b.L_SelectionCannotBound};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeBindingNotExist]={name:b.L_InvalidBindingError,message:b.L_BindingNotExist};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeBindingToMultipleSelection]={name:b.L_BindingCreationError,message:b.L_BindingToMultipleSelection};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSelectionForBindingType]={name:b.L_BindingCreationError,message:b.L_InvalidSelectionForBindingType};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeOperationNotSupportedOnThisBindingType]={name:b.L_InvalidBindingOperation,message:b.L_OperationNotSupportedOnThisBindingType};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeNamedItemNotFound]={name:b.L_BindingCreationError,message:b.L_NamedItemNotFound};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeMultipleNamedItemFound]={name:b.L_BindingCreationError,message:b.L_MultipleNamedItemFound};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidNamedItemForBindingType]={name:b.L_BindingCreationError,message:b.L_InvalidNamedItemForBindingType};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeUnknownBindingType]={name:b.L_InvalidBinding,message:b.L_UnknownBindingType};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeOperationNotSupportedOnMatrixData]={name:b.L_InvalidBindingOperation,message:b.L_OperationNotSupportedOnMatrixData};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidColumnsForBinding]={name:b.L_InvalidBinding,message:b.L_InvalidColumnsForBinding};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeSettingNameNotExist]={name:b.L_ReadSettingsError,message:b.L_SettingNameNotExist};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeSettingsCannotSave]={name:b.L_SaveSettingsError,message:b.L_SettingsCannotSave};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeSettingsAreStale]={name:b.L_SettingsStaleError,message:b.L_SettingsAreStale};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeOperationNotSupported]={name:b.L_HostError,message:b.L_OperationNotSupported};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError]={name:b.L_InternalError,message:b.L_InternalErrorDescription};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeDocumentReadOnly]={name:b.L_PermissionDenied,message:b.L_DocumentReadOnly};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeEventHandlerNotExist]={name:b.L_EventRegistrationError,message:b.L_EventHandlerNotExist};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidApiCallInContext]={name:b.L_InvalidAPICall,message:b.L_InvalidApiCallInContext};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeShuttingDown]={name:b.L_ShuttingDown,message:b.L_ShuttingDown};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeUnsupportedEnumeration]={name:b.L_UnsupportedEnumeration,message:b.L_UnsupportedEnumerationMessage};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeIndexOutOfRange]={name:b.L_IndexOutOfRange,message:b.L_IndexOutOfRange};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeBrowserAPINotSupported]={name:b.L_APINotSupported,message:b.L_BrowserAPINotSupported};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeRequestTimeout]={name:b.L_APICallFailed,message:b.L_RequestTimeout};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidOrTimedOutSession]={name:b.L_InvalidOrTimedOutSession,message:b.L_InvalidOrTimedOutSessionMessage};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeTooManyIncompleteRequests]={name:b.L_APICallFailed,message:b.L_TooManyIncompleteRequests};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeRequestTokenUnavailable]={name:b.L_APICallFailed,message:b.L_RequestTokenUnavailable};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeActivityLimitReached]={name:b.L_APICallFailed,message:b.L_ActivityLimitReached};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidApiArguments]={name:b.L_APICallFailed,message:b.L_InvalidApiArgumentsMessage};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeWorkbookHidden]={name:b.L_APICallFailed,message:b.L_WorkbookHiddenMessage};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeCustomXmlNodeNotFound]={name:b.L_InvalidNode,message:b.L_CustomXmlNodeNotFound};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeCustomXmlError]={name:b.L_CustomXmlError,message:b.L_CustomXmlError};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeCustomXmlExceedQuota]={name:b.L_CustomXmlExceedQuotaName,message:b.L_CustomXmlExceedQuotaMessage};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeCustomXmlOutOfDate]={name:b.L_CustomXmlOutOfDateName,message:b.L_CustomXmlOutOfDateMessage};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeNoCapability]={name:b.L_PermissionDenied,message:b.L_NoCapability};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeCannotNavTo]={name:b.L_CannotNavigateTo,message:b.L_CannotNavigateTo};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeSpecifiedIdNotExist]={name:b.L_SpecifiedIdNotExist,message:b.L_SpecifiedIdNotExist};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeNavOutOfBound]={name:b.L_NavOutOfBound,message:b.L_NavOutOfBound};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeCellDataAmountBeyondLimits]={name:b.L_DataWriteReminder,message:b.L_CellDataAmountBeyondLimits};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeElementMissing]={name:b.L_MissingParameter,message:b.L_ElementMissing};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeProtectedError]={name:b.L_PermissionDenied,message:b.L_NoCapability};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidCellsValue]={name:b.L_InvalidValue,message:b.L_InvalidCellsValue};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidTableOptionValue]={name:b.L_InvalidValue,message:b.L_InvalidTableOptionValue};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidFormatValue]={name:b.L_InvalidValue,message:b.L_InvalidFormatValue};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeRowIndexOutOfRange]={name:b.L_OutOfRange,message:b.L_RowIndexOutOfRange};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeColIndexOutOfRange]={name:b.L_OutOfRange,message:b.L_ColIndexOutOfRange};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeFormatValueOutOfRange]={name:b.L_OutOfRange,message:b.L_FormatValueOutOfRange};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeCellFormatAmountBeyondLimits]={name:b.L_FormattingReminder,message:b.L_CellFormatAmountBeyondLimits};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeMemoryFileLimit]={name:b.L_MemoryLimit,message:b.L_CloseFileBeforeRetrieve};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeNetworkProblemRetrieveFile]={name:b.L_NetworkProblem,message:b.L_NetworkProblemRetrieveFile};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSliceSize]={name:b.L_InvalidValue,message:b.L_SliceSizeNotSupported};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeDialogAlreadyOpened]={name:b.L_DisplayDialogError,message:b.L_DialogAlreadyOpened};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidWidth]={name:b.L_IndexOutOfRange,message:b.L_IndexOutOfRange};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidHeight]={name:b.L_IndexOutOfRange,message:b.L_IndexOutOfRange};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeNavigationError]={name:b.L_DisplayDialogError,message:b.L_NetworkProblem};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidScheme]={name:b.L_DialogNavigateError,message:b.L_DialogInvalidScheme};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeAppDomains]={name:b.L_DisplayDialogError,message:b.L_DialogAddressNotTrusted};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeRequireHTTPS]={name:b.L_DisplayDialogError,message:b.L_DialogRequireHTTPS};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeEndUserIgnore]={name:b.L_DisplayDialogError,message:b.L_UserClickIgnore};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeCrossZone]={name:b.L_DisplayDialogError,message:b.L_NewWindowCrossZoneErrorString};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeNotSSOAgave]={name:b.L_APINotSupported,message:b.L_InvalidSSOAddinMessage};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOUserNotSignedIn]={name:b.L_UserNotSignedIn,message:b.L_UserNotSignedIn};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOUserAborted]={name:b.L_UserAborted,message:b.L_UserAbortedMessage};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOUnsupportedUserIdentity]={name:b.L_UnsupportedUserIdentity,message:b.L_UnsupportedUserIdentityMessage};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOInvalidResourceUrl]={name:b.L_InvalidResourceUrl,message:b.L_InvalidResourceUrlMessage};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOInvalidGrant]={name:b.L_InvalidGrant,message:b.L_InvalidGrantMessage};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOClientError]={name:b.L_SSOClientError,message:b.L_SSOClientErrorMessage};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOServerError]={name:b.L_SSOServerError,message:b.L_SSOServerErrorMessage};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeAddinIsAlreadyRequestingToken]={name:b.L_AddinIsAlreadyRequestingToken,message:b.L_AddinIsAlreadyRequestingTokenMessage};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOUserConsentNotSupportedByCurrentAddinCategory]={name:b.L_SSOUserConsentNotSupportedByCurrentAddinCategory,message:b.L_SSOUserConsentNotSupportedByCurrentAddinCategoryMessage};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOConnectionLost]={name:b.L_SSOConnectionLostError,message:b.L_SSOConnectionLostErrorMessage};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOUnsupportedPlatform]={name:b.L_SSOConnectionLostError,message:b.L_SSOUnsupportedPlatform};a[OSF.DDA.ErrorCodeManager.errorCodes.ooeOperationCancelled]={name:b.L_OperationCancelledError,message:b.L_OperationCancelledErrorMessage}}}}();var OfficeExt;(function(a){var b;(function(a){var y=function(){function a(){}return a}();a.RequirementVersion=y;var c=function(){function a(a){this.isSetSupported=function(d,b){if(d==undefined)return false;if(b==undefined)b=0;var f=this._setMap,e=f._sets;if(e.hasOwnProperty(d.toLowerCase())){var g=e[d.toLowerCase()];try{var a=this._getVersion(g);b=b+"";var c=this._getVersion(b);if(a.major>0&&a.major>c.major)return true;if(a.minor>0&&a.minor>0&&a.major==c.major&&a.minor>=c.minor)return true}catch(h){return false}}return false};this._getVersion=function(a){a=a+"";var b=a.split("."),c=0,d=0;if(b.length<2&&isNaN(Number(a)))throw"version format incorrect";else{c=Number(b[0]);if(b.length>=2)d=Number(b[1]);if(isNaN(c)||isNaN(d))throw"version format incorrect";}var e={minor:d,major:c};return e};this._setMap=a;this.isSetSupported=this.isSetSupported.bind(this)}return a}();a.RequirementMatrix=c;var b=function(){function a(a){this._addSetMap=function(a){for(var b in a)this._sets[b]=a[b]};this._sets=a}return a}();a.DefaultSetRequirement=b;var w=function(b){__extends(a,b);function a(){b.call(this,{dialogapi:1.1})}return a}(b);a.DefaultDialogSetRequirement=w;var e=function(b){__extends(a,b);function a(){b.call(this,{bindingevents:1.1,documentevents:1.1,excelapi:1.1,matrixbindings:1.1,matrixcoercion:1.1,selection:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1,textbindings:1.1,textcoercion:1.1})}return a}(b);a.ExcelClientDefaultSetRequirement=e;var j=function(b){__extends(a,b);function a(){b.call(this);this._addSetMap({imagecoercion:1.1})}return a}(e);a.ExcelClientV1DefaultSetRequirement=j;var k=function(b){__extends(a,b);function a(){b.call(this,{mailbox:1.3})}return a}(b);a.OutlookClientDefaultSetRequirement=k;var g=function(b){__extends(a,b);function a(){b.call(this,{bindingevents:1.1,compressedfile:1.1,customxmlparts:1.1,documentevents:1.1,file:1.1,htmlcoercion:1.1,matrixbindings:1.1,matrixcoercion:1.1,ooxmlcoercion:1.1,pdffile:1.1,selection:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1,textbindings:1.1,textcoercion:1.1,textfile:1.1,wordapi:1.1})}return a}(b);a.WordClientDefaultSetRequirement=g;var o=function(b){__extends(a,b);function a(){b.call(this);this._addSetMap({customxmlparts:1.2,wordapi:1.2,imagecoercion:1.1})}return a}(g);a.WordClientV1DefaultSetRequirement=o;var d=function(b){__extends(a,b);function a(){b.call(this,{activeview:1.1,compressedfile:1.1,documentevents:1.1,file:1.1,pdffile:1.1,selection:1.1,settings:1.1,textcoercion:1.1})}return a}(b);a.PowerpointClientDefaultSetRequirement=d;var i=function(b){__extends(a,b);function a(){b.call(this);this._addSetMap({imagecoercion:1.1})}return a}(d);a.PowerpointClientV1DefaultSetRequirement=i;var n=function(b){__extends(a,b);function a(){b.call(this,{selection:1.1,textcoercion:1.1})}return a}(b);a.ProjectClientDefaultSetRequirement=n;var t=function(b){__extends(a,b);function a(){b.call(this,{bindingevents:1.1,documentevents:1.1,matrixbindings:1.1,matrixcoercion:1.1,selection:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1,textbindings:1.1,textcoercion:1.1,file:1.1})}return a}(b);a.ExcelWebDefaultSetRequirement=t;var v=function(b){__extends(a,b);function a(){b.call(this,{compressedfile:1.1,documentevents:1.1,file:1.1,imagecoercion:1.1,matrixcoercion:1.1,ooxmlcoercion:1.1,pdffile:1.1,selection:1.1,settings:1.1,tablecoercion:1.1,textcoercion:1.1,textfile:1.1})}return a}(b);a.WordWebDefaultSetRequirement=v;var m=function(b){__extends(a,b);function a(){b.call(this,{activeview:1.1,settings:1.1})}return a}(b);a.PowerpointWebDefaultSetRequirement=m;var f=function(b){__extends(a,b);function a(){b.call(this,{mailbox:1.3})}return a}(b);a.OutlookWebDefaultSetRequirement=f;var u=function(b){__extends(a,b);function a(){b.call(this,{activeview:1.1,documentevents:1.1,selection:1.1,settings:1.1,textcoercion:1.1})}return a}(b);a.SwayWebDefaultSetRequirement=u;var q=function(b){__extends(a,b);function a(){b.call(this,{bindingevents:1.1,partialtablebindings:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1})}return a}(b);a.AccessWebDefaultSetRequirement=q;var s=function(b){__extends(a,b);function a(){b.call(this,{bindingevents:1.1,documentevents:1.1,matrixbindings:1.1,matrixcoercion:1.1,selection:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1,textbindings:1.1,textcoercion:1.1})}return a}(b);a.ExcelIOSDefaultSetRequirement=s;var h=function(b){__extends(a,b);function a(){b.call(this,{bindingevents:1.1,compressedfile:1.1,customxmlparts:1.1,documentevents:1.1,file:1.1,htmlcoercion:1.1,matrixbindings:1.1,matrixcoercion:1.1,ooxmlcoercion:1.1,pdffile:1.1,selection:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1,textbindings:1.1,textcoercion:1.1,textfile:1.1})}return a}(b);a.WordIOSDefaultSetRequirement=h;var r=function(b){__extends(a,b);function a(){b.call(this);this._addSetMap({customxmlparts:1.2,wordapi:1.2})}return a}(h);a.WordIOSV1DefaultSetRequirement=r;var l=function(b){__extends(a,b);function a(){b.call(this,{activeview:1.1,compressedfile:1.1,documentevents:1.1,file:1.1,pdffile:1.1,selection:1.1,settings:1.1,textcoercion:1.1})}return a}(b);a.PowerpointIOSDefaultSetRequirement=l;var p=function(b){__extends(a,b);function a(){b.call(this,{mailbox:1.1})}return a}(b);a.OutlookIOSDefaultSetRequirement=p;var x=function(){function a(){}a.initializeOsfDda=function(){OSF.OUtil.setNamespace("Requirement",OSF.DDA)};a.getDefaultRequirementMatrix=function(e){this.initializeDefaultSetMatrix();var d=undefined,f=e.get_requirementMatrix();if(f!=undefined&&f.length>0&&typeof JSON!=="undefined"){var h=JSON.parse(e.get_requirementMatrix().toLowerCase());d=new c(new b(h))}else{var g=a.getClientFullVersionString(e);if(a.DefaultSetArrayMatrix!=undefined&&a.DefaultSetArrayMatrix[g]!=undefined)d=new c(a.DefaultSetArrayMatrix[g]);else d=new c(new b({}))}return d};a.getDefaultDialogRequirementMatrix=function(e){var a=undefined,d=e.get_dialogRequirementMatrix();if(d!=undefined&&d.length>0&&typeof JSON!=="undefined"){var f=JSON.parse(e.get_requirementMatrix().toLowerCase());a=new c(new b(f))}else a=new c(new w);return a};a.getClientFullVersionString=function(a){var d=a.get_appMinorVersion(),e="",b="",c=a.get_appName(),f=c==1024||c==4096||c==8192||c==65536;if(f&&a.get_appVersion()==1)if(c==4096&&d>=15)b="16.00.01";else b="16.00";else if(a.get_appName()==64)b=a.get_appVersion();else{if(d<10)e="0"+d;else e=""+d;b=a.get_appVersion()+"."+e}return a.get_appName()+"-"+b};a.initializeDefaultSetMatrix=function(){a.DefaultSetArrayMatrix[a.Excel_RCLIENT_1600]=new e;a.DefaultSetArrayMatrix[a.Word_RCLIENT_1600]=new g;a.DefaultSetArrayMatrix[a.PowerPoint_RCLIENT_1600]=new d;a.DefaultSetArrayMatrix[a.Excel_RCLIENT_1601]=new j;a.DefaultSetArrayMatrix[a.Word_RCLIENT_1601]=new o;a.DefaultSetArrayMatrix[a.PowerPoint_RCLIENT_1601]=new i;a.DefaultSetArrayMatrix[a.Outlook_RCLIENT_1600]=new k;a.DefaultSetArrayMatrix[a.Excel_WAC_1600]=new t;a.DefaultSetArrayMatrix[a.Word_WAC_1600]=new v;a.DefaultSetArrayMatrix[a.Outlook_WAC_1600]=new f;a.DefaultSetArrayMatrix[a.Outlook_WAC_1601]=new f;a.DefaultSetArrayMatrix[a.Project_RCLIENT_1600]=new n;a.DefaultSetArrayMatrix[a.Access_WAC_1600]=new q;a.DefaultSetArrayMatrix[a.PowerPoint_WAC_1600]=new m;a.DefaultSetArrayMatrix[a.Excel_IOS_1600]=new s;a.DefaultSetArrayMatrix[a.SWAY_WAC_1600]=new u;a.DefaultSetArrayMatrix[a.Word_IOS_1600]=new h;a.DefaultSetArrayMatrix[a.Word_IOS_16001]=new r;a.DefaultSetArrayMatrix[a.PowerPoint_IOS_1600]=new l;a.DefaultSetArrayMatrix[a.Outlook_IOS_1600]=new p};a.Excel_RCLIENT_1600="1-16.00";a.Excel_RCLIENT_1601="1-16.01";a.Word_RCLIENT_1600="2-16.00";a.Word_RCLIENT_1601="2-16.01";a.PowerPoint_RCLIENT_1600="4-16.00";a.PowerPoint_RCLIENT_1601="4-16.01";a.Outlook_RCLIENT_1600="8-16.00";a.Excel_WAC_1600="16-16.00";a.Word_WAC_1600="32-16.00";a.Outlook_WAC_1600="64-16.00";a.Outlook_WAC_1601="64-16.01";a.Project_RCLIENT_1600="128-16.00";a.Access_WAC_1600="256-16.00";a.PowerPoint_WAC_1600="512-16.00";a.Excel_IOS_1600="1024-16.00";a.SWAY_WAC_1600="2048-16.00";a.Word_IOS_1600="4096-16.00";a.Word_IOS_16001="4096-16.00.01";a.PowerPoint_IOS_1600="8192-16.00";a.Outlook_IOS_1600="65536-16.00";a.DefaultSetArrayMatrix={};return a}();a.RequirementsMatrixFactory=x})(b=a.Requirement||(a.Requirement={}))})(OfficeExt||(OfficeExt={}));OfficeExt.Requirement.RequirementsMatrixFactory.initializeOsfDda();Microsoft.Office.WebExtension.ApplicationMode={WebEditor:"webEditor",WebViewer:"webViewer",Client:"client"};Microsoft.Office.WebExtension.DocumentMode={ReadOnly:"readOnly",ReadWrite:"readWrite"};OSF.NamespaceManager=function(){var b,a=false;return{enableShortcut:function(){if(!a){if(window.Office)b=window.Office;else OSF.OUtil.setNamespace("Office",window);window.Office=Microsoft.Office.WebExtension;a=true}},disableShortcut:function(){if(a){if(b)window.Office=b;else OSF.OUtil.unsetNamespace("Office",window);a=false}}}}();OSF.NamespaceManager.enableShortcut();Microsoft.Office.WebExtension.useShortNamespace=function(a){if(a)OSF.NamespaceManager.enableShortcut();else OSF.NamespaceManager.disableShortcut()};Microsoft.Office.WebExtension.select=function(a,b){var c;if(a&&typeof a=="string"){var d=a.indexOf("#");if(d!=-1){var h=a.substring(0,d),g=a.substring(d+1);switch(h){case"binding":case"bindings":if(g)c=new OSF.DDA.BindingPromise(g);break}}}if(!c){if(b){var e=typeof b;if(e=="function"){var f={};f[Microsoft.Office.WebExtension.Parameters.Callback]=b;OSF.DDA.issueAsyncResult(f,OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidApiCallInContext,OSF.DDA.ErrorCodeManager.getErrorArgs(OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidApiCallInContext))}else throw OSF.OUtil.formatString(Strings.OfficeOM.L_CallbackNotAFunction,e);}}else{c.onFail=b;return c}};OSF.DDA.Context=function(a,e,f,b,c){OSF.OUtil.defineEnumerableProperties(this,{contentLanguage:{value:a.get_dataLocale()},displayLanguage:{value:a.get_appUILocale()},touchEnabled:{value:a.get_touchEnabled()},commerceAllowed:{value:a.get_commerceAllowed()},host:{value:OfficeExt.HostName.Host.getInstance().getHost()},platform:{value:OfficeExt.HostName.Host.getInstance().getPlatform()},isDialog:{value:OSF._OfficeAppFactory.getHostInfo().isDialog},diagnostics:{value:OfficeExt.HostName.Host.getInstance().getDiagnostics(a.get_hostFullVersion())}});f&&OSF.OUtil.defineEnumerableProperty(this,"license",{value:f});a.ui&&OSF.OUtil.defineEnumerableProperty(this,"ui",{value:a.ui});a.auth&&OSF.OUtil.defineEnumerableProperty(this,"auth",{value:a.auth});a.webAuth&&OSF.OUtil.defineEnumerableProperty(this,"webAuth",{value:a.webAuth});a.application&&OSF.OUtil.defineEnumerableProperty(this,"application",{value:a.application});if(a.get_isDialog()){var d=OfficeExt.Requirement.RequirementsMatrixFactory.getDefaultDialogRequirementMatrix(a);OSF.OUtil.defineEnumerableProperty(this,"requirements",{value:d})}else{e&&OSF.OUtil.defineEnumerableProperty(this,"document",{value:e});if(b){var g=b.displayName||"appOM";delete b.displayName;OSF.OUtil.defineEnumerableProperty(this,g,{value:b})}c&&OSF.OUtil.defineEnumerableProperty(this,"officeTheme",{"get":function(){return c()}});var d=OfficeExt.Requirement.RequirementsMatrixFactory.getDefaultRequirementMatrix(a);OSF.OUtil.defineEnumerableProperty(this,"requirements",{value:d})}};OSF.DDA.OutlookContext=function(c,a,d,e,b){OSF.DDA.OutlookContext.uber.constructor.call(this,c,null,d,e,b);a&&OSF.OUtil.defineEnumerableProperty(this,"roamingSettings",{value:a})};OSF.OUtil.extend(OSF.DDA.OutlookContext,OSF.DDA.Context);OSF.DDA.OutlookAppOm=function(a,c,b){};OSF.DDA.Application=function(a){};OSF.DDA.Document=function(b,c){var a;switch(b.get_clientMode()){case OSF.ClientMode.ReadOnly:a=Microsoft.Office.WebExtension.DocumentMode.ReadOnly;break;case OSF.ClientMode.ReadWrite:a=Microsoft.Office.WebExtension.DocumentMode.ReadWrite;break}c&&OSF.OUtil.defineEnumerableProperty(this,"settings",{value:c});OSF.OUtil.defineMutableProperties(this,{mode:{value:a},url:{value:b.get_docUrl()}})};OSF.DDA.JsomDocument=function(c,a,d){OSF.DDA.JsomDocument.uber.constructor.call(this,c,d);a&&OSF.OUtil.defineEnumerableProperty(this,"bindings",{"get":function(){return a}});var b=OSF.DDA.AsyncMethodNames;OSF.DDA.DispIdHost.addAsyncMethods(this,[b.GetSelectedDataAsync,b.SetSelectedDataAsync]);OSF.DDA.DispIdHost.addEventSupport(this,new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.DocumentSelectionChanged]))};OSF.OUtil.extend(OSF.DDA.JsomDocument,OSF.DDA.Document);OSF.OUtil.defineEnumerableProperty(Microsoft.Office.WebExtension,"context",{"get":function(){var a;if(OSF&&OSF._OfficeAppFactory)a=OSF._OfficeAppFactory.getContext();return a}});OSF.DDA.License=function(a){OSF.OUtil.defineEnumerableProperty(this,"value",{value:a})};OSF.DDA.ApiMethodCall=function(b,e,d,f,g){var c=b.length,a=OSF.OUtil.delayExecutionAndCache(function(){return OSF.OUtil.formatString(Strings.OfficeOM.L_InvalidParameters,g)});this.verifyArguments=function(d,f){for(var e in d){var b=d[e],c=f[e];if(b["enum"])switch(typeof c){case"string":if(OSF.OUtil.listContainsValue(b["enum"],c))break;case"undefined":throw OSF.DDA.ErrorCodeManager.errorCodes.ooeUnsupportedEnumeration;default:throw a();}if(b.types)if(!OSF.OUtil.listContainsValue(b.types,typeof c))throw a();}};this.extractRequiredArguments=function(g,l,j){if(g.length<c)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_MissingRequiredArguments);for(var e=[],d=0;d<c;d++)e.push(g[d]);this.verifyArguments(b,e);var i={};for(d=0;d<c;d++){var f=b[d],h=e[d];if(f.verify){var k=f.verify(h,l,j);if(!k)throw a();}i[f.name]=h}return i},this.fillOptions=function(a,f,h,g){a=a||{};for(var d in e)if(!OSF.OUtil.listContainsKey(a,d)){var c=undefined,b=e[d];if(b.calculate&&f)c=b.calculate(f,h,g);if(!c&&b.defaultValue!==undefined)c=b.defaultValue;a[d]=c}return a};this.constructCallArgs=function(c,e,g,b){var a={};for(var i in c)a[i]=c[i];for(var h in e)a[h]=e[h];for(var j in d)a[j]=d[j](g,b);if(f)a=f(a,g,b);return a}};OSF.OUtil.setNamespace("AsyncResultEnum",OSF.DDA);OSF.DDA.AsyncResultEnum.Properties={Context:"Context",Value:"Value",Status:"Status",Error:"Error"};Microsoft.Office.WebExtension.AsyncResultStatus={Succeeded:"succeeded",Failed:"failed"};OSF.DDA.AsyncResultEnum.ErrorCode={Success:0,Failed:1};OSF.DDA.AsyncResultEnum.ErrorProperties={Name:"Name",Message:"Message",Code:"Code"};OSF.DDA.AsyncMethodNames={};OSF.DDA.AsyncMethodNames.addNames=function(b){for(var a in b){var c={};OSF.OUtil.defineEnumerableProperties(c,{id:{value:a},displayName:{value:b[a]}});OSF.DDA.AsyncMethodNames[a]=c}};OSF.DDA.AsyncMethodCall=function(c,d,h,e,f,i,j){var b=c.length,a=new OSF.DDA.ApiMethodCall(c,d,h,i,j);function g(g,i,k,j){if(g.length>b+2)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_TooManyArguments);for(var c,e,h=g.length-1;h>=b;h--){var f=g[h];switch(typeof f){case"object":if(c)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_TooManyOptionalObjects);else c=f;break;case"function":if(e)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_TooManyOptionalFunction);else e=f;break;default:throw OsfMsAjaxFactory.msAjaxError.argument(Strings.OfficeOM.L_InValidOptionalArgument);break}}c=a.fillOptions(c,i,k,j);if(e)if(c[Microsoft.Office.WebExtension.Parameters.Callback])throw Strings.OfficeOM.L_RedundantCallbackSpecification;else c[Microsoft.Office.WebExtension.Parameters.Callback]=e;a.verifyArguments(d,c);return c}this.verifyAndExtractCall=function(e,c,b){var d=a.extractRequiredArguments(e,c,b),h=g(e,d,c,b),f=a.constructCallArgs(d,h,c,b);return f};this.processResponse=function(c,b,g,d){var a;if(c==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess)if(e)a=e(b,g,d);else a=b;else if(f)a=f(c,b);else a=OSF.DDA.ErrorCodeManager.getErrorArgs(c);return a};this.getCallArgs=function(f){for(var a,c,e=f.length-1;e>=b;e--){var d=f[e];switch(typeof d){case"object":a=d;break;case"function":c=d;break}}a=a||{};if(c)a[Microsoft.Office.WebExtension.Parameters.Callback]=c;return a}};OSF.DDA.AsyncMethodCallFactory=function(){return{manufacture:function(a){var c=a.supportedOptions?OSF.OUtil.createObject(a.supportedOptions):[],b=a.privateStateCallbacks?OSF.OUtil.createObject(a.privateStateCallbacks):[];return new OSF.DDA.AsyncMethodCall(a.requiredArguments||[],c,b,a.onSucceeded,a.onFailed,a.checkCallArgs,a.method.displayName)}}}();OSF.DDA.AsyncMethodCalls={};OSF.DDA.AsyncMethodCalls.define=function(a){OSF.DDA.AsyncMethodCalls[a.method.id]=OSF.DDA.AsyncMethodCallFactory.manufacture(a)};OSF.DDA.Error=function(c,a,b){OSF.OUtil.defineEnumerableProperties(this,{name:{value:c},message:{value:a},code:{value:b}})};OSF.DDA.AsyncResult=function(b,a){OSF.OUtil.defineEnumerableProperties(this,{value:{value:b[OSF.DDA.AsyncResultEnum.Properties.Value]},status:{value:a?Microsoft.Office.WebExtension.AsyncResultStatus.Failed:Microsoft.Office.WebExtension.AsyncResultStatus.Succeeded}});b[OSF.DDA.AsyncResultEnum.Properties.Context]&&OSF.OUtil.defineEnumerableProperty(this,"asyncContext",{value:b[OSF.DDA.AsyncResultEnum.Properties.Context]});a&&OSF.OUtil.defineEnumerableProperty(this,"error",{value:new OSF.DDA.Error(a[OSF.DDA.AsyncResultEnum.ErrorProperties.Name],a[OSF.DDA.AsyncResultEnum.ErrorProperties.Message],a[OSF.DDA.AsyncResultEnum.ErrorProperties.Code])})};OSF.DDA.issueAsyncResult=function(d,f,a){var e=d[Microsoft.Office.WebExtension.Parameters.Callback];if(e){var c={};c[OSF.DDA.AsyncResultEnum.Properties.Context]=d[Microsoft.Office.WebExtension.Parameters.AsyncContext];var b;if(f==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess)c[OSF.DDA.AsyncResultEnum.Properties.Value]=a;else{b={};a=a||OSF.DDA.ErrorCodeManager.getErrorArgs(OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError);b[OSF.DDA.AsyncResultEnum.ErrorProperties.Code]=f||OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError;b[OSF.DDA.AsyncResultEnum.ErrorProperties.Name]=a.name||a;b[OSF.DDA.AsyncResultEnum.ErrorProperties.Message]=a.message||a}e(new OSF.DDA.AsyncResult(c,b))}};OSF.DDA.SyncMethodNames={};OSF.DDA.SyncMethodNames.addNames=function(b){for(var a in b){var c={};OSF.OUtil.defineEnumerableProperties(c,{id:{value:a},displayName:{value:b[a]}});OSF.DDA.SyncMethodNames[a]=c}};OSF.DDA.SyncMethodCall=function(b,c,f,g,h){var d=b.length,a=new OSF.DDA.ApiMethodCall(b,c,f,g,h);function e(e,h,j,i){if(e.length>d+1)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_TooManyArguments);for(var b,k,f=e.length-1;f>=d;f--){var g=e[f];switch(typeof g){case"object":if(b)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_TooManyOptionalObjects);else b=g;break;default:throw OsfMsAjaxFactory.msAjaxError.argument(Strings.OfficeOM.L_InValidOptionalArgument);break}}b=a.fillOptions(b,h,j,i);a.verifyArguments(c,b);return b}this.verifyAndExtractCall=function(f,c,b){var d=a.extractRequiredArguments(f,c,b),h=e(f,d,c,b),g=a.constructCallArgs(d,h,c,b);return g}};OSF.DDA.SyncMethodCallFactory=function(){return{manufacture:function(a){var b=a.supportedOptions?OSF.OUtil.createObject(a.supportedOptions):[];return new OSF.DDA.SyncMethodCall(a.requiredArguments||[],b,a.privateStateCallbacks,a.checkCallArgs,a.method.displayName)}}}();OSF.DDA.SyncMethodCalls={};OSF.DDA.SyncMethodCalls.define=function(a){OSF.DDA.SyncMethodCalls[a.method.id]=OSF.DDA.SyncMethodCallFactory.manufacture(a)};OSF.DDA.ListType=function(){var a={};return{setListType:function(c,b){a[c]=b},isListType:function(b){return OSF.OUtil.listContainsKey(a,b)},getDescriptor:function(b){return a[b]}}}();OSF.DDA.HostParameterMap=function(a,b){var h="toHost",d="fromHost",j="sourceData",f="self",c={};c[Microsoft.Office.WebExtension.Parameters.Data]={toHost:function(a){if(a!=null&&a.rows!==undefined){var b={};b[OSF.DDA.TableDataProperties.TableRows]=a.rows;b[OSF.DDA.TableDataProperties.TableHeaders]=a.headers;a=b}return a},fromHost:function(a){return a}};c[Microsoft.Office.WebExtension.Parameters.SampleData]=c[Microsoft.Office.WebExtension.Parameters.Data];function e(j,i){var m=j?{}:undefined;for(var h in j){var g=j[h],f;if(OSF.DDA.ListType.isListType(h)){f=[];for(var n in g)f.push(e(g[n],i))}else if(OSF.OUtil.listContainsKey(c,h))f=c[h][i](g);else if(i==d&&a.preserveNesting(h))f=e(g,i);else{var k=b[h];if(k){var l=k[i];if(l){f=l[g];if(f===undefined)f=g}}else f=g}m[h]=f}return m}function i(k,j){var e;for(var c in j){var d;if(a.isComplexType(c))d=i(k,b[c][h]);else d=k[c];if(d!=undefined){if(!e)e={};var g=j[c];if(g==f)g=c;e[g]=a.pack(c,d)}}return e}function g(k,n,h){if(!h)h={};for(var c in n){var l=n[c],e;if(l==f)e=k;else if(l==j){h[c]=k.toArray();continue}else e=k[l];if(e===null||e===undefined)h[c]=undefined;else{e=a.unpack(c,e);var i;if(a.isComplexType(c)){i=b[c][d];if(a.preserveNesting(c))h[c]=g(e,i);else g(e,i,h)}else if(OSF.DDA.ListType.isListType(c)){i={};var p=OSF.DDA.ListType.getDescriptor(c);i[p]=f;var m=new Array(e.length);for(var o in e)m[o]=g(e[o],i);h[c]=m}else h[c]=e}}return h}function k(k,f,a){var d=b[k][a],c;if(a=="toHost"){var j=e(f,a);c=i(j,d)}else if(a=="fromHost"){var h=g(f,d);c=e(h,a)}return c}if(!b)b={};this.addMapping=function(l,i){var a,e;if(i.map){a=i.map;e={};for(var j in a){var k=a[j];if(k==f)k=j;e[k]=j}}else{a=i.toHost;e=i.fromHost}var c=b[l];if(c){var g=c[h];for(var n in g)a[n]=g[n];g=c[d];for(var m in g)e[m]=g[m]}else c=b[l]={};c[h]=a;c[d]=e};this.toHost=function(b,a){return k(b,a,h)};this.fromHost=function(a,b){return k(a,b,d)};this.self=f;this.sourceData=j;this.addComplexType=function(b){a.addComplexType(b)};this.getDynamicType=function(b){return a.getDynamicType(b)};this.setDynamicType=function(c,b){a.setDynamicType(c,b)};this.dynamicTypes=c;this.doMapValues=function(a,b){return e(a,b)}};OSF.DDA.SpecialProcessor=function(b,a){this.addComplexType=function(a){b.push(a)};this.getDynamicType=function(b){return a[b]};this.setDynamicType=function(c,b){a[c]=b};this.isComplexType=function(a){return OSF.OUtil.listContainsValue(b,a)};this.isDynamicType=function(b){return OSF.OUtil.listContainsKey(a,b)};this.preserveNesting=function(b){var a=[];OSF.DDA.PropertyDescriptors&&a.push(OSF.DDA.PropertyDescriptors.Subset);if(OSF.DDA.DataNodeEventProperties)a=a.concat([OSF.DDA.DataNodeEventProperties.OldNode,OSF.DDA.DataNodeEventProperties.NewNode,OSF.DDA.DataNodeEventProperties.NextSiblingNode]);return OSF.OUtil.listContainsValue(a,b)};this.pack=function(c,d){var b;if(this.isDynamicType(c))b=a[c].toHost(d);else b=d;return b};this.unpack=function(c,d){var b;if(this.isDynamicType(c))b=a[c].fromHost(d);else b=d;return b}};OSF.DDA.getDecoratedParameterMap=function(d,c){var a=new OSF.DDA.HostParameterMap(d),f=a.self;function b(a){var c=null;if(a){c={};for(var d=a.length,b=0;b<d;b++)c[a[b].name]=a[b].value}return c}a.define=function(c){var d={},e=b(c.toHost);if(c.invertible)d.map=e;else if(c.canonical)d.toHost=d.fromHost=e;else{d.toHost=e;d.fromHost=b(c.fromHost)}a.addMapping(c.type,d);c.isComplexType&&a.addComplexType(c.type)};for(var e in c)a.define(c[e]);return a};OSF.OUtil.setNamespace("DispIdHost",OSF.DDA);OSF.DDA.DispIdHost.Methods={InvokeMethod:"invokeMethod",AddEventHandler:"addEventHandler",RemoveEventHandler:"removeEventHandler",OpenDialog:"openDialog",CloseDialog:"closeDialog",MessageParent:"messageParent",SendMessage:"sendMessage"};OSF.DDA.DispIdHost.Delegates={ExecuteAsync:"executeAsync",RegisterEventAsync:"registerEventAsync",UnregisterEventAsync:"unregisterEventAsync",ParameterMap:"parameterMap",OpenDialog:"openDialog",CloseDialog:"closeDialog",MessageParent:"messageParent",SendMessage:"sendMessage"};OSF.DDA.DispIdHost.Facade=function(d,e){var b={},c=OSF.DDA.AsyncMethodNames,a=OSF.DDA.MethodDispId,k={GoToByIdAsync:a.dispidNavigateToMethod,GetSelectedDataAsync:a.dispidGetSelectedDataMethod,SetSelectedDataAsync:a.dispidSetSelectedDataMethod,GetDocumentCopyChunkAsync:a.dispidGetDocumentCopyChunkMethod,ReleaseDocumentCopyAsync:a.dispidReleaseDocumentCopyMethod,GetDocumentCopyAsync:a.dispidGetDocumentCopyMethod,AddFromSelectionAsync:a.dispidAddBindingFromSelectionMethod,AddFromPromptAsync:a.dispidAddBindingFromPromptMethod,AddFromNamedItemAsync:a.dispidAddBindingFromNamedItemMethod,GetAllAsync:a.dispidGetAllBindingsMethod,GetByIdAsync:a.dispidGetBindingMethod,ReleaseByIdAsync:a.dispidReleaseBindingMethod,GetDataAsync:a.dispidGetBindingDataMethod,SetDataAsync:a.dispidSetBindingDataMethod,AddRowsAsync:a.dispidAddRowsMethod,AddColumnsAsync:a.dispidAddColumnsMethod,DeleteAllDataValuesAsync:a.dispidClearAllRowsMethod,RefreshAsync:a.dispidLoadSettingsMethod,SaveAsync:a.dispidSaveSettingsMethod,GetActiveViewAsync:a.dispidGetActiveViewMethod,GetFilePropertiesAsync:a.dispidGetFilePropertiesMethod,GetOfficeThemeAsync:a.dispidGetOfficeThemeMethod,GetDocumentThemeAsync:a.dispidGetDocumentThemeMethod,ClearFormatsAsync:a.dispidClearFormatsMethod,SetTableOptionsAsync:a.dispidSetTableOptionsMethod,SetFormatsAsync:a.dispidSetFormatsMethod,GetAccessTokenAsync:a.dispidGetAccessTokenMethod,GetAuthContextAsync:a.dispidGetAuthContextMethod,ExecuteRichApiRequestAsync:a.dispidExecuteRichApiRequestMethod,AppCommandInvocationCompletedAsync:a.dispidAppCommandInvocationCompletedMethod,CloseContainerAsync:a.dispidCloseContainerMethod,OpenBrowserWindow:a.dispidOpenBrowserWindow,CreateDocumentAsync:a.dispidCreateDocumentMethod,InsertFormAsync:a.dispidInsertFormMethod,ExecuteFeature:a.dispidExecuteFeature,QueryFeature:a.dispidQueryFeature,AddDataPartAsync:a.dispidAddDataPartMethod,GetDataPartByIdAsync:a.dispidGetDataPartByIdMethod,GetDataPartsByNameSpaceAsync:a.dispidGetDataPartsByNamespaceMethod,GetPartXmlAsync:a.dispidGetDataPartXmlMethod,GetPartNodesAsync:a.dispidGetDataPartNodesMethod,DeleteDataPartAsync:a.dispidDeleteDataPartMethod,GetNodeValueAsync:a.dispidGetDataNodeValueMethod,GetNodeXmlAsync:a.dispidGetDataNodeXmlMethod,GetRelativeNodesAsync:a.dispidGetDataNodesMethod,SetNodeValueAsync:a.dispidSetDataNodeValueMethod,SetNodeXmlAsync:a.dispidSetDataNodeXmlMethod,AddDataPartNamespaceAsync:a.dispidAddDataNamespaceMethod,GetDataPartNamespaceAsync:a.dispidGetDataUriByPrefixMethod,GetDataPartPrefixAsync:a.dispidGetDataPrefixByUriMethod,GetNodeTextAsync:a.dispidGetDataNodeTextMethod,SetNodeTextAsync:a.dispidSetDataNodeTextMethod,GetSelectedTask:a.dispidGetSelectedTaskMethod,GetTask:a.dispidGetTaskMethod,GetWSSUrl:a.dispidGetWSSUrlMethod,GetTaskField:a.dispidGetTaskFieldMethod,GetSelectedResource:a.dispidGetSelectedResourceMethod,GetResourceField:a.dispidGetResourceFieldMethod,GetProjectField:a.dispidGetProjectFieldMethod,GetSelectedView:a.dispidGetSelectedViewMethod,GetTaskByIndex:a.dispidGetTaskByIndexMethod,GetResourceByIndex:a.dispidGetResourceByIndexMethod,SetTaskField:a.dispidSetTaskFieldMethod,SetResourceField:a.dispidSetResourceFieldMethod,GetMaxTaskIndex:a.dispidGetMaxTaskIndexMethod,GetMaxResourceIndex:a.dispidGetMaxResourceIndexMethod,CreateTask:a.dispidCreateTaskMethod};for(var f in k)if(c[f])b[c[f].id]=k[f];c=OSF.DDA.SyncMethodNames;a=OSF.DDA.MethodDispId;var j={MessageParent:a.dispidMessageParentMethod,SendMessage:a.dispidSendMessageMethod};for(var f in j)if(c[f])b[c[f].id]=j[f];c=Microsoft.Office.WebExtension.EventType;a=OSF.DDA.EventDispId;var l={SettingsChanged:a.dispidSettingsChangedEvent,DocumentSelectionChanged:a.dispidDocumentSelectionChangedEvent,BindingSelectionChanged:a.dispidBindingSelectionChangedEvent,BindingDataChanged:a.dispidBindingDataChangedEvent,ActiveViewChanged:a.dispidActiveViewChangedEvent,OfficeThemeChanged:a.dispidOfficeThemeChangedEvent,DocumentThemeChanged:a.dispidDocumentThemeChangedEvent,AppCommandInvoked:a.dispidAppCommandInvokedEvent,DialogMessageReceived:a.dispidDialogMessageReceivedEvent,DialogParentMessageReceived:a.dispidDialogParentMessageReceivedEvent,ObjectDeleted:a.dispidObjectDeletedEvent,ObjectSelectionChanged:a.dispidObjectSelectionChangedEvent,ObjectDataChanged:a.dispidObjectDataChangedEvent,ContentControlAdded:a.dispidContentControlAddedEvent,RichApiMessage:a.dispidRichApiMessageEvent,ItemChanged:a.dispidOlkItemSelectedChangedEvent,RecipientsChanged:a.dispidOlkRecipientsChangedEvent,AppointmentTimeChanged:a.dispidOlkAppointmentTimeChangedEvent,RecurrenceChanged:a.dispidOlkRecurrenceChangedEvent,AttachmentsChanged:a.dispidOlkAttachmentsChangedEvent,EnhancedLocationsChanged:a.dispidOlkEnhancedLocationsChangedEvent,InfobarClicked:a.dispidOlkInfobarClickedEvent,TaskSelectionChanged:a.dispidTaskSelectionChangedEvent,ResourceSelectionChanged:a.dispidResourceSelectionChangedEvent,ViewSelectionChanged:a.dispidViewSelectionChangedEvent,DataNodeInserted:a.dispidDataNodeAddedEvent,DataNodeReplaced:a.dispidDataNodeReplacedEvent,DataNodeDeleted:a.dispidDataNodeDeletedEvent};for(var h in l)if(c[h])b[c[h]]=l[h];function i(a){return a==OSF.DDA.EventDispId.dispidObjectDeletedEvent||a==OSF.DDA.EventDispId.dispidObjectSelectionChangedEvent||a==OSF.DDA.EventDispId.dispidObjectDataChangedEvent||a==OSF.DDA.EventDispId.dispidContentControlAddedEvent}function g(a,c,d,b){if(typeof a=="number"){if(!b)b=c.getCallArgs(d);OSF.DDA.issueAsyncResult(b,a,OSF.DDA.ErrorCodeManager.getErrorArgs(a))}else throw a;}this[OSF.DDA.DispIdHost.Methods.InvokeMethod]=function(r,l,m,o){var a;try{var i=r.id,k=OSF.DDA.AsyncMethodCalls[i];a=k.verifyAndExtractCall(l,m,o);var j=b[i],q=d(i),c=null;if(window.Excel&&window.Office.context.requirements.isSetSupported("RedirectV1Api"))window.Excel._RedirectV1APIs=true;if(window.Excel&&window.Excel._RedirectV1APIs&&(c=window.Excel._V1APIMap[i])){var f=OSF.OUtil.shallowCopy(a);delete f[Microsoft.Office.WebExtension.Parameters.AsyncContext];if(c.preprocess)f=c.preprocess(f);var n=new window.Excel.RequestContext,s=c.call(n,f);n.sync().then(function(){var b=s.value,d=b.status;delete b.status;delete b["@odata.type"];if(c.postprocess)b=c.postprocess(b,f);if(d!=0)b=OSF.DDA.ErrorCodeManager.getErrorArgs(d);OSF.DDA.issueAsyncResult(a,d,b)})["catch"](function(b){OSF.DDA.issueAsyncResult(a,OSF.DDA.ErrorCodeManager.errorCodes.ooeFailure,null)})}else{var h;if(e.toHost)h=e.toHost(j,a);else h=a;var p=+new Date;q[OSF.DDA.DispIdHost.Delegates.ExecuteAsync]({dispId:j,hostCallArgs:h,onCalling:function(){},onReceiving:function(){},onComplete:function(c,d){var b;if(c==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess)if(e.fromHost)b=e.fromHost(j,d);else b=d;else b=d;var f=k.processResponse(c,b,m,a);OSF.DDA.issueAsyncResult(a,c,f);if(OSF.AppTelemetry&&!(OSF.ConstantNames&&OSF.ConstantNames.IsCustomFunctionsRuntime))OSF.AppTelemetry.onMethodDone(j,h,Math.abs(+new Date-p),c)}})}}catch(t){g(t,k,l,a)}};this[OSF.DDA.DispIdHost.Methods.AddEventHandler]=function(o,c,m,q){var f,a,l,h=false;function k(b){if(b==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess){var e=!h?c.addEventHandler(a,l):c.addObjectEventHandler(a,f[Microsoft.Office.WebExtension.Parameters.Id],l);if(!e)b=OSF.DDA.ErrorCodeManager.errorCodes.ooeEventHandlerAdditionFailed}var d;if(b!=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess)d=OSF.DDA.ErrorCodeManager.getErrorArgs(b);OSF.DDA.issueAsyncResult(f,b,d)}try{var p=OSF.DDA.AsyncMethodCalls[OSF.DDA.AsyncMethodNames.AddHandlerAsync.id];f=p.verifyAndExtractCall(o,m,c);a=f[Microsoft.Office.WebExtension.Parameters.EventType];l=f[Microsoft.Office.WebExtension.Parameters.Handler];if(q){k(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess);return}var n=b[a];h=i(n);var j=h?f[Microsoft.Office.WebExtension.Parameters.Id]:m.id||"",s=h?c.getObjectEventHandlerCount(a,j):c.getEventHandlerCount(a);if(s==0){var r=d(a)[OSF.DDA.DispIdHost.Delegates.RegisterEventAsync];r({eventType:a,dispId:n,targetId:j,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)},onComplete:k,onEvent:function(d){var b=e.fromHost(n,d);if(!h)c.fireEvent(OSF.DDA.OMFactory.manufactureEventArgs(a,m,b));else c.fireObjectEvent(j,OSF.DDA.OMFactory.manufactureEventArgs(a,j,b))}})}else k(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess)}catch(t){g(t,p,o,f)}};this[OSF.DDA.DispIdHost.Methods.RemoveEventHandler]=function(n,c,p){var e,a,k,f=false;function m(a){var b;if(a!=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess)b=OSF.DDA.ErrorCodeManager.getErrorArgs(a);OSF.DDA.issueAsyncResult(e,a,b)}try{var o=OSF.DDA.AsyncMethodCalls[OSF.DDA.AsyncMethodNames.RemoveHandlerAsync.id];e=o.verifyAndExtractCall(n,p,c);a=e[Microsoft.Office.WebExtension.Parameters.EventType];k=e[Microsoft.Office.WebExtension.Parameters.Handler];var q=b[a];f=i(q);var j=f?e[Microsoft.Office.WebExtension.Parameters.Id]:p.id||"",l,h;if(k===null){h=f?c.clearObjectEventHandlers(a,j):c.clearEventHandlers(a);l=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess}else{h=f?c.removeObjectEventHandler(a,j,k):c.removeEventHandler(a,k);l=h?OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess:OSF.DDA.ErrorCodeManager.errorCodes.ooeEventHandlerNotExist}var s=f?c.getObjectEventHandlerCount(a,j):c.getEventHandlerCount(a);if(h&&s==0){var r=d(a)[OSF.DDA.DispIdHost.Delegates.UnregisterEventAsync];r({eventType:a,dispId:q,targetId:j,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)},onComplete:m})}else m(l)}catch(t){g(t,o,n,e)}};this[OSF.DDA.DispIdHost.Methods.OpenDialog]=function(n,a,m){var h,l,c=Microsoft.Office.WebExtension.EventType.DialogMessageReceived,f=Microsoft.Office.WebExtension.EventType.DialogEventReceived;function i(b){var e;if(b!=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess)e=OSF.DDA.ErrorCodeManager.getErrorArgs(b);else{var d={};d[Microsoft.Office.WebExtension.Parameters.Id]=l;d[Microsoft.Office.WebExtension.Parameters.Data]=a;var e=j.processResponse(b,d,m,h);OSF.DialogShownStatus.hasDialogShown=true;a.clearEventHandlers(c);a.clearEventHandlers(f)}OSF.DDA.issueAsyncResult(h,b,e)}try{(c==undefined||f==undefined)&&i(OSF.DDA.ErrorCodeManager.ooeOperationNotSupported);if(OSF.DDA.AsyncMethodNames.DisplayDialogAsync==null){i(OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError);return}var j=OSF.DDA.AsyncMethodCalls[OSF.DDA.AsyncMethodNames.DisplayDialogAsync.id];h=j.verifyAndExtractCall(n,m,a);var o=b[c],k=d(c),p=k[OSF.DDA.DispIdHost.Delegates.OpenDialog]!=undefined?k[OSF.DDA.DispIdHost.Delegates.OpenDialog]:k[OSF.DDA.DispIdHost.Delegates.RegisterEventAsync];l=JSON.stringify(h);if(!OSF.DialogShownStatus.hasDialogShown){a.clearQueuedEvent(c);a.clearQueuedEvent(f);a.clearQueuedEvent(Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived)}p({eventType:c,dispId:o,targetId:l,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)},onComplete:i,onEvent:function(i){var h=e.fromHost(o,i),g=OSF.DDA.OMFactory.manufactureEventArgs(c,m,h);if(g.type==f){var d=OSF.DDA.ErrorCodeManager.getErrorArgs(g.error),b={};b[OSF.DDA.AsyncResultEnum.ErrorProperties.Code]=status||OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError;b[OSF.DDA.AsyncResultEnum.ErrorProperties.Name]=d.name||d;b[OSF.DDA.AsyncResultEnum.ErrorProperties.Message]=d.message||d;g.error=new OSF.DDA.Error(b[OSF.DDA.AsyncResultEnum.ErrorProperties.Name],b[OSF.DDA.AsyncResultEnum.ErrorProperties.Message],b[OSF.DDA.AsyncResultEnum.ErrorProperties.Code])}a.fireOrQueueEvent(g);if(h[OSF.DDA.PropertyDescriptors.MessageType]==OSF.DialogMessageType.DialogClosed){a.clearEventHandlers(c);a.clearEventHandlers(f);a.clearEventHandlers(Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived);OSF.DialogShownStatus.hasDialogShown=false}}})}catch(q){g(q,j,n,h)}};this[OSF.DDA.DispIdHost.Methods.CloseDialog]=function(h,m,e,o){var k,a,i,f=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess;function l(a){f=a;OSF.DialogShownStatus.hasDialogShown=false}try{var j=OSF.DDA.AsyncMethodCalls[OSF.DDA.AsyncMethodNames.CloseAsync.id];k=j.verifyAndExtractCall(h,o,e);a=Microsoft.Office.WebExtension.EventType.DialogMessageReceived;i=Microsoft.Office.WebExtension.EventType.DialogEventReceived;e.clearEventHandlers(a);e.clearEventHandlers(i);var p=b[a],c=d(a),n=c[OSF.DDA.DispIdHost.Delegates.CloseDialog]!=undefined?c[OSF.DDA.DispIdHost.Delegates.CloseDialog]:c[OSF.DDA.DispIdHost.Delegates.UnregisterEventAsync];n({eventType:a,dispId:p,targetId:m,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)},onComplete:l})}catch(q){g(q,j,h,k)}if(f!=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess)throw OSF.OUtil.formatString(Strings.OfficeOM.L_FunctionCallFailed,OSF.DDA.AsyncMethodNames.CloseAsync.displayName,f);};this[OSF.DDA.DispIdHost.Methods.MessageParent]=function(a,i){var e={},c=OSF.DDA.SyncMethodCalls[OSF.DDA.SyncMethodNames.MessageParent.id],f=c.verifyAndExtractCall(a,i,e),g=d(OSF.DDA.SyncMethodNames.MessageParent.id),h=g[OSF.DDA.DispIdHost.Delegates.MessageParent],j=b[OSF.DDA.SyncMethodNames.MessageParent.id];return h({dispId:j,hostCallArgs:f,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)}})};this[OSF.DDA.DispIdHost.Methods.SendMessage]=function(a,k,i){var e={},c=OSF.DDA.SyncMethodCalls[OSF.DDA.SyncMethodNames.SendMessage.id],f=c.verifyAndExtractCall(a,i,e),g=d(OSF.DDA.SyncMethodNames.SendMessage.id),h=g[OSF.DDA.DispIdHost.Delegates.SendMessage],j=b[OSF.DDA.SyncMethodNames.SendMessage.id];return h({dispId:j,hostCallArgs:f,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)}})}};OSF.DDA.DispIdHost.addAsyncMethods=function(a,b,e){for(var f in b){var c=b[f],d=c.displayName;!a[d]&&OSF.OUtil.defineEnumerableProperty(a,d,{value:function(b){return function(){var c=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.InvokeMethod];c(b,arguments,a,e)}}(c)})}};OSF.DDA.DispIdHost.addEventSupport=function(a,b,e){var d=OSF.DDA.AsyncMethodNames.AddHandlerAsync.displayName,c=OSF.DDA.AsyncMethodNames.RemoveHandlerAsync.displayName;!a[d]&&OSF.OUtil.defineEnumerableProperty(a,d,{value:function(){var c=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.AddEventHandler];c(arguments,b,a,e)}});!a[c]&&OSF.OUtil.defineEnumerableProperty(a,c,{value:function(){var c=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.RemoveEventHandler];c(arguments,b,a)}})};OSF.ShowWindowDialogParameterKeys={Url:"url",Width:"width",Height:"height",DisplayInIframe:"displayInIframe",HideTitle:"hideTitle",UseDeviceIndependentPixels:"useDeviceIndependentPixels",PromptBeforeOpen:"promptBeforeOpen",EnforceAppDomain:"enforceAppDomain"};OSF.HostThemeButtonStyleKeys={ButtonBorderColor:"buttonBorderColor",ButtonBackgroundColor:"buttonBackgroundColor"};OSF.OmexPageParameterKeys={AppName:"client",AppVersion:"cv",AppUILocale:"ui",AppDomain:"appDomain",StoreLocator:"rs",AssetId:"assetid",NotificationType:"notificationType",AppCorrelationId:"corr",AuthType:"authType",AppId:"appid",Scopes:"scopes"};OSF.AuthType={Anonymous:0,MSA:1,OrgId:2,ADAL:3};OSF.OmexMessageKeys={MessageType:"messageType",MessageValue:"messageValue"};OSF.OmexRemoveAddinMessageKeys={RemoveAddinResultCode:"resultCode",RemoveAddinResultValue:"resultValue"};OSF.OmexRemoveAddinResultCode={Success:0,ClientError:400,ServerError:500,UnknownError:600};var OfficeExt;(function(a){var b;(function(a){var k="^https://[a-z0-9-]+.(officeapps.live|officeapps-df.live|partner.officewebapps).com/";function f(a,b){return OSF.OUtil.parseInfoFromWindowName(a,b,OSF.WindowNameItemKeys.AppContext)}a.parseAppContextFromWindowName=f;function c(a){if(typeof JSON!=="undefined")try{return JSON.stringify(a)}catch(b){}return""}a.serializeObjectToString=c;function l(){return new RegExp(k).test(OSF.getClientEndPoint()._targetUrl.toLowerCase())}a.isHostTrusted=l;function h(b,e){if(!b)return null;b=b.trim()||"";var f="?",k="_host_Info=",j="&_host_Info=",d="#",i=b.split(d),c=i.shift(),h=i.join(d),g=c.split(f),a;if(g.length>1)a=c+j+e;else if(g.length>0)a=c+f+k+e;if(h)return[a,d,h].join("");else return a}a.addHostInfoAsQueryParam=h;function i(b){if(!b)return null;var a=document.createElement("a");a.href=b;return a.protocol+"//"+a.host}a.getDomainForUrl=i;function e(){try{for(var c=["Windows NT 6.1","Windows NT 6.2","Windows NT 6.3"],e=window.navigator.userAgent,a=0,f=c.length;a<f;a++)if(e.indexOf(c[a])>-1)return d();return false}catch(g){b("Error happens in shouldUseLocalStorageToPassMessage.",g);return false}}a.shouldUseLocalStorageToPassMessage=e;function d(){try{var a=window.navigator.userAgent;return a.indexOf("MSIE ")>-1||a.indexOf("Trident/")>-1||a.indexOf("Edge/")>-1}catch(c){b("Error happens in isInternetExplorer.",c);return false}}a.isInternetExplorer=d;function g(c){for(var d=OSF.OUtil.getLocalStorage(),e=d.getKeysWithPrefix(""),a=0,h=e.length;a<h;a++)for(var f=e[a],b=0,g=c.length;b<g;b++)if(c[b].test(f)){d.removeItem(f);break}}a.removeMatchesFromLocalStorage=g;function b(b,a){OsfMsAjaxFactory.msAjaxDebug.trace(b+" Exception details: "+c(a))}a.logExceptionToBrowserConsole=b;var j=function(){function a(){}a.GatedCacheKeyPrefix="__OSF_GATED_OMEX.";a.AuthenticatedAppInstallInfoCacheKey=a.GatedCacheKeyPrefix+"appinstall_authenticated.{0}.{1}.{2}.{3}";a.EntitlementsKey="entitle.{0}.{1}";return a}();a.CacheConstants=j})(b=a.WACUtils||(a.WACUtils={}))})(OfficeExt||(OfficeExt={}));var OfficeExt;(function(c){var f=function(){function a(){}a.isInstanceOfType=function(c,b){if(typeof b==="undefined"||b===null)return false;if(b instanceof c)return true;var a=b.constructor;if(!a||typeof a!=="function"||!a.__typeName||a.__typeName==="Object")a=Object;return!!(a===c)||a.__typeName&&c.__typeName&&a.__typeName===c.__typeName};return a}();c.MsAjaxTypeHelper=f;var d=function(){function a(){}a.create=function(c,b){var a=new Error(c);a.message=c;if(b)for(var d in b)a[d]=b[d];a.popStackFrame();return a};a.parameterCount=function(b){var d="Sys.ParameterCountException: "+(b?b:"Parameter count mismatch."),c=a.create(d,{name:"Sys.ParameterCountException"});c.popStackFrame();return c};a.argument=function(c,e){var d="Sys.ArgumentException: "+(e?e:"Value does not fall within the expected range.");if(c)d+="\n"+b.format("Parameter name: {0}",c);var f=a.create(d,{name:"Sys.ArgumentException",paramName:c});f.popStackFrame();return f};a.argumentNull=function(c,e){var d="Sys.ArgumentNullException: "+(e?e:"Value cannot be null.");if(c)d+="\n"+b.format("Parameter name: {0}",c);var f=a.create(d,{name:"Sys.ArgumentNullException",paramName:c});f.popStackFrame();return f};a.argumentOutOfRange=function(e,c,f){var d="Sys.ArgumentOutOfRangeException: "+(f?f:"Specified argument was out of the range of valid values.");if(e)d+="\n"+b.format("Parameter name: {0}",e);if(typeof c!=="undefined"&&c!==null)d+="\n"+b.format("Actual value was {0}.",c);var g=a.create(d,{name:"Sys.ArgumentOutOfRangeException",paramName:e,actualValue:c});g.popStackFrame();return g};a.argumentType=function(f,e,d,g){var c="Sys.ArgumentTypeException: ";if(g)c+=g;else if(e&&d)c+=b.format("Object of type '{0}' cannot be converted to type '{1}'.",e.getName?e.getName():e,d.getName?d.getName():d);else c+="Object cannot be converted to the required type.";if(f)c+="\n"+b.format("Parameter name: {0}",f);var h=a.create(c,{name:"Sys.ArgumentTypeException",paramName:f,actualType:e,expectedType:d});h.popStackFrame();return h};a.argumentUndefined=function(c,e){var d="Sys.ArgumentUndefinedException: "+(e?e:"Value cannot be undefined.");if(c)d+="\n"+b.format("Parameter name: {0}",c);var f=a.create(d,{name:"Sys.ArgumentUndefinedException",paramName:c});f.popStackFrame();return f};a.invalidOperation=function(b){var d="Sys.InvalidOperationException: "+(b?b:"Operation is not valid due to the current state of the object."),c=a.create(d,{name:"Sys.InvalidOperationException"});c.popStackFrame();return c};return a}();c.MsAjaxError=d;var b=function(){function a(){}a.format=function(c){for(var b=[],a=1;a<arguments.length;a++)b[a-1]=arguments[a];var d=c;return d.replace(/{(\d+)}/gm,function(d,a){var c=parseInt(a,10);return b[c]===undefined?"{"+a+"}":b[c]})};a.startsWith=function(b,a){return b.substr(0,a.length)===a};return a}();c.MsAjaxString=b;var e=function(){function a(){}a.trace=function(a){typeof Debug!=="undefined"&&Debug.writeln;window.console&&window.console.log&&window.console.log(a);window.opera&&window.opera.postError&&window.opera.postError(a);window.debugService&&window.debugService.trace&&window.debugService.trace(a);var b=document.getElementById("TraceConsole");if(b&&b.tagName.toUpperCase()==="TEXTAREA")b.innerHTML+=a+"\n"};return a}();c.MsAjaxDebug=e;if(!OsfMsAjaxFactory.isMsAjaxLoaded()){var a=function(a,c,b){if(a.__typeName===undefined||a.__typeName===null)a.__typeName=c;if(a.__class===undefined||a.__class===null)a.__class=b};a(Function,"Function",true);a(Error,"Error",true);a(Object,"Object",true);a(String,"String",true);a(Boolean,"Boolean",true);a(Date,"Date",true);a(Number,"Number",true);a(RegExp,"RegExp",true);a(Array,"Array",true);if(!Function.createCallback)Function.createCallback=function(b,a){var c=Function._validateParams(arguments,[{name:"method",type:Function},{name:"context",mayBeNull:true}]);if(c)throw c;return function(){var e=arguments.length;if(e>0){for(var d=[],c=0;c<e;c++)d[c]=arguments[c];d[e]=a;return b.apply(this,d)}return b.call(this,a)}};if(!Function.createDelegate)Function.createDelegate=function(b,c){var a=Function._validateParams(arguments,[{name:"instance",mayBeNull:true},{name:"method",type:Function}]);if(a)throw a;return function(){return c.apply(b,arguments)}};if(!Function._validateParams)Function._validateParams=function(g,e,c){var a,d=e.length;c=c||typeof c==="undefined";a=Function._validateParameterCount(g,e,c);if(a){a.popStackFrame();return a}for(var b=0,i=g.length;b<i;b++){var f=e[Math.min(b,d-1)],h=f.name;if(f.parameterArray)h+="["+(b-d+1)+"]";else if(!c&&b>=d)break;a=Function._validateParameter(g[b],f,h);if(a){a.popStackFrame();return a}}return null};if(!Function._validateParameterCount)Function._validateParameterCount=function(k,e,j){var a,c,b=e.length,f=k.length;if(f<b){var g=b;for(a=0;a<b;a++){var h=e[a];if(h.optional||h.parameterArray)g--}if(f<g)c=true}else if(j&&f>b){c=true;for(a=0;a<b;a++)if(e[a].parameterArray){c=false;break}}if(c){var i=d.parameterCount();i.popStackFrame();return i}return null};if(!Function._validateParameter)Function._validateParameter=function(c,a,h){var b,g=a.type,l=!!a.integer,k=!!a.domElement,m=!!a.mayBeNull;b=Function._validateParameterType(c,g,l,k,m,h);if(b){b.popStackFrame();return b}var e=a.elementType,f=!!a.elementMayBeNull;if(g===Array&&typeof c!=="undefined"&&c!==null&&(e||!f))for(var j=!!a.elementInteger,i=!!a.elementDomElement,d=0;d<c.length;d++){var n=c[d];b=Function._validateParameterType(n,e,j,i,f,h+"["+d+"]");if(b){b.popStackFrame();return b}}return null};if(!Function._validateParameterType)Function._validateParameterType=function(b,d,h,g,f,e){var a,i;if(typeof b==="undefined")if(f)return null;else{a=c.MsAjaxError.argumentUndefined(e);a.popStackFrame();return a}if(b===null)if(f)return null;else{a=c.MsAjaxError.argumentNull(e);a.popStackFrame();return a}if(d&&!c.MsAjaxTypeHelper.isInstanceOfType(d,b)){a=c.MsAjaxError.argumentType(e,typeof b,d);a.popStackFrame();return a}return null};if(!window.Type)window.Type=Function;if(!Type.registerNamespace)Type.registerNamespace=function(d){for(var c=d.split("."),b=window,a=0;a<c.length;a++){b[c[a]]=b[c[a]]||{};b=b[c[a]]}};if(!Type.prototype.registerClass)Type.prototype.registerClass=function(a){a={}};typeof Sys==="undefined"&&Type.registerNamespace("Sys");if(!Error.prototype.popStackFrame)Error.prototype.popStackFrame=function(){if(arguments.length!==0)throw d.parameterCount();if(typeof this.stack==="undefined"||this.stack===null||typeof this.fileName==="undefined"||this.fileName===null||typeof this.lineNumber==="undefined"||this.lineNumber===null)return;var a=this.stack.split("\n"),c=a[0],f=this.fileName+":"+this.lineNumber;while(typeof c!=="undefined"&&c!==null&&c.indexOf(f)===-1){a.shift();c=a[0]}var e=a[1];if(typeof e==="undefined"||e===null)return;var b=e.match(/@(.*):(\d+)$/);if(typeof b==="undefined"||b===null)return;this.fileName=b[1];this.lineNumber=parseInt(b[2]);a.shift();this.stack=a.join("\n")};OsfMsAjaxFactory.msAjaxError=d;OsfMsAjaxFactory.msAjaxString=b;OsfMsAjaxFactory.msAjaxDebug=e}})(OfficeExt||(OfficeExt={}));OSF.OUtil.setNamespace("Microsoft",window);OSF.OUtil.setNamespace("Office",Microsoft);OSF.OUtil.setNamespace("Common",Microsoft.Office);Microsoft.Office.Common.InvokeType={async:0,sync:1,asyncRegisterEvent:2,asyncUnregisterEvent:3,syncRegisterEvent:4,syncUnregisterEvent:5};OSF.SerializerVersion={MsAjax:0,Browser:1};var OfficeExt;(function(b){function a(b,c,d,a){return false}b.appSpecificCheckOrigin=a})(OfficeExt||(OfficeExt={}));Microsoft.Office.Common.InvokeType={async:0,sync:1,asyncRegisterEvent:2,asyncUnregisterEvent:3,syncRegisterEvent:4,syncUnregisterEvent:5};Microsoft.Office.Common.InvokeResultCode={noError:0,errorInRequest:-1,errorHandlingRequest:-2,errorInResponse:-3,errorHandlingResponse:-4,errorHandlingRequestAccessDenied:-5,errorHandlingMethodCallTimedout:-6};Microsoft.Office.Common.MessageType={request:0,response:1};Microsoft.Office.Common.ActionType={invoke:0,registerEvent:1,unregisterEvent:2};Microsoft.Office.Common.ResponseType={forCalling:0,forEventing:1};Microsoft.Office.Common.MethodObject=function(c,b,a){this._method=c;this._invokeType=b;this._blockingOthers=a};Microsoft.Office.Common.MethodObject.prototype={getMethod:function(){return this._method},getInvokeType:function(){return this._invokeType},getBlockingFlag:function(){return this._blockingOthers}};Microsoft.Office.Common.EventMethodObject=function(b,a){this._registerMethodObject=b;this._unregisterMethodObject=a};Microsoft.Office.Common.EventMethodObject.prototype={getRegisterMethodObject:function(){return this._registerMethodObject},getUnregisterMethodObject:function(){return this._unregisterMethodObject}};Microsoft.Office.Common.ServiceEndPoint=function(b){var a=Function._validateParams(arguments,[{name:"serviceEndPointId",type:String,mayBeNull:false}]);if(a)throw a;this._methodObjectList={};this._eventHandlerProxyList={};this._Id=b;this._conversations={};this._policyManager=null;this._appDomains={};this._onHandleRequestError=null;this._addInSourceLocationSubdomainAllowedIsEnabled=false};Microsoft.Office.Common.ServiceEndPoint.prototype={registerMethod:function(e,f,a,c){var b=Function._validateParams(arguments,[{name:"methodName",type:String,mayBeNull:false},{name:"method",type:Function,mayBeNull:false},{name:"invokeType",type:Number,mayBeNull:false},{name:"blockingOthers",type:Boolean,mayBeNull:false}]);if(b)throw b;if(a!==Microsoft.Office.Common.InvokeType.async&&a!==Microsoft.Office.Common.InvokeType.sync)throw OsfMsAjaxFactory.msAjaxError.argument("invokeType");var d=new Microsoft.Office.Common.MethodObject(f,a,c);this._methodObjectList[e]=d},unregisterMethod:function(b){var a=Function._validateParams(arguments,[{name:"methodName",type:String,mayBeNull:false}]);if(a)throw a;delete this._methodObjectList[b]},registerEvent:function(e,c,b){var a=Function._validateParams(arguments,[{name:"eventName",type:String,mayBeNull:false},{name:"registerMethod",type:Function,mayBeNull:false},{name:"unregisterMethod",type:Function,mayBeNull:false}]);if(a)throw a;var d=new Microsoft.Office.Common.EventMethodObject(new Microsoft.Office.Common.MethodObject(c,Microsoft.Office.Common.InvokeType.syncRegisterEvent,false),new Microsoft.Office.Common.MethodObject(b,Microsoft.Office.Common.InvokeType.syncUnregisterEvent,false));this._methodObjectList[e]=d},registerEventEx:function(g,e,c,d,b){var a=Function._validateParams(arguments,[{name:"eventName",type:String,mayBeNull:false},{name:"registerMethod",type:Function,mayBeNull:false},{name:"registerMethodInvokeType",type:Number,mayBeNull:false},{name:"unregisterMethod",type:Function,mayBeNull:false},{name:"unregisterMethodInvokeType",type:Number,mayBeNull:false}]);if(a)throw a;var f=new Microsoft.Office.Common.EventMethodObject(new Microsoft.Office.Common.MethodObject(e,c,false),new Microsoft.Office.Common.MethodObject(d,b,false));this._methodObjectList[g]=f},unregisterEvent:function(b){var a=Function._validateParams(arguments,[{name:"eventName",type:String,mayBeNull:false}]);if(a)throw a;this.unregisterMethod(b)},registerConversation:function(c,f,a,e,b){var d=Function._validateParams(arguments,[{name:"conversationId",type:String,mayBeNull:false},{name:"conversationUrl",type:String,mayBeNull:false,optional:true},{name:"appDomains",type:Object,mayBeNull:true,optional:true},{name:"serializerVersion",type:Number,mayBeNull:true,optional:true},{name:"addInSourceLocationSubdomainAllowedIsEnabled",type:Boolean,mayBeNull:true,optional:true}]);if(d)throw d;if(b)this._addInSourceLocationSubdomainAllowedIsEnabled=b;if(a){if(!(a instanceof Array))throw OsfMsAjaxFactory.msAjaxError.argument("appDomains");this._appDomains[c]=a}this._conversations[c]={url:f,serializerVersion:e}},unregisterConversation:function(b){var a=Function._validateParams(arguments,[{name:"conversationId",type:String,mayBeNull:false}]);if(a)throw a;delete this._conversations[b]},setPolicyManager:function(a){var b=Function._validateParams(arguments,[{name:"policyManager",type:Object,mayBeNull:false}]);if(b)throw b;if(!a.checkPermission)throw OsfMsAjaxFactory.msAjaxError.argument("policyManager");this._policyManager=a},getPolicyManager:function(){return this._policyManager},dispose:function(){this._methodObjectList=null;this._eventHandlerProxyList=null;this._Id=null;this._conversations=null;this._policyManager=null;this._appDomains=null;this._onHandleRequestError=null}};Microsoft.Office.Common.ClientEndPoint=function(d,a,e,b){var c=Function._validateParams(arguments,[{name:"conversationId",type:String,mayBeNull:false},{name:"targetWindow",mayBeNull:false},{name:"targetUrl",type:String,mayBeNull:false},{name:"serializerVersion",type:Number,mayBeNull:true,optional:true}]);if(c)throw c;try{if(!a.postMessage)throw OsfMsAjaxFactory.msAjaxError.argument("targetWindow");}catch(f){if(!Object.prototype.hasOwnProperty.call(a,"postMessage"))throw OsfMsAjaxFactory.msAjaxError.argument("targetWindow");}this._conversationId=d;this._targetWindow=a;this._targetUrl=e;this._callingIndex=0;this._callbackList={};this._eventHandlerList={};if(b!=null)this._serializerVersion=b;else this._serializerVersion=OSF.SerializerVersion.Browser};Microsoft.Office.Common.ClientEndPoint.prototype={invoke:function(f,c,a){var e=Function._validateParams(arguments,[{name:"targetMethodName",type:String,mayBeNull:false},{name:"callback",type:Function,mayBeNull:true},{name:"param",mayBeNull:true}]);if(e)throw e;var b=this._callingIndex++,i=new Date,d={callback:c,createdOn:i.getTime()};if(a&&typeof a==="object"&&typeof a.__timeout__==="number"){d.timeout=a.__timeout__;delete a.__timeout__}this._callbackList[b]=d;try{var g=new Microsoft.Office.Common.Request(f,Microsoft.Office.Common.ActionType.invoke,this._conversationId,b,a),h=Microsoft.Office.Common.MessagePackager.envelope(g,this._serializerVersion);this._targetWindow.postMessage(h,this._targetUrl);Microsoft.Office.Common.XdmCommunicationManager._startMethodTimeoutTimer()}catch(j){try{c!==null&&c(Microsoft.Office.Common.InvokeResultCode.errorInRequest,j)}finally{delete this._callbackList[b]}}},registerForEvent:function(c,e,b,g){var d=Function._validateParams(arguments,[{name:"targetEventName",type:String,mayBeNull:false},{name:"eventHandler",type:Function,mayBeNull:false},{name:"callback",type:Function,mayBeNull:true},{name:"data",mayBeNull:true,optional:true}]);if(d)throw d;var a=this._callingIndex++,i=new Date;this._callbackList[a]={callback:b,createdOn:i.getTime()};try{var f=new Microsoft.Office.Common.Request(c,Microsoft.Office.Common.ActionType.registerEvent,this._conversationId,a,g),h=Microsoft.Office.Common.MessagePackager.envelope(f,this._serializerVersion);this._targetWindow.postMessage(h,this._targetUrl);Microsoft.Office.Common.XdmCommunicationManager._startMethodTimeoutTimer();this._eventHandlerList[c]=e}catch(j){try{b!==null&&b(Microsoft.Office.Common.InvokeResultCode.errorInRequest,j)}finally{delete this._callbackList[a]}}},unregisterForEvent:function(c,b,f){var d=Function._validateParams(arguments,[{name:"targetEventName",type:String,mayBeNull:false},{name:"callback",type:Function,mayBeNull:true},{name:"data",mayBeNull:true,optional:true}]);if(d)throw d;var a=this._callingIndex++,h=new Date;this._callbackList[a]={callback:b,createdOn:h.getTime()};try{var e=new Microsoft.Office.Common.Request(c,Microsoft.Office.Common.ActionType.unregisterEvent,this._conversationId,a,f),g=Microsoft.Office.Common.MessagePackager.envelope(e,this._serializerVersion);this._targetWindow.postMessage(g,this._targetUrl);Microsoft.Office.Common.XdmCommunicationManager._startMethodTimeoutTimer()}catch(i){try{b!==null&&b(Microsoft.Office.Common.InvokeResultCode.errorInRequest,i)}finally{delete this._callbackList[a]}}finally{delete this._eventHandlerList[c]}}};Microsoft.Office.Common.XdmCommunicationManager=function(){var i=[],h=null,c=null,k=10,e=false,d=null,q=2e3,j=65e3,m=j,b={},a={},n=false;function s(c){for(var a in b)if(b[a]._conversations[c])return b[a];OsfMsAjaxFactory.msAjaxDebug.trace("Unknown conversation Id.");throw OsfMsAjaxFactory.msAjaxError.argument("conversationId");}function t(c){var b=a[c];!b&&OsfMsAjaxFactory.msAjaxDebug.trace("Unknown conversation Id.");return b}function w(d,b){var a=d._methodObjectList[b._actionName];if(!a){OsfMsAjaxFactory.msAjaxDebug.trace("The specified method is not registered on service endpoint:"+b._actionName);throw OsfMsAjaxFactory.msAjaxError.argument("messageObject");}var c=null;if(b._actionType===Microsoft.Office.Common.ActionType.invoke)c=a;else if(b._actionType===Microsoft.Office.Common.ActionType.registerEvent)c=a.getRegisterMethodObject();else c=a.getUnregisterMethodObject();return c}function z(a){i.push(a)}function y(){if(c!==null){if(!e)if(i.length>0){var a=i.shift();l(a)}else{clearInterval(c);c=null}}else OsfMsAjaxFactory.msAjaxDebug.trace("channel is not ready.")}function l(a){e=a.getInvokeBlockingFlag();a.invoke();h=+new Date}function v(){if(d){var c,f=0,i=new Date,e;for(var h in a){c=a[h];for(var g in c._callbackList){var b=c._callbackList[g];e=b.timeout?b.timeout:m;if(e>=0&&Math.abs(i.getTime()-b.createdOn)>=e)try{b.callback&&b.callback(Microsoft.Office.Common.InvokeResultCode.errorHandlingMethodCallTimedout,null)}finally{delete c._callbackList[g]}else f++}}if(f===0){clearInterval(d);d=null}}else OsfMsAjaxFactory.msAjaxDebug.trace("channel is not ready.")}function u(){e=false}function x(a){if(window.addEventListener)window.addEventListener("message",a,false);else if(navigator.userAgent.indexOf("MSIE")>-1&&window.attachEvent)window.attachEvent("onmessage",a);else{OsfMsAjaxFactory.msAjaxDebug.trace("Browser doesn't support the required API.");throw OsfMsAjaxFactory.msAjaxError.argument("Browser");}}function A(c,d){var e=false;if(c===true)return true;if(!c||!d||!c.length||!d.length)return e;var b,a;b=document.createElement("a");a=document.createElement("a");b.href=c;a.href=d;e=p(b,a);delete b,a;return e}function g(a,f){var b=false;if(!f||!f.length||!a||!(a instanceof Array)||!a.length)return b;var e=document.createElement("a"),d=document.createElement("a");e.href=f;for(var c=0;c<a.length&&!b;c++)if(a[c].indexOf("://")!==-1){d.href=a[c];b=p(e,d)}delete e,d;return b}function r(c){var a=["^office-int\\.com$","^officeapps\\.live-int\\.com$","^.*\\.dod\\.online\\.office365\\.us$","^.*\\.gov\\.online\\.office365\\.us$","^.*\\.officeapps\\.live\\.com$","^.*\\.officeapps\\.live-int\\.com$","^.*\\.officeapps-df\\.live\\.com$","^.*\\.online\\.office\\.de$","^.*\\.partner\\.officewebapps\\.cn$","^"+document.domain.replace(new RegExp("\\.","g"),"\\.")+"$"],b=new RegExp(a.join("|"));return b.test(c)}function f(e,f){if(!e||!f)return false;var b=document.createElement("a");b.href=e;var c=document.createElement("a");c.href=f;var j=b.protocol===c.protocol,k=b.port===c.port,d=c.hostname,a=b.hostname,g=d===a,h=false;if(!g&&d.length>a.length+1)h=d.slice(-(a.length+1))==="."+a;var i=g||h;return k&&j&&i}function p(a,b){return a.hostname==b.hostname&&a.protocol==b.protocol&&a.port==b.port}function B(b){if(!OSF)return;if(b.data!=""){var a,i=OSF.SerializerVersion.Browser,I=b.data;try{a=Microsoft.Office.Common.MessagePackager.unenvelope(I,OSF.SerializerVersion.Browser);i=a._serializerVersion!=null?a._serializerVersion:i}catch(M){return}if(a._messageType===Microsoft.Office.Common.MessageType.request){var B=b.origin==null||b.origin=="null"?a._origin:b.origin;try{var d=s(a._conversationId),m=d._conversations[a._conversationId];i=m.serializerVersion!=null?m.serializerVersion:i;var q=[m.url].concat(d._appDomains[a._conversationId]);if(!g(q,b.origin))if(!OfficeExt.appSpecificCheckOrigin(q,b,a._origin,g)){var H=d._addInSourceLocationSubdomainAllowedIsEnabled&&f(m.url,b.origin);if(!H)throw"Failed origin check";}var x=d.getPolicyManager();if(x&&!x.checkPermission(a._conversationId,a._actionName,a._data))throw"Access Denied";var L=w(d,a),G=new Microsoft.Office.Common.InvokeCompleteCallback(b.source,B,a._actionName,a._conversationId,a._correlationId,u,i),E=new Microsoft.Office.Common.Invoker(L,a._data,G,d._eventHandlerProxyList,a._conversationId,a._actionName,i),C=true;if(c==null)if((h==null||+new Date-h>k)&&!e){l(E);C=false}else c=setInterval(y,k);C&&z(E)}catch(M){d&&d._onHandleRequestError&&d._onHandleRequestError(a,M);var D=Microsoft.Office.Common.InvokeResultCode.errorHandlingRequest;if(M=="Access Denied")D=Microsoft.Office.Common.InvokeResultCode.errorHandlingRequestAccessDenied;var K=new Microsoft.Office.Common.Response(a._actionName,a._conversationId,a._correlationId,D,Microsoft.Office.Common.ResponseType.forCalling,M),J=Microsoft.Office.Common.MessagePackager.envelope(K,i),v=false;try{v=!!(b.source&&b.source.postMessage)}catch(M){}var o=false;if(window.location.href&&b.origin&&f(window.location.href,b.origin))o=true;else if(b.origin){var F=document.createElement("a");F.href=b.origin;o=r(F.hostname)}v&&o&&b.source.postMessage(J,B)}}else if(a._messageType===Microsoft.Office.Common.MessageType.response){var j=t(a._conversationId);if(!j)return;j._serializerVersion=i;if(!A(j._targetUrl,b.origin))throw"Failed orgin check";if(a._responseType===Microsoft.Office.Common.ResponseType.forCalling){var n=j._callbackList[a._correlationId];if(n)try{n.callback&&n.callback(a._errorCode,a._data)}finally{delete j._callbackList[a._correlationId]}}else{var p=j._eventHandlerList[a._actionName];p!==undefined&&p!==null&&p(a._data)}}else return}}function o(){if(!n){x(B);n=true}}return{connect:function(c,e,f,d){var b=a[c];if(!b){o();b=new Microsoft.Office.Common.ClientEndPoint(c,e,f,d);a[c]=b}return b},getClientEndPoint:function(c){var b=Function._validateParams(arguments,[{name:"conversationId",type:String,mayBeNull:false}]);if(b)throw b;return a[c]},createServiceEndPoint:function(a){o();var c=new Microsoft.Office.Common.ServiceEndPoint(a);b[a]=c;return c},getServiceEndPoint:function(c){var a=Function._validateParams(arguments,[{name:"serviceEndPointId",type:String,mayBeNull:false}]);if(a)throw a;return b[c]},deleteClientEndPoint:function(c){var b=Function._validateParams(arguments,[{name:"conversationId",type:String,mayBeNull:false}]);if(b)throw b;delete a[c]},deleteServiceEndPoint:function(c){var a=Function._validateParams(arguments,[{name:"serviceEndPointId",type:String,mayBeNull:false}]);if(a)throw a;delete b[c]},checkUrlWithAppDomains:function(a,b){return g(a,b)},isTargetSubdomainOfSourceLocation:function(a,b){return f(a,b)},_setMethodTimeout:function(a){var b=Function._validateParams(arguments,[{name:"methodTimeout",type:Number,mayBeNull:false}]);if(b)throw b;m=a<=0?j:a},_startMethodTimeoutTimer:function(){if(!d)d=setInterval(v,q)}}}();Microsoft.Office.Common.Message=function(e,f,c,d,a){var b=Function._validateParams(arguments,[{name:"messageType",type:Number,mayBeNull:false},{name:"actionName",type:String,mayBeNull:false},{name:"conversationId",type:String,mayBeNull:false},{name:"correlationId",mayBeNull:false},{name:"data",mayBeNull:true,optional:true}]);if(b)throw b;this._messageType=e;this._actionName=f;this._conversationId=c;this._correlationId=d;this._origin=window.location.href;if(typeof a=="undefined")this._data=null;else this._data=a};Microsoft.Office.Common.Message.prototype={getActionName:function(){return this._actionName},getConversationId:function(){return this._conversationId},getCorrelationId:function(){return this._correlationId},getOrigin:function(){return this._origin},getData:function(){return this._data},getMessageType:function(){return this._messageType}};Microsoft.Office.Common.Request=function(c,d,a,b,e){Microsoft.Office.Common.Request.uber.constructor.call(this,Microsoft.Office.Common.MessageType.request,c,a,b,e);this._actionType=d};OSF.OUtil.extend(Microsoft.Office.Common.Request,Microsoft.Office.Common.Message);Microsoft.Office.Common.Request.prototype.getActionType=function(){return this._actionType};Microsoft.Office.Common.Response=function(d,a,b,e,c,f){Microsoft.Office.Common.Response.uber.constructor.call(this,Microsoft.Office.Common.MessageType.response,d,a,b,f);this._errorCode=e;this._responseType=c};OSF.OUtil.extend(Microsoft.Office.Common.Response,Microsoft.Office.Common.Message);Microsoft.Office.Common.Response.prototype.getErrorCode=function(){return this._errorCode};Microsoft.Office.Common.Response.prototype.getResponseType=function(){return this._responseType};Microsoft.Office.Common.MessagePackager={envelope:function(a,b){if(typeof a==="object")a._serializerVersion=OSF.SerializerVersion.Browser;return JSON.stringify(a)},unenvelope:function(a,b){return JSON.parse(a)}};Microsoft.Office.Common.ResponseSender=function(d,g,i,e,f,h,c){var b=Function._validateParams(arguments,[{name:"requesterWindow",mayBeNull:false},{name:"requesterUrl",type:String,mayBeNull:false},{name:"actionName",type:String,mayBeNull:false},{name:"conversationId",type:String,mayBeNull:false},{name:"correlationId",mayBeNull:false},{name:"responsetype",type:Number,maybeNull:false},{name:"serializerVersion",type:Number,maybeNull:true,optional:true}]);if(b)throw b;this._requesterWindow=d;this._requesterUrl=g;this._actionName=i;this._conversationId=e;this._correlationId=f;this._invokeResultCode=Microsoft.Office.Common.InvokeResultCode.noError;this._responseType=h;var a=this;this._send=function(e){try{var d=new Microsoft.Office.Common.Response(a._actionName,a._conversationId,a._correlationId,a._invokeResultCode,a._responseType,e),b=Microsoft.Office.Common.MessagePackager.envelope(d,c);a._requesterWindow.postMessage(b,a._requesterUrl)}catch(f){OsfMsAjaxFactory.msAjaxDebug.trace("ResponseSender._send error:"+f.message)}}};Microsoft.Office.Common.ResponseSender.prototype={getRequesterWindow:function(){return this._requesterWindow},getRequesterUrl:function(){return this._requesterUrl},getActionName:function(){return this._actionName},getConversationId:function(){return this._conversationId},getCorrelationId:function(){return this._correlationId},getSend:function(){return this._send},setResultCode:function(a){this._invokeResultCode=a}};Microsoft.Office.Common.InvokeCompleteCallback=function(d,g,h,e,f,c,b){Microsoft.Office.Common.InvokeCompleteCallback.uber.constructor.call(this,d,g,h,e,f,Microsoft.Office.Common.ResponseType.forCalling,b);this._postCallbackHandler=c;var a=this;this._send=function(f,c){if(c!=undefined)a._invokeResultCode=c;try{var e=new Microsoft.Office.Common.Response(a._actionName,a._conversationId,a._correlationId,a._invokeResultCode,a._responseType,f),d=Microsoft.Office.Common.MessagePackager.envelope(e,b);a._requesterWindow.postMessage(d,a._requesterUrl);a._postCallbackHandler()}catch(g){OsfMsAjaxFactory.msAjaxDebug.trace("InvokeCompleteCallback._send error:"+g.message)}}};OSF.OUtil.extend(Microsoft.Office.Common.InvokeCompleteCallback,Microsoft.Office.Common.ResponseSender);Microsoft.Office.Common.Invoker=function(f,g,b,c,e,h,d){var a=Function._validateParams(arguments,[{name:"methodObject",mayBeNull:false},{name:"paramValue",mayBeNull:true},{name:"invokeCompleteCallback",mayBeNull:false},{name:"eventHandlerProxyList",mayBeNull:true},{name:"conversationId",type:String,mayBeNull:false},{name:"eventName",type:String,mayBeNull:false},{name:"serializerVersion",type:Number,mayBeNull:true,optional:true}]);if(a)throw a;this._methodObject=f;this._param=g;this._invokeCompleteCallback=b;this._eventHandlerProxyList=c;this._conversationId=e;this._eventName=h;this._serializerVersion=d};Microsoft.Office.Common.Invoker.prototype={invoke:function(){try{var a;switch(this._methodObject.getInvokeType()){case Microsoft.Office.Common.InvokeType.async:this._methodObject.getMethod()(this._param,this._invokeCompleteCallback.getSend());break;case Microsoft.Office.Common.InvokeType.sync:a=this._methodObject.getMethod()(this._param);this._invokeCompleteCallback.getSend()(a);break;case Microsoft.Office.Common.InvokeType.syncRegisterEvent:var c=this._createEventHandlerProxyObject(this._invokeCompleteCallback);a=this._methodObject.getMethod()(c.getSend(),this._param);this._eventHandlerProxyList[this._conversationId+this._eventName]=c.getSend();this._invokeCompleteCallback.getSend()(a);break;case Microsoft.Office.Common.InvokeType.syncUnregisterEvent:var e=this._eventHandlerProxyList[this._conversationId+this._eventName];a=this._methodObject.getMethod()(e,this._param);delete this._eventHandlerProxyList[this._conversationId+this._eventName];this._invokeCompleteCallback.getSend()(a);break;case Microsoft.Office.Common.InvokeType.asyncRegisterEvent:var b=this._createEventHandlerProxyObject(this._invokeCompleteCallback);this._methodObject.getMethod()(b.getSend(),this._invokeCompleteCallback.getSend(),this._param);this._eventHandlerProxyList[this._callerId+this._eventName]=b.getSend();break;case Microsoft.Office.Common.InvokeType.asyncUnregisterEvent:var d=this._eventHandlerProxyList[this._callerId+this._eventName];this._methodObject.getMethod()(d,this._invokeCompleteCallback.getSend(),this._param);delete this._eventHandlerProxyList[this._callerId+this._eventName];break;default:break}}catch(f){this._invokeCompleteCallback.setResultCode(Microsoft.Office.Common.InvokeResultCode.errorInResponse);this._invokeCompleteCallback.getSend()(f)}},getInvokeBlockingFlag:function(){return this._methodObject.getBlockingFlag()},_createEventHandlerProxyObject:function(a){return new Microsoft.Office.Common.ResponseSender(a.getRequesterWindow(),a.getRequesterUrl(),a.getActionName(),a.getConversationId(),a.getCorrelationId(),Microsoft.Office.Common.ResponseType.forEventing,this._serializerVersion)}};OSF.OUtil.setNamespace("WAC",OSF.DDA);OSF.DDA.WAC.UniqueArguments={Data:"Data",Properties:"Properties",BindingRequest:"DdaBindingsMethod",BindingResponse:"Bindings",SingleBindingResponse:"singleBindingResponse",GetData:"DdaGetBindingData",AddRowsColumns:"DdaAddRowsColumns",SetData:"DdaSetBindingData",ClearFormats:"DdaClearBindingFormats",SetFormats:"DdaSetBindingFormats",SettingsRequest:"DdaSettingsMethod",BindingEventSource:"ddaBinding",ArrayData:"ArrayData"};OSF.OUtil.setNamespace("Delegate",OSF.DDA.WAC);OSF.DDA.WAC.Delegate.SpecialProcessor=function(){var a=[OSF.DDA.WAC.UniqueArguments.SingleBindingResponse,OSF.DDA.WAC.UniqueArguments.BindingRequest,OSF.DDA.WAC.UniqueArguments.BindingResponse,OSF.DDA.WAC.UniqueArguments.GetData,OSF.DDA.WAC.UniqueArguments.AddRowsColumns,OSF.DDA.WAC.UniqueArguments.SetData,OSF.DDA.WAC.UniqueArguments.ClearFormats,OSF.DDA.WAC.UniqueArguments.SetFormats,OSF.DDA.WAC.UniqueArguments.SettingsRequest,OSF.DDA.WAC.UniqueArguments.BindingEventSource],b={};OSF.DDA.WAC.Delegate.SpecialProcessor.uber.constructor.call(this,a,b)};OSF.OUtil.extend(OSF.DDA.WAC.Delegate.SpecialProcessor,OSF.DDA.SpecialProcessor);OSF.DDA.WAC.Delegate.ParameterMap=OSF.DDA.getDecoratedParameterMap(new OSF.DDA.WAC.Delegate.SpecialProcessor,[]);OSF.OUtil.setNamespace("WAC",OSF.DDA);OSF.OUtil.setNamespace("Delegate",OSF.DDA.WAC);OSF.DDA.WAC.getDelegateMethods=function(){var a={};a[OSF.DDA.DispIdHost.Delegates.ExecuteAsync]=OSF.DDA.WAC.Delegate.executeAsync;a[OSF.DDA.DispIdHost.Delegates.RegisterEventAsync]=OSF.DDA.WAC.Delegate.registerEventAsync;a[OSF.DDA.DispIdHost.Delegates.UnregisterEventAsync]=OSF.DDA.WAC.Delegate.unregisterEventAsync;a[OSF.DDA.DispIdHost.Delegates.OpenDialog]=OSF.DDA.WAC.Delegate.openDialog;a[OSF.DDA.DispIdHost.Delegates.MessageParent]=OSF.DDA.WAC.Delegate.messageParent;a[OSF.DDA.DispIdHost.Delegates.SendMessage]=OSF.DDA.WAC.Delegate.sendMessage;a[OSF.DDA.DispIdHost.Delegates.CloseDialog]=OSF.DDA.WAC.Delegate.closeDialog;return a};OSF.DDA.WAC.Delegate.version=1;OSF.DDA.WAC.Delegate.executeAsync=function(a){if(!a.hostCallArgs)a.hostCallArgs={};a.hostCallArgs.DdaMethod={ControlId:OSF._OfficeAppFactory.getId(),Version:OSF.DDA.WAC.Delegate.version,DispatchId:a.dispId};a.hostCallArgs.__timeout__=-1;a.onCalling&&a.onCalling();if(!OSF.getClientEndPoint())return;OSF.getClientEndPoint().invoke("executeMethod",function(d,c){a.onReceiving&&a.onReceiving();var b;if(d==Microsoft.Office.Common.InvokeResultCode.noError){OSF.DDA.WAC.Delegate.version=c.Version;b=c.Error}else switch(d){case Microsoft.Office.Common.InvokeResultCode.errorHandlingRequestAccessDenied:b=OSF.DDA.ErrorCodeManager.errorCodes.ooeNoCapability;break;default:b=OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError;break}if(a.onComplete)a.onComplete(b,c)},a.hostCallArgs)};OSF.DDA.WAC.Delegate._getOnAfterRegisterEvent=function(c,a){var b=+new Date;return function(f,e){a.onReceiving&&a.onReceiving();var d;if(f!=Microsoft.Office.Common.InvokeResultCode.noError)switch(f){case Microsoft.Office.Common.InvokeResultCode.errorHandlingRequestAccessDenied:d=OSF.DDA.ErrorCodeManager.errorCodes.ooeNoCapability;break;default:d=OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError;break}else if(e)if(e.Error)d=e.Error;else d=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess;else d=OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError;if(a.onComplete)a.onComplete(d);if(OSF.AppTelemetry)OSF.AppTelemetry.onRegisterDone(c,a.dispId,Math.abs(+new Date-b),d)}};OSF.DDA.WAC.Delegate.registerEventAsync=function(a){a.onCalling&&a.onCalling();if(!OSF.getClientEndPoint())return;OSF.getClientEndPoint().registerForEvent(OSF.DDA.getXdmEventName(a.targetId,a.eventType),function(b){if(a.onEvent)a.onEvent(b);if(OSF.AppTelemetry)OSF.AppTelemetry.onEventDone(a.dispId)},OSF.DDA.WAC.Delegate._getOnAfterRegisterEvent(true,a),{controlId:OSF._OfficeAppFactory.getId(),eventDispId:a.dispId,targetId:a.targetId})};OSF.DDA.WAC.Delegate.unregisterEventAsync=function(a){a.onCalling&&a.onCalling();if(!OSF.getClientEndPoint())return;OSF.getClientEndPoint().unregisterForEvent(OSF.DDA.getXdmEventName(a.targetId,a.eventType),OSF.DDA.WAC.Delegate._getOnAfterRegisterEvent(false,a),{controlId:OSF._OfficeAppFactory.getId(),eventDispId:a.dispId,targetId:a.targetId})};OSF.OUtil.setNamespace("WebApp",OSF);OSF.WebApp.AddHostInfoAndXdmInfo=function(a){if(OSF._OfficeAppFactory.getWindowLocationSearch&&OSF._OfficeAppFactory.getWindowLocationHash)return a+OSF._OfficeAppFactory.getWindowLocationSearch()+OSF._OfficeAppFactory.getWindowLocationHash();else return a};OSF.WebApp._UpdateLinksForHostAndXdmInfo=function(){for(var b=document.querySelectorAll("a[data-officejs-navigate]"),a=0;a<b.length;a++)if(OSF.WebApp._isGoodUrl(b[a].href))b[a].href=OSF.WebApp.AddHostInfoAndXdmInfo(b[a].href);for(var d=document.querySelectorAll("form[data-officejs-navigate]"),a=0;a<d.length;a++){var c=d[a];if(OSF.WebApp._isGoodUrl(c.action))c.action=OSF.WebApp.AddHostInfoAndXdmInfo(c.action)}};OSF.WebApp._isGoodUrl=function(a){if(typeof a=="undefined")return false;a=a.trim();var d=a.indexOf(":"),b=d>0?a.substr(0,d):null,c=b!==null?b.toLowerCase()==="http"||b.toLowerCase()==="https":true;c=c&&a!="#"&&a!="/"&&a!=""&&a!=OSF._OfficeAppFactory.getWebAppState().webAppUrl;return c};OSF.InitializationHelper=function(d,a,f,e,b){this._hostInfo=d;this._webAppState=a;this._context=f;this._settings=e;this._hostFacade=b;this._appContext={};this._tabbableElements="a[href]:not([tabindex='-1']),area[href]:not([tabindex='-1']),button:not([disabled]):not([tabindex='-1']),input:not([disabled]):not([tabindex='-1']),select:not([disabled]):not([tabindex='-1']),textarea:not([disabled]):not([tabindex='-1']),*[tabindex]:not([tabindex='-1']),*[contenteditable]:not([disabled]):not([tabindex='-1'])";this._initializeSettings=function(g,f){var d,b=g.get_settings(),c=OSF.OUtil.getSessionStorage();if(c){var a=c.getItem(OSF._OfficeAppFactory.getCachedSessionSettingsKey());if(a)b=JSON.parse(a);else{a=JSON.stringify(b);c.setItem(OSF._OfficeAppFactory.getCachedSessionSettingsKey(),a)}}var e=OSF.DDA.SettingsManager.deserializeSettings(b);if(f)d=new OSF.DDA.RefreshableSettings(e);else d=new OSF.DDA.Settings(e);return d};var c=function(a){var b=window.open;a.open=function(e,d,c){var a=null;try{a=b(e,d,c)}catch(g){OSF.AppTelemetry&&OSF.AppTelemetry.logAppCommonMessage("Exception happens at windowOpen."+g)}if(!a){var f={strUrl:e,strWindowName:d,strWindowFeatures:c};OSF._OfficeAppFactory.getClientEndPoint()&&OSF._OfficeAppFactory.getClientEndPoint().invoke("ContextActivationManager_openWindowInHost",null,f)}return a}};c(window)};OSF.InitializationHelper.prototype.saveAndSetDialogInfo=function(a){var d=function(){var a=OSF.OUtil.parseXdmInfo(true);if(a){var b=a.split("|");return b[1]}return null},b=OSF.OUtil.getSessionStorage();if(b){if(!a)a=OSF.OUtil.parseHostInfoFromWindowName(true,OSF._OfficeAppFactory.getWindowName());if(a&&a.indexOf("isDialog")>-1){var c=d();c!=null&&b.setItem(c+"IsDialog","true");this._hostInfo.isDialog=true;return}this._hostInfo.isDialog=b.getItem(OSF.OUtil.getXdmFieldValue(OSF.XdmFieldName.AppId,false)+"IsDialog")!=null?true:false}};OSF.InitializationHelper.prototype.getAppContext=function(e,c){var a=this,b=function(i,b){var e;if(b._appName===OSF.AppName.ExcelWebApp){var f=b._settings;e={};for(var p in f){var k=f[p];e[k[0]]=k[1]}}else e=b._settings;if(b._appName===OSF.AppName.OutlookWebApp&&!!b._requirementMatrix&&b._requirementMatrix.indexOf("react")==-1)OSF.AgaveHostAction.SendTelemetryEvent=undefined;if(!a._hostInfo.isDialog||window.opener==null){var o=window.location.href;a._webAppState.clientEndPoint.invoke("ContextActivationManager_notifyHost",null,[a._webAppState.id,OSF.AgaveHostAction.UpdateTargetUrl,o])}if(i===0&&b._id!=undefined&&b._appName!=undefined&&b._appVersion!=undefined&&b._appUILocale!=undefined&&b._dataLocale!=undefined&&b._docUrl!=undefined&&b._clientMode!=undefined&&b._settings!=undefined&&b._reason!=undefined){a._appContext=b;var m=b._appInstanceId?b._appInstanceId:b._id,n=false,l=true,h=0;if(b._appMinorVersion!=undefined)h=b._appMinorVersion;var g=undefined;if(b._requirementMatrix!=undefined)g=b._requirementMatrix;b.eToken=b.eToken?b.eToken:"";var d=new OSF.OfficeAppContext(b._id,b._appName,b._appVersion,b._appUILocale,b._dataLocale,b._docUrl,b._clientMode,e,b._reason,b._osfControlType,b._eToken,b._correlationId,m,n,l,h,g,b._hostCustomMessage,b._hostFullVersion,b._clientWindowHeight,b._clientWindowWidth,b._addinName,b._appDomains,b._dialogRequirementMatrix,b._featureGates);d._wacHostEnvironment=b._wacHostEnvironment||"0";d._isFromWacAutomation=!!b._isFromWacAutomation;OSF.AppTelemetry&&OSF.AppTelemetry.initialize(d);c(d)}else{var j="Function ContextActivationManager_getAppContextAsync call failed. ErrorCode is "+i+", exception: "+b;OSF.AppTelemetry&&OSF.AppTelemetry.logAppException(j);throw j;}};try{if(this._hostInfo.isDialog&&window.opener!=null){var d=OfficeExt.WACUtils.parseAppContextFromWindowName(false,OSF._OfficeAppFactory.getWindowName());b(0,d)}else this._webAppState.clientEndPoint.invoke("ContextActivationManager_getAppContextAsync",b,this._webAppState.id)}catch(f){OSF.AppTelemetry&&OSF.AppTelemetry.logAppException("Exception thrown when trying to invoke getAppContextAsync. Exception:["+f+"]");throw f;}};OSF.InitializationHelper.prototype.setAgaveHostCommunication=function(){try{var a=this,c=OSF.OUtil.parseXdmInfoWithGivenFragment(false,OSF._OfficeAppFactory.getWindowLocationHash());if(!c&&OSF._OfficeAppFactory.getWindowName)c=OSF.OUtil.parseXdmInfoFromWindowName(false,OSF._OfficeAppFactory.getWindowName());if(c){var b=OSF.OUtil.getInfoItems(c);if(b!=undefined&&b.length>=3){a._webAppState.conversationID=b[0];a._webAppState.id=b[1];a._webAppState.webAppUrl=b[2].indexOf(":")>=0?b[2]:decodeURIComponent(b[2])}}a._webAppState.wnd=window.opener!=null?window.opener:window.parent;var d=OSF.OUtil.parseSerializerVersionWithGivenFragment(false,OSF._OfficeAppFactory.getWindowLocationHash());if(isNaN(d)&&OSF._OfficeAppFactory.getWindowName)d=OSF.OUtil.parseSerializerVersionFromWindowName(false,OSF._OfficeAppFactory.getWindowName());a._webAppState.serializerVersion=d;if(this._hostInfo.isDialog&&window.opener!=null)return;a._webAppState.clientEndPoint=Microsoft.Office.Common.XdmCommunicationManager.connect(a._webAppState.conversationID,a._webAppState.wnd,a._webAppState.webAppUrl,a._webAppState.serializerVersion);a._webAppState.serviceEndPoint=Microsoft.Office.Common.XdmCommunicationManager.createServiceEndPoint(a._webAppState.id);var e=a._webAppState.conversationID+OSF.SharedConstants.NotificationConversationIdSuffix;a._webAppState.serviceEndPoint.registerConversation(e,a._webAppState.webAppUrl);var f=function(b){switch(b){case OSF.AgaveHostAction.Select:a._webAppState.focused=true;break;case OSF.AgaveHostAction.UnSelect:a._webAppState.focused=false;break;case OSF.AgaveHostAction.TabIn:case OSF.AgaveHostAction.CtrlF6In:window.focus();var d=document.querySelectorAll(a._tabbableElements),c=OSF.OUtil.focusToFirstTabbable(d,false);if(!c){window.blur();a._webAppState.focused=false;a._webAppState.clientEndPoint.invoke("ContextActivationManager_notifyHost",null,[a._webAppState.id,OSF.AgaveHostAction.ExitNoFocusable])}break;case OSF.AgaveHostAction.TabInShift:window.focus();var d=document.querySelectorAll(a._tabbableElements),c=OSF.OUtil.focusToFirstTabbable(d,true);if(!c){window.blur();a._webAppState.focused=false;a._webAppState.clientEndPoint.invoke("ContextActivationManager_notifyHost",null,[a._webAppState.id,OSF.AgaveHostAction.ExitNoFocusableShift])}break;default:OsfMsAjaxFactory.msAjaxDebug.trace("actionId "+b+" notifyAgave is wrong.");break}};a._webAppState.serviceEndPoint.registerMethod("Office_notifyAgave",f,Microsoft.Office.Common.InvokeType.async,false);a.addOrRemoveEventListenersForWindow(true)}catch(g){OSF.AppTelemetry&&OSF.AppTelemetry.logAppException("Exception thrown in setAgaveHostCommunication. Exception:["+g+"]");throw g;}};OSF.InitializationHelper.prototype.addOrRemoveEventListenersForWindow=function(f){var a=this,d=function(){if(!a._webAppState.focused)a._webAppState.focused=true;a._webAppState.clientEndPoint.invoke("ContextActivationManager_notifyHost",null,[a._webAppState.id,OSF.AgaveHostAction.Select])},e=function(){if(!OSF)return;if(a._webAppState.focused)a._webAppState.focused=false;a._webAppState.clientEndPoint.invoke("ContextActivationManager_notifyHost",null,[a._webAppState.id,OSF.AgaveHostAction.UnSelect])},c=function(b){b.preventDefault=b.preventDefault||function(){b.returnValue=false};if(b.keyCode==117&&(b.ctrlKey||b.metaKey)){var d=OSF.AgaveHostAction.CtrlF6Exit;if(b.shiftKey)d=OSF.AgaveHostAction.CtrlF6ExitShift;a._webAppState.clientEndPoint.invoke("ContextActivationManager_notifyHost",null,[a._webAppState.id,d])}else if(b.keyCode==9){b.preventDefault();var c=document.querySelectorAll(a._tabbableElements),e=OSF.OUtil.focusToNextTabbable(c,b.target||b.srcElement,b.shiftKey);if(!e)if(a._hostInfo.isDialog)OSF.OUtil.focusToFirstTabbable(c,b.shiftKey);else if(b.shiftKey)a._webAppState.clientEndPoint.invoke("ContextActivationManager_notifyHost",null,[a._webAppState.id,OSF.AgaveHostAction.TabExitShift]);else a._webAppState.clientEndPoint.invoke("ContextActivationManager_notifyHost",null,[a._webAppState.id,OSF.AgaveHostAction.TabExit])}else if(b.keyCode==27){b.preventDefault();a.dismissDialogNotification&&a.dismissDialogNotification();a._webAppState.clientEndPoint.invoke("ContextActivationManager_notifyHost",null,[a._webAppState.id,OSF.AgaveHostAction.EscExit])}else if(b.keyCode==113){b.preventDefault();a._webAppState.clientEndPoint.invoke("ContextActivationManager_notifyHost",null,[a._webAppState.id,OSF.AgaveHostAction.F2Exit])}},b=function(a){if(a.keyCode==117&&a.ctrlKey)if(a.preventDefault)a.preventDefault();else a.returnValue=false};if(f){OSF.OUtil.addEventListener(window,"focus",d);OSF.OUtil.addEventListener(window,"blur",e);OSF.OUtil.addEventListener(window,"keydown",c);OSF.OUtil.addEventListener(window,"keypress",b)}else{OSF.OUtil.removeEventListener(window,"focus",d);OSF.OUtil.removeEventListener(window,"blur",e);OSF.OUtil.removeEventListener(window,"keydown",c);OSF.OUtil.removeEventListener(window,"keypress",b)}};OSF.InitializationHelper.prototype.initWebDialog=function(a){if(a.get_isDialog()){if(OSF.DDA.UI.ChildUI){var b=window.opener!=null;a.ui=new OSF.DDA.UI.ChildUI(b);if(b)this.registerMessageReceivedEventForWindowDialog&&this.registerMessageReceivedEventForWindowDialog()}}else if(OSF.DDA.UI.ParentUI){a.ui=new OSF.DDA.UI.ParentUI;OfficeExt.Container&&OSF.DDA.DispIdHost.addAsyncMethods(a.ui,[OSF.DDA.AsyncMethodNames.CloseContainerAsync])}};OSF.InitializationHelper.prototype.initWebAuth=function(a){if(OSF.DDA.Auth){a.auth=new OSF.DDA.Auth;OSF.DDA.DispIdHost.addAsyncMethods(a.auth,[OSF.DDA.AsyncMethodNames.GetAccessTokenAsync])}};OSF.InitializationHelper.prototype.initWebAuthImplicit=function(a){if(OSF.DDA.WebAuth){a.webAuth=new OSF.DDA.WebAuth;OSF.DDA.DispIdHost.addAsyncMethods(a.webAuth,[OSF.DDA.AsyncMethodNames.GetAuthContextAsync])}};OSF.getClientEndPoint=function(){var a=OSF._OfficeAppFactory.getInitializationHelper();return a._webAppState.clientEndPoint};OSF.InitializationHelper.prototype.prepareRightAfterWebExtensionInitialize=function(){if(this._hostInfo.isDialog){window.focus();var b=document.querySelectorAll(this._tabbableElements),a=OSF.OUtil.focusToFirstTabbable(b,false);if(!a){window.blur();this._webAppState.focused=false;this._webAppState.clientEndPoint&&this._webAppState.clientEndPoint.invoke("ContextActivationManager_notifyHost",null,[this._webAppState.id,OSF.AgaveHostAction.ExitNoFocusable])}}};OSF.CommonUI={HostButtonBorderColor:"#f5ba9d",HostButtonBackgroundColor:"#fcf0ed"};var OSFLog;(function(b){var a=function(){function a(a){this._table=a;this._fields={}}Object.defineProperty(a.prototype,"Fields",{"get":function(){return this._fields},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"Table",{"get":function(){return this._table},enumerable:true,configurable:true});a.prototype.SerializeFields=function(){};a.prototype.SetSerializedField=function(b,a){if(typeof a!=="undefined"&&a!==null)this._serializedFields[b]=a.toString()};a.prototype.SerializeRow=function(){this._serializedFields={};this.SetSerializedField("Table",this._table);this.SerializeFields();return JSON.stringify(this._serializedFields)};return a}();b.BaseUsageData=a;var d=function(b){__extends(a,b);function a(){b.call(this,"AppActivated")}Object.defineProperty(a.prototype,"CorrelationId",{"get":function(){return this.Fields.CorrelationId},"set":function(a){this.Fields.CorrelationId=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"SessionId",{"get":function(){return this.Fields.SessionId},"set":function(a){this.Fields.SessionId=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"AppId",{"get":function(){return this.Fields.AppId},"set":function(a){this.Fields.AppId=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"AppInstanceId",{"get":function(){return this.Fields.AppInstanceId},"set":function(a){this.Fields.AppInstanceId=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"AppURL",{"get":function(){return this.Fields.AppURL},"set":function(a){this.Fields.AppURL=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"AssetId",{"get":function(){return this.Fields.AssetId},"set":function(a){this.Fields.AssetId=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"Browser",{"get":function(){return this.Fields.Browser},"set":function(a){this.Fields.Browser=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"UserId",{"get":function(){return this.Fields.UserId},"set":function(a){this.Fields.UserId=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"Host",{"get":function(){return this.Fields.Host},"set":function(a){this.Fields.Host=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"HostVersion",{"get":function(){return this.Fields.HostVersion},"set":function(a){this.Fields.HostVersion=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"ClientId",{"get":function(){return this.Fields.ClientId},"set":function(a){this.Fields.ClientId=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"AppSizeWidth",{"get":function(){return this.Fields.AppSizeWidth},"set":function(a){this.Fields.AppSizeWidth=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"AppSizeHeight",{"get":function(){return this.Fields.AppSizeHeight},"set":function(a){this.Fields.AppSizeHeight=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"Message",{"get":function(){return this.Fields.Message},"set":function(a){this.Fields.Message=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"DocUrl",{"get":function(){return this.Fields.DocUrl},"set":function(a){this.Fields.DocUrl=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"OfficeJSVersion",{"get":function(){return this.Fields.OfficeJSVersion},"set":function(a){this.Fields.OfficeJSVersion=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"HostJSVersion",{"get":function(){return this.Fields.HostJSVersion},"set":function(a){this.Fields.HostJSVersion=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"WacHostEnvironment",{"get":function(){return this.Fields.WacHostEnvironment},"set":function(a){this.Fields.WacHostEnvironment=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"IsFromWacAutomation",{"get":function(){return this.Fields.IsFromWacAutomation},"set":function(a){this.Fields.IsFromWacAutomation=a},enumerable:true,configurable:true});a.prototype.SerializeFields=function(){this.SetSerializedField("CorrelationId",this.CorrelationId);this.SetSerializedField("SessionId",this.SessionId);this.SetSerializedField("AppId",this.AppId);this.SetSerializedField("AppInstanceId",this.AppInstanceId);this.SetSerializedField("AppURL",this.AppURL);this.SetSerializedField("AssetId",this.AssetId);this.SetSerializedField("Browser",this.Browser);this.SetSerializedField("UserId",this.UserId);this.SetSerializedField("Host",this.Host);this.SetSerializedField("HostVersion",this.HostVersion);this.SetSerializedField("ClientId",this.ClientId);this.SetSerializedField("AppSizeWidth",this.AppSizeWidth);this.SetSerializedField("AppSizeHeight",this.AppSizeHeight);this.SetSerializedField("Message",this.Message);this.SetSerializedField("DocUrl",this.DocUrl);this.SetSerializedField("OfficeJSVersion",this.OfficeJSVersion);this.SetSerializedField("HostJSVersion",this.HostJSVersion);this.SetSerializedField("WacHostEnvironment",this.WacHostEnvironment);this.SetSerializedField("IsFromWacAutomation",this.IsFromWacAutomation)};return a}(a);b.AppActivatedUsageData=d;var e=function(b){__extends(a,b);function a(){b.call(this,"ScriptLoad")}Object.defineProperty(a.prototype,"CorrelationId",{"get":function(){return this.Fields.CorrelationId},"set":function(a){this.Fields.CorrelationId=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"SessionId",{"get":function(){return this.Fields.SessionId},"set":function(a){this.Fields.SessionId=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"ScriptId",{"get":function(){return this.Fields.ScriptId},"set":function(a){this.Fields.ScriptId=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"StartTime",{"get":function(){return this.Fields.StartTime},"set":function(a){this.Fields.StartTime=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"ResponseTime",{"get":function(){return this.Fields.ResponseTime},"set":function(a){this.Fields.ResponseTime=a},enumerable:true,configurable:true});a.prototype.SerializeFields=function(){this.SetSerializedField("CorrelationId",this.CorrelationId);this.SetSerializedField("SessionId",this.SessionId);this.SetSerializedField("ScriptId",this.ScriptId);this.SetSerializedField("StartTime",this.StartTime);this.SetSerializedField("ResponseTime",this.ResponseTime)};return a}(a);b.ScriptLoadUsageData=e;var f=function(b){__extends(a,b);function a(){b.call(this,"AppClosed")}Object.defineProperty(a.prototype,"CorrelationId",{"get":function(){return this.Fields.CorrelationId},"set":function(a){this.Fields.CorrelationId=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"SessionId",{"get":function(){return this.Fields.SessionId},"set":function(a){this.Fields.SessionId=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"FocusTime",{"get":function(){return this.Fields.FocusTime},"set":function(a){this.Fields.FocusTime=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"AppSizeFinalWidth",{"get":function(){return this.Fields.AppSizeFinalWidth},"set":function(a){this.Fields.AppSizeFinalWidth=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"AppSizeFinalHeight",{"get":function(){return this.Fields.AppSizeFinalHeight},"set":function(a){this.Fields.AppSizeFinalHeight=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"OpenTime",{"get":function(){return this.Fields.OpenTime},"set":function(a){this.Fields.OpenTime=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"CloseMethod",{"get":function(){return this.Fields.CloseMethod},"set":function(a){this.Fields.CloseMethod=a},enumerable:true,configurable:true});a.prototype.SerializeFields=function(){this.SetSerializedField("CorrelationId",this.CorrelationId);this.SetSerializedField("SessionId",this.SessionId);this.SetSerializedField("FocusTime",this.FocusTime);this.SetSerializedField("AppSizeFinalWidth",this.AppSizeFinalWidth);this.SetSerializedField("AppSizeFinalHeight",this.AppSizeFinalHeight);this.SetSerializedField("OpenTime",this.OpenTime);this.SetSerializedField("CloseMethod",this.CloseMethod)};return a}(a);b.AppClosedUsageData=f;var g=function(b){__extends(a,b);function a(){b.call(this,"APIUsage")}Object.defineProperty(a.prototype,"CorrelationId",{"get":function(){return this.Fields.CorrelationId},"set":function(a){this.Fields.CorrelationId=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"SessionId",{"get":function(){return this.Fields.SessionId},"set":function(a){this.Fields.SessionId=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"APIType",{"get":function(){return this.Fields.APIType},"set":function(a){this.Fields.APIType=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"APIID",{"get":function(){return this.Fields.APIID},"set":function(a){this.Fields.APIID=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"Parameters",{"get":function(){return this.Fields.Parameters},"set":function(a){this.Fields.Parameters=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"ResponseTime",{"get":function(){return this.Fields.ResponseTime},"set":function(a){this.Fields.ResponseTime=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"ErrorType",{"get":function(){return this.Fields.ErrorType},"set":function(a){this.Fields.ErrorType=a},enumerable:true,configurable:true});a.prototype.SerializeFields=function(){this.SetSerializedField("CorrelationId",this.CorrelationId);this.SetSerializedField("SessionId",this.SessionId);this.SetSerializedField("APIType",this.APIType);this.SetSerializedField("APIID",this.APIID);this.SetSerializedField("Parameters",this.Parameters);this.SetSerializedField("ResponseTime",this.ResponseTime);this.SetSerializedField("ErrorType",this.ErrorType)};return a}(a);b.APIUsageUsageData=g;var c=function(b){__extends(a,b);function a(){b.call(this,"AppInitialization")}Object.defineProperty(a.prototype,"CorrelationId",{"get":function(){return this.Fields.CorrelationId},"set":function(a){this.Fields.CorrelationId=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"SessionId",{"get":function(){return this.Fields.SessionId},"set":function(a){this.Fields.SessionId=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"SuccessCode",{"get":function(){return this.Fields.SuccessCode},"set":function(a){this.Fields.SuccessCode=a},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"Message",{"get":function(){return this.Fields.Message},"set":function(a){this.Fields.Message=a},enumerable:true,configurable:true});a.prototype.SerializeFields=function(){this.SetSerializedField("CorrelationId",this.CorrelationId);this.SetSerializedField("SessionId",this.SessionId);this.SetSerializedField("SuccessCode",this.SuccessCode);this.SetSerializedField("Message",this.Message)};return a}(a);b.AppInitializationUsageData=c})(OSFLog||(OSFLog={}));var Logger;(function(a){"use strict";(function(a){a[a.info=0]="info";a[a.warning=1]="warning";a[a.error=2]="error"})(a.TraceLevel||(a.TraceLevel={}));var f=a.TraceLevel;(function(a){a[a.none=0]="none";a[a.flush=1]="flush"})(a.SendFlag||(a.SendFlag={}));var g=a.SendFlag;function b(){}a.allowUploadingData=b;function e(a,b,c){}a.sendLog=e;function c(){try{return new d}catch(a){return null}}var d=function(){function a(){}a.prototype.writeLog=function(a){};a.prototype.loadProxyFrame=function(){};return a}();if(!OSF.Logger)OSF.Logger=a;a.ulsEndpoint=c()})(Logger||(Logger={}));var OSFAriaLogger;(function(k){var d={name:"AppActivated",enabled:true,basic:true,critical:true,points:[{name:"Browser",type:"string"},{name:"Message",type:"string"},{name:"AppURL",type:"string"},{name:"Host",type:"string"},{name:"AppSizeWidth",type:"int64"},{name:"AppSizeHeight",type:"int64"},{name:"IsFromWacAutomation",type:"string"}]},e={name:"ScriptLoad",enabled:true,basic:false,critical:false,points:[{name:"ScriptId",type:"string"},{name:"StartTime",type:"double"},{name:"ResponseTime",type:"double"}]},i={name:"APIUsage",enabled:false,basic:false,critical:false,points:[{name:"APIType",type:"string"},{name:"APIID",type:"int64"},{name:"Parameters",type:"string"},{name:"ResponseTime",type:"int64"},{name:"ErrorType",type:"int64"}]},c={name:"AppInitialization",enabled:true,basic:false,critical:false,points:[{name:"SuccessCode",type:"int64"},{name:"Message",type:"string"}]},f={name:"AppClosed",enabled:true,basic:false,critical:false,points:[{name:"FocusTime",type:"int64"},{name:"AppSizeFinalWidth",type:"int64"},{name:"AppSizeFinalHeight",type:"int64"},{name:"OpenTime",type:"int64"}]},b=[d,e,i,c,f];function j(a,c){var d=c.rename===undefined?c.name:c.rename,e=c.type,b=undefined;switch(e){case"string":b=oteljs.makeStringDataField(d,a);break;case"double":if(typeof a==="string")a=parseFloat(a);b=oteljs.makeDoubleDataField(d,a);break;case"int64":if(typeof a==="string")a=parseInt(a);b=oteljs.makeInt64DataField(d,a);break;case"boolean":if(typeof a==="string")a=a==="true";b=oteljs.makeBooleanDataField(d,a);break}return b}function a(d){for(var a=0;a<b.length;a++){var c=b[a];if(c.name===d)return c}return undefined}function l(c){var b=a(c);if(b===undefined)return false;return b.enabled}function g(f,m){var b=a(f);if(b===undefined)return undefined;for(var e=[],d=0,k=b.points;d<k.length;d++){var h=k[d],o=h.name,i=m[o];if(i===undefined)continue;var g=j(i,h);g!==undefined&&e.push(g)}var c={dataCategories:oteljs.DataCategories.ProductServiceUsage};if(b.critical)c.samplingPolicy=oteljs.SamplingPolicy.CriticalBusinessImpact;if(b.basic)c.diagnosticLevel=oteljs.DiagnosticLevel.BasicEvent;var l="Office.Extensibility.OfficeJs."+f+"X",n={eventName:l,dataFields:e,eventFlags:c};return n}function h(a,b){if(l(a))if(typeof OTel!=="undefined")OTel.OTelLogger.onTelemetryLoaded(function(){var c=g(a,b);if(c===undefined)return;Microsoft.Office.WebExtension.sendTelemetryEvent(c)})}var m=function(){function a(){}a.prototype.getAriaCDNLocation=function(){return OSF._OfficeAppFactory.getLoadScriptHelper().getOfficeJsBasePath()+"ariatelemetry/aria-web-telemetry.js"};a.getInstance=function(){if(a.AriaLoggerObj===undefined)a.AriaLoggerObj=new a;return a.AriaLoggerObj};a.prototype.isIUsageData=function(a){return a.Fields!==undefined};a.prototype.shouldSendDirectToAria=function(){var d,b;if(OSF._OfficeAppFactory&&OSF._OfficeAppFactory.getHostInfo)d=OSF._OfficeAppFactory.getHostInfo().hostPlatform;if(!d)return false;else if(d.toLowerCase()!=="win32")return true;if(window.external&&typeof window.external.GetContext!=="undefined"&&typeof window.external.GetContext().GetHostFullVersion!=="undefined")b=window.external.GetContext().GetHostFullVersion();var c=10,f=16,g=0,e=11601;if(b){var a=b.split(".");if(a.length<3)return false;else if(parseInt(a[0],c)>=f&&parseInt(a[1],c)>=g&&parseInt(a[2],c)>=e)return false;else return true}return false};a.prototype.isDirectToAriaEnabled=function(){if(this.EnableDirectToAria===undefined||this.EnableDirectToAria===null)this.EnableDirectToAria=this.shouldSendDirectToAria();return this.EnableDirectToAria};a.prototype.sendTelemetry=function(c,b){var e=1e3,d=a.EnableSendingTelemetryWithLegacyAria&&this.isDirectToAriaEnabled();d&&OSF.OUtil.loadScript(this.getAriaCDNLocation(),function(){try{if(!this.ALogger){var e="db334b301e7b474db5e0f02f07c51a47-a1b5bc36-1bbe-482f-a64a-c2d9cb606706-7439";this.ALogger=AWTLogManager.initialize(e)}var a=new AWTEventProperties;a.setName("Office.Extensibility.OfficeJS."+c);for(var d in b)d.toLowerCase()!=="table"&&a.setProperty(d,b[d]);var f=new Date;a.setProperty("Date",f.toISOString());this.ALogger.logEvent(a)}catch(g){}},e);a.EnableSendingTelemetryWithOTel&&h(c,b)};a.prototype.logData=function(a){if(this.isIUsageData(a))this.sendTelemetry(a.Table,a.Fields);else this.sendTelemetry(a.Table,a)};a.EnableSendingTelemetryWithOTel=true;a.EnableSendingTelemetryWithLegacyAria=false;return a}();k.AriaLogger=m})(OSFAriaLogger||(OSFAriaLogger={}));var OSFAppTelemetry;(function(b){"use strict";var a,d=OSF.OUtil.Guid.generateNewGuid(),g="",n=new RegExp("^https?://store\\.office(ppe|-int)?\\.com/","i");b.enableTelemetry=true;var j=function(){function a(){}return a}();b.AppInfo=j;var e=function(){function a(b,a){this.name=b;this.handler=a}return a}(),i=function(){function a(){this.clientIDKey="Office API client";this.logIdSetKey="Office App Log Id Set"}a.prototype.getClientId=function(){var a=this.getValue(this.clientIDKey);if(!a||a.length<=0||a.length>40){a=OSF.OUtil.Guid.generateNewGuid();this.setValue(this.clientIDKey,a)}return a};a.prototype.saveLog=function(b,c){var a=this.getValue(this.logIdSetKey);a=(a&&a.length>0?a+";":"")+b;this.setValue(this.logIdSetKey,a);this.setValue(b,c)};a.prototype.enumerateLog=function(b,d){var c=this.getValue(this.logIdSetKey);if(c){var e=c.split(";");for(var g in e){var a=e[g],f=this.getValue(a);if(f){b&&b(a,f);d&&this.remove(a)}}d&&this.remove(this.logIdSetKey)}};a.prototype.getValue=function(c){var a=OSF.OUtil.getLocalStorage(),b="";if(a)b=a.getItem(c);return b};a.prototype.setValue=function(c,b){var a=OSF.OUtil.getLocalStorage();a&&a.setItem(c,b)};a.prototype.remove=function(b){var a=OSF.OUtil.getLocalStorage();if(a)try{a.removeItem(b)}catch(c){}};return a}(),f=function(){function a(){}a.prototype.LogData=function(a){if(!b.enableTelemetry)return;try{OSFAriaLogger.AriaLogger.getInstance().logData(a)}catch(c){}};a.prototype.LogRawData=function(a){if(!b.enableTelemetry)return;try{OSFAriaLogger.AriaLogger.getInstance().logData(JSON.parse(a))}catch(c){}};return a}();function c(a){if(a)a=a.replace(/[{}]/g,"").toLowerCase();return a||""}var x=function(){function a(){}a.hashString=function(c){var a=0;if(c.length===0)return a;for(var b=0;b<c.length;b++){var d=c.charCodeAt(b);a=(a<<5)-a+d;a|=0}return a};a.stringToHash=function(d){var c=a.hashString(d),b=c.toString();if(c<0)b="1"+b.substring(1);else b="0"+b;return b};a.startsWith=function(b,a){return b.indexOf(a)==-0};a.isFileUrl=function(b){return a.startsWith(b.toLowerCase(),"file:")};a.removeHttpPrefix=function(c){var b="";if(a.startsWith(c.toLowerCase(),a.httpsPrefix))b=a.httpsPrefix;else if(a.startsWith(c.toLowerCase(),a.httpPrefix))b=a.httpPrefix;var d=c.slice(b.length);return d};a.getUrlDomain=function(c){var b=a.removeHttpPrefix(c);b=b.split("/")[0];b=b.split(":")[0];return b};a.isIp4Address=function(b){var a=/^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/;return a.test(b)};a.filter=function(d){if(a.isFileUrl(d)){var c=a.stringToHash(d);return"file://"+c}var b=a.getUrlDomain(d);if(a.isIp4Address(b)){var c=a.stringToHash(d);if(a.startsWith(b,"10."))return"IP10Range_"+c;else if(a.startsWith(b,"192."))return"IP192Range_"+c;else if(a.startsWith(b,"127."))return"IP127Range_"+c;return"IPOther_"+c}return b};a.httpPrefix="http://";a.httpsPrefix="https://";return a}();function v(f){if(!b.enableTelemetry)return;if(a)return;a=new j;if(f.get_hostFullVersion())a.hostVersion=f.get_hostFullVersion();else a.hostVersion=f.get_appVersion();a.appId=f.get_id();a.host=f.get_appName();a.browser=window.navigator.userAgent;a.correlationId=c(f.get_correlationId());a.clientId=(new i).getClientId();a.appInstanceId=f.get_appInstanceId();if(a.appInstanceId)a.appInstanceId=a.appInstanceId.replace(/[{}]/g,"").toLowerCase();a.message=f.get_hostCustomMessage();a.officeJSVersion=OSF.ConstantNames.FileVersion;a.hostJSVersion="16.0.11620.10000";if(f._wacHostEnvironment)a.wacHostEnvironment=f._wacHostEnvironment;if(f._isFromWacAutomation!==undefined&&f._isFromWacAutomation!==null)a.isFromWacAutomation=f._isFromWacAutomation.toString().toLowerCase();var h=f.get_docUrl();a.docUrl=n.test(h)?h:"";var g=location.href;if(g)g=g.split("?")[0].split("#")[0];a.appURL=x.filter(g);(function(g,a){var c,f,b;a.assetId="";a.userId="";try{c=decodeURIComponent(g);f=new DOMParser;b=f.parseFromString(c,"text/xml");var d=b.getElementsByTagName("t")[0].attributes.getNamedItem("cid"),e=b.getElementsByTagName("t")[0].attributes.getNamedItem("oid");if(d&&d.nodeValue)a.userId=d.nodeValue;else if(e&&e.nodeValue)a.userId=e.nodeValue;a.assetId=b.getElementsByTagName("t")[0].attributes.getNamedItem("aid").nodeValue}catch(h){}finally{c=null;b=null;f=null}})(f.get_eToken(),a);a.sessionId=d;a.name=f.get_addinName();typeof OTel!=="undefined"&&OTel.OTelLogger.initialize(a);(function(){var j=new Date,c=null,g=0,i=false,d=function(){if(document.hasFocus()){if(c==null)c=new Date}else if(c){g+=Math.abs(+new Date-c.getTime());c=null}},a=[];a.push(new e("focus",d));a.push(new e("blur",d));a.push(new e("focusout",d));a.push(new e("focusin",d));var h=function(){for(var d=0;d<a.length;d++)OSF.OUtil.removeEventListener(window,a[d].name,a[d].handler);a.length=0;if(!i){if(document.hasFocus()&&c){g+=Math.abs(+new Date-c.getTime());c=null}b.onAppClosed(Math.abs(+new Date-j.getTime()),g);i=true}};a.push(new e("beforeunload",h));a.push(new e("unload",h));for(var f=0;f<a.length;f++)OSF.OUtil.addEventListener(window,a[f].name,a[f].handler);d()})();b.onAppActivated()}b.initialize=v;function o(){if(!a)return;(new i).enumerateLog(function(b,a){return(new f).LogRawData(a)},true);var b=new OSFLog.AppActivatedUsageData;b.SessionId=d;b.AppId=a.appId;b.AssetId=a.assetId;b.AppURL=a.appURL;b.UserId="";b.ClientId=a.clientId;b.Browser=a.browser;b.Host=a.host;b.HostVersion=a.hostVersion;b.CorrelationId=c(a.correlationId);b.AppSizeWidth=window.innerWidth;b.AppSizeHeight=window.innerHeight;b.AppInstanceId=a.appInstanceId;b.Message=a.message;b.DocUrl=a.docUrl;b.OfficeJSVersion=a.officeJSVersion;b.HostJSVersion=a.hostJSVersion;if(a.wacHostEnvironment)b.WacHostEnvironment=a.wacHostEnvironment;if(a.isFromWacAutomation!==undefined&&a.isFromWacAutomation!==null)b.IsFromWacAutomation=a.isFromWacAutomation;(new f).LogData(b)}b.onAppActivated=o;function s(h,g,e,b){var a=new OSFLog.ScriptLoadUsageData;a.CorrelationId=c(b);a.SessionId=d;a.ScriptId=h;a.StartTime=g;a.ResponseTime=e;(new f).LogData(a)}b.onScriptDone=s;function w(j,k,h,e,i){if(!a)return;var b=new OSFLog.APIUsageUsageData;b.CorrelationId=c(g);b.SessionId=d;b.APIType=j;b.APIID=k;b.Parameters=h;b.ResponseTime=e;b.ErrorType=i;(new f).LogData(b)}b.onCallDone=w;function r(f,b,d,e){var a=null;if(b)if(typeof b=="number")a=String(b);else if(typeof b==="object")for(var c in b){if(a!==null)a+=",";else a="";if(typeof b[c]=="number")a+=String(b[c])}else a="";OSF.AppTelemetry.onCallDone("method",f,a,d,e)}b.onMethodDone=r;function p(b,a){OSF.AppTelemetry.onCallDone("property",-1,b,a)}b.onPropertyDone=p;function u(b,a){OSF.AppTelemetry.onCallDone("event",b,null,0,a)}b.onEventDone=u;function q(c,d,a,b){OSF.AppTelemetry.onCallDone(c?"registerevent":"unregisterevent",d,null,a,b)}b.onRegisterDone=q;function t(f,e){if(!a)return;var b=new OSFLog.AppClosedUsageData;b.CorrelationId=c(g);b.SessionId=d;b.FocusTime=e;b.OpenTime=f;b.AppSizeFinalWidth=window.innerWidth;b.AppSizeFinalHeight=window.innerHeight;(new i).saveLog(d,b.SerializeRow())}b.onAppClosed=t;function k(a){g=c(a)}b.setOsfControlAppCorrelationId=k;function h(b,e){var a=new OSFLog.AppInitializationUsageData;a.CorrelationId=c(g);a.SessionId=d;a.SuccessCode=b?1:0;a.Message=e;(new f).LogData(a)}b.doAppInitializationLogging=h;function l(a){h(false,a)}b.logAppCommonMessage=l;function m(a){h(true,a)}b.logAppException=m;OSF.AppTelemetry=b})(OSFAppTelemetry||(OSFAppTelemetry={}));var OSFWebAuth;(function(a){var b="webauth/webauth.implicit.js";a.config=null;function e(c){OSF.OUtil.loadScript(OSF._OfficeAppFactory.getLoadScriptHelper().getOfficeJsBasePath()+b,function(){if(a.config){Implicit.Load(a.config);a.loaded=true}else Implicit.GetAuthConfig().then(function(b){a.config=b;Implicit.Load(a.config);a.loaded=true},function(){a.loaded=false});c&&c(a.loaded)})}a.load=e;function d(b,c){if(!a.loaded)return null;if(typeof c==="boolean")return Implicit.GetToken(b,c);else return Implicit.GetToken(b)}a.getToken=d;function c(){a.loaded&&Implicit.SwitchUser()}a.clearCache=c;OSF.WebAuth=a})(OSFWebAuth||(OSFWebAuth={}));Microsoft.Office.WebExtension.TableData=function(b,a){function c(a){if(a==null||a==undefined)return null;try{for(var b=OSF.DDA.DataCoercion.findArrayDimensionality(a,2);b<2;b++)a=[a];return a}catch(c){}}OSF.OUtil.defineEnumerableProperties(this,{headers:{"get":function(){return a},"set":function(b){a=c(b)}},rows:{"get":function(){return b},"set":function(a){b=a==null||OSF.OUtil.isArray(a)&&a.length==0?[]:c(a)}}});this.headers=a;this.rows=b};OSF.DDA.OMFactory=OSF.DDA.OMFactory||{};OSF.DDA.OMFactory.manufactureTableData=function(a){return new Microsoft.Office.WebExtension.TableData(a[OSF.DDA.TableDataProperties.TableRows],a[OSF.DDA.TableDataProperties.TableHeaders])};Microsoft.Office.WebExtension.CoercionType={Text:"text",Matrix:"matrix",Table:"table"};OSF.DDA.DataCoercion=function(){return{findArrayDimensionality:function(c){if(OSF.OUtil.isArray(c)){for(var b=0,a=0;a<c.length;a++)b=Math.max(b,OSF.DDA.DataCoercion.findArrayDimensionality(c[a]));return b+1}else return 0},getCoercionDefaultForBinding:function(a){switch(a){case Microsoft.Office.WebExtension.BindingType.Matrix:return Microsoft.Office.WebExtension.CoercionType.Matrix;case Microsoft.Office.WebExtension.BindingType.Table:return Microsoft.Office.WebExtension.CoercionType.Table;case Microsoft.Office.WebExtension.BindingType.Text:default:return Microsoft.Office.WebExtension.CoercionType.Text}},getBindingDefaultForCoercion:function(a){switch(a){case Microsoft.Office.WebExtension.CoercionType.Matrix:return Microsoft.Office.WebExtension.BindingType.Matrix;case Microsoft.Office.WebExtension.CoercionType.Table:return Microsoft.Office.WebExtension.BindingType.Table;case Microsoft.Office.WebExtension.CoercionType.Text:case Microsoft.Office.WebExtension.CoercionType.Html:case Microsoft.Office.WebExtension.CoercionType.Ooxml:default:return Microsoft.Office.WebExtension.BindingType.Text}},determineCoercionType:function(a){if(a==null||a==undefined)return null;var b=null,c=typeof a;if(a.rows!==undefined)b=Microsoft.Office.WebExtension.CoercionType.Table;else if(OSF.OUtil.isArray(a))b=Microsoft.Office.WebExtension.CoercionType.Matrix;else if(c=="string"||c=="number"||c=="boolean"||OSF.OUtil.isDate(a))b=Microsoft.Office.WebExtension.CoercionType.Text;else throw OSF.DDA.ErrorCodeManager.errorCodes.ooeUnsupportedDataObject;return b},coerceData:function(b,c,a){a=a||OSF.DDA.DataCoercion.determineCoercionType(b);if(a&&a!=c){OSF.OUtil.writeProfilerMark(OSF.InternalPerfMarker.DataCoercionBegin);b=OSF.DDA.DataCoercion._coerceDataFromTable(c,OSF.DDA.DataCoercion._coerceDataToTable(b,a));OSF.OUtil.writeProfilerMark(OSF.InternalPerfMarker.DataCoercionEnd)}return b},_matrixToText:function(a){if(a.length==1&&a[0].length==1)return""+a[0][0];for(var b="",c=0;c<a.length;c++)b+=a[c].join("\t")+"\n";return b.substring(0,b.length-1)},_textToMatrix:function(c){for(var a=c.split("\n"),b=0;b<a.length;b++)a[b]=a[b].split("\t");return a},_tableToText:function(b){var a="";if(b.headers!=null)a=OSF.DDA.DataCoercion._matrixToText([b.headers])+"\n";var c=OSF.DDA.DataCoercion._matrixToText(b.rows);if(c=="")a=a.substring(0,a.length-1);return a+c},_tableToMatrix:function(a){var b=a.rows;a.headers!=null&&b.unshift(a.headers);return b},_coerceDataFromTable:function(c,b){var a;switch(c){case Microsoft.Office.WebExtension.CoercionType.Table:a=b;break;case Microsoft.Office.WebExtension.CoercionType.Matrix:a=OSF.DDA.DataCoercion._tableToMatrix(b);break;case Microsoft.Office.WebExtension.CoercionType.SlideRange:a=null;if(OSF.DDA.OMFactory.manufactureSlideRange)a=OSF.DDA.OMFactory.manufactureSlideRange(OSF.DDA.DataCoercion._tableToText(b));if(a==null)a=OSF.DDA.DataCoercion._tableToText(b);break;case Microsoft.Office.WebExtension.CoercionType.Text:case Microsoft.Office.WebExtension.CoercionType.Html:case Microsoft.Office.WebExtension.CoercionType.Ooxml:default:a=OSF.DDA.DataCoercion._tableToText(b);break}return a},_coerceDataToTable:function(b,c){if(c==undefined)c=OSF.DDA.DataCoercion.determineCoercionType(b);var a;switch(c){case Microsoft.Office.WebExtension.CoercionType.Table:a=b;break;case Microsoft.Office.WebExtension.CoercionType.Matrix:a=new Microsoft.Office.WebExtension.TableData(b);break;case Microsoft.Office.WebExtension.CoercionType.Text:case Microsoft.Office.WebExtension.CoercionType.Html:case Microsoft.Office.WebExtension.CoercionType.Ooxml:default:a=new Microsoft.Office.WebExtension.TableData(OSF.DDA.DataCoercion._textToMatrix(b));break}return a}}}();OSF.OUtil.augmentList(Microsoft.Office.WebExtension.CoercionType,{SlideRange:"slideRange"});OSF.DDA.SlideProperties={Id:0,Title:1,Index:2};OSF.DDA.Slide=function(c,b,a){OSF.OUtil.defineEnumerableProperties(this,{id:{value:c},title:{value:b},index:{value:a}})};OSF.DDA.SlideRange=function(a){OSF.OUtil.defineEnumerableProperties(this,{slides:{value:a}})};OSF.DDA.OMFactory=OSF.DDA.OMFactory||{};OSF.DDA.OMFactory.manufactureSlideRange=function(g){var a=null;if(JSON)a=JSON.parse(g);else a=Sys.Serialization.JavaScriptSerializer.deserialize(g);if(a==null)return null;var d=0;for(var j in OSF.DDA.SlideProperties)if(OSF.DDA.SlideProperties.hasOwnProperty(j))d++;for(var e=[],c=true,b=0;b<a.length&&c;b++){c=false;if(a[b].length==d){var h=parseInt(a[b][OSF.DDA.SlideProperties.Id]),i=a[b][OSF.DDA.SlideProperties.Title],f=parseInt(a[b][OSF.DDA.SlideProperties.Index]);if(!isNaN(h)&&!isNaN(f)){c=true;e.push(new OSF.DDA.Slide(h,i,f))}}}if(!c)return null;return new OSF.DDA.SlideRange(e)};Microsoft.Office.WebExtension.BindingType={Table:"table",Text:"text",Matrix:"matrix"};OSF.DDA.BindingProperties={Id:"BindingId",Type:Microsoft.Office.WebExtension.Parameters.BindingType};OSF.OUtil.augmentList(OSF.DDA.ListDescriptors,{BindingList:"BindingList"});OSF.OUtil.augmentList(OSF.DDA.PropertyDescriptors,{Subset:"subset",BindingProperties:"BindingProperties"});OSF.DDA.ListType.setListType(OSF.DDA.ListDescriptors.BindingList,OSF.DDA.PropertyDescriptors.BindingProperties);OSF.DDA.BindingPromise=function(b,a){this._id=b;OSF.OUtil.defineEnumerableProperty(this,"onFail",{"get":function(){return a},"set":function(c){var b=typeof c;if(b!="undefined"&&b!="function")throw OSF.OUtil.formatString(Strings.OfficeOM.L_CallbackNotAFunction,b);a=c}})};OSF.DDA.BindingPromise.prototype={_fetch:function(a){if(this.binding)a&&a(this.binding);else if(!this._binding){var b=this;Microsoft.Office.WebExtension.context.document.bindings.getByIdAsync(this._id,function(c){if(c.status==Microsoft.Office.WebExtension.AsyncResultStatus.Succeeded){OSF.OUtil.defineEnumerableProperty(b,"binding",{value:c.value});a&&a(b.binding)}else if(b.onFail)b.onFail(c)})}return this},getDataAsync:function(){var a=arguments;this._fetch(function(b){b.getDataAsync.apply(b,a)});return this},setDataAsync:function(){var a=arguments;this._fetch(function(b){b.setDataAsync.apply(b,a)});return this},addHandlerAsync:function(){var a=arguments;this._fetch(function(b){b.addHandlerAsync.apply(b,a)});return this},removeHandlerAsync:function(){var a=arguments;this._fetch(function(b){b.removeHandlerAsync.apply(b,a)});return this}};OSF.DDA.BindingFacade=function(b){this._eventDispatches=[];OSF.OUtil.defineEnumerableProperty(this,"document",{value:b});var a=OSF.DDA.AsyncMethodNames;OSF.DDA.DispIdHost.addAsyncMethods(this,[a.AddFromSelectionAsync,a.AddFromNamedItemAsync,a.GetAllAsync,a.GetByIdAsync,a.ReleaseByIdAsync])};OSF.DDA.UnknownBinding=function(b,a){OSF.OUtil.defineEnumerableProperties(this,{document:{value:a},id:{value:b}})};OSF.DDA.Binding=function(a,c){OSF.OUtil.defineEnumerableProperties(this,{document:{value:c},id:{value:a}});var d=OSF.DDA.AsyncMethodNames;OSF.DDA.DispIdHost.addAsyncMethods(this,[d.GetDataAsync,d.SetDataAsync]);var e=Microsoft.Office.WebExtension.EventType,b=c.bindings._eventDispatches;if(!b[a])b[a]=new OSF.EventDispatch([e.BindingSelectionChanged,e.BindingDataChanged]);var f=b[a];OSF.DDA.DispIdHost.addEventSupport(this,f)};OSF.DDA.generateBindingId=function(){return"UnnamedBinding_"+OSF.OUtil.getUniqueId()+"_"+ +new Date};OSF.DDA.OMFactory=OSF.DDA.OMFactory||{};OSF.DDA.OMFactory.manufactureBinding=function(a,c){var d=a[OSF.DDA.BindingProperties.Id],g=a[OSF.DDA.BindingProperties.RowCount],f=a[OSF.DDA.BindingProperties.ColumnCount],h=a[OSF.DDA.BindingProperties.HasHeaders],b;switch(a[OSF.DDA.BindingProperties.Type]){case Microsoft.Office.WebExtension.BindingType.Text:b=new OSF.DDA.TextBinding(d,c);break;case Microsoft.Office.WebExtension.BindingType.Matrix:b=new OSF.DDA.MatrixBinding(d,c,g,f);break;case Microsoft.Office.WebExtension.BindingType.Table:var i=function(){return OSF.DDA.ExcelDocument&&Microsoft.Office.WebExtension.context.document&&Microsoft.Office.WebExtension.context.document instanceof OSF.DDA.ExcelDocument},e;if(i()&&OSF.DDA.ExcelTableBinding)e=OSF.DDA.ExcelTableBinding;else e=OSF.DDA.TableBinding;b=new e(d,c,g,f,h);break;default:b=new OSF.DDA.UnknownBinding(d,c)}return b};OSF.DDA.AsyncMethodNames.addNames({AddFromSelectionAsync:"addFromSelectionAsync",AddFromNamedItemAsync:"addFromNamedItemAsync",GetAllAsync:"getAllAsync",GetByIdAsync:"getByIdAsync",ReleaseByIdAsync:"releaseByIdAsync",GetDataAsync:"getDataAsync",SetDataAsync:"setDataAsync"});(function(){function a(a){return OSF.DDA.OMFactory.manufactureBinding(a,Microsoft.Office.WebExtension.context.document)}function b(a){return a.id}function c(b,d,c){var a=b[Microsoft.Office.WebExtension.Parameters.Data];if(OSF.DDA.TableDataProperties&&a&&(a[OSF.DDA.TableDataProperties.TableRows]!=undefined||a[OSF.DDA.TableDataProperties.TableHeaders]!=undefined))a=OSF.DDA.OMFactory.manufactureTableData(a);a=OSF.DDA.DataCoercion.coerceData(a,c[Microsoft.Office.WebExtension.Parameters.CoercionType]);return a==undefined?null:a}OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AddFromSelectionAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.BindingType,"enum":Microsoft.Office.WebExtension.BindingType}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:{types:["string"],calculate:OSF.DDA.generateBindingId}},{name:Microsoft.Office.WebExtension.Parameters.Columns,value:{types:["object"],defaultValue:null}}],privateStateCallbacks:[],onSucceeded:a});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AddFromNamedItemAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.ItemName,types:["string"]},{name:Microsoft.Office.WebExtension.Parameters.BindingType,"enum":Microsoft.Office.WebExtension.BindingType}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:{types:["string"],calculate:OSF.DDA.generateBindingId}},{name:Microsoft.Office.WebExtension.Parameters.Columns,value:{types:["object"],defaultValue:null}}],privateStateCallbacks:[{name:Microsoft.Office.WebExtension.Parameters.FailOnCollision,value:function(){return true}}],onSucceeded:a});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetAllAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[],onSucceeded:function(b){return OSF.OUtil.mapList(b[OSF.DDA.ListDescriptors.BindingList],a)}});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetByIdAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Id,types:["string"]}],supportedOptions:[],privateStateCallbacks:[],onSucceeded:a});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.ReleaseByIdAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Id,types:["string"]}],supportedOptions:[],privateStateCallbacks:[],onSucceeded:function(d,b,a){var c=a[Microsoft.Office.WebExtension.Parameters.Id];delete b._eventDispatches[c]}});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetDataAsync,requiredArguments:[],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:{"enum":Microsoft.Office.WebExtension.CoercionType,calculate:function(b,a){return OSF.DDA.DataCoercion.getCoercionDefaultForBinding(a.type)}}},{name:Microsoft.Office.WebExtension.Parameters.ValueFormat,value:{"enum":Microsoft.Office.WebExtension.ValueFormat,defaultValue:Microsoft.Office.WebExtension.ValueFormat.Unformatted}},{name:Microsoft.Office.WebExtension.Parameters.FilterType,value:{"enum":Microsoft.Office.WebExtension.FilterType,defaultValue:Microsoft.Office.WebExtension.FilterType.All}},{name:Microsoft.Office.WebExtension.Parameters.Rows,value:{types:["object","string"],defaultValue:null}},{name:Microsoft.Office.WebExtension.Parameters.Columns,value:{types:["object"],defaultValue:null}},{name:Microsoft.Office.WebExtension.Parameters.StartRow,value:{types:["number"],defaultValue:0}},{name:Microsoft.Office.WebExtension.Parameters.StartColumn,value:{types:["number"],defaultValue:0}},{name:Microsoft.Office.WebExtension.Parameters.RowCount,value:{types:["number"],defaultValue:0}},{name:Microsoft.Office.WebExtension.Parameters.ColumnCount,value:{types:["number"],defaultValue:0}}],checkCallArgs:function(a,b,c){if(a[Microsoft.Office.WebExtension.Parameters.StartRow]==0&&a[Microsoft.Office.WebExtension.Parameters.StartColumn]==0&&a[Microsoft.Office.WebExtension.Parameters.RowCount]==0&&a[Microsoft.Office.WebExtension.Parameters.ColumnCount]==0){delete a[Microsoft.Office.WebExtension.Parameters.StartRow];delete a[Microsoft.Office.WebExtension.Parameters.StartColumn];delete a[Microsoft.Office.WebExtension.Parameters.RowCount];delete a[Microsoft.Office.WebExtension.Parameters.ColumnCount]}if(a[Microsoft.Office.WebExtension.Parameters.CoercionType]!=OSF.DDA.DataCoercion.getCoercionDefaultForBinding(b.type)&&(a[Microsoft.Office.WebExtension.Parameters.StartRow]||a[Microsoft.Office.WebExtension.Parameters.StartColumn]||a[Microsoft.Office.WebExtension.Parameters.RowCount]||a[Microsoft.Office.WebExtension.Parameters.ColumnCount]))throw OSF.DDA.ErrorCodeManager.errorCodes.ooeCoercionTypeNotMatchBinding;return a},privateStateCallbacks:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:b}],onSucceeded:c});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.SetDataAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Data,types:["string","object","number","boolean"]}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:{"enum":Microsoft.Office.WebExtension.CoercionType,calculate:function(a){return OSF.DDA.DataCoercion.determineCoercionType(a[Microsoft.Office.WebExtension.Parameters.Data])}}},{name:Microsoft.Office.WebExtension.Parameters.Rows,value:{types:["object","string"],defaultValue:null}},{name:Microsoft.Office.WebExtension.Parameters.Columns,value:{types:["object"],defaultValue:null}},{name:Microsoft.Office.WebExtension.Parameters.StartRow,value:{types:["number"],defaultValue:0}},{name:Microsoft.Office.WebExtension.Parameters.StartColumn,value:{types:["number"],defaultValue:0}}],checkCallArgs:function(a,b,c){if(a[Microsoft.Office.WebExtension.Parameters.StartRow]==0&&a[Microsoft.Office.WebExtension.Parameters.StartColumn]==0){delete a[Microsoft.Office.WebExtension.Parameters.StartRow];delete a[Microsoft.Office.WebExtension.Parameters.StartColumn]}if(a[Microsoft.Office.WebExtension.Parameters.CoercionType]!=OSF.DDA.DataCoercion.getCoercionDefaultForBinding(b.type)&&(a[Microsoft.Office.WebExtension.Parameters.StartRow]||a[Microsoft.Office.WebExtension.Parameters.StartColumn]))throw OSF.DDA.ErrorCodeManager.errorCodes.ooeCoercionTypeNotMatchBinding;return a},privateStateCallbacks:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:b}]})})();OSF.OUtil.augmentList(OSF.DDA.PropertyDescriptors,{TableDataProperties:"TableDataProperties"});OSF.OUtil.augmentList(OSF.DDA.BindingProperties,{RowCount:"BindingRowCount",ColumnCount:"BindingColumnCount",HasHeaders:"HasHeaders"});OSF.DDA.TableDataProperties={TableRows:"TableRows",TableHeaders:"TableHeaders"};OSF.DDA.TableBinding=function(f,e,d,c,b){OSF.DDA.TableBinding.uber.constructor.call(this,f,e);OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.BindingType.Table},rowCount:{value:d?d:0},columnCount:{value:c?c:0},hasHeaders:{value:b?b:false}});var a=OSF.DDA.AsyncMethodNames;OSF.DDA.DispIdHost.addAsyncMethods(this,[a.AddRowsAsync,a.AddColumnsAsync,a.DeleteAllDataValuesAsync])};OSF.OUtil.extend(OSF.DDA.TableBinding,OSF.DDA.Binding);OSF.DDA.AsyncMethodNames.addNames({AddRowsAsync:"addRowsAsync",AddColumnsAsync:"addColumnsAsync",DeleteAllDataValuesAsync:"deleteAllDataValuesAsync"});(function(){function a(a){return a.id}OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AddRowsAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Data,types:["object"]}],supportedOptions:[],privateStateCallbacks:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:a}]});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AddColumnsAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Data,types:["object"]}],supportedOptions:[],privateStateCallbacks:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:a}]});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.DeleteAllDataValuesAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:a}]})})();OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.WAC.UniqueArguments.GetData,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:"BindingId"},{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:"CoerceType"},{name:Microsoft.Office.WebExtension.Parameters.ValueFormat,value:"ValueFormat"},{name:Microsoft.Office.WebExtension.Parameters.FilterType,value:"FilterType"},{name:Microsoft.Office.WebExtension.Parameters.Rows,value:"Rows"},{name:Microsoft.Office.WebExtension.Parameters.Columns,value:"Columns"},{name:Microsoft.Office.WebExtension.Parameters.StartRow,value:"StartRow"},{name:Microsoft.Office.WebExtension.Parameters.StartColumn,value:"StartCol"},{name:Microsoft.Office.WebExtension.Parameters.RowCount,value:"RowCount"},{name:Microsoft.Office.WebExtension.Parameters.ColumnCount,value:"ColCount"}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.WAC.UniqueArguments.SetData,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:"BindingId"},{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:"CoerceType"},{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.WAC.UniqueArguments.Data},{name:Microsoft.Office.WebExtension.Parameters.Rows,value:"Rows"},{name:Microsoft.Office.WebExtension.Parameters.Columns,value:"Columns"},{name:Microsoft.Office.WebExtension.Parameters.StartRow,value:"StartRow"},{name:Microsoft.Office.WebExtension.Parameters.StartColumn,value:"StartCol"},{name:Microsoft.Office.WebExtension.Parameters.ImageLeft,value:"ImageLeft"},{name:Microsoft.Office.WebExtension.Parameters.ImageTop,value:"ImageTop"},{name:Microsoft.Office.WebExtension.Parameters.ImageWidth,value:"ImageWidth"},{name:Microsoft.Office.WebExtension.Parameters.ImageHeight,value:"ImageHeight"}]});OSF.DDA.WAC.Delegate.ParameterMap.addComplexType(OSF.DDA.PropertyDescriptors.BindingProperties);OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.WAC.UniqueArguments.BindingRequest,toHost:[{name:Microsoft.Office.WebExtension.Parameters.ItemName,value:"ItemName"},{name:Microsoft.Office.WebExtension.Parameters.Id,value:"BindingId"},{name:Microsoft.Office.WebExtension.Parameters.BindingType,value:"BindingType"},{name:Microsoft.Office.WebExtension.Parameters.PromptText,value:"PromptText"},{name:Microsoft.Office.WebExtension.Parameters.Columns,value:"Columns"},{name:Microsoft.Office.WebExtension.Parameters.SampleData,value:"SampleData"},{name:Microsoft.Office.WebExtension.Parameters.FailOnCollision,value:"FailOnCollision"}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.BindingType,toHost:[{name:Microsoft.Office.WebExtension.BindingType.Text,value:2},{name:Microsoft.Office.WebExtension.BindingType.Matrix,value:3},{name:Microsoft.Office.WebExtension.BindingType.Table,value:1}],invertible:true});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.BindingProperties,fromHost:[{name:OSF.DDA.BindingProperties.Id,value:"Name"},{name:OSF.DDA.BindingProperties.Type,value:"BindingType"},{name:OSF.DDA.BindingProperties.RowCount,value:"RowCount"},{name:OSF.DDA.BindingProperties.ColumnCount,value:"ColCount"},{name:OSF.DDA.BindingProperties.HasHeaders,value:"HasHeaders"}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.WAC.UniqueArguments.SingleBindingResponse,fromHost:[{name:OSF.DDA.PropertyDescriptors.BindingProperties,value:0}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidAddBindingFromSelectionMethod,fromHost:[{name:OSF.DDA.WAC.UniqueArguments.SingleBindingResponse,value:OSF.DDA.WAC.UniqueArguments.BindingResponse}],toHost:[{name:OSF.DDA.WAC.UniqueArguments.BindingRequest,value:OSF.DDA.WAC.Delegate.ParameterMap.self}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidAddBindingFromNamedItemMethod,fromHost:[{name:OSF.DDA.WAC.UniqueArguments.SingleBindingResponse,value:OSF.DDA.WAC.UniqueArguments.BindingResponse}],toHost:[{name:OSF.DDA.WAC.UniqueArguments.BindingRequest,value:OSF.DDA.WAC.Delegate.ParameterMap.self}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidReleaseBindingMethod,toHost:[{name:OSF.DDA.WAC.UniqueArguments.BindingRequest,value:OSF.DDA.WAC.Delegate.ParameterMap.self}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetBindingMethod,fromHost:[{name:OSF.DDA.WAC.UniqueArguments.SingleBindingResponse,value:OSF.DDA.WAC.UniqueArguments.BindingResponse}],toHost:[{name:OSF.DDA.WAC.UniqueArguments.BindingRequest,value:OSF.DDA.WAC.Delegate.ParameterMap.self}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetAllBindingsMethod,fromHost:[{name:OSF.DDA.ListDescriptors.BindingList,value:OSF.DDA.WAC.UniqueArguments.BindingResponse}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetBindingDataMethod,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.WAC.UniqueArguments.Data}],toHost:[{name:OSF.DDA.WAC.UniqueArguments.GetData,value:OSF.DDA.WAC.Delegate.ParameterMap.self}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidSetBindingDataMethod,toHost:[{name:OSF.DDA.WAC.UniqueArguments.SetData,value:OSF.DDA.WAC.Delegate.ParameterMap.self}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidAddRowsMethod,toHost:[{name:OSF.DDA.WAC.UniqueArguments.AddRowsColumns,value:OSF.DDA.WAC.Delegate.ParameterMap.self}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidAddColumnsMethod,toHost:[{name:OSF.DDA.WAC.UniqueArguments.AddRowsColumns,value:OSF.DDA.WAC.Delegate.ParameterMap.self}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidClearAllRowsMethod,toHost:[{name:OSF.DDA.WAC.UniqueArguments.BindingRequest,value:OSF.DDA.WAC.Delegate.ParameterMap.self}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.WAC.UniqueArguments.AddRowsColumns,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:"BindingId"},{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.WAC.UniqueArguments.Data}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.Subset,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.StartRow,value:"StartRow"},{name:Microsoft.Office.WebExtension.Parameters.StartColumn,value:"StartCol"},{name:Microsoft.Office.WebExtension.Parameters.RowCount,value:"RowCount"},{name:Microsoft.Office.WebExtension.Parameters.ColumnCount,value:"ColCount"}]});OSF.DDA.AsyncMethodNames.addNames({GetSelectedDataAsync:"getSelectedDataAsync",SetSelectedDataAsync:"setSelectedDataAsync"});(function(){function a(b,d,c){var a=b[Microsoft.Office.WebExtension.Parameters.Data];if(OSF.DDA.TableDataProperties&&a&&(a[OSF.DDA.TableDataProperties.TableRows]!=undefined||a[OSF.DDA.TableDataProperties.TableHeaders]!=undefined))a=OSF.DDA.OMFactory.manufactureTableData(a);a=OSF.DDA.DataCoercion.coerceData(a,c[Microsoft.Office.WebExtension.Parameters.CoercionType]);return a==undefined?null:a}OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetSelectedDataAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,"enum":Microsoft.Office.WebExtension.CoercionType}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.ValueFormat,value:{"enum":Microsoft.Office.WebExtension.ValueFormat,defaultValue:Microsoft.Office.WebExtension.ValueFormat.Unformatted}},{name:Microsoft.Office.WebExtension.Parameters.FilterType,value:{"enum":Microsoft.Office.WebExtension.FilterType,defaultValue:Microsoft.Office.WebExtension.FilterType.All}}],privateStateCallbacks:[],onSucceeded:a});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.SetSelectedDataAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Data,types:["string","object","number","boolean"]}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:{"enum":Microsoft.Office.WebExtension.CoercionType,calculate:function(a){return OSF.DDA.DataCoercion.determineCoercionType(a[Microsoft.Office.WebExtension.Parameters.Data])}}},{name:Microsoft.Office.WebExtension.Parameters.ImageLeft,value:{types:["number","boolean"],defaultValue:false}},{name:Microsoft.Office.WebExtension.Parameters.ImageTop,value:{types:["number","boolean"],defaultValue:false}},{name:Microsoft.Office.WebExtension.Parameters.ImageWidth,value:{types:["number","boolean"],defaultValue:false}},{name:Microsoft.Office.WebExtension.Parameters.ImageHeight,value:{types:["number","boolean"],defaultValue:false}}],privateStateCallbacks:[]})})();OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetSelectedDataMethod,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.WAC.UniqueArguments.Data}],toHost:[{name:OSF.DDA.WAC.UniqueArguments.GetData,value:OSF.DDA.WAC.Delegate.ParameterMap.self}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidSetSelectedDataMethod,toHost:[{name:OSF.DDA.WAC.UniqueArguments.SetData,value:OSF.DDA.WAC.Delegate.ParameterMap.self}]});Microsoft.Office.WebExtension.EventType={};OSF.EventDispatch=function(b){this._eventHandlers={};this._objectEventHandlers={};this._queuedEventsArgs={};if(b!=null)for(var c=0;c<b.length;c++){var a=b[c],d=a=="objectDeleted"||a=="objectSelectionChanged"||a=="objectDataChanged"||a=="contentControlAdded";if(!d)this._eventHandlers[a]=[];else this._objectEventHandlers[a]={};this._queuedEventsArgs[a]=[]}};OSF.EventDispatch.prototype={getSupportedEvents:function(){var a=[];for(var b in this._eventHandlers)a.push(b);for(var b in this._objectEventHandlers)a.push(b);return a},supportsEvent:function(b){for(var a in this._eventHandlers)if(b==a)return true;for(var a in this._objectEventHandlers)if(b==a)return true;return false},hasEventHandler:function(c,d){var a=this._eventHandlers[c];if(a&&a.length>0)for(var b=0;b<a.length;b++)if(a[b]===d)return true;return false},hasObjectEventHandler:function(d,e,f){var c=this._objectEventHandlers[d];if(c!=null)for(var a=c[e],b=0;a!=null&&b<a.length;b++)if(a[b]===f)return true;return false},addEventHandler:function(b,a){if(typeof a!="function")return false;var c=this._eventHandlers[b];if(c&&!this.hasEventHandler(b,a)){c.push(a);return true}else return false},addObjectEventHandler:function(d,b,c){if(typeof c!="function")return false;var a=this._objectEventHandlers[d];if(a&&!this.hasObjectEventHandler(d,b,c)){if(a[b]==null)a[b]=[];a[b].push(c);return true}return false},addEventHandlerAndFireQueuedEvent:function(a,e){var d=this._eventHandlers[a],c=d.length==0,b=this.addEventHandler(a,e);c&&b&&this.fireQueuedEvent(a);return b},removeEventHandler:function(c,d){var a=this._eventHandlers[c];if(a&&a.length>0)for(var b=0;b<a.length;b++)if(a[b]===d){a.splice(b,1);return true}return false},removeObjectEventHandler:function(d,e,f){var c=this._objectEventHandlers[d];if(c!=null)for(var a=c[e],b=0;a!=null&&b<a.length;b++)if(a[b]===f){a.splice(b,1);return true}return false},clearEventHandlers:function(a){if(typeof this._eventHandlers[a]!="undefined"&&this._eventHandlers[a].length>0){this._eventHandlers[a]=[];return true}return false},clearObjectEventHandlers:function(a,b){if(this._objectEventHandlers[a]!=null&&this._objectEventHandlers[a][b]!=null){this._objectEventHandlers[a][b]=[];return true}return false},getEventHandlerCount:function(a){return this._eventHandlers[a]!=undefined?this._eventHandlers[a].length:-1},getObjectEventHandlerCount:function(a,b){if(this._objectEventHandlers[a]==null||this._objectEventHandlers[a][b]==null)return 0;return this._objectEventHandlers[a][b].length},fireEvent:function(a){if(a.type==undefined)return false;var b=a.type;if(b&&this._eventHandlers[b]){for(var d=this._eventHandlers[b],c=0;c<d.length;c++)d[c](a);return true}else return false},fireObjectEvent:function(f,a){if(a.type==undefined)return false;var b=a.type;if(b&&this._objectEventHandlers[b]){var e=this._objectEventHandlers[b],c=e[f];if(c!=null){for(var d=0;d<c.length;d++)c[d](a);return true}}return false},fireOrQueueEvent:function(b){var a=b.type;if(a&&this._eventHandlers[a]){var c=this._eventHandlers[a],d=this._queuedEventsArgs[a];if(c.length==0)d.push(b);else this.fireEvent(b);return true}else return false},fireQueuedEvent:function(a){if(a&&this._eventHandlers[a]){var b=this._eventHandlers[a],c=this._queuedEventsArgs[a];if(b.length>0){var d=b[0];while(c.length>0){var e=c.shift();d(e)}return true}}return false},clearQueuedEvent:function(a){if(a&&this._eventHandlers[a]){var b=this._queuedEventsArgs[a];if(b)this._queuedEventsArgs[a]=[]}}};OSF.DDA.OMFactory=OSF.DDA.OMFactory||{};OSF.DDA.OMFactory.manufactureEventArgs=function(c,d,b){var a;switch(c){case Microsoft.Office.WebExtension.EventType.DocumentSelectionChanged:a=new OSF.DDA.DocumentSelectionChangedEventArgs(d);break;case Microsoft.Office.WebExtension.EventType.BindingSelectionChanged:a=new OSF.DDA.BindingSelectionChangedEventArgs(this.manufactureBinding(b,d.document),b[OSF.DDA.PropertyDescriptors.Subset]);break;case Microsoft.Office.WebExtension.EventType.BindingDataChanged:a=new OSF.DDA.BindingDataChangedEventArgs(this.manufactureBinding(b,d.document));break;case Microsoft.Office.WebExtension.EventType.SettingsChanged:a=new OSF.DDA.SettingsChangedEventArgs(d);break;case Microsoft.Office.WebExtension.EventType.ActiveViewChanged:a=new OSF.DDA.ActiveViewChangedEventArgs(b);break;case Microsoft.Office.WebExtension.EventType.OfficeThemeChanged:a=new OSF.DDA.Theming.OfficeThemeChangedEventArgs(b);break;case Microsoft.Office.WebExtension.EventType.DocumentThemeChanged:a=new OSF.DDA.Theming.DocumentThemeChangedEventArgs(b);break;case Microsoft.Office.WebExtension.EventType.AppCommandInvoked:a=OSF.DDA.AppCommand.AppCommandInvokedEventArgs.create(b);break;case Microsoft.Office.WebExtension.EventType.ObjectDeleted:case Microsoft.Office.WebExtension.EventType.ObjectSelectionChanged:case Microsoft.Office.WebExtension.EventType.ObjectDataChanged:case Microsoft.Office.WebExtension.EventType.ContentControlAdded:a=new OSF.DDA.ObjectEventArgs(c,b[Microsoft.Office.WebExtension.Parameters.Id]);break;case Microsoft.Office.WebExtension.EventType.RichApiMessage:a=new OSF.DDA.RichApiMessageEventArgs(c,b);break;case Microsoft.Office.WebExtension.EventType.DataNodeInserted:a=new OSF.DDA.NodeInsertedEventArgs(this.manufactureDataNode(b[OSF.DDA.DataNodeEventProperties.NewNode]),b[OSF.DDA.DataNodeEventProperties.InUndoRedo]);break;case Microsoft.Office.WebExtension.EventType.DataNodeReplaced:a=new OSF.DDA.NodeReplacedEventArgs(this.manufactureDataNode(b[OSF.DDA.DataNodeEventProperties.OldNode]),this.manufactureDataNode(b[OSF.DDA.DataNodeEventProperties.NewNode]),b[OSF.DDA.DataNodeEventProperties.InUndoRedo]);break;case Microsoft.Office.WebExtension.EventType.DataNodeDeleted:a=new OSF.DDA.NodeDeletedEventArgs(this.manufactureDataNode(b[OSF.DDA.DataNodeEventProperties.OldNode]),this.manufactureDataNode(b[OSF.DDA.DataNodeEventProperties.NextSiblingNode]),b[OSF.DDA.DataNodeEventProperties.InUndoRedo]);break;case Microsoft.Office.WebExtension.EventType.TaskSelectionChanged:a=new OSF.DDA.TaskSelectionChangedEventArgs(d);break;case Microsoft.Office.WebExtension.EventType.ResourceSelectionChanged:a=new OSF.DDA.ResourceSelectionChangedEventArgs(d);break;case Microsoft.Office.WebExtension.EventType.ViewSelectionChanged:a=new OSF.DDA.ViewSelectionChangedEventArgs(d);break;case Microsoft.Office.WebExtension.EventType.DialogMessageReceived:a=new OSF.DDA.DialogEventArgs(b);break;case Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived:a=new OSF.DDA.DialogParentEventArgs(b);break;case Microsoft.Office.WebExtension.EventType.ItemChanged:if(OSF._OfficeAppFactory.getHostInfo().hostType=="outlook"){a=new OSF.DDA.OlkItemSelectedChangedEventArgs(b);d.initialize(a.initialData);(OSF._OfficeAppFactory.getHostInfo().hostPlatform=="win32"||OSF._OfficeAppFactory.getHostInfo().hostPlatform=="mac")&&d.setCurrentItemNumber(a.itemNumber.itemNumber)}else throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,c));break;case Microsoft.Office.WebExtension.EventType.RecipientsChanged:if(OSF._OfficeAppFactory.getHostInfo().hostType=="outlook")a=new OSF.DDA.OlkRecipientsChangedEventArgs(b);else throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,c));break;case Microsoft.Office.WebExtension.EventType.AppointmentTimeChanged:if(OSF._OfficeAppFactory.getHostInfo().hostType=="outlook")a=new OSF.DDA.OlkAppointmentTimeChangedEventArgs(b);else throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,c));break;case Microsoft.Office.WebExtension.EventType.RecurrenceChanged:if(OSF._OfficeAppFactory.getHostInfo().hostType=="outlook")a=new OSF.DDA.OlkRecurrenceChangedEventArgs(b);else throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,c));break;case Microsoft.Office.WebExtension.EventType.AttachmentsChanged:if(OSF._OfficeAppFactory.getHostInfo().hostType=="outlook")a=new OSF.DDA.OlkAttachmentsChangedEventArgs(b);else throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,c));break;case Microsoft.Office.WebExtension.EventType.EnhancedLocationsChanged:if(OSF._OfficeAppFactory.getHostInfo().hostType=="outlook")a=new OSF.DDA.OlkEnhancedLocationsChangedEventArgs(b);else throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,c));break;case Microsoft.Office.WebExtension.EventType.InfobarClicked:if(OSF._OfficeAppFactory.getHostInfo().hostType=="outlook")a=new OSF.DDA.OlkInfobarClickedEventArgs(b);else throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,c));break;default:throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,c));}return a};OSF.DDA.AsyncMethodNames.addNames({AddHandlerAsync:"addHandlerAsync",RemoveHandlerAsync:"removeHandlerAsync"});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AddHandlerAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.EventType,"enum":Microsoft.Office.WebExtension.EventType,verify:function(b,c,a){return a.supportsEvent(b)}},{name:Microsoft.Office.WebExtension.Parameters.Handler,types:["function"]}],supportedOptions:[],privateStateCallbacks:[]});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.RemoveHandlerAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.EventType,"enum":Microsoft.Office.WebExtension.EventType,verify:function(b,c,a){return a.supportsEvent(b)}}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.Handler,value:{types:["function","object"],defaultValue:null}}],privateStateCallbacks:[]});OSF.OUtil.augmentList(OSF.DDA.EventDescriptors,{ActiveViewChangedEvent:"ActiveViewChangedEvent"});Microsoft.Office.WebExtension.ActiveView={Read:"read",Edit:"edit"};OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{ActiveViewChanged:"activeViewChanged"});OSF.DDA.AsyncMethodNames.addNames({GetActiveViewAsync:"getActiveViewAsync"});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetActiveViewAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[],onSucceeded:function(b){var a=b[Microsoft.Office.WebExtension.Parameters.ActiveView];return a==undefined?null:a}});OSF.DDA.ActiveViewChangedEventArgs=function(a){OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.ActiveViewChanged},activeView:{value:a.activeView}})};OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetActiveViewMethod,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.ActiveView,value:Microsoft.Office.WebExtension.Parameters.Data}]});Microsoft.Office.WebExtension.GoToType={Binding:"binding",NamedItem:"namedItem",Slide:"slide",Index:"index"};Microsoft.Office.WebExtension.SelectionMode={Default:"default",Selected:"selected",None:"none"};Microsoft.Office.WebExtension.Index={First:"first",Last:"last",Next:"next",Previous:"previous"};OSF.DDA.AsyncMethodNames.addNames({GoToByIdAsync:"goToByIdAsync"});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GoToByIdAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Id,types:["string","number"]},{name:Microsoft.Office.WebExtension.Parameters.GoToType,"enum":Microsoft.Office.WebExtension.GoToType}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.SelectionMode,value:{"enum":Microsoft.Office.WebExtension.SelectionMode,defaultValue:Microsoft.Office.WebExtension.SelectionMode.Default}}]});OSF.OUtil.setNamespace("Marshaling",OSF.DDA);OSF.DDA.Marshaling.NavigationKeys={NavigationRequest:"DdaGoToByIdMethod",Id:"Id",GoToType:"GoToType",SelectionMode:"SelectionMode"};var OSF_DDA_Marshaling_GoToType;(function(a){a[a.Binding=0]="Binding";a[a.NamedItem=1]="NamedItem";a[a.Slide=2]="Slide";a[a.Index=3]="Index"})(OSF_DDA_Marshaling_GoToType||(OSF_DDA_Marshaling_GoToType={}));OSF.DDA.Marshaling.GoToType=OSF_DDA_Marshaling_GoToType;var OSF_DDA_Marshaling_SelectionMode;(function(a){a[a.Default=0]="Default";a[a.Selected=1]="Selected";a[a.None=2]="None"})(OSF_DDA_Marshaling_SelectionMode||(OSF_DDA_Marshaling_SelectionMode={}));OSF.DDA.Marshaling.SelectionMode=OSF_DDA_Marshaling_SelectionMode;OSF.DDA.WAC.Delegate.ParameterMap.addComplexType(OSF.DDA.Marshaling.NavigationKeys.NavigationRequest);OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.Marshaling.NavigationKeys.NavigationRequest,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:OSF.DDA.Marshaling.NavigationKeys.Id},{name:Microsoft.Office.WebExtension.Parameters.GoToType,value:OSF.DDA.Marshaling.NavigationKeys.GoToType},{name:Microsoft.Office.WebExtension.Parameters.SelectionMode,value:OSF.DDA.Marshaling.NavigationKeys.SelectionMode}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.GoToType,toHost:[{name:Microsoft.Office.WebExtension.GoToType.Binding,value:OSF.DDA.Marshaling.GoToType.Binding},{name:Microsoft.Office.WebExtension.GoToType.NamedItem,value:OSF.DDA.Marshaling.GoToType.NamedItem},{name:Microsoft.Office.WebExtension.GoToType.Slide,value:OSF.DDA.Marshaling.GoToType.Slide},{name:Microsoft.Office.WebExtension.GoToType.Index,value:OSF.DDA.Marshaling.GoToType.Index}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.SelectionMode,toHost:[{name:Microsoft.Office.WebExtension.SelectionMode.Default,value:OSF.DDA.Marshaling.SelectionMode.Default},{name:Microsoft.Office.WebExtension.SelectionMode.Selected,value:OSF.DDA.Marshaling.SelectionMode.Selected},{name:Microsoft.Office.WebExtension.SelectionMode.None,value:OSF.DDA.Marshaling.SelectionMode.None}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidNavigateToMethod,toHost:[{name:OSF.DDA.Marshaling.NavigationKeys.NavigationRequest,value:OSF.DDA.WAC.Delegate.ParameterMap.self}]});Microsoft.Office.WebExtension.FileType={Text:"text",Compressed:"compressed",Pdf:"pdf"};OSF.OUtil.augmentList(OSF.DDA.PropertyDescriptors,{FileProperties:"FileProperties",FileSliceProperties:"FileSliceProperties"});OSF.DDA.FileProperties={Handle:"FileHandle",FileSize:"FileSize",SliceSize:Microsoft.Office.WebExtension.Parameters.SliceSize};OSF.DDA.File=function(e,c,b){OSF.OUtil.defineEnumerableProperties(this,{size:{value:c},sliceCount:{value:Math.ceil(c/b)}});var a={};a[OSF.DDA.FileProperties.Handle]=e;a[OSF.DDA.FileProperties.SliceSize]=b;var d=OSF.DDA.AsyncMethodNames;OSF.DDA.DispIdHost.addAsyncMethods(this,[d.GetDocumentCopyChunkAsync,d.ReleaseDocumentCopyAsync],a)};OSF.DDA.FileSliceOffset="fileSliceoffset";OSF.DDA.AsyncMethodNames.addNames({GetDocumentCopyAsync:"getFileAsync",GetDocumentCopyChunkAsync:"getSliceAsync",ReleaseDocumentCopyAsync:"closeAsync"});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetDocumentCopyAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.FileType,"enum":Microsoft.Office.WebExtension.FileType}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.SliceSize,value:{types:["number"],defaultValue:4*1024*1024}}],checkCallArgs:function(b,d,c){var a=b[Microsoft.Office.WebExtension.Parameters.SliceSize];if(a<=0||a>4*1024*1024)throw OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSliceSize;return b},onSucceeded:function(a,c,b){return new OSF.DDA.File(a[OSF.DDA.FileProperties.Handle],a[OSF.DDA.FileProperties.FileSize],b[Microsoft.Office.WebExtension.Parameters.SliceSize])}});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetDocumentCopyChunkAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.SliceIndex,types:["number"]}],privateStateCallbacks:[{name:OSF.DDA.FileProperties.Handle,value:function(b,a){return a[OSF.DDA.FileProperties.Handle]}},{name:OSF.DDA.FileProperties.SliceSize,value:function(b,a){return a[OSF.DDA.FileProperties.SliceSize]}}],checkCallArgs:function(a,d,c){var b=a[Microsoft.Office.WebExtension.Parameters.SliceIndex];if(b<0||b>=d.sliceCount)throw OSF.DDA.ErrorCodeManager.errorCodes.ooeIndexOutOfRange;a[OSF.DDA.FileSliceOffset]=parseInt((b*c[OSF.DDA.FileProperties.SliceSize]).toString());return a},onSucceeded:function(a,d,c){var b={};OSF.OUtil.defineEnumerableProperties(b,{data:{value:a[Microsoft.Office.WebExtension.Parameters.Data]},index:{value:c[Microsoft.Office.WebExtension.Parameters.SliceIndex]},size:{value:a[OSF.DDA.FileProperties.SliceSize]}});return b}});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.ReleaseDocumentCopyAsync,privateStateCallbacks:[{name:OSF.DDA.FileProperties.Handle,value:function(b,a){return a[OSF.DDA.FileProperties.Handle]}}]});OSF.OUtil.setNamespace("Marshaling",OSF.DDA);OSF.OUtil.setNamespace("File",OSF.DDA.Marshaling);var OSF_DDA_Marshaling_File_FilePropertiesKeys;(function(a){a[a.Handle=0]="Handle";a[a.FileSize=1]="FileSize"})(OSF_DDA_Marshaling_File_FilePropertiesKeys||(OSF_DDA_Marshaling_File_FilePropertiesKeys={}));OSF.DDA.Marshaling.File.FilePropertiesKeys=OSF_DDA_Marshaling_File_FilePropertiesKeys;var OSF_DDA_Marshaling_File_SlicePropertiesKeys;(function(a){a[a.Data=0]="Data";a[a.SliceSize=1]="SliceSize"})(OSF_DDA_Marshaling_File_SlicePropertiesKeys||(OSF_DDA_Marshaling_File_SlicePropertiesKeys={}));OSF.DDA.Marshaling.File.SlicePropertiesKeys=OSF_DDA_Marshaling_File_SlicePropertiesKeys;var OSF_DDA_Marshaling_File_FileType;(function(a){a[a.Text=0]="Text";a[a.Compressed=1]="Compressed";a[a.Pdf=2]="Pdf"})(OSF_DDA_Marshaling_File_FileType||(OSF_DDA_Marshaling_File_FileType={}));OSF.DDA.Marshaling.File.FileType=OSF_DDA_Marshaling_File_FileType;var OSF_DDA_Marshaling_File_ParameterKeys;(function(a){a[a.FileType=0]="FileType";a[a.SliceSize=1]="SliceSize";a[a.Handle=2]="Handle";a[a.SliceIndex=3]="SliceIndex"})(OSF_DDA_Marshaling_File_ParameterKeys||(OSF_DDA_Marshaling_File_ParameterKeys={}));OSF.DDA.Marshaling.File.ParameterKeys=OSF_DDA_Marshaling_File_ParameterKeys;OSF.DDA.WAC.Delegate.ParameterMap.addComplexType(OSF.DDA.PropertyDescriptors.FileProperties);OSF.DDA.WAC.Delegate.ParameterMap.addComplexType(OSF.DDA.PropertyDescriptors.FileSliceProperties);OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.FileProperties,fromHost:[{name:OSF.DDA.FileProperties.Handle,value:OSF.DDA.Marshaling.File.FilePropertiesKeys.Handle},{name:OSF.DDA.FileProperties.FileSize,value:OSF.DDA.Marshaling.File.FilePropertiesKeys.FileSize}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.FileSliceProperties,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.Marshaling.File.SlicePropertiesKeys.Data},{name:OSF.DDA.FileProperties.SliceSize,value:OSF.DDA.Marshaling.File.SlicePropertiesKeys.SliceSize}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.FileType,toHost:[{name:Microsoft.Office.WebExtension.FileType.Text,value:OSF.DDA.Marshaling.File.FileType.Text},{name:Microsoft.Office.WebExtension.FileType.Compressed,value:OSF.DDA.Marshaling.File.FileType.Compressed},{name:Microsoft.Office.WebExtension.FileType.Pdf,value:OSF.DDA.Marshaling.File.FileType.Pdf}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetDocumentCopyMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.FileType,value:OSF.DDA.Marshaling.File.ParameterKeys.FileType},{name:Microsoft.Office.WebExtension.Parameters.SliceSize,value:OSF.DDA.Marshaling.File.ParameterKeys.SliceSize}],fromHost:[{name:OSF.DDA.PropertyDescriptors.FileProperties,value:OSF.DDA.WAC.Delegate.ParameterMap.self}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetDocumentCopyChunkMethod,toHost:[{name:OSF.DDA.FileProperties.Handle,value:OSF.DDA.Marshaling.File.ParameterKeys.Handle},{name:Microsoft.Office.WebExtension.Parameters.SliceIndex,value:OSF.DDA.Marshaling.File.ParameterKeys.SliceIndex}],fromHost:[{name:OSF.DDA.PropertyDescriptors.FileSliceProperties,value:OSF.DDA.WAC.Delegate.ParameterMap.self}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidReleaseDocumentCopyMethod,toHost:[{name:OSF.DDA.FileProperties.Handle,value:OSF.DDA.Marshaling.File.ParameterKeys.Handle}]});OSF.DDA.FilePropertiesDescriptor={Url:"Url"};OSF.OUtil.augmentList(OSF.DDA.PropertyDescriptors,{FilePropertiesDescriptor:"FilePropertiesDescriptor"});Microsoft.Office.WebExtension.FileProperties=function(a){OSF.OUtil.defineEnumerableProperties(this,{url:{value:a[OSF.DDA.FilePropertiesDescriptor.Url]}})};OSF.DDA.AsyncMethodNames.addNames({GetFilePropertiesAsync:"getFilePropertiesAsync"});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetFilePropertiesAsync,fromHost:[{name:OSF.DDA.PropertyDescriptors.FilePropertiesDescriptor,value:0}],requiredArguments:[],supportedOptions:[],onSucceeded:function(a,c,b){return new Microsoft.Office.WebExtension.FileProperties(a)}});OSF.OUtil.setNamespace("Marshaling",OSF.DDA);var OSF_DDA_Marshaling_FilePropertiesKeys;(function(a){a[a.Properties=0]="Properties";a[a.Url=1]="Url"})(OSF_DDA_Marshaling_FilePropertiesKeys||(OSF_DDA_Marshaling_FilePropertiesKeys={}));OSF.DDA.Marshaling.FilePropertiesKeys=OSF_DDA_Marshaling_FilePropertiesKeys;OSF.DDA.WAC.Delegate.ParameterMap.addComplexType(OSF.DDA.PropertyDescriptors.FilePropertiesDescriptor);OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.FilePropertiesDescriptor,fromHost:[{name:OSF.DDA.FilePropertiesDescriptor.Url,value:OSF.DDA.Marshaling.FilePropertiesKeys.Url}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetFilePropertiesMethod,fromHost:[{name:OSF.DDA.PropertyDescriptors.FilePropertiesDescriptor,value:OSF.DDA.Marshaling.FilePropertiesKeys.Properties}]});OSF.DDA.AsyncMethodNames.addNames({ExecuteRichApiRequestAsync:"executeRichApiRequestAsync"});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.ExecuteRichApiRequestAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Data,types:["object"]}],supportedOptions:[]});OSF.OUtil.setNamespace("RichApi",OSF.DDA);OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidExecuteRichApiRequestMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.WAC.UniqueArguments.ArrayData}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.WAC.UniqueArguments.Data}]});OSF.DDA.AsyncMethodNames.addNames({GetOfficeThemeAsync:"getOfficeThemeAsync",GetDocumentThemeAsync:"getDocumentThemeAsync"});OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{OfficeThemeChanged:"officeThemeChanged",DocumentThemeChanged:"documentThemeChanged"});OSF.OUtil.augmentList(Microsoft.Office.WebExtension.Parameters,{DocumentTheme:"documentTheme",OfficeTheme:"officeTheme"});OSF.OUtil.augmentList(OSF.DDA.EventDescriptors,{DocumentThemeChangedEvent:"DocumentThemeChangedEvent",OfficeThemeChangedEvent:"OfficeThemeChangedEvent"});OSF.OUtil.setNamespace("Theming",OSF.DDA);OSF.DDA.Theming.OfficeThemeEnum={PrimaryFontColor:"primaryFontColor",PrimaryBackgroundColor:"primaryBackgroundColor",SecondaryFontColor:"secondaryFontColor",SecondaryBackgroundColor:"secondaryBackgroundColor"};OSF.DDA.Theming.DocumentThemeEnum={PrimaryFontColor:"primaryFontColor",PrimaryBackgroundColor:"primaryBackgroundColor",SecondaryFontColor:"secondaryFontColor",SecondaryBackgroundColor:"secondaryBackgroundColor",Accent1:"accent1",Accent2:"accent2",Accent3:"accent3",Accent4:"accent4",Accent5:"accent5",Accent6:"accent6",Hyperlink:"hyperlink",FollowedHyperlink:"followedHyperlink",HeaderLatinFont:"headerLatinFont",HeaderEastAsianFont:"headerEastAsianFont",HeaderScriptFont:"headerScriptFont",HeaderLocalizedFont:"headerLocalizedFont",BodyLatinFont:"bodyLatinFont",BodyEastAsianFont:"bodyEastAsianFont",BodyScriptFont:"bodyScriptFont",BodyLocalizedFont:"bodyLocalizedFont"};OSF.DDA.Theming.ConvertToDocumentTheme=function(d){for(var b=[{name:"primaryFontColor",needToConvertToHex:true},{name:"primaryBackgroundColor",needToConvertToHex:true},{name:"secondaryFontColor",needToConvertToHex:true},{name:"secondaryBackgroundColor",needToConvertToHex:true},{name:"accent1",needToConvertToHex:true},{name:"accent2",needToConvertToHex:true},{name:"accent3",needToConvertToHex:true},{name:"accent4",needToConvertToHex:true},{name:"accent5",needToConvertToHex:true},{name:"accent6",needToConvertToHex:true},{name:"hyperlink",needToConvertToHex:true},{name:"followedHyperlink",needToConvertToHex:true},{name:"headerLatinFont",needToConvertToHex:false},{name:"headerEastAsianFont",needToConvertToHex:false},{name:"headerScriptFont",needToConvertToHex:false},{name:"headerLocalizedFont",needToConvertToHex:false},{name:"bodyLatinFont",needToConvertToHex:false},{name:"bodyEastAsianFont",needToConvertToHex:false},{name:"bodyScriptFont",needToConvertToHex:false},{name:"bodyLocalizedFont",needToConvertToHex:false}],c={},a=0;a<b.length;a++)if(b[a].needToConvertToHex)c[b[a].name]=OSF.OUtil.convertIntToCssHexColor(d[b[a].name]);else c[b[a].name]=d[b[a].name];return c};OSF.DDA.Theming.ConvertToOfficeTheme=function(a){var b={};for(var c in a)b[c]=OSF.OUtil.convertIntToCssHexColor(a[c]);return b};OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetDocumentThemeAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[],onSucceeded:OSF.DDA.Theming.ConvertToDocumentTheme});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetOfficeThemeAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[],onSucceeded:OSF.DDA.Theming.ConvertToOfficeTheme});OSF.DDA.Theming.OfficeThemeChangedEventArgs=function(a){var b=OSF.DDA.Theming.ConvertToOfficeTheme(a);OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.OfficeThemeChanged},officeTheme:{value:b}})};OSF.DDA.Theming.DocumentThemeChangedEventArgs=function(a){var b=OSF.DDA.Theming.ConvertToDocumentTheme(a);OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DocumentThemeChanged},documentTheme:{value:b}})};var OSF_DDA_Theming_InternalThemeHandler=function(){function a(){this._pseudoDocumentObject=null;this._previousDocumentThemeData=null;this._previousOfficeThemeData=null;this._officeCss=null;this._asyncCallsCompleted=null;this._onAsyncCallsCompleted=null}a.prototype.InitializeAndChangeOnce=function(b){this._officeCss=this._getOfficeThemesCss();if(!this._officeCss){b&&b();return}this._onAsyncCallsCompleted=b;this._pseudoDocumentObject={};var a=this._pseudoDocumentObject;OSF.DDA.DispIdHost.addAsyncMethods(a,[OSF.DDA.AsyncMethodNames.GetOfficeThemeAsync,OSF.DDA.AsyncMethodNames.GetDocumentThemeAsync]);OSF.DDA.DispIdHost.addEventSupport(a,new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.OfficeThemeChanged,Microsoft.Office.WebExtension.EventType.DocumentThemeChanged]));this._asyncCallsCompleted={};this._asyncCallsCompleted[OSF.DDA.AsyncMethodNames.GetOfficeThemeAsync]=false;this._asyncCallsCompleted[OSF.DDA.AsyncMethodNames.GetDocumentThemeAsync]=false;this._getAndProcessThemeData(a.getDocumentThemeAsync,Function.createDelegate(this,this._processDocumentThemeData),OSF.DDA.AsyncMethodNames.GetDocumentThemeAsync);this._getAndProcessThemeData(a.getOfficeThemeAsync,Function.createDelegate(this,this._processOfficeThemeData),OSF.DDA.AsyncMethodNames.GetOfficeThemeAsync)};a.prototype._getOfficeThemesCss=function(){function a(){for(var c="officethemes.css",b=0;b<document.styleSheets.length;b++){var a=document.styleSheets[b];if(!a.disabled&&a.href&&c==a.href.substring(a.href.length-c.length,a.href.length).toLowerCase())if(!a.cssRules&&!a.rules)return null;else return a}}try{return a()}catch(b){return null}};a.prototype._changeCss=function(a,f,e){for(var g=a.cssRules?a.cssRules.length:a.rules.length,b=0;b<g;b++){var d;if(a.cssRules)d=a.cssRules[b];else d=a.rules[b];var c=d.selectorText;if(c&&c.toLowerCase()==f.toLowerCase())if(a.cssRules){a.deleteRule(b);a.insertRule(c+e,b)}else{a.removeRule(b);a.addRule(c,e,b)}}};a.prototype._changeDocumentThemeData=function(e){for(var b=[{name:"primaryFontColor",cssSelector:".office-docTheme-primary-fontColor",cssProperty:"color"},{name:"primaryBackgroundColor",cssSelector:".office-docTheme-primary-bgColor",cssProperty:"background-color"},{name:"secondaryFontColor",cssSelector:".office-docTheme-secondary-fontColor",cssProperty:"color"},{name:"secondaryBackgroundColor",cssSelector:".office-docTheme-secondary-bgColor",cssProperty:"background-color"},{name:"accent1",cssSelector:".office-contentAccent1-color",cssProperty:"color"},{name:"accent2",cssSelector:".office-contentAccent2-color",cssProperty:"color"},{name:"accent3",cssSelector:".office-contentAccent3-color",cssProperty:"color"},{name:"accent4",cssSelector:".office-contentAccent4-color",cssProperty:"color"},{name:"accent5",cssSelector:".office-contentAccent5-color",cssProperty:"color"},{name:"accent6",cssSelector:".office-contentAccent6-color",cssProperty:"color"},{name:"accent1",cssSelector:".office-contentAccent1-bgColor",cssProperty:"background-color"},{name:"accent2",cssSelector:".office-contentAccent2-bgColor",cssProperty:"background-color"},{name:"accent3",cssSelector:".office-contentAccent3-bgColor",cssProperty:"background-color"},{name:"accent4",cssSelector:".office-contentAccent4-bgColor",cssProperty:"background-color"},{name:"accent5",cssSelector:".office-contentAccent5-bgColor",cssProperty:"background-color"},{name:"accent6",cssSelector:".office-contentAccent6-bgColor",cssProperty:"background-color"},{name:"accent1",cssSelector:".office-contentAccent1-borderColor",cssProperty:"border-color"},{name:"accent2",cssSelector:".office-contentAccent2-borderColor",cssProperty:"border-color"},{name:"accent3",cssSelector:".office-contentAccent3-borderColor",cssProperty:"border-color"},{name:"accent4",cssSelector:".office-contentAccent4-borderColor",cssProperty:"border-color"},{name:"accent5",cssSelector:".office-contentAccent5-borderColor",cssProperty:"border-color"},{name:"accent6",cssSelector:".office-contentAccent6-borderColor",cssProperty:"border-color"},{name:"hyperlink",cssSelector:".office-a",cssProperty:"color"},{name:"followedHyperlink",cssSelector:".office-a:visited",cssProperty:"color"},{name:"headerLatinFont",cssSelector:".office-headerFont-latin",cssProperty:"font-family"},{name:"headerEastAsianFont",cssSelector:".office-headerFont-eastAsian",cssProperty:"font-family"},{name:"headerScriptFont",cssSelector:".office-headerFont-script",cssProperty:"font-family"},{name:"headerLocalizedFont",cssSelector:".office-headerFont-localized",cssProperty:"font-family"},{name:"bodyLatinFont",cssSelector:".office-bodyFont-latin",cssProperty:"font-family"},{name:"bodyEastAsianFont",cssSelector:".office-bodyFont-eastAsian",cssProperty:"font-family"},{name:"bodyScriptFont",cssSelector:".office-bodyFont-script",cssProperty:"font-family"},{name:"bodyLocalizedFont",cssSelector:".office-bodyFont-localized",cssProperty:"font-family"}],c=e.type=="documentThemeChanged"?e.documentTheme:e,a=0;a<b.length;a++)if(this._previousDocumentThemeData===null||this._previousDocumentThemeData[b[a].name]!=c[b[a].name])if(c[b[a].name]!=null&&c[b[a].name]!=""){var d=c[b[a].name];if(b[a].cssProperty==="font-family")d='"'+d.replace(/"/g,'\\"')+'"';this._changeCss(this._officeCss,b[a].cssSelector,"{"+b[a].cssProperty+":"+d+";}")}else this._changeCss(this._officeCss,b[a].cssSelector,"{}");this._previousDocumentThemeData=c};a.prototype._changeOfficeThemeData=function(d){for(var b=[{name:"primaryFontColor",cssSelector:".office-officeTheme-primary-fontColor",cssProperty:"color"},{name:"primaryBackgroundColor",cssSelector:".office-officeTheme-primary-bgColor",cssProperty:"background-color"},{name:"secondaryFontColor",cssSelector:".office-officeTheme-secondary-fontColor",cssProperty:"color"},{name:"secondaryBackgroundColor",cssSelector:".office-officeTheme-secondary-bgColor",cssProperty:"background-color"}],c=d.type=="officeThemeChanged"?d.officeTheme:d,a=0;a<b.length;a++)if(this._previousOfficeThemeData===null||this._previousOfficeThemeData[b[a].name]!=c[b[a].name])c[b[a].name]!==undefined&&this._changeCss(this._officeCss,b[a].cssSelector,"{"+b[a].cssProperty+":"+c[b[a].name]+";}");this._previousOfficeThemeData=c};a.prototype._getAndProcessThemeData=function(c,b,a){c(Function.createDelegate(this,function(c){if(c.status=="succeeded"){var d=c.value;b(d)}if(this._areAllCallsCompleted(a)&&this._onAsyncCallsCompleted){this._onAsyncCallsCompleted();this._onAsyncCallsCompleted=null}}))};a.prototype._processOfficeThemeData=function(a){this._changeOfficeThemeData(a);this._pseudoDocumentObject.addHandlerAsync(Microsoft.Office.WebExtension.EventType.OfficeThemeChanged,Function.createDelegate(this,this._changeOfficeThemeData),null)};a.prototype._processDocumentThemeData=function(a){this._changeDocumentThemeData(a);this._pseudoDocumentObject.addHandlerAsync(Microsoft.Office.WebExtension.EventType.DocumentThemeChanged,Function.createDelegate(this,this._changeDocumentThemeData),null)};a.prototype._areAllCallsCompleted=function(b){var a;if(!(a=this._asyncCallsCompleted))return true;if(b&&a.hasOwnProperty(b))a[b]=true;for(var c in a){if(a.hasOwnProperty(c)&&a[c])continue;return false}return true};return a}();OSF.DDA.Theming.InternalThemeHandler=OSF_DDA_Theming_InternalThemeHandler;OSF.OUtil.setNamespace("Marshaling",OSF.DDA);var OSF_DDA_Marshaling_ThemingKeys;(function(a){a[a.DocumentTheme=0]="DocumentTheme";a[a.OfficeTheme=1]="OfficeTheme";a[a.Background1=2]="Background1";a[a.Text1=3]="Text1";a[a.Background2=4]="Background2";a[a.Text2=5]="Text2";a[a.Accent1=6]="Accent1";a[a.Accent2=7]="Accent2";a[a.Accent3=8]="Accent3";a[a.Accent4=9]="Accent4";a[a.Accent5=10]="Accent5";a[a.Accent6=11]="Accent6";a[a.Hyperlink=12]="Hyperlink";a[a.FollowedHyperlink=13]="FollowedHyperlink";a[a.HdLatin=14]="HdLatin";a[a.HdEastAsian=15]="HdEastAsian";a[a.HdScript=16]="HdScript";a[a.HdLocalized=17]="HdLocalized";a[a.BdLatin=18]="BdLatin";a[a.BdEastAsian=19]="BdEastAsian";a[a.BdScript=20]="BdScript";a[a.BdLocalized=21]="BdLocalized";a[a.BackgroundColor=22]="BackgroundColor";a[a.PrimaryText=23]="PrimaryText";a[a.PrimaryBackground=24]="PrimaryBackground";a[a.SecondaryText=25]="SecondaryText";a[a.SecondaryBackground=26]="SecondaryBackground"})(OSF_DDA_Marshaling_ThemingKeys||(OSF_DDA_Marshaling_ThemingKeys={}));OSF.DDA.Marshaling.ThemingKeys=OSF_DDA_Marshaling_ThemingKeys;var parameterMap=OSF.DDA.WAC.Delegate.ParameterMap,hostKeys=OSF.DDA.Marshaling.ThemingKeys;parameterMap.addComplexType(Microsoft.Office.WebExtension.Parameters.DocumentTheme);parameterMap.addComplexType(Microsoft.Office.WebExtension.Parameters.OfficeTheme);parameterMap.define({type:OSF.DDA.MethodDispId.dispidGetDocumentThemeMethod,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.DocumentTheme,value:hostKeys.DocumentTheme}]});parameterMap.define({type:OSF.DDA.MethodDispId.dispidGetOfficeThemeMethod,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.OfficeTheme,value:hostKeys.OfficeTheme}]});parameterMap.define({type:OSF.DDA.EventDispId.dispidDocumentThemeChangedEvent,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.DocumentTheme,value:hostKeys.DocumentTheme}]});parameterMap.define({type:OSF.DDA.EventDispId.dispidOfficeThemeChangedEvent,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.OfficeTheme,value:hostKeys.OfficeTheme}]});var destKeys=OSF.DDA.Theming.DocumentThemeEnum;parameterMap.define({type:Microsoft.Office.WebExtension.Parameters.DocumentTheme,fromHost:[{name:destKeys.PrimaryBackgroundColor,value:hostKeys.Background1},{name:destKeys.PrimaryFontColor,value:hostKeys.Text1},{name:destKeys.SecondaryBackgroundColor,value:hostKeys.Background2},{name:destKeys.SecondaryFontColor,value:hostKeys.Text2},{name:destKeys.Accent1,value:hostKeys.Accent1},{name:destKeys.Accent2,value:hostKeys.Accent2},{name:destKeys.Accent3,value:hostKeys.Accent3},{name:destKeys.Accent4,value:hostKeys.Accent4},{name:destKeys.Accent5,value:hostKeys.Accent5},{name:destKeys.Accent6,value:hostKeys.Accent6},{name:destKeys.Hyperlink,value:hostKeys.Hyperlink},{name:destKeys.FollowedHyperlink,value:hostKeys.FollowedHyperlink},{name:destKeys.HeaderLatinFont,value:hostKeys.HdLatin},{name:destKeys.HeaderEastAsianFont,value:hostKeys.HdEastAsian},{name:destKeys.HeaderScriptFont,value:hostKeys.HdScript},{name:destKeys.HeaderLocalizedFont,value:hostKeys.HdLocalized},{name:destKeys.BodyLatinFont,value:hostKeys.BdLatin},{name:destKeys.BodyEastAsianFont,value:hostKeys.BdEastAsian},{name:destKeys.BodyScriptFont,value:hostKeys.BdScript},{name:destKeys.BodyLocalizedFont,value:hostKeys.BdLocalized}]});destKeys=OSF.DDA.Theming.OfficeThemeEnum;parameterMap.define({type:Microsoft.Office.WebExtension.Parameters.OfficeTheme,fromHost:[{name:destKeys.PrimaryFontColor,value:hostKeys.PrimaryText},{name:destKeys.PrimaryBackgroundColor,value:hostKeys.PrimaryBackground},{name:destKeys.SecondaryFontColor,value:hostKeys.SecondaryText},{name:destKeys.SecondaryBackgroundColor,value:hostKeys.SecondaryBackground}]});OSF.DDA.SettingsManager={SerializedSettings:"serializedSettings",RefreshingSettings:"refreshingSettings",DateJSONPrefix:"Date(",DataJSONSuffix:")",serializeSettings:function(a){return OSF.OUtil.serializeSettings(a)},deserializeSettings:function(a){return OSF.OUtil.deserializeSettings(a)}};OSF.DDA.Settings=function(a){a=a||{};var b=function(d){var b=OSF.OUtil.getSessionStorage();if(b){var a=OSF.DDA.SettingsManager.serializeSettings(d),c=JSON?JSON.stringify(a):Sys.Serialization.JavaScriptSerializer.serialize(a);b.setItem(OSF._OfficeAppFactory.getCachedSessionSettingsKey(),c)}};OSF.OUtil.defineEnumerableProperties(this,{"get":{value:function(d){var c=Function._validateParams(arguments,[{name:"name",type:String,mayBeNull:false}]);if(c)throw c;var b=a[d];return typeof b==="undefined"?null:b}},"set":{value:function(e,d){var c=Function._validateParams(arguments,[{name:"name",type:String,mayBeNull:false},{name:"value",mayBeNull:true}]);if(c)throw c;a[e]=d;b(a)}},remove:{value:function(d){var c=Function._validateParams(arguments,[{name:"name",type:String,mayBeNull:false}]);if(c)throw c;delete a[d];b(a)}}});OSF.DDA.DispIdHost.addAsyncMethods(this,[OSF.DDA.AsyncMethodNames.SaveAsync],a)};OSF.DDA.RefreshableSettings=function(a){OSF.DDA.RefreshableSettings.uber.constructor.call(this,a);OSF.DDA.DispIdHost.addAsyncMethods(this,[OSF.DDA.AsyncMethodNames.RefreshAsync],a);OSF.DDA.DispIdHost.addEventSupport(this,new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.SettingsChanged]))};OSF.OUtil.extend(OSF.DDA.RefreshableSettings,OSF.DDA.Settings);OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{SettingsChanged:"settingsChanged"});OSF.DDA.SettingsChangedEventArgs=function(a){OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.SettingsChanged},settings:{value:a}})};OSF.DDA.AsyncMethodNames.addNames({RefreshAsync:"refreshAsync",SaveAsync:"saveAsync"});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.RefreshAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[{name:OSF.DDA.SettingsManager.RefreshingSettings,value:function(b,a){return a}}],onSucceeded:function(d,a,e){var f=d[OSF.DDA.SettingsManager.SerializedSettings],c=OSF.DDA.SettingsManager.deserializeSettings(f),g=e[OSF.DDA.SettingsManager.RefreshingSettings];for(var b in g)a.remove(b);for(var b in c)a.set(b,c[b]);return a}});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.SaveAsync,requiredArguments:[],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.OverwriteIfStale,value:{types:["boolean"],defaultValue:true}}],privateStateCallbacks:[{name:OSF.DDA.SettingsManager.SerializedSettings,value:function(b,a){return OSF.DDA.SettingsManager.serializeSettings(a)}}]});OSF.DDA.WAC.SettingsTranslator=function(){var b=0,a=1;return{read:function(f){var c={},d=f.Settings;for(var g in d){var e=d[g];c[e[b]]=e[a]}return c},write:function(d){var e=[];for(var f in d){var c=[];c[b]=f;c[a]=d[f];e.push(c)}return e}}}();OSF.DDA.WAC.Delegate.ParameterMap.setDynamicType(OSF.DDA.SettingsManager.SerializedSettings,{toHost:OSF.DDA.WAC.SettingsTranslator.write,fromHost:OSF.DDA.WAC.SettingsTranslator.read});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.WAC.UniqueArguments.SettingsRequest,toHost:[{name:Microsoft.Office.WebExtension.Parameters.OverwriteIfStale,value:"OverwriteIfStale"},{name:OSF.DDA.SettingsManager.SerializedSettings,value:OSF.DDA.WAC.UniqueArguments.Properties}],invertible:true});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidLoadSettingsMethod,fromHost:[{name:OSF.DDA.SettingsManager.SerializedSettings,value:OSF.DDA.WAC.UniqueArguments.Properties}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidSaveSettingsMethod,toHost:[{name:OSF.DDA.WAC.UniqueArguments.SettingsRequest,value:OSF.DDA.WAC.Delegate.ParameterMap.self}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidSettingsChangedEvent});var OfficeExt;(function(a){var b;(function(b){var e=function(){function d(){var a=this;this._pseudoDocument=null;this._eventDispatch=null;this._processAppCommandInvocation=function(b){var c=a._verifyManifestCallback(b.callbackName);if(c.errorCode!=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess){a._invokeAppCommandCompletedMethod(b.appCommandId,c.errorCode,"");return}var d=a._constructEventObjectForCallback(b);if(d)window.setTimeout(function(){c.callback(d)},0);else a._invokeAppCommandCompletedMethod(b.appCommandId,OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError,"")}}d.initializeOsfDda=function(){OSF.DDA.AsyncMethodNames.addNames({AppCommandInvocationCompletedAsync:"appCommandInvocationCompletedAsync"});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AppCommandInvocationCompletedAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Id,types:["string"]},{name:Microsoft.Office.WebExtension.Parameters.Status,types:["number"]},{name:Microsoft.Office.WebExtension.Parameters.AppCommandInvocationCompletedData,types:["string"]}]});OSF.OUtil.augmentList(OSF.DDA.EventDescriptors,{AppCommandInvokedEvent:"AppCommandInvokedEvent"});OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{AppCommandInvoked:"appCommandInvoked"});OSF.OUtil.setNamespace("AppCommand",OSF.DDA);OSF.DDA.AppCommand.AppCommandInvokedEventArgs=a.AppCommand.AppCommandInvokedEventArgs};d.prototype.initializeAndChangeOnce=function(a){b.registerDdaFacade();this._pseudoDocument={};OSF.DDA.DispIdHost.addAsyncMethods(this._pseudoDocument,[OSF.DDA.AsyncMethodNames.AppCommandInvocationCompletedAsync]);this._eventDispatch=new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.AppCommandInvoked]);var c=function(b){if(a)if(b.status=="succeeded")a(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess);else a(OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError)};OSF.DDA.DispIdHost.addEventSupport(this._pseudoDocument,this._eventDispatch);this._pseudoDocument.addHandlerAsync(Microsoft.Office.WebExtension.EventType.AppCommandInvoked,this._processAppCommandInvocation,c)};d.prototype._verifyManifestCallback=function(e){var d={callback:null,errorCode:OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidCallback};e=e.trim();try{for(var a=e.split("."),b=window,c=0;c<a.length-1;c++)if(b[a[c]]&&(typeof b[a[c]]=="object"||typeof b[a[c]]=="function"))b=b[a[c]];else return d;var f=b[a[a.length-1]];if(typeof f!="function")return d}catch(g){return d}return{callback:f,errorCode:OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess}};d.prototype._invokeAppCommandCompletedMethod=function(a,b,c){this._pseudoDocument.appCommandInvocationCompletedAsync(a,b,c)};d.prototype._constructEventObjectForCallback=function(b){var e=this,a=new c;try{var d=JSON.parse(b.eventObjStr);this._translateEventObjectInternal(d,a);Object.defineProperty(a,"completed",{value:function(c){a.completedContext=c;var d=JSON.stringify(a);e._invokeAppCommandCompletedMethod(b.appCommandId,OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess,d)},enumerable:true})}catch(f){a=null}return a};d.prototype._translateEventObjectInternal=function(d,c){for(var a in d){if(!d.hasOwnProperty(a))continue;var b=d[a];if(typeof b=="object"&&b!=null){OSF.OUtil.defineEnumerableProperty(c,a,{value:{}});this._translateEventObjectInternal(b,c[a])}else Object.defineProperty(c,a,{value:b,enumerable:true,writable:true})}};d.prototype._constructObjectByTemplate=function(c,g){var b={};if(!c||!g)return b;for(var a in c)if(c.hasOwnProperty(a)){b[a]=null;if(g[a]!=null){var e=c[a],f=g[a],d=typeof f;if(typeof e=="object"&&e!=null)b[a]=this._constructObjectByTemplate(e,f);else if(d=="number"||d=="string"||d=="boolean")b[a]=f}}return b};d.instance=function(){if(d._instance==null)d._instance=new d;return d._instance};d._instance=null;return d}();b.AppCommandManager=e;var d=function(){function a(a,b,c){this.type=Microsoft.Office.WebExtension.EventType.AppCommandInvoked;this.appCommandId=a;this.callbackName=b;this.eventObjStr=c}a.create=function(c){return new a(c[b.AppCommandInvokedEventEnums.AppCommandId],c[b.AppCommandInvokedEventEnums.CallbackName],c[b.AppCommandInvokedEventEnums.EventObjStr])};return a}();b.AppCommandInvokedEventArgs=d;var c=function(){function a(){}return a}();b.AppCommandCallbackEventArgs=c;b.AppCommandInvokedEventEnums={AppCommandId:"appCommandId",CallbackName:"callbackName",EventObjStr:"eventObjStr"}})(b=a.AppCommand||(a.AppCommand={}))})(OfficeExt||(OfficeExt={}));OfficeExt.AppCommand.AppCommandManager.initializeOsfDda();OSF.OUtil.setNamespace("Marshaling",OSF.DDA);OSF.OUtil.setNamespace("AppCommand",OSF.DDA.Marshaling);var OSF_DDA_Marshaling_AppCommand_AppCommandInvokedEventKeys;(function(a){a[a.AppCommandId=0]="AppCommandId";a[a.CallbackName=1]="CallbackName";a[a.EventObjStr=2]="EventObjStr"})(OSF_DDA_Marshaling_AppCommand_AppCommandInvokedEventKeys||(OSF_DDA_Marshaling_AppCommand_AppCommandInvokedEventKeys={}));OSF.DDA.Marshaling.AppCommand.AppCommandInvokedEventKeys=OSF_DDA_Marshaling_AppCommand_AppCommandInvokedEventKeys;var OSF_DDA_Marshaling_AppCommand_AppCommandCompletedMethodParameterKeys;(function(a){a[a.Id=0]="Id";a[a.Status=1]="Status";a[a.Data=2]="Data"})(OSF_DDA_Marshaling_AppCommand_AppCommandCompletedMethodParameterKeys||(OSF_DDA_Marshaling_AppCommand_AppCommandCompletedMethodParameterKeys={}));OSF.DDA.Marshaling.AppCommand.AppCommandCompletedMethodParameterKeys=OSF_DDA_Marshaling_AppCommand_AppCommandCompletedMethodParameterKeys;var OfficeExt;(function(a){var b;(function(c){function b(){if(OSF.DDA.WAC){var b=OSF.DDA.WAC.Delegate.ParameterMap;b.define({type:OSF.DDA.MethodDispId.dispidAppCommandInvocationCompletedMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:OSF.DDA.Marshaling.AppCommand.AppCommandCompletedMethodParameterKeys.Id},{name:Microsoft.Office.WebExtension.Parameters.Status,value:OSF.DDA.Marshaling.AppCommand.AppCommandCompletedMethodParameterKeys.Status},{name:Microsoft.Office.WebExtension.Parameters.AppCommandInvocationCompletedData,value:OSF.DDA.Marshaling.AppCommand.AppCommandCompletedMethodParameterKeys.Data}]});b.define({type:OSF.DDA.EventDispId.dispidAppCommandInvokedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.AppCommandInvokedEvent,value:b.self}]});b.addComplexType(OSF.DDA.EventDescriptors.AppCommandInvokedEvent);b.define({type:OSF.DDA.EventDescriptors.AppCommandInvokedEvent,fromHost:[{name:a.AppCommand.AppCommandInvokedEventEnums.AppCommandId,value:OSF.DDA.Marshaling.AppCommand.AppCommandInvokedEventKeys.AppCommandId},{name:a.AppCommand.AppCommandInvokedEventEnums.CallbackName,value:OSF.DDA.Marshaling.AppCommand.AppCommandInvokedEventKeys.CallbackName},{name:a.AppCommand.AppCommandInvokedEventEnums.EventObjStr,value:OSF.DDA.Marshaling.AppCommand.AppCommandInvokedEventKeys.EventObjStr}]})}}c.registerDdaFacade=b})(b=a.AppCommand||(a.AppCommand={}))})(OfficeExt||(OfficeExt={}));OSF.OUtil.augmentList(Microsoft.Office.WebExtension.CoercionType,{Image:"image"});OSF.OUtil.augmentList(Microsoft.Office.WebExtension.CoercionType,{XmlSvg:"xmlSvg"});OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{DocumentSelectionChanged:"documentSelectionChanged"});OSF.DDA.DocumentSelectionChangedEventArgs=function(a){OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DocumentSelectionChanged},document:{value:a}})};OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{ObjectDeleted:"objectDeleted"});OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{ObjectSelectionChanged:"objectSelectionChanged"});OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{ObjectDataChanged:"objectDataChanged"});OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{ContentControlAdded:"contentControlAdded"});OSF.DDA.ObjectEventArgs=function(a,b){OSF.OUtil.defineEnumerableProperties(this,{type:{value:a},object:{value:b}})};OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidDocumentSelectionChangedEvent});OSF.DialogShownStatus={hasDialogShown:false,isWindowDialog:false};OSF.OUtil.augmentList(OSF.DDA.EventDescriptors,{DialogMessageReceivedEvent:"DialogMessageReceivedEvent"});OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{DialogMessageReceived:"dialogMessageReceived",DialogEventReceived:"dialogEventReceived"});OSF.OUtil.augmentList(OSF.DDA.PropertyDescriptors,{MessageType:"messageType",MessageContent:"messageContent"});OSF.DDA.DialogEventType={};OSF.OUtil.augmentList(OSF.DDA.DialogEventType,{DialogClosed:"dialogClosed",NavigationFailed:"naviationFailed"});OSF.DDA.AsyncMethodNames.addNames({DisplayDialogAsync:"displayDialogAsync",CloseAsync:"close"});OSF.DDA.SyncMethodNames.addNames({MessageParent:"messageParent",AddMessageHandler:"addEventHandler",SendMessage:"sendMessage"});OSF.DDA.UI.ParentUI=function(){var a;if(Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived!=null)a=new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.DialogMessageReceived,Microsoft.Office.WebExtension.EventType.DialogEventReceived,Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived]);else a=new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.DialogMessageReceived,Microsoft.Office.WebExtension.EventType.DialogEventReceived]);var c=OSF.DDA.AsyncMethodNames.DisplayDialogAsync.displayName,b=this;!b[c]&&OSF.OUtil.defineEnumerableProperty(b,c,{value:function(){var c=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.OpenDialog];c(arguments,a,b)}});OSF.OUtil.finalizeProperties(this)};OSF.DDA.UI.ChildUI=function(d){var b=OSF.DDA.SyncMethodNames.MessageParent.displayName,a=this;!a[b]&&OSF.OUtil.defineEnumerableProperty(a,b,{value:function(){var b=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.MessageParent];return b(arguments,a)}});var c=OSF.DDA.SyncMethodNames.AddMessageHandler.displayName;!a[c]&&typeof OSF.DialogParentMessageEventDispatch!="undefined"&&OSF.DDA.DispIdHost.addEventSupport(a,OSF.DialogParentMessageEventDispatch,d);OSF.OUtil.finalizeProperties(this)};OSF.DialogHandler=function(){};OSF.DDA.DialogEventArgs=function(a){if(a[OSF.DDA.PropertyDescriptors.MessageType]==OSF.DialogMessageType.DialogMessageReceived)OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DialogMessageReceived},message:{value:a[OSF.DDA.PropertyDescriptors.MessageContent]}});else OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DialogEventReceived},error:{value:a[OSF.DDA.PropertyDescriptors.MessageType]}})};OSF.DDA.DialogParentEventArgs=function(a){OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived},message:{value:a[OSF.DDA.PropertyDescriptors.MessageContent]}})};OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.DisplayDialogAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Url,types:["string"]}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.Width,value:{types:["number"],defaultValue:99}},{name:Microsoft.Office.WebExtension.Parameters.Height,value:{types:["number"],defaultValue:99}},{name:Microsoft.Office.WebExtension.Parameters.RequireHTTPs,value:{types:["boolean"],defaultValue:true}},{name:Microsoft.Office.WebExtension.Parameters.DisplayInIframe,value:{types:["boolean"],defaultValue:false}},{name:Microsoft.Office.WebExtension.Parameters.HideTitle,value:{types:["boolean"],defaultValue:false}},{name:Microsoft.Office.WebExtension.Parameters.UseDeviceIndependentPixels,value:{types:["boolean"],defaultValue:false}},{name:Microsoft.Office.WebExtension.Parameters.PromptBeforeOpen,value:{types:["boolean"],defaultValue:true}},{name:Microsoft.Office.WebExtension.Parameters.EnforceAppDomain,value:{types:["boolean"],defaultValue:false}}],privateStateCallbacks:[],onSucceeded:function(c,i,h){var g=c[Microsoft.Office.WebExtension.Parameters.Id],b=c[Microsoft.Office.WebExtension.Parameters.Data],a=new OSF.DialogHandler,d=OSF.DDA.AsyncMethodNames.CloseAsync.displayName;OSF.OUtil.defineEnumerableProperty(a,d,{value:function(){var c=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.CloseDialog];c(arguments,g,b,a)}});var f=OSF.DDA.SyncMethodNames.AddMessageHandler.displayName;OSF.OUtil.defineEnumerableProperty(a,f,{value:function(){var d=OSF.DDA.SyncMethodCalls[OSF.DDA.SyncMethodNames.AddMessageHandler.id],c=d.verifyAndExtractCall(arguments,a,b),e=c[Microsoft.Office.WebExtension.Parameters.EventType],f=c[Microsoft.Office.WebExtension.Parameters.Handler];return b.addEventHandlerAndFireQueuedEvent(e,f)}});var e=OSF.DDA.SyncMethodNames.SendMessage.displayName;OSF.OUtil.defineEnumerableProperty(a,e,{value:function(){var c=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.SendMessage];return c(arguments,b,a)}});return a},checkCallArgs:function(a,c,b){if(a[Microsoft.Office.WebExtension.Parameters.Width]<=0)a[Microsoft.Office.WebExtension.Parameters.Width]=1;if(!a[Microsoft.Office.WebExtension.Parameters.UseDeviceIndependentPixels]&&a[Microsoft.Office.WebExtension.Parameters.Width]>100)a[Microsoft.Office.WebExtension.Parameters.Width]=99;if(a[Microsoft.Office.WebExtension.Parameters.Height]<=0)a[Microsoft.Office.WebExtension.Parameters.Height]=1;if(!a[Microsoft.Office.WebExtension.Parameters.UseDeviceIndependentPixels]&&a[Microsoft.Office.WebExtension.Parameters.Height]>100)a[Microsoft.Office.WebExtension.Parameters.Height]=99;if(!a[Microsoft.Office.WebExtension.Parameters.RequireHTTPs])a[Microsoft.Office.WebExtension.Parameters.RequireHTTPs]=true;return a}});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.CloseAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[]});OSF.DDA.SyncMethodCalls.define({method:OSF.DDA.SyncMethodNames.MessageParent,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.MessageToParent,types:["string","number","boolean"]}],supportedOptions:[]});OSF.DDA.SyncMethodCalls.define({method:OSF.DDA.SyncMethodNames.AddMessageHandler,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.EventType,"enum":Microsoft.Office.WebExtension.EventType,verify:function(b,c,a){return a.supportsEvent(b)}},{name:Microsoft.Office.WebExtension.Parameters.Handler,types:["function"]}],supportedOptions:[]});OSF.DDA.SyncMethodCalls.define({method:OSF.DDA.SyncMethodNames.SendMessage,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.MessageContent,types:["string"]}],supportedOptions:[],privateStateCallbacks:[]});OSF.OUtil.setNamespace("Marshaling",OSF.DDA);OSF.OUtil.setNamespace("Dialog",OSF.DDA.Marshaling);OSF.DDA.Marshaling.Dialog.DialogMessageReceivedEventKeys={MessageType:"messageType",MessageContent:"messageContent"};OSF.DDA.Marshaling.Dialog.DialogParentMessageReceivedEventKeys={MessageType:"messageType",MessageContent:"messageContent"};OSF.DDA.Marshaling.MessageParentKeys={MessageToParent:"messageToParent"};OSF.DDA.Marshaling.DialogNotificationShownEventType={DialogNotificationShown:"dialogNotificationShown"};OSF.DDA.Marshaling.SendMessageKeys={MessageContent:"messageContent"};var OfficeExt;(function(a){var b;(function(c){var a={Excel:"excel",Word:"word",PowerPoint:"powerpoint",Outlook:"outlook",Visio:"visio"};function d(c){switch(c){case a.Excel:case a.Word:case a.PowerPoint:case a.Outlook:case a.Visio:return new b;default:return new b}return null}c.getDialogCssManager=d;var b=function(){function a(){this.overlayElementCSS=["position: absolute","top: 0","left: 0","width: 100%","height: 100%","background-color: rgba(198, 198, 198, 0.5)","z-index: 99998"];this.dialogNotificationPanelCSS=["width: 100%","height: 190px","position: absolute","z-index: 99999","background-color: rgba(255, 255, 255, 1)","left: 0px","top: 50%","margin-top: -95px"];this.newWindowNotificationTextPanelCSS=["margin: 20px 14px","font-family: Segoe UI,Arial,Verdana,sans-serif","font-size: 14px","height: 100px","line-height: 100px"];this.newWindowNotificationTextSpanCSS=["display: inline-block","line-height: normal","vertical-align: middle"];this.crossZoneNotificationTextPanelCSS=["margin: 20px 14px","font-family: Segoe UI,Arial,Verdana,sans-serif","font-size: 14px","height: 100px"];this.dialogNotificationButtonPanelCSS="margin:0px 9px";this.buttonStyleCSS=["text-align: center","width: 70px","height: 25px","font-size: 14px","font-family: Segoe UI,Arial,Verdana,sans-serif","margin: 0px 5px","border-width: 1px","border-style: solid"]}a.prototype.getOverlayElementCSS=function(){return this.overlayElementCSS.join(";")};a.prototype.getDialogNotificationPanelCSS=function(){return this.dialogNotificationPanelCSS.join(";")};a.prototype.getNewWindowNotificationTextPanelCSS=function(){return this.newWindowNotificationTextPanelCSS.join(";")};a.prototype.getNewWindowNotificationTextSpanCSS=function(){return this.newWindowNotificationTextSpanCSS.join(";")};a.prototype.getCrossZoneNotificationTextPanelCSS=function(){return this.crossZoneNotificationTextPanelCSS.join(";")};a.prototype.getDialogNotificationButtonPanelCSS=function(){return this.dialogNotificationButtonPanelCSS};a.prototype.getDialogButtonCSS=function(){return this.buttonStyleCSS.join(";")};return a}();c.DefaultDialogCSSManager=b})(b=a.WacCommonUICssManager||(a.WacCommonUICssManager={}))})(OfficeExt||(OfficeExt={}));var OfficeExt;(function(a){var b;(function(b){var c;(function(d){var c=null,k=null,f=null,b=null,E="osfDialogInternal:action=closeDialog",e=null,q=false,m=-1,D="messageParentKey",j=null,y="#ababab",w="#ffffff",H="#ccc",z="newWindowNotificaiton",N="crossZoneNotification",r="configureBrowserLink",n="dialogNotificationTextPanel",h=a.WACUtils.shouldUseLocalStorageToPassMessage(),g={dispId:OSF.DDA.EventDispId.dispidDialogNotificationShownInAddinEvent,eventType:OSF.DDA.Marshaling.DialogNotificationShownEventType.DialogNotificationShown,onComplete:null};function O(b){var a=b.input;if(a!=null)j={HostButtonBorderColor:a[OSF.HostThemeButtonStyleKeys.ButtonBorderColor],HostButtonBackgroundColor:a[OSF.HostThemeButtonStyleKeys.ButtonBackgroundColor]};b.completed()}d.setHostThemeButtonStyle=O;function J(a){OSF._OfficeAppFactory.getInitializationHelper().addOrRemoveEventListenersForWindow(false);a.completed()}d.removeEventListenersForDialog=J;function P(j){try{if(j[OSF.ShowWindowDialogParameterKeys.EnforceAppDomain]&&!Q(j)){e(OSF.DDA.ErrorCodeManager.errorCodes.ooeAppDomains);return}if(!j[OSF.ShowWindowDialogParameterKeys.PromptBeforeOpen]){F(j);return}q=false;var m=false,u=OSF._OfficeAppFactory.getInitializationHelper()._hostInfo,h=a.WacCommonUICssManager.getDialogCssManager(u.hostType),s=OSF.OUtil.formatString(Strings.OfficeOM.L_ShowWindowDialogNotification,OSF._OfficeAppFactory.getInitializationHelper()._appContext._addinName);f=B(h);document.body.insertBefore(f,document.body.firstChild);b=M(h,s);b.id=z;var k=C(h),d=t(h,Strings.OfficeOM.L_ShowWindowDialogNotificationAllow),c=t(h,Strings.OfficeOM.L_ShowWindowDialogNotificationIgnore);k.appendChild(d);k.appendChild(c);b.appendChild(k);document.body.insertBefore(b,document.body.firstChild);d.onclick=function(a){F(j);!q&&i();a.preventDefault();a.stopPropagation()};function n(a){function b(a){l();A(a);e(OSF.DDA.ErrorCodeManager.errorCodes.ooeEndUserIgnore)}g.onComplete=b;OSF.DDA.WAC.Delegate.unregisterEventAsync(g);a.preventDefault();a.stopPropagation()}c.onclick=n;d.addEventListener("keydown",function(a){if(a.shiftKey&&a.keyCode==9){o(d);p(c);c.focus();a.preventDefault();a.stopPropagation()}},false);c.addEventListener("keydown",function(a){if(!a.shiftKey&&a.keyCode==9){o(c);p(d);d.focus();a.preventDefault();a.stopPropagation()}else if(a.keyCode==13){m=true;a.preventDefault();a.stopPropagation()}},false);c.addEventListener("keyup",function(a){if(a.keyCode==13&&m){m=false;n(a)}},false);window.focus();function r(a){d.focus()}g.onComplete=r;OSF.DDA.WAC.Delegate.registerEventAsync(g)}catch(v){OSF.AppTelemetry&&OSF.AppTelemetry.logAppException("Exception happens at new window dialog."+v);e(OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError)}}d.handleNewWindowDialog=P;function S(d){try{if(c!=null){var a=OSF._OfficeAppFactory.getInitializationHelper()._appContext._appDomains;if(a)for(var b=0;b<a.length&&a[b].indexOf("://")!==-1;b++)c.postMessage(E,a[b]);c!=null&&!c.closed&&c.close();if(h)window.removeEventListener("storage",s);else window.removeEventListener("message",u);window.clearInterval(m);c=null;d(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess)}else d(OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError)}catch(e){OSF.AppTelemetry&&OSF.AppTelemetry.logAppException("Exception happens at close window dialog."+e);d(OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError)}}d.closeDialog=S;function R(f){var d=f.hostCallArgs[Microsoft.Office.WebExtension.Parameters.MessageToParent];if(h)try{var e=OSF._OfficeAppFactory.getInitializationHelper()._webAppState.id+D;window.localStorage.setItem(e,d)}catch(g){OSF.AppTelemetry&&OSF.AppTelemetry.logAppException("Error happened during messageParent method:"+g)}else{var a=OSF._OfficeAppFactory.getInitializationHelper()._appContext._appDomains;if(a)for(var c=0;c<a.length&&a[c].indexOf("://")!==-1;c++)window.opener.postMessage(d,a[c]);var b=window.location.origin;if(!b)b=window.location.protocol+"//"+window.location.hostname+(window.location.port?":"+window.location.port:"");!Microsoft.Office.Common.XdmCommunicationManager.checkUrlWithAppDomains(a,b)&&window.opener.postMessage(d,b)}}d.messageParent=R;function T(e){if(c!=null){var b=e.hostCallArgs,a=OSF._OfficeAppFactory.getInitializationHelper()._appContext._appDomains;if(a)for(var d=0;d<a.length&&a[d].indexOf("://")!==-1;d++){if(typeof b!="string")b=JSON.stringify(b);c.postMessage(b,a[d])}}}d.sendMessage=T;function L(){function a(b){if(b.source==window.opener)if(typeof b.data==="string"&&b.data.indexOf(E)>-1)window.close();else{var a=b.data,c=typeof a;if(a&&(c=="object"||c=="string")){if(c=="string")a=JSON.parse(a);var d=OSF.DDA.OMFactory.manufactureEventArgs(Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived,null,a);OSF.DialogParentMessageEventDispatch.fireEvent(d)}}}window.addEventListener("message",a)}d.registerMessageReceivedEvent=L;function I(a,b){k=a;e=b}d.setHandlerAndShowDialogCallback=I;function K(){try{b&&b.id==z&&e&&e(OSF.DDA.ErrorCodeManager.errorCodes.ooeEndUserIgnore)}catch(a){OSF.AppTelemetry&&OSF.AppTelemetry.logAppException("Error happened during executing displayDialogAsync callback."+a)}i()}d.escDismissDialogNotification=K;function x(h,j){var e=false,d=a.WacCommonUICssManager.getDialogCssManager(j);f=B(d);document.body.insertBefore(f,document.body.firstChild);b=G(d,h);b.id=N;var g=C(d),c=t(d,Strings.OfficeOM.L_DialogOK?Strings.OfficeOM.L_DialogOK:"OK");g.appendChild(c);b.appendChild(g);document.body.insertBefore(b,document.body.firstChild);q=true;c.onclick=function(){i()};c.addEventListener("keydown",function(a){if(a.keyCode==9){document.getElementById(r).focus();a.preventDefault();a.stopPropagation()}else if(a.keyCode==13){e=true;a.preventDefault();a.stopPropagation()}},false);c.addEventListener("keyup",function(a){if(a.keyCode==13&&e){e=false;i();a.preventDefault();a.stopPropagation()}},false);document.getElementById(r).addEventListener("keydown",function(a){if(a.keyCode==9){c.focus();a.preventDefault();a.stopPropagation()}},false);window.focus();c.focus()}d.showCrossZoneNotification=x;function u(b){if(b.source==c)try{var a={};a[OSF.DDA.Marshaling.Dialog.DialogMessageReceivedEventKeys.MessageType]=OSF.DialogMessageType.DialogMessageReceived;a[OSF.DDA.Marshaling.Dialog.DialogMessageReceivedEventKeys.MessageContent]=b.data;k(a)}catch(d){OSF.AppTelemetry&&OSF.AppTelemetry.logAppException("Error happened during receive message handler."+d)}}function s(b){var c=OSF._OfficeAppFactory.getInitializationHelper()._webAppState.id+D;if(b.key==c)try{var a={};a[OSF.DDA.Marshaling.Dialog.DialogMessageReceivedEventKeys.MessageType]=OSF.DialogMessageType.DialogMessageReceived;a[OSF.DDA.Marshaling.Dialog.DialogMessageReceivedEventKeys.MessageContent]=b.newValue;k(a)}catch(d){OSF.AppTelemetry&&OSF.AppTelemetry.logAppException("Error happened during storage changed handler."+d)}}function Q(d){var c=OSF._OfficeAppFactory.getInitializationHelper()._appContext._appDomains,b=d[OSF.ShowWindowDialogParameterKeys.Url],a=Microsoft.Office.Common.XdmCommunicationManager.checkUrlWithAppDomains(c,b);if(!a)return OSF._OfficeAppFactory.getInitializationHelper()._appContext._addInSourceLocationSubdomainAllowedIsEnabled&&OSF._OfficeAppFactory.getInitializationHelper()._appContext._addInSourceUrl&&Microsoft.Office.Common.XdmCommunicationManager.isTargetSubdomainOfSourceLocation(OSF._OfficeAppFactory.getInitializationHelper()._appContext._addInSourceUrl,b);return a}function F(g){var b=OSF._OfficeAppFactory.getInitializationHelper()._hostInfo,q=[b.hostType,b.hostPlatform,b.hostSpecificFileVersion,b.hostLocale,b.osfControlAppCorrelationId,"isDialog",b.disableLogging?"disableLogging":""],j=q.join("|"),f=OSF._OfficeAppFactory.getInitializationHelper()._appContext,d=g[OSF.ShowWindowDialogParameterKeys.Url];d=a.WACUtils.addHostInfoAsQueryParam(d,j);var i=JSON.parse(window.name);i[OSF.WindowNameItemKeys.HostInfo]=j;i[OSF.WindowNameItemKeys.AppContext]=f;var o=g[OSF.ShowWindowDialogParameterKeys.Width]*screen.width/100,n=g[OSF.ShowWindowDialogParameterKeys.Height]*screen.height/100,t=f._clientWindowWidth/2-o/2,v=f._clientWindowHeight/2-n/2,r="width="+o+", height="+n+", left="+t+", top="+v+",channelmode=no,directories=no,fullscreen=no,location=no,menubar=no,resizable=yes,scrollbars=yes,status=no,titlebar=yes,toolbar=no";c=window.open(d,a.WACUtils.serializeObjectToString(i),r);if(c==null){OSF.AppTelemetry.logAppCommonMessage("Encountered cross zone issue in displayDialogAsync api.");l();x(d,b.hostType);e(OSF.DDA.ErrorCodeManager.errorCodes.ooeCrossZone);return}if(h)window.addEventListener("storage",s);else window.addEventListener("message",u);function p(){try{if(c==null||c.closed){window.clearInterval(m);if(h)window.removeEventListener("storage",s);else window.removeEventListener("message",u);var a={};a[OSF.DDA.Marshaling.Dialog.DialogMessageReceivedEventKeys.MessageType]=OSF.DialogMessageType.DialogClosed;k(a)}}catch(b){OSF.AppTelemetry&&OSF.AppTelemetry.logAppException("Error happened during check or handle window close."+b)}}m=window.setInterval(p,1e3);if(e!=null)e(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess);else OSF.AppTelemetry&&OSF.AppTelemetry.logAppException("showDialogCallback can not be null.")}function t(d,e){var a=document.createElement("input");a.setAttribute("type","button");a.style.cssText=d.getDialogButtonCSS();a.style.borderColor=y;a.style.backgroundColor=w;a.setAttribute("value",e);var c=function(){p(a)},b=function(){o(a)};a.addEventListener("mouseover",c);a.addEventListener("focus",c);a.addEventListener("mouseout",b);a.addEventListener("focusout",b);return a}function p(a){if(j!=null){a.style.borderColor=j.HostButtonBorderColor;a.style.backgroundColor=j.HostButtonBackgroundColor}else if(OSF.CommonUI&&OSF.CommonUI.HostButtonBorderColor&&OSF.CommonUI.HostButtonBackgroundColor){a.style.borderColor=OSF.CommonUI.HostButtonBorderColor;a.style.backgroundColor=OSF.CommonUI.HostButtonBackgroundColor}else a.style.backgroundColor=H}function o(a){a.style.borderColor=y;a.style.backgroundColor=w}function i(){function a(a){l();A(a)}g.onComplete=a;OSF.DDA.WAC.Delegate.unregisterEventAsync(g)}function l(){if(b!=null){document.body.removeChild(b);b=null}if(f!=null){document.body.removeChild(f);f=null}}function B(b){var a=document.createElement("div");a.style.cssText=b.getOverlayElementCSS();return a}function M(d,e){var b=document.createElement("div");b.style.cssText=d.getDialogNotificationPanelCSS();v(b);var a=document.createElement("div");a.style.cssText=d.getNewWindowNotificationTextPanelCSS();a.id=n;if(document.documentElement.getAttribute("dir")=="rtl")a.style.paddingRight="30px";else a.style.paddingLeft="30px";var c=document.createElement("span");c.style.cssText=d.getNewWindowNotificationTextSpanCSS();c.innerText=e;a.appendChild(c);b.appendChild(a);return b}function C(b){var a=document.createElement("div");a.style.cssText=b.getDialogNotificationButtonPanelCSS();if(document.documentElement.getAttribute("dir")=="rtl")a.style.cssFloat="left";else a.style.cssFloat="right";return a}function A(a){if(a!=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess){var b=document.querySelectorAll(OSF._OfficeAppFactory.getInitializationHelper()._tabbableElements);OSF.OUtil.focusToFirstTabbable(b,false)}}function G(f,g){var d=document.createElement("div");d.style.cssText=f.getDialogNotificationPanelCSS();v(d);var c=document.createElement("div");c.style.cssText=f.getCrossZoneNotificationTextPanelCSS();c.id=n;var b=document.createElement("a");b.id=r;b.href="#";b.innerText=Strings.OfficeOM.L_NewWindowCrossZoneConfigureBrowserLink;b.setAttribute("onclick","window.open('https://support.microsoft.com/en-us/help/17479/windows-internet-explorer-11-change-security-privacy-settings', '_blank', 'fullscreen=1')");var e=document.createElement("span");if(Strings.OfficeOM.L_NewWindowCrossZone)e.innerHTML=OSF.OUtil.formatString(Strings.OfficeOM.L_NewWindowCrossZone,b.outerHTML,a.WACUtils.getDomainForUrl(g));c.appendChild(e);d.appendChild(c);return d}function v(a){a.setAttribute("role","dialog");a.setAttribute("aria-describedby",n)}})(c=b.Dialog||(b.Dialog={}))})(b=a.AddinNativeAction||(a.AddinNativeAction={}))})(OfficeExt||(OfficeExt={}));OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidDialogMessageReceivedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.DialogMessageReceivedEvent,value:OSF.DDA.WAC.Delegate.ParameterMap.self}]});OSF.DDA.WAC.Delegate.ParameterMap.addComplexType(OSF.DDA.EventDescriptors.DialogMessageReceivedEvent);OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.EventDescriptors.DialogMessageReceivedEvent,fromHost:[{name:OSF.DDA.PropertyDescriptors.MessageType,value:OSF.DDA.Marshaling.Dialog.DialogMessageReceivedEventKeys.MessageType},{name:OSF.DDA.PropertyDescriptors.MessageContent,value:OSF.DDA.Marshaling.Dialog.DialogMessageReceivedEventKeys.MessageContent}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidDialogParentMessageReceivedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.DialogParentMessageReceivedEvent,value:OSF.DDA.WAC.Delegate.ParameterMap.self}]});OSF.DDA.WAC.Delegate.ParameterMap.addComplexType(OSF.DDA.EventDescriptors.DialogParentMessageReceivedEvent);OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.EventDescriptors.DialogParentMessageReceivedEvent,fromHost:[{name:OSF.DDA.PropertyDescriptors.MessageType,value:OSF.DDA.Marshaling.Dialog.DialogParentMessageReceivedEventKeys.MessageType},{name:OSF.DDA.PropertyDescriptors.MessageContent,value:OSF.DDA.Marshaling.Dialog.DialogParentMessageReceivedEventKeys.MessageContent}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidMessageParentMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.MessageToParent,value:OSF.DDA.Marshaling.MessageParentKeys.MessageToParent}]});OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidSendMessageMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.MessageContent,value:OSF.DDA.Marshaling.SendMessageKeys.MessageContent}]});OSF.DDA.WAC.Delegate.openDialog=function(a){var e="https://",f="http://",c=JSON.parse(a.targetId),g=OSF.DDA.WAC.Delegate._getOnAfterRegisterEvent(true,a);function b(b){var a={Error:b};try{g(Microsoft.Office.Common.InvokeResultCode.noError,a)}catch(c){OSF.AppTelemetry&&OSF.AppTelemetry.logAppException("Exception happens at showDialogCallback."+c)}}if(OSF.DialogShownStatus.hasDialogShown){b(OSF.DDA.ErrorCodeManager.errorCodes.ooeDialogAlreadyOpened);return}var d=c[OSF.ShowWindowDialogParameterKeys.Url].toLowerCase();if(d==null||!(d.substr(0,e.length)===e)){if(d.substr(0,f.length)===f)b(OSF.DDA.ErrorCodeManager.errorCodes.ooeRequireHTTPS);else b(OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidScheme);return}if(!c[OSF.ShowWindowDialogParameterKeys.DisplayInIframe]){OSF.DialogShownStatus.isWindowDialog=true;OfficeExt.AddinNativeAction.Dialog.setHandlerAndShowDialogCallback(function(b){if(a.onEvent)a.onEvent(b);if(OSF.AppTelemetry)OSF.AppTelemetry.onEventDone(a.dispId)},b);OfficeExt.AddinNativeAction.Dialog.handleNewWindowDialog(c)}else{OSF.DialogShownStatus.isWindowDialog=false;OSF.DDA.WAC.Delegate.registerEventAsync(a)}};OSF.DDA.WAC.Delegate.messageParent=function(a){if(window.opener!=null)OfficeExt.AddinNativeAction.Dialog.messageParent(a);else OSF.DDA.WAC.Delegate.executeAsync(a)};OSF.DDA.WAC.Delegate.sendMessage=function(a){if(OSF.DialogShownStatus.hasDialogShown)if(OSF.DialogShownStatus.isWindowDialog)OfficeExt.AddinNativeAction.Dialog.sendMessage(a);else OSF.DDA.WAC.Delegate.executeAsync(a)};OSF.DDA.WAC.Delegate.closeDialog=function(a){var c=OSF.DDA.WAC.Delegate._getOnAfterRegisterEvent(false,a);function b(b){var a={Error:b};try{c(Microsoft.Office.Common.InvokeResultCode.noError,a)}catch(d){OSF.AppTelemetry&&OSF.AppTelemetry.logAppException("Exception happens at closeDialogCallback."+d)}}if(!OSF.DialogShownStatus.hasDialogShown)b(OSF.DDA.ErrorCodeManager.errorCodes.ooeWebDialogClosed);else if(OSF.DialogShownStatus.isWindowDialog){a.onCalling&&a.onCalling();OfficeExt.AddinNativeAction.Dialog.closeDialog(b)}else OSF.DDA.WAC.Delegate.unregisterEventAsync(a)};OSF.InitializationHelper.prototype.dismissDialogNotification=function(){OfficeExt.AddinNativeAction.Dialog.escDismissDialogNotification()};OSF.InitializationHelper.prototype.registerMessageReceivedEventForWindowDialog=function(){OfficeExt.AddinNativeAction.Dialog.registerMessageReceivedEvent()};var OfficeExt;(function(a){var b;(function(b){var c;(function(d){var e=function(){function a(){}return a}();function b(f,h){var e=function(){return typeof Html2canvas!=="undefined"&&typeof Html2canvas.html2canvas!=="undefined"},b=function(){return typeof window.Promise!=="undefined"||typeof OfficeExtension!=="undefined"&&typeof OfficeExtension.Promise!=="undefined"};if(e()&&b()){f();return}var a=new ScriptLoading.LoadScriptHelper,c=a.getOfficeJsBasePath(),d={html2canvasJs:"Html2canvas.debug.js",promiseJs:"es6-promise.debug.js"},g=function(){if(e()&&b())f();else h()};if(!b())a.loadScript(c+d.promiseJs,null,function(){a.loadScript(c+d.html2canvasJs,null,g)});else a.loadScript(c+d.html2canvasJs,null,g)}function c(c){if(!a.WACUtils.isHostTrusted||!a.WACUtils.isHostTrusted())c.completed();else{var d=function(){c.completed()},f=function(a){try{c.result=a.toDataURL("image/png").replace("image/png","image/octet-stream")}catch(b){}c.completed()},e=function(){try{Html2canvas.html2canvas(document.body,{onrendered:f})}catch(a){d()}};b(e,d)}}d.generateLatestSnapshot=c})(c=b.Snapshot||(b.Snapshot={}))})(b=a.AddinNativeAction||(a.AddinNativeAction={}))})(OfficeExt||(OfficeExt={}));OSF.DDA.AsyncMethodNames.addNames({GetAccessTokenAsync:"getAccessTokenAsync"});OSF.DDA.Auth=function(){};OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetAccessTokenAsync,requiredArguments:[],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.ForceConsent,value:{types:["boolean"],defaultValue:false}},{name:Microsoft.Office.WebExtension.Parameters.ForceAddAccount,value:{types:["boolean"],defaultValue:false}},{name:Microsoft.Office.WebExtension.Parameters.AuthChallenge,value:{types:["string"],defaultValue:""}}],onSucceeded:function(a,d,c){var b=a[Microsoft.Office.WebExtension.Parameters.Data];return b}});OSF.OUtil.setNamespace("Marshaling",OSF.DDA);OSF.OUtil.setNamespace("SingleSignOn",OSF.DDA.Marshaling);OSF.DDA.Marshaling.SingleSignOn.GetAccessTokenKeys={ForceConsent:"forceConsent",ForceAddAccount:"forceAddAccount",AuthChallenge:"authChallenge"};OSF.DDA.Marshaling.SingleSignOn.AccessTokenResultKeys={AccessToken:"accessToken"};OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetAccessTokenMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.ForceConsent,value:OSF.DDA.Marshaling.SingleSignOn.GetAccessTokenKeys.ForceConsent},{name:Microsoft.Office.WebExtension.Parameters.ForceAddAccount,value:OSF.DDA.Marshaling.SingleSignOn.GetAccessTokenKeys.ForceAddAccount},{name:Microsoft.Office.WebExtension.Parameters.AuthChallenge,value:OSF.DDA.Marshaling.SingleSignOn.GetAccessTokenKeys.AuthChallenge}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.Marshaling.SingleSignOn.AccessTokenResultKeys.AccessToken}]});OSF.DDA.AsyncMethodNames.addNames({GetAuthContextAsync:"getAuthContextAsync"});OSF.DDA.WebAuth=function(){};OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetAuthContextAsync,requiredArguments:[],supportedOptions:[],onSucceeded:function(a,d,c){var b=a[Microsoft.Office.WebExtension.Parameters.Data];return b}});OSF.OUtil.setNamespace("Marshaling",OSF.DDA);OSF.OUtil.setNamespace("WebAuth",OSF.DDA.Marshaling);OSF.DDA.Marshaling.WebAuth.GetAuthContextKeys={};OSF.DDA.Marshaling.WebAuth.GetAuthContextResultKeys={AuthContext:"authContext",AppId:"appId",MsaAppId:"msaAppId",Upn:"upn",UserId:"userId",Authority:"authority",AuthorityType:"authorityType",IsAnonymous:"isAnonymous",TenantId:"tenantId",Error:"error"};OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetAuthContextMethod,toHost:[],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.Marshaling.WebAuth.GetAuthContextResultKeys.AuthContext}]});OSF.DDA.AsyncMethodNames.addNames({CreateDocumentAsync:"createDocumentAsync"});OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.CreateDocumentAsync,supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.Base64,value:{types:["string"],defaultValue:""}}],privateStateCallbacks:[]});OSF.OUtil.setNamespace("Marshaling",OSF.DDA);OSF.DDA.Marshaling.CreateDocument={Base64:"base64"};OSF.DDA.WAC.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidCreateDocumentMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Base64,value:OSF.DDA.Marshaling.CreateDocument.Base64}]});var OSFPPTWAC;(function(b){var a=function(){function a(a,b){OSF.DDA.DispIdHost.addEventSupport(this,new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.ActiveViewChanged,Microsoft.Office.WebExtension.EventType.DocumentSelectionChanged]));OSF.DDA.PowerPointDocument.uber.constructor.call(this,a,b);OSF.DDA.DispIdHost.addAsyncMethods(this,[OSF.DDA.AsyncMethodNames.GetSelectedDataAsync,OSF.DDA.AsyncMethodNames.SetSelectedDataAsync,OSF.DDA.AsyncMethodNames.GoToByIdAsync,OSF.DDA.AsyncMethodNames.GetActiveViewAsync,OSF.DDA.AsyncMethodNames.GetDocumentCopyAsync,OSF.DDA.AsyncMethodNames.GetFilePropertiesAsync]);OSF.OUtil.finalizeProperties(this)}return a}();b.PowerPointDocument=a})(OSFPPTWAC||(OSFPPTWAC={}));OSF.DDA.PowerPointDocument=OSFPPTWAC.PowerPointDocument;OSF.OUtil.extend(OSF.DDA.PowerPointDocument,OSF.DDA.Document);OSF.OUtil.redefineList(Microsoft.Office.WebExtension.GoToType,{Slide:"slide",Index:"index"});OSF.InitializationHelper.prototype.loadAppSpecificScriptAndCreateOM=function(a,b,c){OSF.DDA.ErrorCodeManager.initializeErrorMessages(Strings.OfficeOM);a.doc=new OSF.DDA.PowerPointDocument(a,this._initializeSettings(a,true));OSF.DDA.DispIdHost.addAsyncMethods(OSF.DDA.RichApi,[OSF.DDA.AsyncMethodNames.ExecuteRichApiRequestAsync]);b()};OSF.InitializationHelper.prototype.prepareRightBeforeWebExtensionInitialize=function(a){OSF.WebApp._UpdateLinksForHostAndXdmInfo();var e=new OSF.DDA.License(a.get_eToken());this.initWebDialog(a);this.initWebAuth(a);this.initWebAuthImplicit(a);if(OSF.DDA.Application){a.application=new OSF.DDA.Application(a);OSF.DDA.DispIdHost.addAsyncMethods(a.application,[OSF.DDA.AsyncMethodNames.CreateDocumentAsync]);OSF.OUtil.finalizeProperties(a.application)}OSF._OfficeAppFactory.setContext(new OSF.DDA.Context(a,a.doc,e));var b;OSF._OfficeAppFactory.setHostFacade(new OSF.DDA.DispIdHost.Facade(OSF.DDA.WAC.getDelegateMethods,OSF.DDA.WAC.Delegate.ParameterMap));b=function(b,d){if(b==0&&d!=true&&OSF.getClientEndPoint())OSF.getClientEndPoint().registerForEvent("activationCompleted",function(){var b=a.get_reason();Microsoft.Office.WebExtension.initialize(b)},null,{controlId:OSF._OfficeAppFactory.getId(),eventDispId:OSF.DDA.EventDispId.dispidActivationStatusChangedEvent,targetId:""});else{var c=a.get_reason();Microsoft.Office.WebExtension.initialize(c)}};if(OSF.getClientEndPoint())OSF.getClientEndPoint().invoke("getActivationCompletedStatus",b,this._webAppState.id);else if(a.get_isDialog()){var f=a.get_reason();Microsoft.Office.WebExtension.initialize(f);return}var d=new OSF.DDA.Theming.InternalThemeHandler;d.InitializeAndChangeOnce();var c=OfficeExt.AppCommand.AppCommandManager.instance();c.initializeAndChangeOnce()};var __extends=this&&this.__extends||function(){var a=function(c,b){a=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(b,a){b.__proto__=a}||function(c,a){for(var b in a)if(a.hasOwnProperty(b))c[b]=a[b]};return a(c,b)};return function(c,b){a(c,b);function d(){this.constructor=c}c.prototype=b===null?Object.create(b):(d.prototype=b.prototype,new d)}}(),OfficeExtension;(function(a){var b;(function(a){a.OfficeRequire=function(){return null}()})(b=a._Internal||(a._Internal={}));(function(a){var b;(function(b){function c(){return function(){"use strict";function N(a){return typeof a==="function"||typeof a==="object"&&a!==null}function u(a){return typeof a==="function"}function Q(a){return typeof a==="object"&&a!==null}var v;if(!Array.isArray)v=function(a){return Object.prototype.toString.call(a)==="[object Array]"};else v=Array.isArray;var A=v,n=0,lb={}.toString,gb,s,h=function(a,b){m[n]=a;m[n+1]=b;n+=2;if(n===2)if(s)s(l);else o()};function Z(a){s=a}function ib(a){h=a}var U=typeof window!=="undefined"?window:undefined,z=U||{},w=z.MutationObserver||z.WebKitMutationObserver,jb=typeof process!=="undefined"&&{}.toString.call(process)==="[object process]",hb=typeof Uint8ClampedArray!=="undefined"&&typeof importScripts!=="undefined"&&typeof MessageChannel!=="undefined";function bb(){var b=process.nextTick,a=process.versions.node.match(/^(?:(\d+)\.)?(?:(\d+)\.)?(\*|\d+)$/);if(Array.isArray(a)&&a[1]==="0"&&a[2]==="10")b=window.setImmediate;return function(){b(l)}}function kb(){return function(){gb(l)}}function I(){var a=0,c=new w(l),b=document.createTextNode("");c.observe(b,{characterData:true});return function(){b.data=a=++a%2}}function L(){var a=new MessageChannel;a.port1.onmessage=l;return function(){a.port2.postMessage(0)}}function V(){return function(){setTimeout(l,1)}}var m=new Array(1e3);function l(){for(var a=0;a<n;a+=2){var b=m[a],c=m[a+1];b(c);m[a]=undefined;m[a+1]=undefined}n=0}var o;if(jb)o=bb();else if(w)o=I();else if(hb)o=L();else o=V();function k(){}var g=void 0,i=1,f=2,p=new y;function G(){return new TypeError("You cannot resolve a promise with itself")}function H(){return new TypeError("A promises callback cannot return that same promise.")}function X(a){try{return a.then}catch(b){p.error=b;return p}}function Y(d,c,a,b){try{d.call(c,a,b)}catch(e){return e}}function B(c,a,e){h(function(f){var c=false,g=Y(e,a,function(b){if(c)return;c=true;if(a!==b)j(f,b);else d(f,b)},function(a){if(c)return;c=true;b(f,a)},"Settle: "+(f._label||" unknown promise"));if(!c&&g){c=true;b(f,g)}},c)}function D(c,a){if(a._state===i)d(c,a._result);else if(a._state===f)b(c,a._result);else q(a,undefined,function(a){j(c,a)},function(a){b(c,a)})}function C(c,a){if(a.constructor===c.constructor)D(c,a);else{var e=X(a);if(e===p)b(c,p.error);else if(e===undefined)d(c,a);else if(u(e))B(c,a,e);else d(c,a)}}function j(a,c){if(a===c)b(a,G());else if(N(c))C(a,c);else d(a,c)}function F(a){a._onerror&&a._onerror(a._result);t(a)}function d(a,b){if(a._state!==g)return;a._result=b;a._state=i;a._subscribers.length!==0&&h(t,a)}function b(a,b){if(a._state!==g)return;a._state=f;a._result=b;h(F,a)}function q(c,g,d,e){var a=c._subscribers,b=a.length;c._onerror=null;a[b]=g;a[b+i]=d;a[b+f]=e;b===0&&c._state&&h(t,c)}function t(b){var a=b._subscribers,f=b._state;if(a.length===0)return;for(var e,d,g=b._result,c=0;c<a.length;c+=3){e=a[c];d=a[c+f];if(e)x(f,e,d,g);else d(g)}b._subscribers.length=0}function y(){this.error=null}var r=new y;function T(a,b){try{return a(b)}catch(c){r.error=c;return r}}function x(l,c,k,m){var h=u(k),a,o,e,n;if(h){a=T(k,m);if(a===r){n=true;o=a.error;a=null}else e=true;if(c===a){b(c,H());return}}else{a=m;e=true}if(c._state===g)if(h&&e)j(c,a);else if(n)b(c,o);else if(l===i)d(c,a);else l===f&&b(c,a)}function E(a,c){try{c(function(b){j(a,b)},function(c){b(a,c)})}catch(d){b(a,d)}}function e(e,c){var a=this;a._instanceConstructor=e;a.promise=new e(k);if(a._validateInput(c)){a._input=c;a.length=c.length;a._remaining=c.length;a._init();if(a.length===0)d(a.promise,a._result);else{a.length=a.length||0;a._enumerate();a._remaining===0&&d(a.promise,a._result)}}else b(a.promise,a._validationError())}e.prototype._validateInput=function(a){return A(a)};e.prototype._validationError=function(){return new a.Error("Array Methods must be provided an Array")};e.prototype._init=function(){this._result=new Array(this.length)};var W=e;e.prototype._enumerate=function(){for(var a=this,d=a.length,c=a.promise,e=a._input,b=0;c._state===g&&b<d;b++)a._eachEntry(e[b],b)};e.prototype._eachEntry=function(a,c){var b=this,d=b._instanceConstructor;if(Q(a))if(a.constructor===d&&a._state!==g){a._onerror=null;b._settledAt(a._state,c,a._result)}else b._willSettleAt(d.resolve(a),c);else{b._remaining--;b._result[c]=a}};e.prototype._settledAt=function(h,i,e){var a=this,c=a.promise;if(c._state===g){a._remaining--;if(h===f)b(c,e);else a._result[i]=e}a._remaining===0&&d(c,a._result)};e.prototype._willSettleAt=function(c,b){var a=this;q(c,undefined,function(c){a._settledAt(i,b,c)},function(c){a._settledAt(f,b,c)})};function fb(a){return new W(this,a).promise}var S=fb;function ab(c){var e=this,a=new e(k);if(!A(c)){b(a,new TypeError("You must pass an array to race."));return a}var i=c.length;function f(b){j(a,b)}function h(c){b(a,c)}for(var d=0;a._state===g&&d<i;d++)q(e.resolve(c[d]),undefined,f,h);return a}var R=ab;function K(a){var b=this;if(a&&typeof a==="object"&&a.constructor===b)return a;var c=new b(k);j(c,a);return c}var J=K;function P(d){var c=this,a=new c(k);b(a,d);return a}var M=P,db=0;function O(){throw new TypeError("You must pass a resolver function as the first argument to the promise constructor");}function cb(){throw new TypeError("Failed to construct 'Promise': Please use the 'new' operator, this object constructor cannot be called as a function.");}var eb=c;function c(a){this._id=db++;this._state=undefined;this._result=undefined;this._subscribers=[];if(k!==a){!u(a)&&O();!(this instanceof c)&&cb();E(this,a)}}c.all=S;c.race=R;c.resolve=J;c.reject=M;c._setScheduler=Z;c._setAsap=ib;c._asap=h;c.prototype={constructor:c,then:function(d,e){var b=this,a=b._state;if(a===i&&!d||a===f&&!e)return this;var c=new this.constructor(k),j=b._result;if(a){var g=arguments[a-1];h(function(){x(a,c,g,j)})}else q(b,c,d,e);return c},"catch":function(a){return this.then(null,a)}};return eb}.call(this)}b.Init=c})(b=a.PromiseImpl||(a.PromiseImpl={}))})(b=a._Internal||(a._Internal={}));(function(a){function c(){var a=window.navigator.userAgent,b=a.indexOf("Edge/");if(b>=0){a=a.substring(b+5,a.length);if(a<"14.14393")return true;else return false}return false}function b(){if(typeof window==="undefined"&&typeof Promise==="function")return Promise;if(typeof window!=="undefined"&&window.Promise)if(c())return a.PromiseImpl.Init();else return window.Promise;else return a.PromiseImpl.Init()}a.OfficePromise=b()})(b=a._Internal||(a._Internal={}));var c=b.OfficePromise;a.Promise=c})(OfficeExtension||(OfficeExtension={}));var OfficeExtension;(function(c){var s=function(){function b(){}b.prototype._resolveRequestUrlAndHeaderInfo=function(){return a._createPromiseFromResult(null)};b.prototype._createRequestExecutorOrNull=function(){return null};Object.defineProperty(b.prototype,"eventRegistration",{"get":function(){return null},enumerable:true,configurable:true});return b}();c.SessionBase=s;var D=function(){function b(){}b.setCustomSendRequestFunc=function(a){b.s_customSendRequestFunc=a};b.xhrSendRequestFunc=function(b){return a.createPromise(function(g,h){var c=new XMLHttpRequest;c.open(b.method,b.url);c.onload=function(){var b={statusCode:c.status,headers:a._parseHttpResponseHeaders(c.getAllResponseHeaders()),body:c.responseText};g(b)};c.onerror=function(){h(new d.RuntimeError({code:f.connectionFailure,message:a._getResourceString(i.connectionFailureWithStatus,c.statusText)}))};if(b.headers)for(var e in b.headers)c.setRequestHeader(e,b.headers[e]);c.send(a._getRequestBodyText(b))})};b.sendRequest=function(c){b.validateAndNormalizeRequest(c);var a=b.s_customSendRequestFunc;if(!a)a=b.xhrSendRequestFunc;return a(c)};b.setCustomSendLocalDocumentRequestFunc=function(a){b.s_customSendLocalDocumentRequestFunc=a};b.sendLocalDocumentRequest=function(a){b.validateAndNormalizeRequest(a);var c;c=b.s_customSendLocalDocumentRequestFunc||b.officeJsSendLocalDocumentRequestFunc;return c(a)};b.officeJsSendLocalDocumentRequestFunc=function(b){b=a._validateLocalDocumentRequest(b);var c=a._buildRequestMessageSafeArray(b);return a.createPromise(function(b,d){OSF.DDA.RichApi.executeRichApiRequestAsync(c,function(c){var d;if(c.status=="succeeded")d={statusCode:k.getResponseStatusCode(c),headers:k.getResponseHeaders(c),body:k.getResponseBody(c)};else d=k.buildHttpResponseFromOfficeJsError(c.error.code,c.error.message);a.log("Response:");a.log(JSON.stringify(d));b(d)})})};b.validateAndNormalizeRequest=function(b){if(a.isNullOrUndefined(b))throw d.RuntimeError._createInvalidArgError({argumentName:"request"});if(a.isNullOrEmptyString(b.method))b.method="GET";b.method=b.method.toUpperCase()};b.logRequest=function(c){if(a._logEnabled){a.log("---HTTP Request---");a.log(c.method+" "+c.url);if(c.headers)for(var d in c.headers)a.log(d+": "+c.headers[d]);b._logBodyEnabled&&a.log(a._getRequestBodyText(c))}};b.logResponse=function(c){if(a._logEnabled){a.log("---HTTP Response---");a.log(""+c.statusCode);if(c.headers)for(var d in c.headers)a.log(d+": "+c.headers[d]);b._logBodyEnabled&&a.log(c.body)}};b._logBodyEnabled=false;return b}();c.HttpUtility=D;var v=function(){function b(a){var b=this;this.m_bridge=a;this.m_promiseResolver={};this.m_handlers=[];this.m_bridge.onMessageFromHost=function(f){var e=JSON.parse(f);if(e.type==3){var c=e.message;if(c&&c.entries)for(var d=0;d<c.entries.length;d++){var a=c.entries[d];if(Array.isArray(a)){var g={messageCategory:a[0],messageType:a[1],targetId:a[2],message:a[3],id:a[4]};c.entries[d]=g}}}b.dispatchMessage(e)}}b.init=function(d){if(typeof d!=="object"||!d)return;var c=new b(d);b.s_instance=c;D.setCustomSendLocalDocumentRequestFunc(function(d){d=a._validateLocalDocumentRequest(d);var e=0;if(!a.isReadonlyRestRequest(d.method))e=1;var g=d.url.indexOf("?");if(g>=0){var i=d.url.substr(g+1),f=a._parseRequestFlagsFromQueryStringIfAny(i);if(f>=0)e=f}var h={id:b.nextId(),type:1,flags:e,message:d};return c.sendMessageToHostAndExpectResponse(h).then(function(a){var b=a.message;return b})});for(var e=0;e<b.s_onInitedHandlers.length;e++)b.s_onInitedHandlers[e](c)};Object.defineProperty(b,"instance",{"get":function(){return b.s_instance},enumerable:true,configurable:true});b.prototype.sendMessageToHost=function(a){this.m_bridge.sendMessageToHost(JSON.stringify(a))};b.prototype.sendMessageToHostAndExpectResponse=function(b){var c=this,d=a.createPromise(function(a,d){c.m_promiseResolver[b.id]=a});this.m_bridge.sendMessageToHost(JSON.stringify(b));return d};b.prototype.addHostMessageHandler=function(a){this.m_handlers.push(a)};b.prototype.removeHostMessageHandler=function(b){var a=this.m_handlers.indexOf(b);a>=0&&this.m_handlers.splice(a,1)};b.onInited=function(a){b.s_onInitedHandlers.push(a);b.s_instance&&a(b.s_instance)};b.prototype.dispatchMessage=function(a){if(typeof a.id==="number"){var c=this.m_promiseResolver[a.id];if(c){c(a);delete this.m_promiseResolver[a.id];return}}for(var b=0;b<this.m_handlers.length;b++)this.m_handlers[b](a)};b.nextId=function(){return b.s_nextId++};b.s_onInitedHandlers=[];b.s_nextId=1;return b}();c.HostBridge=v;typeof _richApiNativeBridge==="object"&&_richApiNativeBridge&&v.init(_richApiNativeBridge);var d;(function(b){var c=function(d){__extends(c,d);function c(a){var b=d.call(this,typeof a==="string"?a:a.message)||this;Object.setPrototypeOf(b,c.prototype);b.name="RichApi.Error";if(typeof a==="string")b.message=a;else{b.code=a.code;b.message=a.message;b.traceMessages=a.traceMessages||[];b.innerError=a.innerError||null;b.debugInfo=b._createDebugInfo(a.debugInfo||{})}return b}c.prototype.toString=function(){return this.code+": "+this.message};c.prototype._createDebugInfo=function(c){var a={code:this.code,message:this.message};a.toString=function(){return JSON.stringify(this)};for(var d in c)a[d]=c[d];if(this.innerError)if(this.innerError instanceof b.RuntimeError)a.innerError=this.innerError.debugInfo;else a.innerError=this.innerError;return a};c._createInvalidArgError=function(c){return new b.RuntimeError({code:f.invalidArgument,message:a.isNullOrEmptyString(c.argumentName)?a._getResourceString(i.invalidArgumentGeneric):a._getResourceString(i.invalidArgument,c.argumentName),debugInfo:c.errorLocation?{errorLocation:c.errorLocation}:{},innerError:c.innerError})};return c}(Error);b.RuntimeError=c})(d=c._Internal||(c._Internal={}));c.Error=d.RuntimeError;var f=function(){function a(){}a.apiNotFound="ApiNotFound";a.accessDenied="AccessDenied";a.generalException="GeneralException";a.activityLimitReached="ActivityLimitReached";a.invalidArgument="InvalidArgument";a.connectionFailure="ConnectionFailure";a.timeout="Timeout";a.invalidOrTimedOutSession="InvalidOrTimedOutSession";a.invalidObjectPath="InvalidObjectPath";a.invalidRequestContext="InvalidRequestContext";a.valueNotLoaded="ValueNotLoaded";return a}();c.CoreErrorCodes=f;var i=function(){function a(){}a.apiNotFoundDetails="ApiNotFoundDetails";a.connectionFailureWithStatus="ConnectionFailureWithStatus";a.connectionFailureWithDetails="ConnectionFailureWithDetails";a.invalidArgument="InvalidArgument";a.invalidArgumentGeneric="InvalidArgumentGeneric";a.timeout="Timeout";a.invalidOrTimedOutSessionMessage="InvalidOrTimedOutSessionMessage";a.invalidObjectPath="InvalidObjectPath";a.invalidRequestContext="InvalidRequestContext";a.valueNotLoaded="ValueNotLoaded";return a}();c.CoreResourceStrings=i;var m=function(){function a(){}a.flags="flags";a.sourceLibHeader="SdkVersion";a.processQuery="ProcessQuery";a.localDocument="http://document.localhost/";a.localDocumentApiPrefix="http://document.localhost/_api/";return a}();c.CoreConstants=m;var k=function(){function b(){}b.buildMessageArrayForIRequestExecutor=function(i,h,g,e){var c=JSON.stringify(g.Body);a.log("Request:");a.log(c);var d={};d[m.sourceLibHeader]=e;var f=b.buildRequestMessageSafeArray(i,h,"POST",m.processQuery,d,c);return f};b.buildResponseOnSuccess=function(c,b){var a={ErrorCode:"",ErrorMessage:"",Headers:null,Body:null};a.Body=JSON.parse(c);a.Headers=b;return a};b.buildResponseOnError=function(d,e){var c={ErrorCode:"",ErrorMessage:"",Headers:null,Body:null};c.ErrorCode=f.generalException;c.ErrorMessage=e;if(d==b.OfficeJsErrorCode_ooeNoCapability)c.ErrorCode=f.accessDenied;else if(d==b.OfficeJsErrorCode_ooeActivityLimitReached)c.ErrorCode=f.activityLimitReached;else if(d==b.OfficeJsErrorCode_ooeInvalidOrTimedOutSession){c.ErrorCode=f.invalidOrTimedOutSession;c.ErrorMessage=a._getResourceString(i.invalidOrTimedOutSessionMessage)}return c};b.buildHttpResponseFromOfficeJsError=function(d,e){var c=500,a={};a.error={};a.error.code=f.generalException;a.error.message=e;if(d===b.OfficeJsErrorCode_ooeNoCapability){c=403;a.error.code=f.accessDenied}else if(d===b.OfficeJsErrorCode_ooeActivityLimitReached){c=429;a.error.code=f.activityLimitReached}return{statusCode:c,headers:{},body:JSON.stringify(a)}};b.buildRequestMessageSafeArray=function(g,f,j,l,b,k){var a=[];if(b)for(var c in b){a.push(c);a.push(b[c])}var e=0,i="",h="",d="";return[g,j,l,a,k,e,f,i,h,d]};b.getResponseBody=function(a){return b.getResponseBodyFromSafeArray(a.value.data)};b.getResponseHeaders=function(a){return b.getResponseHeadersFromSafeArray(a.value.data)};b.getResponseBodyFromSafeArray=function(b){var a=b[2];if(typeof a==="string")return a;var c=a;return c.join("")};b.getResponseHeadersFromSafeArray=function(d){var a=d[1];if(!a)return null;for(var c={},b=0;b<a.length-1;b+=2)c[a[b]]=a[b+1];return c};b.getResponseStatusCode=function(a){return b.getResponseStatusCodeFromSafeArray(a.value.data)};b.getResponseStatusCodeFromSafeArray=function(a){return a[0]};b.OfficeJsErrorCode_ooeInvalidOrTimedOutSession=5012;b.OfficeJsErrorCode_ooeActivityLimitReached=5102;b.OfficeJsErrorCode_ooeNoCapability=7e3;return b}();c.RichApiMessageUtility=k;(function(a){function b(){if(typeof Promise!=="undefined")return Promise;if(typeof Office!=="undefined")if(Office.Promise)return Office.Promise;if(typeof OfficeExtension!=="undefined")if(OfficeExtension.Promise)return OfficeExtension.Promise;throw new a.Error("No Promise implementation found");}a.getPromiseType=b})(d=c._Internal||(c._Internal={}));var a=function(){function a(){}a.log=function(b){a._logEnabled&&typeof console!=="undefined"&&console.log&&console.log(b)};a.checkArgumentNull=function(b,c){if(a.isNullOrUndefined(b))throw d.RuntimeError._createInvalidArgError({argumentName:c});};a.isNullOrUndefined=function(a){if(a===null)return true;if(typeof a==="undefined")return true;return false};a.isUndefined=function(a){if(typeof a==="undefined")return true;return false};a.isNullOrEmptyString=function(a){if(a===null)return true;if(typeof a==="undefined")return true;if(a.length==0)return true;return false};a.isPlainJsonObject=function(c){if(a.isNullOrUndefined(c))return false;if(typeof c!=="object")return false;if(Object.prototype.toString.apply(c)!=="[object Object]")return false;var b=c;do b=Object.getPrototypeOf(b);while(b!==null&&Object.getPrototypeOf(b)!==null);return Object.getPrototypeOf(c)===b};a.trim=function(a){return a.replace(new RegExp("^\\s+|\\s+$","g"),"")};a.caseInsensitiveCompareString=function(c,b){if(a.isNullOrUndefined(c))return a.isNullOrUndefined(b);else if(a.isNullOrUndefined(b))return false;else return c.toUpperCase()==b.toUpperCase()};a.isReadonlyRestRequest=function(b){return a.caseInsensitiveCompareString(b,"GET")};a._getResourceString=function(d,c){var b;if(typeof window!=="undefined"&&window.Strings&&window.Strings.OfficeOM){var f="L_"+d,e=window.Strings.OfficeOM[f];if(e)b=e}if(!b)b=a.s_resourceStringValues[d];if(!b)b=d;if(!a.isNullOrUndefined(c))if(Array.isArray(c)){var g=c;b=a._formatString(b,g)}else b=b.replace("{0}",c);return b};a._formatString=function(b,a){return b.replace(/\{\d\}/g,function(c){var b=parseInt(c.substr(1,c.length-2));if(b<a.length)return a[b];else throw d.RuntimeError._createInvalidArgError({argumentName:"format"});})};Object.defineProperty(a,"Promise",{"get":function(){return d.getPromiseType()},enumerable:true,configurable:true});a.createPromise=function(b){var c=new a.Promise(b);return c};a._createPromiseFromResult=function(b){return a.createPromise(function(a,c){a(b)})};a._createPromiseFromException=function(b){return a.createPromise(function(c,a){a(b)})};a._createTimeoutPromise=function(b){return a.createPromise(function(a,c){setTimeout(function(){a(null)},b)})};a._createInvalidArgError=function(a){return d.RuntimeError._createInvalidArgError(a)};a._isLocalDocumentUrl=function(b){return a._getLocalDocumentUrlPrefixLength(b)>0};a._getLocalDocumentUrlPrefixLength=function(d){for(var b=["http://document.localhost","https://document.localhost","//document.localhost"],c=d.toLowerCase().trim(),a=0;a<b.length;a++)if(c===b[a])return b[a].length;else if(c.substr(0,b[a].length+1)===b[a]+"/")return b[a].length+1;return 0};a._validateLocalDocumentRequest=function(b){var f=a._getLocalDocumentUrlPrefixLength(b.url);if(f<=0)throw d.RuntimeError._createInvalidArgError({argumentName:"request"});var c=b.url.substr(f),e=c.toLowerCase();if(e==="_api")c="";else if(e.substr(0,"_api/".length)==="_api/")c=c.substr("_api/".length);return{method:b.method,url:c,headers:b.headers,body:b.body}};a._parseRequestFlagsFromQueryStringIfAny=function(e){for(var d=e.split("&"),b=0;b<d.length;b++){var c=d[b].split("=");if(c[0].toLowerCase()===m.flags){var a=parseInt(c[1]);a=a&511;return a}}return-1};a._getRequestBodyText=function(a){var b="";if(typeof a.body==="string")b=a.body;else if(a.body&&typeof a.body==="object")b=JSON.stringify(a.body);return b};a._parseResponseBody=function(b){if(typeof b.body==="string"){var c=a.trim(b.body);return JSON.parse(c)}else return b.body};a._buildRequestMessageSafeArray=function(b){var c=0;if(!a.isReadonlyRestRequest(b.method))c=1;if(b.url.substr(0,m.processQuery.length).toLowerCase()===m.processQuery.toLowerCase()){var e=b.url.indexOf("?");if(e>0){var f=b.url.substr(e+1),d=a._parseRequestFlagsFromQueryStringIfAny(f);if(d>=0)c=d}}return k.buildRequestMessageSafeArray("",c,b.method,b.url,b.headers,a._getRequestBodyText(b))};a._parseHttpResponseHeaders=function(g){var h={};if(!a.isNullOrEmptyString(g))for(var j=new RegExp("\x0d?\x0a"),i=g.split(j),f=0;f<i.length;f++){var b=i[f];if(b!=null){var c=b.indexOf(":");if(c>0){var e=b.substr(0,c),d=b.substr(c+1);e=a.trim(e);d=a.trim(d);h[e.toUpperCase()]=d}}}return h};a._parseErrorResponse=function(c){var b=null;if(a.isPlainJsonObject(c.body))b=c.body;else if(!a.isNullOrEmptyString(c.body)){var g=a.trim(c.body);try{b=JSON.parse(g)}catch(h){a.log("Error when parse "+g)}}var e,d;if(!a.isNullOrUndefined(b)&&typeof b==="object"&&b.error){d=b.error.code;e=a._getResourceString(i.connectionFailureWithDetails,[c.statusCode.toString(),b.error.code,b.error.message])}else e=a._getResourceString(i.connectionFailureWithStatus,c.statusCode.toString());if(a.isNullOrEmptyString(d))d=f.connectionFailure;return{errorCode:d,errorMessage:e}};a._copyHeaders=function(a,b){if(a&&b)for(var c in a)b[c]=a[c]};a.addResourceStringValues=function(b){for(var c in b)a.s_resourceStringValues[c]=b[c]};a._logEnabled=false;a.s_resourceStringValues={ApiNotFoundDetails:"The method or property {0} is part of the {1} requirement set, which is not available in your version of {2}.",ConnectionFailureWithStatus:"The request failed with status code of {0}.",ConnectionFailureWithDetails:"The request failed with status code of {0}, error code {1} and the following error message: {2}",InvalidArgument:"The argument '{0}' doesn't work for this situation, is missing, or isn't in the right format.",InvalidObjectPath:'The object path \'{0}\' isn\'t working for what you\'re trying to do. If you\'re using the object across multiple "context.sync" calls and outside the sequential execution of a ".run" batch, please use the "context.trackedObjects.add()" and "context.trackedObjects.remove()" methods to manage the object\'s lifetime.',InvalidRequestContext:"Cannot use the object across different request contexts.",Timeout:"The operation has timed out.",ValueNotLoaded:'The value of the result object has not been loaded yet. Before reading the value property, call "context.sync()" on the associated request context.'};return a}();c.CoreUtility=a;c._internalConfig={showDisposeInfoInDebugInfo:false,showInternalApiInDebugInfo:false,enableEarlyDispose:true,alwaysPolyfillClientObjectUpdateMethod:false,alwaysPolyfillClientObjectRetrieveMethod:false,enableConcurrentFlag:true,enableUndoableFlag:true};c.config={extendedErrorLogging:false};var t=function(){function a(){}a.createSetPropertyAction=function(f,a,g,i,h){e.validateObjectPath(a);var d={Id:f._nextId(),ActionType:4,Name:g,ObjectPathId:a._objectPath.objectPathInfo.Id,ArgumentInfo:{}},j=[i],c=e.setMethodArguments(f,d.ArgumentInfo,j);e.validateReferencedObjectPaths(c);var b=new n(d,0,h);b.referencedObjectPath=a._objectPath;b.referencedArgumentObjectPaths=c;return a._addAction(b)};a.createQueryAction=function(g,a,d,c){e.validateObjectPath(a);var f={Id:g._nextId(),ActionType:2,Name:"",ObjectPathId:a._objectPath.objectPathInfo.Id,QueryInfo:d},b=new n(f,1,4);b.referencedObjectPath=a._objectPath;return a._addAction(b,c)};a.createQueryAsJsonAction=function(g,a,d,c){e.validateObjectPath(a);var f={Id:g._nextId(),ActionType:7,Name:"",ObjectPathId:a._objectPath.objectPathInfo.Id,QueryInfo:d},b=new n(f,1,4);b.referencedObjectPath=a._objectPath;return a._addAction(b,c)};a.createUpdateAction=function(f,a,c){e.validateObjectPath(a);var d={Id:f._nextId(),ActionType:9,Name:"",ObjectPathId:a._objectPath.objectPathInfo.Id,ObjectState:c},b=new n(d,0,0);b.referencedObjectPath=a._objectPath;return a._addAction(b)};return a}();c.CommonActionFactory=t;var y=function(){function b(a,b){this.m_contextBase=a;this.m_objectPath=b}Object.defineProperty(b.prototype,"_objectPath",{"get":function(){return this.m_objectPath},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"_context",{"get":function(){return this.m_contextBase},enumerable:true,configurable:true});b.prototype._addAction=function(c,b){var d=this;if(b===void 0)b=null;return a.createPromise(function(a,e){d._context._addServiceApiAction(c,b,a,e)})};b.prototype._retrieve=function(f,b){var a=c._internalConfig.alwaysPolyfillClientObjectRetrieveMethod;if(!a)a=!e.isSetSupported("RichApiRuntime","1.1");var d=B._parseQueryOption(f);if(a)return t.createQueryAction(this._context,this,d,b);return t.createQueryAsJsonAction(this._context,this,d,b)};b.prototype._recursivelyUpdate=function(p){var n=c._internalConfig.alwaysPolyfillClientObjectUpdateMethod;if(!n)n=!e.isSetSupported("RichApiRuntime","1.2");try{var g=this[j.scalarPropertyNames];if(!g)g=[];var k=this[j.scalarPropertyUpdateable];if(!k){k=[];for(var h=0;h<g.length;h++)k.push(false)}var l=this[j.navigationPropertyNames];if(!l)l=[];var o={},m={},q=0;for(var b in p){var s=g.indexOf(b);if(s>=0){if(!k[s])throw new d.RuntimeError({code:f.invalidArgument,message:a._getResourceString(w.attemptingToSetReadOnlyProperty,b),debugInfo:{errorLocation:b}});o[b]=p[b];++q}else if(l.indexOf(b)>=0)m[b]=p[b];else throw new d.RuntimeError({code:f.invalidArgument,message:a._getResourceString(w.propertyDoesNotExist,b),debugInfo:{errorLocation:b}});}if(q>0)if(n)for(var h=0;h<g.length;h++){var b=g[h],r=o[b];!e.isUndefined(r)&&t.createSetPropertyAction(this._context,this,b,r)}else t.createUpdateAction(this._context,this,o);for(var b in m){var u=this[b],v=m[b];u._recursivelyUpdate(v)}}catch(x){throw new d.RuntimeError({code:f.invalidArgument,message:a._getResourceString(i.invalidArgument,"properties"),debugInfo:{errorLocation:this._className+".update"},innerError:x});}};return b}();c.ClientObjectBase=y;var n=function(){function a(b,a,c){this.m_actionInfo=b;this.m_operationType=a;this.m_flags=c}Object.defineProperty(a.prototype,"actionInfo",{"get":function(){return this.m_actionInfo},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"operationType",{"get":function(){return this.m_operationType},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"flags",{"get":function(){return this.m_flags},enumerable:true,configurable:true});return a}();c.Action=n;var l=function(){function b(c,b,e,a,d,f){this.m_objectPathInfo=c;this.m_parentObjectPath=b;this.m_isCollection=e;this.m_isInvalidAfterRequest=a;this.m_isValid=true;this.m_operationType=d;this.m_flags=f}Object.defineProperty(b.prototype,"objectPathInfo",{"get":function(){return this.m_objectPathInfo},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"operationType",{"get":function(){return this.m_operationType},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"flags",{"get":function(){return this.m_flags},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"isCollection",{"get":function(){return this.m_isCollection},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"isInvalidAfterRequest",{"get":function(){return this.m_isInvalidAfterRequest},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"parentObjectPath",{"get":function(){return this.m_parentObjectPath},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"argumentObjectPaths",{"get":function(){return this.m_argumentObjectPaths},"set":function(a){this.m_argumentObjectPaths=a},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"isValid",{"get":function(){return this.m_isValid},"set":function(a){this.m_isValid=a;if(!a&&this.m_objectPathInfo.ObjectPathType===6&&this.m_savedObjectPathInfo){b.copyObjectPathInfo(this.m_savedObjectPathInfo.pathInfo,this.m_objectPathInfo);this.m_parentObjectPath=this.m_savedObjectPathInfo.parent;this.m_isValid=true;this.m_savedObjectPathInfo=null}},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"originalObjectPathInfo",{"get":function(){return this.m_originalObjectPathInfo},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"getByIdMethodName",{"get":function(){return this.m_getByIdMethodName},"set":function(a){this.m_getByIdMethodName=a},enumerable:true,configurable:true});b.prototype._updateAsNullObject=function(){this.resetForUpdateUsingObjectData();this.m_objectPathInfo.ObjectPathType=7;this.m_objectPathInfo.Name="";this.m_parentObjectPath=null};b.prototype.saveOriginalObjectPathInfo=function(){if(c.config.extendedErrorLogging&&!this.m_originalObjectPathInfo){this.m_originalObjectPathInfo={};b.copyObjectPathInfo(this.m_objectPathInfo,this.m_originalObjectPathInfo)}};b.prototype.updateUsingObjectData=function(i,c){var m=i[j.referenceId];if(!a.isNullOrEmptyString(m)){if(!this.m_savedObjectPathInfo&&!this.isInvalidAfterRequest&&b.isRestorableObjectPath(this.m_objectPathInfo.ObjectPathType)){var n={};b.copyObjectPathInfo(this.m_objectPathInfo,n);this.m_savedObjectPathInfo={pathInfo:n,parent:this.m_parentObjectPath}}this.saveOriginalObjectPathInfo();this.resetForUpdateUsingObjectData();this.m_objectPathInfo.ObjectPathType=6;this.m_objectPathInfo.Name=m;delete this.m_objectPathInfo.ParentObjectPathId;this.m_parentObjectPath=null;return}if(c){var l=c[j.collectionPropertyPath];if(!a.isNullOrEmptyString(l)&&c.context){var d=e.tryGetObjectIdFromLoadOrRetrieveResult(i);if(!a.isNullOrUndefined(d)){for(var g=l.split("."),h=c.context[g[0]],k=1;k<g.length;k++)h=h[g[k]];this.saveOriginalObjectPathInfo();this.resetForUpdateUsingObjectData();this.m_parentObjectPath=h._objectPath;this.m_objectPathInfo.ParentObjectPathId=this.m_parentObjectPath.objectPathInfo.Id;this.m_objectPathInfo.ObjectPathType=5;this.m_objectPathInfo.Name="";this.m_objectPathInfo.ArgumentInfo.Arguments=[d];return}}}var o=this.parentObjectPath&&this.parentObjectPath.isCollection,f=this.getByIdMethodName;if(o||!a.isNullOrEmptyString(f)){var d=e.tryGetObjectIdFromLoadOrRetrieveResult(i);if(!a.isNullOrUndefined(d)){this.saveOriginalObjectPathInfo();this.resetForUpdateUsingObjectData();if(!a.isNullOrEmptyString(f)){this.m_objectPathInfo.ObjectPathType=3;this.m_objectPathInfo.Name=f;this.m_getByIdMethodName=null}else{this.m_objectPathInfo.ObjectPathType=5;this.m_objectPathInfo.Name=""}this.m_objectPathInfo.ArgumentInfo.Arguments=[d];return}}};b.prototype.resetForUpdateUsingObjectData=function(){this.m_isInvalidAfterRequest=false;this.m_isValid=true;this.m_operationType=1;this.m_flags=4;this.m_objectPathInfo.ArgumentInfo={};this.m_argumentObjectPaths=null};b.isRestorableObjectPath=function(a){return a===1||a===5||a===3||a===4};b.copyObjectPathInfo=function(b,a){a.Id=b.Id;a.ArgumentInfo=b.ArgumentInfo;a.Name=b.Name;a.ObjectPathType=b.ObjectPathType;a.ParentObjectPathId=b.ParentObjectPathId};return b}();c.ObjectPath=l;var B=function(){function a(){this.m_nextId=0}a.prototype._nextId=function(){return++this.m_nextId};a.prototype._addServiceApiAction=function(c,a,b,d){if(!this.m_serviceApiQueue)this.m_serviceApiQueue=new cb(this);this.m_serviceApiQueue.add(c,a,b,d)};a._parseQueryOption=function(f){var c={};if(typeof f==="string"){var g=f;c.Select=e._parseSelectExpand(g)}else if(Array.isArray(f))c.Select=f;else if(typeof f==="object"){var b=f;if(a.isLoadOption(b)){if(typeof b.select==="string")c.Select=e._parseSelectExpand(b.select);else if(Array.isArray(b.select))c.Select=b.select;else if(!e.isNullOrUndefined(b.select))throw d.RuntimeError._createInvalidArgError({argumentName:"option.select"});if(typeof b.expand==="string")c.Expand=e._parseSelectExpand(b.expand);else if(Array.isArray(b.expand))c.Expand=b.expand;else if(!e.isNullOrUndefined(b.expand))throw d.RuntimeError._createInvalidArgError({argumentName:"option.expand"});if(typeof b.top==="number")c.Top=b.top;else if(!e.isNullOrUndefined(b.top))throw d.RuntimeError._createInvalidArgError({argumentName:"option.top"});if(typeof b.skip==="number")c.Skip=b.skip;else if(!e.isNullOrUndefined(b.skip))throw d.RuntimeError._createInvalidArgError({argumentName:"option.skip"});}else c=a.parseStrictLoadOption(f)}else if(!e.isNullOrUndefined(f))throw d.RuntimeError._createInvalidArgError({argumentName:"option"});return c};a.isLoadOption=function(a){if(!e.isUndefined(a.select)&&(typeof a.select==="string"||Array.isArray(a.select)))return true;if(!e.isUndefined(a.expand)&&(typeof a.expand==="string"||Array.isArray(a.expand)))return true;if(!e.isUndefined(a.top)&&typeof a.top==="number")return true;if(!e.isUndefined(a.skip)&&typeof a.skip==="number")return true;for(var b in a)return false;return true};a.parseStrictLoadOption=function(c){var b={Select:[]};a.parseStrictLoadOptionHelper(b,"","option",c);return b};a.combineQueryPath=function(a,b,c){if(a.length===0)return b;else return a+c+b};a.parseStrictLoadOptionHelper=function(g,e,f,h){for(var b in h){var c=h[b];if(b==="$all"){if(typeof c!=="boolean")throw d.RuntimeError._createInvalidArgError({argumentName:a.combineQueryPath(f,b,".")});c&&g.Select.push(a.combineQueryPath(e,"*","/"))}else if(b==="$top"){if(typeof c!=="number"||e.length>0)throw d.RuntimeError._createInvalidArgError({argumentName:a.combineQueryPath(f,b,".")});g.Top=c}else if(b==="$skip"){if(typeof c!=="number"||e.length>0)throw d.RuntimeError._createInvalidArgError({argumentName:a.combineQueryPath(f,b,".")});g.Skip=c}else if(typeof c==="boolean")c&&g.Select.push(a.combineQueryPath(e,b,"/"));else if(typeof c==="object")a.parseStrictLoadOptionHelper(g,a.combineQueryPath(e,b,"/"),a.combineQueryPath(f,b,"."),c);else throw d.RuntimeError._createInvalidArgError({argumentName:a.combineQueryPath(f,b,".")});}};return a}();c.ClientRequestContextBase=B;var P=function(){function b(a){this.m_objectPath=a}b.prototype._handleResult=function(b){if(a.isNullOrUndefined(b))this.m_objectPath._updateAsNullObject();else this.m_objectPath.updateUsingObjectData(b,null)};return b}(),H=function(){function b(a){this.m_contextBase=a;this.m_actions=[];this.m_actionResultHandler={};this.m_referencedObjectPaths={};this.m_instantiatedObjectPaths={};this.m_preSyncPromises=[]}b.prototype.addAction=function(a){this.m_actions.push(a);if(a.actionInfo.ActionType==1)this.m_instantiatedObjectPaths[a.actionInfo.ObjectPathId]=a};Object.defineProperty(b.prototype,"hasActions",{"get":function(){return this.m_actions.length>0},enumerable:true,configurable:true});b.prototype._getLastAction=function(){return this.m_actions[this.m_actions.length-1]};b.prototype.ensureInstantiateObjectPath=function(a){if(a){if(this.m_instantiatedObjectPaths[a.objectPathInfo.Id])return;this.ensureInstantiateObjectPath(a.parentObjectPath);this.ensureInstantiateObjectPaths(a.argumentObjectPaths);if(!this.m_instantiatedObjectPaths[a.objectPathInfo.Id]){var d={Id:this.m_contextBase._nextId(),ActionType:1,Name:"",ObjectPathId:a.objectPathInfo.Id},b=new n(d,1,4);b.referencedObjectPath=a;this.addReferencedObjectPath(a);this.addAction(b);var c=new P(a);this.addActionResultHandler(b,c)}}};b.prototype.ensureInstantiateObjectPaths=function(a){if(a)for(var b=0;b<a.length;b++)this.ensureInstantiateObjectPath(a[b])};b.prototype.addReferencedObjectPath=function(b){if(!b||this.m_referencedObjectPaths[b.objectPathInfo.Id])return;if(!b.isValid)throw new d.RuntimeError({code:f.invalidObjectPath,message:a._getResourceString(i.invalidObjectPath,e.getObjectPathExpression(b)),debugInfo:{errorLocation:e.getObjectPathExpression(b)}});while(b){this.m_referencedObjectPaths[b.objectPathInfo.Id]=b;b.objectPathInfo.ObjectPathType==3&&this.addReferencedObjectPaths(b.argumentObjectPaths);b=b.parentObjectPath}};b.prototype.addReferencedObjectPaths=function(a){if(a)for(var b=0;b<a.length;b++)this.addReferencedObjectPath(a[b])};b.prototype.addActionResultHandler=function(b,a){this.m_actionResultHandler[b.actionInfo.Id]=a};b.prototype.aggregrateRequestFlags=function(a,c,b){if(c===0){a=a|1;if((b&2)===0)a=a&~16;if((b&8)===0)a=a&~256;a=a&~4}if(b&1)a=a|2;if((b&4)===0)a=a&~4;return a};b.prototype.finallyNormalizeFlags=function(a){if((a&1)===0){a=a&~16;a=a&~256}if(!c._internalConfig.enableConcurrentFlag)a=a&~4;if(!c._internalConfig.enableUndoableFlag)a=a&~16;if(!e.isSetSupported("RichApiRuntimeFlag","1.1")){a=a&~4;a=a&~16}if(!e.isSetSupported("RichApiRuntimeFlag","1.2"))a=a&~256;if(typeof this.m_flagsForTesting==="number")a=this.m_flagsForTesting;return a};b.prototype.buildRequestMessageBodyAndRequestFlags=function(){c._internalConfig.enableEarlyDispose&&b._calculateLastUsedObjectPathIds(this.m_actions);var a=4|16|256,h={};for(var e in this.m_referencedObjectPaths){a=this.aggregrateRequestFlags(a,this.m_referencedObjectPaths[e].operationType,this.m_referencedObjectPaths[e].flags);h[e]=this.m_referencedObjectPaths[e].objectPathInfo}for(var i=[],g=false,f=0;f<this.m_actions.length;f++){var d=this.m_actions[f];if(d.actionInfo.ActionType===3&&d.actionInfo.Name===j.keepReference)g=true;a=this.aggregrateRequestFlags(a,d.operationType,d.flags);i.push(d.actionInfo)}a=this.finallyNormalizeFlags(a);var k={AutoKeepReference:this.m_contextBase._autoCleanup&&g,Actions:i,ObjectPaths:h};return{body:k,flags:a}};b.prototype.processResponse=function(a){if(a)for(var b=0;b<a.length;b++){var c=a[b],d=this.m_actionResultHandler[c.ActionId];d&&d._handleResult(c.Value)}};b.prototype.invalidatePendingInvalidObjectPaths=function(){for(var a in this.m_referencedObjectPaths)if(this.m_referencedObjectPaths[a].isInvalidAfterRequest)this.m_referencedObjectPaths[a].isValid=false};b.prototype._addPreSyncPromise=function(a){this.m_preSyncPromises.push(a)};Object.defineProperty(b.prototype,"_preSyncPromises",{"get":function(){return this.m_preSyncPromises},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"_actions",{"get":function(){return this.m_actions},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"_objectPaths",{"get":function(){return this.m_referencedObjectPaths},enumerable:true,configurable:true});b.prototype._removeKeepReferenceAction=function(c){for(var a=this.m_actions.length-1;a>=0;a--){var b=this.m_actions[a].actionInfo;if(b.ObjectPathId===c&&b.ActionType===3&&b.Name===j.keepReference){this.m_actions.splice(a,1);break}}};b._updateLastUsedActionIdOfObjectPathId=function(c,a,f){while(a){if(c[a.objectPathInfo.Id])return;c[a.objectPathInfo.Id]=f;var d=a.argumentObjectPaths;if(d)for(var g=d.length,e=0;e<g;e++)b._updateLastUsedActionIdOfObjectPathId(c,d[e],f);a=a.parentObjectPath}};b._calculateLastUsedObjectPathIds=function(k){for(var d={},l=k.length,c=l-1;c>=0;--c){var a=k[c],f=a.actionInfo.Id;a.referencedObjectPath&&b._updateLastUsedActionIdOfObjectPathId(d,a.referencedObjectPath,f);var i=a.referencedArgumentObjectPaths;if(i)for(var n=i.length,j=0;j<n;j++)b._updateLastUsedActionIdOfObjectPathId(d,i[j],f)}var g={};for(var m in d){var f=d[m],e=g[f];if(!e){e=[];g[f]=e}e.push(parseInt(m))}for(var c=0;c<l;c++){var a=k[c],h=g[a.actionInfo.Id];if(h&&h.length>0)a.actionInfo.L=h;else if(a.actionInfo.L)delete a.actionInfo.L}};return b}();c.ClientRequestBase=H;var z=function(){function b(a){this.m_type=a}Object.defineProperty(b.prototype,"value",{"get":function(){if(!this.m_isLoaded)throw new d.RuntimeError({code:f.valueNotLoaded,message:a._getResourceString(i.valueNotLoaded),debugInfo:{errorLocation:"clientResult.value"}});return this.m_value},enumerable:true,configurable:true});b.prototype._handleResult=function(a){this.m_isLoaded=true;if(typeof a==="object"&&a&&a._IsNull)return;if(this.m_type===1)this.m_value=e.adjustToDateTime(a);else this.m_value=a};return b}();c.ClientResult=z;var cb=function(){function b(a){this.m_context=a;this.m_actions=[]}b.prototype.add=function(c,a,b,d){var e=this;this.m_actions.push({action:c,resultHandler:a,resolve:b,reject:d});this.m_actions.length===1&&setTimeout(function(){return e.processActions()},0)};b.prototype.processActions=function(){var k=this;if(this.m_actions.length===0)return;var c=this.m_actions;this.m_actions=[];for(var b=new H(this.m_context),e=0;e<c.length;e++){var d=c[e];b.ensureInstantiateObjectPath(d.action.referencedObjectPath);b.ensureInstantiateObjectPaths(d.action.referencedArgumentObjectPaths);b.addAction(d.action);b.addReferencedObjectPath(d.action.referencedObjectPath);b.addReferencedObjectPaths(d.action.referencedArgumentObjectPaths)}var g=b.buildRequestMessageBodyAndRequestFlags(),f=g.body,j=g.flags,h={Url:m.localDocumentApiPrefix,Headers:null,Body:f};a.log("Request:");a.log(JSON.stringify(f));var i=new F;i.executeAsync(this.m_context._customData,j,h).then(function(a){k.processResponse(b,c,a)})["catch"](function(d){for(var a=0;a<c.length;a++){var b=c[a];b.reject(d)}})};b.prototype.processResponse=function(d,c,a){var e=this.getErrorFromResponse(a),b=null;if(a.Body.Results)b=a.Body.Results;else if(a.Body.ProcessedResults&&a.Body.ProcessedResults.Results)b=a.Body.ProcessedResults.Results;if(!b)b=[];this.processActionResults(d,c,b,e)};b.prototype.getErrorFromResponse=function(b){if(!a.isNullOrEmptyString(b.ErrorCode))return new d.RuntimeError({code:b.ErrorCode,message:b.ErrorMessage});if(b.Body&&b.Body.Error)return new d.RuntimeError({code:b.Body.Error.Code,message:b.Body.Error.Message});return null};b.prototype.processActionResults=function(j,g,b,h){j.processResponse(b);for(var e=0;e<g.length;e++){for(var a=g[e],i=a.action.actionInfo.Id,f=false,c=0;c<b.length;c++)if(i==b[c].ActionId){var d=b[c].Value;if(a.resultHandler){a.resultHandler._handleResult(d);d=a.resultHandler.value}a.resolve&&a.resolve(d);f=true;break}if(!f&&a.reject)if(h)a.reject(h);else a.reject("No response for the action.")}};return b}(),F=function(){function b(){}b.prototype.executeAsync=function(i,h,d){var c=d.Url;if(c.charAt(c.length-1)!="/")c=c+"/";c=c+m.processQuery;c=c+"?"+m.flags+"="+h.toString();var e={method:"POST",url:c,headers:{},body:d.Body};e.headers[m.sourceLibHeader]=b.SourceLibHeaderValue;e.headers["CONTENT-TYPE"]="application/json";if(d.Headers)for(var f in d.Headers)e.headers[f]=d.Headers[f];var g=a._isLocalDocumentUrl(e.url)?D.sendLocalDocumentRequest:D.sendRequest;return g(e).then(function(b){var c;if(b.statusCode===200)c={ErrorCode:null,ErrorMessage:null,Headers:b.headers,Body:a._parseResponseBody(b)};else{a.log("Error Response:"+b.body);var d=a._parseErrorResponse(b);c={ErrorCode:d.errorCode,ErrorMessage:d.errorMessage,Headers:b.headers,Body:null}}return c})};b.SourceLibHeaderValue="officejs-rest";return b}();c.HttpRequestExecutor=F;var j=function(b){__extends(a,b);function a(){return b!==null&&b.apply(this,arguments)||this}a.collectionPropertyPath="_collectionPropertyPath";a.id="Id";a.idLowerCase="id";a.idPrivate="_Id";a.keepReference="_KeepReference";a.objectPathIdPrivate="_ObjectPathId";a.referenceId="_ReferenceId";a.items="_Items";a.itemsLowerCase="items";a.scalarPropertyNames="_scalarPropertyNames";a.navigationPropertyNames="_navigationPropertyNames";a.scalarPropertyUpdateable="_scalarPropertyUpdateable";return a}(m);c.CommonConstants=j;var e=function(c){__extends(b,c);function b(){return c!==null&&c.apply(this,arguments)||this}b.validateObjectPath=function(e){var c=e._objectPath;while(c){if(!c.isValid)throw new d.RuntimeError({code:f.invalidObjectPath,message:a._getResourceString(i.invalidObjectPath,b.getObjectPathExpression(c)),debugInfo:{errorLocation:b.getObjectPathExpression(c)}});c=c.parentObjectPath}};b.validateReferencedObjectPaths=function(e){if(e)for(var g=0;g<e.length;g++){var c=e[g];while(c){if(!c.isValid)throw new d.RuntimeError({code:f.invalidObjectPath,message:a._getResourceString(i.invalidObjectPath,b.getObjectPathExpression(c))});c=c.parentObjectPath}}};b._toCamelLowerCase=function(b){if(a.isNullOrEmptyString(b))return b;var c=0;while(c<b.length&&b.charCodeAt(c)>=65&&b.charCodeAt(c)<=90)c++;if(c<b.length)return b.substr(0,c).toLowerCase()+b.substr(c);else return b.toLowerCase()};b.adjustToDateTime=function(c){if(a.isNullOrUndefined(c))return null;if(typeof c==="string")return new Date(c);if(Array.isArray(c)){for(var d=c,e=0;e<d.length;e++)d[e]=b.adjustToDateTime(d[e]);return d}throw a._createInvalidArgError({argumentName:"date"});};b.tryGetObjectIdFromLoadOrRetrieveResult=function(c){var b=c[j.id];if(a.isNullOrUndefined(b))b=c[j.idLowerCase];if(a.isNullOrUndefined(b))b=c[j.idPrivate];return b};b.getObjectPathExpression=function(c){var a="";while(c){switch(c.objectPathInfo.ObjectPathType){case 1:a=a;break;case 2:a="new()"+(a.length>0?".":"")+a;break;case 3:a=b.normalizeName(c.objectPathInfo.Name)+"()"+(a.length>0?".":"")+a;break;case 4:a=b.normalizeName(c.objectPathInfo.Name)+(a.length>0?".":"")+a;break;case 5:a="getItem()"+(a.length>0?".":"")+a;break;case 6:a="_reference()"+(a.length>0?".":"")+a;break}c=c.parentObjectPath}return a};b.setMethodArguments=function(g,f,c){if(a.isNullOrUndefined(c))return null;var e=[],d=[],h=b.collectObjectPathInfos(g,c,e,d);f.Arguments=c;if(h)f.ReferencedObjectPathIds=d;return e};b.validateContext=function(b,c){if(b&&c&&c._context!==b)throw new d.RuntimeError({code:f.invalidRequestContext,message:a._getResourceString(i.invalidRequestContext)});};b.isSetSupported=function(b,a){if(typeof window!=="undefined"&&window.Office&&window.Office.context&&window.Office.context.requirements)return window.Office.context.requirements.isSetSupported(b,a);return true};b.throwIfApiNotSupported=function(e,g,c,h){if(!b._doApiNotSupportedCheck)return;if(!b.isSetSupported(g,c)){var j=a._getResourceString(i.apiNotFoundDetails,[e,g+" "+c,h]);throw new d.RuntimeError({code:f.apiNotFound,message:j,debugInfo:{errorLocation:e}});}};b._parseSelectExpand=function(e){var f=[];if(!a.isNullOrEmptyString(e))for(var d=e.split(","),c=0;c<d.length;c++){var b=d[c];b=g(b.trim());b.length>0&&f.push(b)}return f;function g(b){var a=b.toLowerCase();if(a==="items"||a==="items/")return"*";var c=6,d=a.substr(0,c)==="items/"||a.substr(0,c)==="items.";if(d)b=b.substr(c);return b.replace(new RegExp("[/.]items[/.]","gi"),"/")}};b.changePropertyNameToCamelLowerCase=function(a){var h=95;if(Array.isArray(a)){for(var c=[],e=0;e<a.length;e++)c.push(this.changePropertyNameToCamelLowerCase(a[e]));return c}else if(typeof a==="object"&&a!==null){var c={};for(var d in a){var f=a[d];if(d===j.items){c={};c[j.itemsLowerCase]=this.changePropertyNameToCamelLowerCase(f);break}else{var g=b._toCamelLowerCase(d);c[g]=this.changePropertyNameToCamelLowerCase(f)}}return c}else return a};b.purifyJson=function(a){var f=95;if(Array.isArray(a)){for(var c=[],e=0;e<a.length;e++)c.push(this.purifyJson(a[e]));return c}else if(typeof a==="object"&&a!==null){var c={};for(var d in a)if(d.charCodeAt(0)!==f){var b=a[d];if(typeof b==="object"&&b!==null&&Array.isArray(b.items))b=b.items;c[d]=this.purifyJson(b)}return c}else return a};b.collectObjectPathInfos=function(j,d,g,e){for(var h=false,c=0;c<d.length;c++)if(d[c]instanceof y){var f=d[c];b.validateContext(j,f);d[c]=f._objectPath.objectPathInfo.Id;e.push(f._objectPath.objectPathInfo.Id);g.push(f._objectPath);h=true}else if(Array.isArray(d[c])){var i=[],k=b.collectObjectPathInfos(j,d[c],g,i);if(k){e.push(i);h=true}else e.push(0)}else if(a.isPlainJsonObject(d[c])){e.push(0);b.replaceClientObjectPropertiesWithObjectPathIds(d[c],g)}else e.push(0);return h};b.replaceClientObjectPropertiesWithObjectPathIds=function(f,e){var g,h;for(var k in f){var c=f[k];if(c instanceof y){e.push(c._objectPath);f[k]=(g={},g[j.objectPathIdPrivate]=c._objectPath.objectPathInfo.Id,g)}else if(Array.isArray(c))for(var d=0;d<c.length;d++)if(c[d]instanceof y){var i=c[d];e.push(i._objectPath);c[d]=(h={},h[j.objectPathIdPrivate]=i._objectPath.objectPathInfo.Id,h)}else a.isPlainJsonObject(c[d])&&b.replaceClientObjectPropertiesWithObjectPathIds(c[d],e);else a.isPlainJsonObject(c)&&b.replaceClientObjectPropertiesWithObjectPathIds(c,e)}};b.normalizeName=function(a){return a.substr(0,1).toLowerCase()+a.substr(1)};b._doApiNotSupportedCheck=false;return b}(a);c.CommonUtility=e;var w=function(b){__extends(a,b);function a(){return b!==null&&b.apply(this,arguments)||this}a.propertyDoesNotExist="PropertyDoesNotExist";a.attemptingToSetReadOnlyProperty="AttemptingToSetReadOnlyProperty";return a}(i);c.CommonResourceStrings=w;var K=function(b){__extends(a,b);function a(c){var a=b.call(this)||this;a.m_shouldPolyfill=c;return a}a.prototype._handleResult=function(a){b.prototype._handleResult.call(this,a);if(this.m_shouldPolyfill)this.m_value=e.changePropertyNameToCamelLowerCase(this.m_value);this.m_value=this.removeItemNodes(this.m_value)};a.prototype.removeItemNodes=function(a){if(typeof a==="object"&&a!==null&&a[j.itemsLowerCase])a=a[j.itemsLowerCase];return e.purifyJson(a)};return a}(z);c.ClientRetrieveResult=K;var Z=function(){function b(){}b.invokeMethod=function(b,h,c,f,d,g){if(c===void 0)c=0;if(f===void 0)f=[];if(d===void 0)d=0;if(g===void 0)g=0;return a.createPromise(function(j,k){var l=new z,g={Id:b._context._nextId(),ActionType:3,Name:h,ObjectPathId:b._objectPath.objectPathInfo.Id,ArgumentInfo:{}},i=e.setMethodArguments(b._context,g.ArgumentInfo,f),a=new n(g,c,d);a.referencedObjectPath=b._objectPath;a.referencedArgumentObjectPaths=i;b._context._addServiceApiAction(a,l,j,k)})};b.invokeRetrieve=function(h,a){var f=c._internalConfig.alwaysPolyfillClientObjectRetrieveMethod;if(!f)f=!e.isSetSupported("RichApiRuntime","1.1");var g;if(typeof a[0]==="object"&&a[0].hasOwnProperty("$all")){if(!a[0].$all)throw d.RuntimeError._createInvalidArgError({});g=a[0]}else g=b._parseSelectOption(a);return h._retrieve(g,new K(f))};b._parseSelectOption=function(a){if(!a||!a[0])throw d.RuntimeError._createInvalidArgError({});var c=a[0]&&typeof a[0]!=="string"?a[0]:a;return Array.isArray(c)?c:b.parseRecursiveSelect(c)};b.parseRecursiveSelect=function(b){var a=function(b){return Object.keys(b).reduce(function(c,e){var d=b[e];if(typeof d==="object")return c.concat(a(d).map(function(a){return e+"/"+a}));if(d)return c.concat(e);return c},[])};return a(b)};b.invokeRecursiveUpdate=function(b,c){return a.createPromise(function(d,f){b._recursivelyUpdate(c);var a={Id:b._context._nextId(),ActionType:5,Name:"Trace",ObjectPathId:0},e=new n(a,1,4);b._context._addServiceApiAction(e,null,d,f)})};b.createRootServiceObject=function(d,a){var b={Id:a._nextId(),ObjectPathType:1,Name:""},c=new l(b,null,false,false,1,4);return new d(a,c)};b.createTopLevelServiceObject=function(g,a,e,c,f){var b={Id:a._nextId(),ObjectPathType:2,Name:e},d=new l(b,null,c,false,1,f|4);return new g(a,d)};b.createPropertyObject=function(g,a,d,c,f){var b={Id:a._context._nextId(),ObjectPathType:4,Name:d,ParentObjectPathId:a._objectPath.objectPathInfo.Id},e=new l(b,a._objectPath,c,false,1,f|4);return new g(a._context,e)};b.createIndexerObject=function(e,a,d){var b={Id:a._context._nextId(),ObjectPathType:5,Name:"",ParentObjectPathId:a._objectPath.objectPathInfo.Id,ArgumentInfo:{}};b.ArgumentInfo.Arguments=d;var c=new l(b,a._objectPath,false,false,1,4);return new e(a._context,c)};b.createMethodObject=function(n,a,j,h,m,i,d,g,k){var c={Id:a._context._nextId(),ObjectPathType:3,Name:j,ParentObjectPathId:a._objectPath.objectPathInfo.Id,ArgumentInfo:{}},f=e.setMethodArguments(a._context,c.ArgumentInfo,m),b=new l(c,a._objectPath,i,d,h,k);b.argumentObjectPaths=f;b.getByIdMethodName=g;return new n(a._context,b)};b.createAndInstantiateMethodObject=function(k,b,h,f,j,g,c,d,i){return a.createPromise(function(r,s){var m={Id:b._context._nextId(),ObjectPathType:3,Name:h,ParentObjectPathId:b._objectPath.objectPathInfo.Id,ArgumentInfo:{}},p=e.setMethodArguments(b._context,m.ArgumentInfo,j),a=new l(m,b._objectPath,g,c,f,i);a.argumentObjectPaths=p;a.getByIdMethodName=d;var t=new z,q={Id:b._context._nextId(),ActionType:1,Name:"",ObjectPathId:a.objectPathInfo.Id,QueryInfo:{}},o=new n(q,1,4);o.referencedObjectPath=a;b._context._addServiceApiAction(o,t,function(){return r(new k(b._context,a))},s)})};b.localDocumentContext=new B;return b}();c.OperationalApiHelper=Z;var A=function(b){__extends(a,b);function a(){return b!==null&&b.apply(this,arguments)||this}a.propertyNotLoaded="PropertyNotLoaded";a.runMustReturnPromise="RunMustReturnPromise";a.cannotRegisterEvent="CannotRegisterEvent";a.invalidOrTimedOutSession="InvalidOrTimedOutSession";a.cannotUpdateReadOnlyProperty="CannotUpdateReadOnlyProperty";return a}(f);c.ErrorCodes=A;var T=function(){function a(a){this.m_callback=a}a.prototype._handleResult=function(a){this.m_callback&&this.m_callback()};return a}(),o=function(c){__extends(a,c);function a(){return c!==null&&c.apply(this,arguments)||this}a.createMethodAction=function(f,c,h,g,j,i){b.validateObjectPath(c);var e={Id:f._nextId(),ActionType:3,Name:h,ObjectPathId:c._objectPath.objectPathInfo.Id,ArgumentInfo:{}},d=b.setMethodArguments(f,e.ArgumentInfo,j);b.validateReferencedObjectPaths(d);var a=new n(e,g,b._fixupApiFlags(i));a.referencedObjectPath=c._objectPath;a.referencedArgumentObjectPaths=d;c._addAction(a);return a};a.createRecursiveQueryAction=function(e,a,f){b.validateObjectPath(a);var d={Id:e._nextId(),ActionType:6,Name:"",ObjectPathId:a._objectPath.objectPathInfo.Id,RecursiveQueryInfo:f},c=new n(d,1,4);c.referencedObjectPath=a._objectPath;a._addAction(c);return c};a.createEnsureUnchangedAction=function(f,a,d){b.validateObjectPath(a);var e={Id:f._nextId(),ActionType:8,Name:"",ObjectPathId:a._objectPath.objectPathInfo.Id,ObjectState:d},c=new n(e,1,4);c.referencedObjectPath=a._objectPath;a._addAction(c);return c};a.createInstantiateAction=function(c,a){b.validateObjectPath(a);c._pendingRequest.ensureInstantiateObjectPath(a._objectPath.parentObjectPath);c._pendingRequest.ensureInstantiateObjectPaths(a._objectPath.argumentObjectPaths);var e={Id:c._nextId(),ActionType:1,Name:"",ObjectPathId:a._objectPath.objectPathInfo.Id},d=new n(e,1,4);d.referencedObjectPath=a._objectPath;a._addAction(d,new S(a),true);return d};a.createTraceAction=function(a,e,d){var b={Id:a._nextId(),ActionType:5,Name:"Trace",ObjectPathId:0},c=new n(b,1,4);a._pendingRequest.addAction(c);d&&a._pendingRequest.addTrace(b.Id,e);return c};a.createTraceMarkerForCallback=function(b,c){var d=a.createTraceAction(b,null,false);b._pendingRequest.addActionResultHandler(d,new T(c))};return a}(t);c.ActionFactory=o;var J=function(e){__extends(c,e);function c(a,d){var c=e.call(this,a,d)||this;b.checkArgumentNull(a,"context");c.m_context=a;if(c._objectPath)if(!a._processingResult&&a._pendingRequest){o.createInstantiateAction(a,c);a._autoCleanup&&c._KeepReference&&a.trackedObjects._autoAdd(c)}return c}Object.defineProperty(c.prototype,"context",{"get":function(){return this.m_context},enumerable:true,configurable:true});Object.defineProperty(c.prototype,"isNull",{"get":function(){b.throwIfNotLoaded("isNull",this._isNull,null,this._isNull);return this._isNull},enumerable:true,configurable:true});Object.defineProperty(c.prototype,"isNullObject",{"get":function(){b.throwIfNotLoaded("isNullObject",this._isNull,null,this._isNull);return this._isNull},enumerable:true,configurable:true});Object.defineProperty(c.prototype,"_isNull",{"get":function(){return this.m_isNull},"set":function(a){this.m_isNull=a;a&&this._objectPath&&this._objectPath._updateAsNullObject()},enumerable:true,configurable:true});c.prototype._addAction=function(b,c,d){if(c===void 0)c=null;if(!d){this.context._pendingRequest.ensureInstantiateObjectPath(this._objectPath);this.context._pendingRequest.ensureInstantiateObjectPaths(b.referencedArgumentObjectPaths)}this.context._pendingRequest.addAction(b);this.context._pendingRequest.addReferencedObjectPath(this._objectPath);this.context._pendingRequest.addReferencedObjectPaths(b.referencedArgumentObjectPaths);this.context._pendingRequest.addActionResultHandler(b,c);return a._createPromiseFromResult(null)};c.prototype._handleResult=function(a){this._isNull=b.isNullOrUndefined(a);this.context.trackedObjects._autoTrackIfNecessaryWhenHandleObjectResultValue(this,a)};c.prototype._handleIdResult=function(a){this._isNull=b.isNullOrUndefined(a);b.fixObjectPathIfNecessary(this,a);this.context.trackedObjects._autoTrackIfNecessaryWhenHandleObjectResultValue(this,a)};c.prototype._handleRetrieveResult=function(a,b){this._handleIdResult(a)};c.prototype._recursivelySet=function(g,n,k,l,o){var m=g instanceof c,s=g;if(m)if(Object.getPrototypeOf(this)===Object.getPrototypeOf(g))g=JSON.parse(JSON.stringify(g));else throw d.RuntimeError._createInvalidArgError({argumentName:"properties",errorLocation:this._className+".set"});try{for(var e,h=0;h<k.length;h++){e=k[h];if(g.hasOwnProperty(e))if(typeof g[e]!=="undefined")this[e]=g[e]}for(var h=0;h<l.length;h++){e=l[h];if(g.hasOwnProperty(e))if(typeof g[e]!=="undefined"){var r=m?s[e]:g[e];this[e].set(r,n)}}var j=!m;if(n&&!b.isNullOrUndefined(j))j=n.throwOnReadOnly;for(var h=0;h<o.length;h++){e=o[h];if(g.hasOwnProperty(e))if(typeof g[e]!=="undefined"&&j)throw new d.RuntimeError({code:f.invalidArgument,message:a._getResourceString(p.cannotApplyPropertyThroughSetMethod,e),debugInfo:{errorLocation:e}});}for(e in g)if(k.indexOf(e)<0&&l.indexOf(e)<0){var q=Object.getOwnPropertyDescriptor(Object.getPrototypeOf(this),e);if(!q)throw new d.RuntimeError({code:f.invalidArgument,message:a._getResourceString(w.propertyDoesNotExist,e),debugInfo:{errorLocation:e}});if(j&&!q.set)throw new d.RuntimeError({code:f.invalidArgument,message:a._getResourceString(w.attemptingToSetReadOnlyProperty,e),debugInfo:{errorLocation:e}});}}catch(t){throw new d.RuntimeError({code:f.invalidArgument,message:a._getResourceString(i.invalidArgument,"properties"),debugInfo:{errorLocation:this._className+".set"},innerError:t});}};return c}(y);c.ClientObject=J;var U=function(){function b(a){this.m_session=a}b.prototype.executeAsync=function(f,e,b){var d={url:m.processQuery,method:"POST",headers:b.Headers,body:b.Body},c={id:v.nextId(),type:1,flags:e,message:d};a.log(JSON.stringify(c));return this.m_session.sendMessageToHost(c).then(function(d){a.log("Received response: "+JSON.stringify(d));var b=d.message,c;if(b.statusCode===200)c={ErrorCode:null,ErrorMessage:null,Headers:b.headers,Body:a._parseResponseBody(b)};else{a.log("Error Response:"+b.body);var e=a._parseErrorResponse(b);c={ErrorCode:e.errorCode,ErrorMessage:e.errorMessage,Headers:b.headers,Body:null}}return c})};return b}(),L=function(c){__extends(b,c);function b(b){var a=c.call(this)||this;a.m_bridge=b;a.m_bridge.addHostMessageHandler(function(a){a.type===3&&q.getGenericEventRegistration()._handleRichApiMessage(a.message)});return a}b.getInstanceIfHostBridgeInited=function(){if(v.instance){if(a.isNullOrUndefined(b.s_instance)||b.s_instance.m_bridge!==v.instance)b.s_instance=new b(v.instance);return b.s_instance}return null};b.prototype._resolveRequestUrlAndHeaderInfo=function(){return a._createPromiseFromResult(null)};b.prototype._createRequestExecutorOrNull=function(){a.log("NativeBridgeSession::CreateRequestExecutor");return new U(this)};Object.defineProperty(b.prototype,"eventRegistration",{"get":function(){return q.getGenericEventRegistration()},enumerable:true,configurable:true});b.prototype.sendMessageToHost=function(a){return this.m_bridge.sendMessageToHostAndExpectResponse(a)};return b}(s),X=function(h){__extends(e,h);function e(f){var c=h.call(this)||this;c.m_customRequestHeaders={};c.m_batchMode=0;c._onRunFinishedNotifiers=[];if(s._overrideSession)c.m_requestUrlAndHeaderInfoResolver=s._overrideSession;else{if(b.isNullOrUndefined(f)||typeof f==="string"&&f.length===0){f=e.defaultRequestUrlAndHeaders;if(!f)f={url:m.localDocument,headers:{}}}if(typeof f==="string")c.m_requestUrlAndHeaderInfo={url:f,headers:{}};else if(e.isRequestUrlAndHeaderInfoResolver(f))c.m_requestUrlAndHeaderInfoResolver=f;else if(e.isRequestUrlAndHeaderInfo(f)){var i=f;c.m_requestUrlAndHeaderInfo={url:i.url,headers:{}};a._copyHeaders(i.headers,c.m_requestUrlAndHeaderInfo.headers)}else throw d.RuntimeError._createInvalidArgError({argumentName:"url"});}if(!c.m_requestUrlAndHeaderInfoResolver&&c.m_requestUrlAndHeaderInfo&&a._isLocalDocumentUrl(c.m_requestUrlAndHeaderInfo.url)&&L.getInstanceIfHostBridgeInited()){c.m_requestUrlAndHeaderInfo=null;c.m_requestUrlAndHeaderInfoResolver=L.getInstanceIfHostBridgeInited()}if(c.m_requestUrlAndHeaderInfoResolver instanceof s)c.m_session=c.m_requestUrlAndHeaderInfoResolver;c._processingResult=false;c._customData=g.iterativeExecutor;c.sync=c.sync.bind(c);return c}Object.defineProperty(e.prototype,"session",{"get":function(){return this.m_session},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"eventRegistration",{"get":function(){if(this.m_session)return this.m_session.eventRegistration;return d.officeJsEventRegistration},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"_url",{"get":function(){if(this.m_requestUrlAndHeaderInfo)return this.m_requestUrlAndHeaderInfo.url;return null},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"_pendingRequest",{"get":function(){if(this.m_pendingRequest==null)this.m_pendingRequest=new x(this);return this.m_pendingRequest},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"debugInfo",{"get":function(){var a=new E(this._rootObjectPropertyName,this._pendingRequest._objectPaths,this._pendingRequest._actions,c._internalConfig.showDisposeInfoInDebugInfo),b=a.process();return{pendingStatements:b}},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"trackedObjects",{"get":function(){if(!this.m_trackedObjects)this.m_trackedObjects=new M(this);return this.m_trackedObjects},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"requestHeaders",{"get":function(){return this.m_customRequestHeaders},enumerable:true,configurable:true});Object.defineProperty(e.prototype,"batchMode",{"get":function(){return this.m_batchMode},enumerable:true,configurable:true});e.prototype.ensureInProgressBatchIfBatchMode=function(){if(this.m_batchMode===1&&!this.m_explicitBatchInProgress)throw b.createRuntimeError(f.generalException,a._getResourceString(p.notInsideBatch),null);};e.prototype.load=function(a,d){b.validateContext(this,a);var c=e._parseQueryOption(d);t.createQueryAction(this,a,c,a)};e.prototype.loadRecursive=function(c,a,h){if(!b.isPlainJsonObject(a))throw d.RuntimeError._createInvalidArgError({argumentName:"options"});var f={};for(var g in a)f[g]=e._parseQueryOption(a[g]);var i=o.createRecursiveQueryAction(this,c,{Queries:f,MaxDepth:h});this._pendingRequest.addActionResultHandler(i,c)};e.prototype.trace=function(a){o.createTraceAction(this,a,true)};e.prototype._processOfficeJsErrorResponse=function(a,b){};e.prototype.ensureRequestUrlAndHeaderInfo=function(){var a=this;return b._createPromiseFromResult(null).then(function(){if(!a.m_requestUrlAndHeaderInfo)return a.m_requestUrlAndHeaderInfoResolver._resolveRequestUrlAndHeaderInfo().then(function(d){a.m_requestUrlAndHeaderInfo=d;if(!a.m_requestUrlAndHeaderInfo)a.m_requestUrlAndHeaderInfo={url:m.localDocument,headers:{}};if(b.isNullOrEmptyString(a.m_requestUrlAndHeaderInfo.url))a.m_requestUrlAndHeaderInfo.url=m.localDocument;if(!a.m_requestUrlAndHeaderInfo.headers)a.m_requestUrlAndHeaderInfo.headers={};if(typeof a.m_requestUrlAndHeaderInfoResolver._createRequestExecutorOrNull==="function"){var c=a.m_requestUrlAndHeaderInfoResolver._createRequestExecutorOrNull();if(c)a._requestExecutor=c}})})};e.prototype.syncPrivateMain=function(){var a=this;return this.ensureRequestUrlAndHeaderInfo().then(function(){var b=a._pendingRequest;a.m_pendingRequest=null;return a.processPreSyncPromises(b).then(function(){return a.syncPrivate(b)})})};e.prototype.syncPrivate=function(e){var i=this;if(!e.hasActions)return this.processPendingEventHandlers(e);var j=e.buildRequestMessageBodyAndRequestFlags(),m=j.body,g=j.flags;if(this._requestFlagModifier)g|=this._requestFlagModifier;if(!this._requestExecutor)if(a._isLocalDocumentUrl(this.m_requestUrlAndHeaderInfo.url))this._requestExecutor=new W(this);else this._requestExecutor=new F;var l=this._requestExecutor,h={};a._copyHeaders(this.m_requestUrlAndHeaderInfo.headers,h);a._copyHeaders(this.m_customRequestHeaders,h);var k={Url:this.m_requestUrlAndHeaderInfo.url,Headers:h,Body:m};e.invalidatePendingInvalidObjectPaths();var f=null,c=null;this._lastSyncStart=typeof performance==="undefined"?0:performance.now();this._lastRequestFlags=g;return l.executeAsync(this._customData,g,k).then(function(b){i._lastSyncEnd=typeof performance==="undefined"?0:performance.now();f=i.processRequestExecutorResponseMessage(e,b);return i.processPendingEventHandlers(e)["catch"](function(b){a.log("Error in processPendingEventHandlers");a.log(JSON.stringify(b));c=b})}).then(function(){if(f){a.log("Throw error from response: "+JSON.stringify(f));throw f;}if(c){a.log("Throw error from ProcessEventHandler: "+JSON.stringify(c));var h=null;if(c instanceof d.RuntimeError){h=c;h.traceMessages=e._responseTraceMessages}else{var g=null;if(typeof c==="string")g=c;else g=c.message;if(b.isNullOrEmptyString(g))g=a._getResourceString(p.cannotRegisterEvent);h=new d.RuntimeError({code:A.cannotRegisterEvent,message:g,traceMessages:e._responseTraceMessages})}throw h;}})};e.prototype.processRequestExecutorResponseMessage=function(e,a){a.Body&&a.Body.TraceIds&&e._setResponseTraceIds(a.Body.TraceIds);var k=e._responseTraceMessages,f=null;if(a.Body){if(a.Body.Error&&a.Body.Error.ActionIndex>=0){var i=new E(this._rootObjectPropertyName,e._objectPaths,e._actions,false,true),j=i.processForDebugStatementInfo(a.Body.Error.ActionIndex);f={statement:j.statement,surroundingStatements:j.surroundingStatements,fullStatements:["Please enable config.extendedErrorLogging to see full statements."]};if(c.config.extendedErrorLogging){i=new E(this._rootObjectPropertyName,e._objectPaths,e._actions,false,false);f.fullStatements=i.process()}}var g=null;if(a.Body.Results)g=a.Body.Results;else if(a.Body.ProcessedResults&&a.Body.ProcessedResults.Results)g=a.Body.ProcessedResults.Results;if(g){this._processingResult=true;try{e.processResponse(g)}finally{this._processingResult=false}}}if(!b.isNullOrEmptyString(a.ErrorCode))return new d.RuntimeError({code:a.ErrorCode,message:a.ErrorMessage,traceMessages:k});else if(a.Body&&a.Body.Error){var h={errorLocation:a.Body.Error.Location};if(f){h.statement=f.statement;h.surroundingStatements=f.surroundingStatements;h.fullStatements=f.fullStatements}return new d.RuntimeError({code:a.Body.Error.Code,message:a.Body.Error.Message,traceMessages:k,debugInfo:h})}return null};e.prototype.processPendingEventHandlers=function(a){for(var c=b._createPromiseFromResult(null),d=0;d<a._pendingProcessEventHandlers.length;d++){var e=a._pendingProcessEventHandlers[d];c=c.then(this.createProcessOneEventHandlersFunc(e,a))}return c};e.prototype.createProcessOneEventHandlersFunc=function(a,b){return function(){return a._processRegistration(b)}};e.prototype.processPreSyncPromises=function(d){for(var a=b._createPromiseFromResult(null),c=0;c<d._preSyncPromises.length;c++){var e=d._preSyncPromises[c];a=a.then(this.createProcessOneProSyncFunc(e))}return a};e.prototype.createProcessOneProSyncFunc=function(a){return function(){return a}};e.prototype.sync=function(a){return this.syncPrivateMain().then(function(){return a})};e.prototype.batch=function(i){var c=this;if(this.m_batchMode!==1)return a._createPromiseFromException(b.createRuntimeError(f.generalException,null,null));if(this.m_explicitBatchInProgress)return a._createPromiseFromException(b.createRuntimeError(f.generalException,a._getResourceString(p.pendingBatchInProgress),null));if(b.isNullOrUndefined(i))return b._createPromiseFromResult(null);this.m_explicitBatchInProgress=true;var e=this.m_pendingRequest;this.m_pendingRequest=new x(this);var d;try{d=i(this._rootObject,this)}catch(j){this.m_explicitBatchInProgress=false;this.m_pendingRequest=e;return a._createPromiseFromException(j)}var g,h;if(typeof d==="object"&&d&&typeof d.then==="function")h=b._createPromiseFromResult(null).then(function(){return d}).then(function(a){c.m_explicitBatchInProgress=false;g=c.m_pendingRequest;c.m_pendingRequest=e;return a})["catch"](function(b){c.m_explicitBatchInProgress=false;g=c.m_pendingRequest;c.m_pendingRequest=e;return a._createPromiseFromException(b)});else{this.m_explicitBatchInProgress=false;g=this.m_pendingRequest;this.m_pendingRequest=e;h=b._createPromiseFromResult(d)}return h.then(function(a){return c.ensureRequestUrlAndHeaderInfo().then(function(){return c.syncPrivate(g)}).then(function(){return a})})};e._run=function(f,g,a,b,d,c){if(a===void 0)a=3;if(b===void 0)b=5e3;return e._runCommon("run",null,f,0,g,a,b,null,d,c)};e.isValidRequestInfo=function(a){return typeof a==="string"||e.isRequestUrlAndHeaderInfo(a)||e.isRequestUrlAndHeaderInfoResolver(a)};e.isRequestUrlAndHeaderInfo=function(a){return typeof a==="object"&&a!==null&&Object.getPrototypeOf(a)===Object.getPrototypeOf({})&&!b.isNullOrUndefined(a.url)};e.isRequestUrlAndHeaderInfoResolver=function(a){return typeof a==="object"&&a!==null&&typeof a._resolveRequestUrlAndHeaderInfo==="function"};e._runBatch=function(h,f,g,i,a,b,d,c){if(a===void 0)a=3;if(b===void 0)b=5e3;return e._runBatchCommon(0,h,f,g,a,b,i,d,c)};e._runExplicitBatch=function(h,f,g,i,a,b,d,c){if(a===void 0)a=3;if(b===void 0)b=5e3;return e._runBatchCommon(1,h,f,g,a,b,i,d,c)};e._runBatchCommon=function(u,d,a,t,l,m,q,s,r){if(l===void 0)l=3;if(m===void 0)m=5e3;var h,n,i=null,c=null,f=0,j=null;if(a.length>0)if(e.isValidRequestInfo(a[0])){i=a[0];f=1}else if(b.isPlainJsonObject(a[0])){j=a[0];i=j.session;if(i!=null&&!e.isValidRequestInfo(i))return e.createErrorPromise(d);c=j.previousObjects;f=1}if(a.length==f+1)n=a[f+0];else if(j==null&&a.length==f+2){c=a[f+0];n=a[f+1]}else return e.createErrorPromise(d);if(c!=null)if(c instanceof J)h=function(){return c.context};else if(c instanceof e)h=function(){return c};else if(Array.isArray(c)){var g=c;if(g.length==0)return e.createErrorPromise(d);for(var k=0;k<g.length;k++){if(!(g[k]instanceof J))return e.createErrorPromise(d);if(g[k].context!=g[0].context)return e.createErrorPromise(d,p.invalidRequestContext)}h=function(){return g[0].context}}else return e.createErrorPromise(d);else h=t;var o=null;if(q)o=function(a){return q(j||{},a)};return e._runCommon(d,i,h,u,n,l,m,o,s,r)};e.createErrorPromise=function(d,c){if(c===void 0)c=i.invalidArgument;return a._createPromiseFromException(b.createRuntimeError(c,a._getResourceString(c),d))};e._runCommon=function(t,g,r,h,i,o,u,m,l,k){if(s._overrideSession)g=s._overrideSession;var q=a.createPromise(function(a,b){a()}),d,n=false,f,j;return q.then(function(){d=r(g);if(d._autoCleanup)return new c.Promise(function(a,b){d._onRunFinishedNotifiers.push(function(){d._autoCleanup=true;a()})});else d._autoCleanup=true}).then(function(){if(typeof i!=="function")return e.createErrorPromise(t);j=d.m_batchMode;d.m_batchMode=h;m&&m(d);var a;if(h==1)a=i(d.batch.bind(d));else a=i(d);(b.isNullOrUndefined(a)||typeof a.then!=="function")&&b.throwError(p.runMustReturnPromise);return a}).then(function(a){if(h===1)return a;else return d.sync(a)}).then(function(a){n=true;f=a})["catch"](function(a){f=a}).then(function(){var c=d.trackedObjects._retrieveAndClearAutoCleanupList();d._autoCleanup=false;d.m_batchMode=j;for(var h in c)c[h]._objectPath.isValid=false;var a=0;if(b._synchronousCleanup||e.isRequestUrlAndHeaderInfoResolver(g))return f();else f();function f(){a++;var e=d.m_pendingRequest,g=d.m_batchMode,b=new x(d);d.m_pendingRequest=b;d.m_batchMode=0;try{for(var h in c)d.trackedObjects.remove(c[h])}finally{d.m_batchMode=g;d.m_pendingRequest=e}return d.syncPrivate(b).then(function(){l&&l(a)})["catch"](function(){k&&k(a);a<o&&setTimeout(function(){f()},u)})}}).then(function(){if(d._onRunFinishedNotifiers&&d._onRunFinishedNotifiers.length>0){var a=d._onRunFinishedNotifiers.shift();a()}if(n)return f;else throw f;})};return e}(B);c.ClientRequestContext=X;var ab=function(){function c(c,h){this.m_proxy=c;this.m_shouldPolyfill=h;var e=c[g.scalarPropertyNames],d=c[g.navigationPropertyNames],f=c[g.className],i=c[g.isCollection];if(e)for(var a=0;a<e.length;a++)b.definePropertyThrowUnloadedException(this,f,e[a]);if(d)for(var a=0;a<d.length;a++)b.definePropertyThrowUnloadedException(this,f,d[a]);i&&b.definePropertyThrowUnloadedException(this,f,g.itemsLowerCase)}Object.defineProperty(c.prototype,"$proxy",{"get":function(){return this.m_proxy},enumerable:true,configurable:true});Object.defineProperty(c.prototype,"$isNullObject",{"get":function(){if(!this.m_isLoaded)throw new d.RuntimeError({code:A.valueNotLoaded,message:a._getResourceString(p.valueNotLoaded),debugInfo:{errorLocation:"retrieveResult.$isNullObject"}});return this.m_isNullObject},enumerable:true,configurable:true});c.prototype.toJSON=function(){if(!this.m_isLoaded)return undefined;if(this.m_isNullObject)return null;if(b.isUndefined(this.m_json))this.m_json=b.purifyJson(this.m_value);return this.m_json};c.prototype.toString=function(){return JSON.stringify(this.toJSON())};c.prototype._handleResult=function(a){this.m_isLoaded=true;if(a===null||typeof a==="object"&&a&&a._IsNull){this.m_isNullObject=true;a=null}else this.m_isNullObject=false;if(this.m_shouldPolyfill)a=b.changePropertyNameToCamelLowerCase(a);this.m_value=a;this.m_proxy._handleRetrieveResult(a,this)};return c}(),g=function(b){__extends(a,b);function a(){return b!==null&&b.apply(this,arguments)||this}a.getItemAt="GetItemAt";a.index="_Index";a.iterativeExecutor="IterativeExecutor";a.isTracked="_IsTracked";a.eventMessageCategory=65536;a.eventWorkbookId="Workbook";a.eventSourceRemote="Remote";a.proxy="$proxy";a.className="_className";a.isCollection="_isCollection";a.collectionPropertyPath="_collectionPropertyPath";a.objectPathInfoDoNotKeepReferenceFieldName="D";return a}(j);c.Constants=g;var x=function(c){__extends(b,c);function b(b){var a=c.call(this,b)||this;a.m_context=b;a.m_pendingProcessEventHandlers=[];a.m_pendingEventHandlerActions={};a.m_traceInfos={};a.m_responseTraceIds={};a.m_responseTraceMessages=[];return a}Object.defineProperty(b.prototype,"traceInfos",{"get":function(){return this.m_traceInfos},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"_responseTraceMessages",{"get":function(){return this.m_responseTraceMessages},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"_responseTraceIds",{"get":function(){return this.m_responseTraceIds},enumerable:true,configurable:true});b.prototype._setResponseTraceIds=function(c){if(c)for(var d=0;d<c.length;d++){var b=c[d];this.m_responseTraceIds[b]=b;var e=this.m_traceInfos[b];!a.isNullOrUndefined(e)&&this.m_responseTraceMessages.push(e)}};b.prototype.addTrace=function(a,b){this.m_traceInfos[a]=b};b.prototype._addPendingEventHandlerAction=function(a,b){if(!this.m_pendingEventHandlerActions[a._id]){this.m_pendingEventHandlerActions[a._id]=[];this.m_pendingProcessEventHandlers.push(a)}this.m_pendingEventHandlerActions[a._id].push(b)};Object.defineProperty(b.prototype,"_pendingProcessEventHandlers",{"get":function(){return this.m_pendingProcessEventHandlers},enumerable:true,configurable:true});b.prototype._getPendingEventHandlerActions=function(a){return this.m_pendingEventHandlerActions[a._id]};return b}(H);c.ClientRequest=x;var N=function(){function b(a,e,d,c){var b=this;this.m_id=a._nextId();this.m_context=a;this.m_name=d;this.m_handlers=[];this.m_registered=false;this.m_eventInfo=c;this.m_callback=function(a){b.m_eventInfo.eventArgsTransformFunc(a).then(function(a){return b.fireEvent(a)})}}Object.defineProperty(b.prototype,"_registered",{"get":function(){return this.m_registered},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"_id",{"get":function(){return this.m_id},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"_handlers",{"get":function(){return this.m_handlers},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"_context",{"get":function(){return this.m_context},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"_callback",{"get":function(){return this.m_callback},enumerable:true,configurable:true});b.prototype.add=function(a){var b=o.createTraceAction(this.m_context,null,false);this.m_context._pendingRequest._addPendingEventHandlerAction(this,{id:b.actionInfo.Id,handler:a,operation:0});return new G(this.m_context,this,a)};b.prototype.remove=function(a){var b=o.createTraceAction(this.m_context,null,false);this.m_context._pendingRequest._addPendingEventHandlerAction(this,{id:b.actionInfo.Id,handler:a,operation:1})};b.prototype.removeAll=function(){var a=o.createTraceAction(this.m_context,null,false);this.m_context._pendingRequest._addPendingEventHandlerAction(this,{id:a.actionInfo.Id,handler:null,operation:2})};b.prototype._processRegistration=function(i){var e=this,d=a._createPromiseFromResult(null),f=i._getPendingEventHandlerActions(this);if(!f)return d;for(var b=[],c=0;c<this.m_handlers.length;c++)b.push(this.m_handlers[c]);for(var h=false,c=0;c<f.length;c++)if(i._responseTraceIds[f[c].id]){h=true;switch(f[c].operation){case 0:b.push(f[c].handler);break;case 1:for(var g=b.length-1;g>=0;g--)if(b[g]===f[c].handler){b.splice(g,1);break}break;case 2:b=[];break}}if(h){if(!this.m_registered&&b.length>0)d=d.then(function(){return e.m_eventInfo.registerFunc(e.m_callback)}).then(function(){return e.m_registered=true});else if(this.m_registered&&b.length==0)d=d.then(function(){return e.m_eventInfo.unregisterFunc(e.m_callback)})["catch"](function(b){a.log("Error when unregister event: "+JSON.stringify(b))}).then(function(){return e.m_registered=false});d=d.then(function(){return e.m_handlers=b})}return d};b.prototype.fireEvent=function(e){for(var c=[],b=0;b<this.m_handlers.length;b++){var d=this.m_handlers[b],f=a._createPromiseFromResult(null).then(this.createFireOneEventHandlerFunc(d,e))["catch"](function(b){a.log("Error when invoke handler: "+JSON.stringify(b))});c.push(f)}a.Promise.all(c)};b.prototype.createFireOneEventHandlerFunc=function(a,b){return function(){return a(b)}};return b}();c.EventHandlers=N;var G=function(){function a(b,a,c){this.m_context=b;this.m_allHandlers=a;this.m_handler=c}Object.defineProperty(a.prototype,"context",{"get":function(){return this.m_context},enumerable:true,configurable:true});a.prototype.remove=function(){if(this.m_allHandlers&&this.m_handler){this.m_allHandlers.remove(this.m_handler);this.m_allHandlers=null;this.m_handler=null}};return a}();c.EventHandlerResult=G;(function(a){var c=function(){function c(){}c.prototype.register=function(e,d,c){switch(e){case 4:return b.promisify(function(a){return Office.context.document.bindings.getByIdAsync(d,a)}).then(function(a){return b.promisify(function(b){return a.addHandlerAsync(Office.EventType.BindingDataChanged,c,b)})});case 3:return b.promisify(function(a){return Office.context.document.bindings.getByIdAsync(d,a)}).then(function(a){return b.promisify(function(b){return a.addHandlerAsync(Office.EventType.BindingSelectionChanged,c,b)})});case 2:return b.promisify(function(a){return Office.context.document.addHandlerAsync(Office.EventType.DocumentSelectionChanged,c,a)});case 1:return b.promisify(function(a){return Office.context.document.settings.addHandlerAsync(Office.EventType.SettingsChanged,c,a)});case 5:return b.promisify(function(a){return OSF.DDA.RichApi.richApiMessageManager.addHandlerAsync("richApiMessage",c,a)});case 13:return b.promisify(function(a){return Office.context.document.addHandlerAsync(Office.EventType.ObjectDeleted,c,{id:d},a)});case 14:return b.promisify(function(a){return Office.context.document.addHandlerAsync(Office.EventType.ObjectSelectionChanged,c,{id:d},a)});case 15:return b.promisify(function(a){return Office.context.document.addHandlerAsync(Office.EventType.ObjectDataChanged,c,{id:d},a)});case 16:return b.promisify(function(a){return Office.context.document.addHandlerAsync(Office.EventType.ContentControlAdded,c,{id:d},a)});default:throw a.RuntimeError._createInvalidArgError({argumentName:"eventId"});}};c.prototype.unregister=function(e,d,c){switch(e){case 4:return b.promisify(function(a){return Office.context.document.bindings.getByIdAsync(d,a)}).then(function(a){return b.promisify(function(b){return a.removeHandlerAsync(Office.EventType.BindingDataChanged,{handler:c},b)})});case 3:return b.promisify(function(a){return Office.context.document.bindings.getByIdAsync(d,a)}).then(function(a){return b.promisify(function(b){return a.removeHandlerAsync(Office.EventType.BindingSelectionChanged,{handler:c},b)})});case 2:return b.promisify(function(a){return Office.context.document.removeHandlerAsync(Office.EventType.DocumentSelectionChanged,{handler:c},a)});case 1:return b.promisify(function(a){return Office.context.document.settings.removeHandlerAsync(Office.EventType.SettingsChanged,{handler:c},a)});case 5:return b.promisify(function(a){return OSF.DDA.RichApi.richApiMessageManager.removeHandlerAsync("richApiMessage",{handler:c},a)});case 13:return b.promisify(function(a){return Office.context.document.removeHandlerAsync(Office.EventType.ObjectDeleted,{id:d,handler:c},a)});case 14:return b.promisify(function(a){return Office.context.document.removeHandlerAsync(Office.EventType.ObjectSelectionChanged,{id:d,handler:c},a)});case 15:return b.promisify(function(a){return Office.context.document.removeHandlerAsync(Office.EventType.ObjectDataChanged,{id:d,handler:c},a)});case 16:return b.promisify(function(a){return Office.context.document.removeHandlerAsync(Office.EventType.ContentControlAdded,{id:d,handler:c},a)});default:throw a.RuntimeError._createInvalidArgError({argumentName:"eventId"});}};return c}();a.officeJsEventRegistration=new c})(d=c._Internal||(c._Internal={}));var I=function(){function a(b,a){this.m_handlersByEventByTarget={};this.m_registerEventImpl=b;this.m_unregisterEventImpl=a}a.prototype.getHandlers=function(e,d){if(b.isNullOrUndefined(d))d="";var a=this.m_handlersByEventByTarget[e];if(!a){a={};this.m_handlersByEventByTarget[e]=a}var c=a[d];if(!c){c=[];a[d]=c}return c};a.prototype.register=function(e,c,f){if(!f)throw d.RuntimeError._createInvalidArgError({argumentName:"handler"});var a=this.getHandlers(e,c);a.push(f);if(a.length===1)return this.m_registerEventImpl(e,c);return b._createPromiseFromResult(null)};a.prototype.unregister=function(f,e,g){if(!g)throw d.RuntimeError._createInvalidArgError({argumentName:"handler"});for(var a=this.getHandlers(f,e),c=a.length-1;c>=0;c--)if(a[c]===g){a.splice(c,1);break}if(a.length===0)return this.m_unregisterEventImpl(f,e);return b._createPromiseFromResult(null)};return a}();c.EventRegistration=I;var q=function(){function c(){this.m_eventRegistration=new I(this._registerEventImpl.bind(this),this._unregisterEventImpl.bind(this));this.m_richApiMessageHandler=this._handleRichApiMessage.bind(this)}c.prototype.ready=function(){var a=this;if(!this.m_ready)if(c._testReadyImpl)this.m_ready=c._testReadyImpl().then(function(){a.m_isReady=true});else if(v.instance)this.m_ready=b._createPromiseFromResult(null).then(function(){a.m_isReady=true});else this.m_ready=d.officeJsEventRegistration.register(5,"",this.m_richApiMessageHandler).then(function(){a.m_isReady=true});return this.m_ready};Object.defineProperty(c.prototype,"isReady",{"get":function(){return this.m_isReady},enumerable:true,configurable:true});c.prototype.register=function(b,a,c){var d=this;return this.ready().then(function(){return d.m_eventRegistration.register(b,a,c)})};c.prototype.unregister=function(b,a,c){var d=this;return this.ready().then(function(){return d.m_eventRegistration.unregister(b,a,c)})};c.prototype._registerEventImpl=function(c,a){return b._createPromiseFromResult(null)};c.prototype._unregisterEventImpl=function(c,a){return b._createPromiseFromResult(null)};c.prototype._handleRichApiMessage=function(c){if(c&&c.entries)for(var d=0;d<c.entries.length;d++){var b=c.entries[d];if(b.messageCategory==g.eventMessageCategory){a._logEnabled&&a.log(JSON.stringify(b));var e=this.m_eventRegistration.getHandlers(b.messageType,b.targetId);if(e.length>0){var h=JSON.parse(b.message);if(b.isRemoteOverride)h.source=g.eventSourceRemote;for(var f=0;f<e.length;f++)e[f](h)}}}};c.getGenericEventRegistration=function(){if(!c.s_genericEventRegistration)c.s_genericEventRegistration=new c;return c.s_genericEventRegistration};c.richApiMessageEventCategory=65536;return c}();function Q(a){q._testReadyImpl=a}c._testSetRichApiMessageReadyImpl=Q;function R(a){q.getGenericEventRegistration()._handleRichApiMessage(a)}c._testTriggerRichApiMessageEvent=R;var Y=function(b){__extends(a,b);function a(e,d,f,a){var c=b.call(this,e,d,f,a)||this;c.m_genericEventInfo=a;return c}a.prototype.add=function(b){var a=this;this._handlers.length==0&&this.m_genericEventInfo.registerFunc&&this.m_genericEventInfo.registerFunc();!q.getGenericEventRegistration().isReady&&this._context._pendingRequest._addPreSyncPromise(q.getGenericEventRegistration().ready());o.createTraceMarkerForCallback(this._context,function(){a._handlers.push(b);a._handlers.length==1&&q.getGenericEventRegistration().register(a.m_genericEventInfo.eventType,a.m_genericEventInfo.getTargetIdFunc(),a._callback)});return new G(this._context,this,b)};a.prototype.remove=function(b){var a=this;this._handlers.length==1&&this.m_genericEventInfo.unregisterFunc&&this.m_genericEventInfo.unregisterFunc();o.createTraceMarkerForCallback(this._context,function(){for(var c=a._handlers,d=c.length-1;d>=0;d--)if(c[d]===b){c.splice(d,1);break}c.length==0&&q.getGenericEventRegistration().unregister(a.m_genericEventInfo.eventType,a.m_genericEventInfo.getTargetIdFunc(),a._callback)})};a.prototype.removeAll=function(){};return a}(N);c.GenericEventHandlers=Y;var S=function(){function a(a){this.m_clientObject=a}a.prototype._handleResult=function(a){this.m_clientObject._handleIdResult(a)};return a}(),r=function(){function a(){}a.createGlobalObjectObjectPath=function(b){var a={Id:b._nextId(),ObjectPathType:1,Name:""};return new l(a,null,false,false,1,4)};a.createNewObjectObjectPath=function(e,d,c,f){var a={Id:e._nextId(),ObjectPathType:2,Name:d},g=new l(a,null,c,false,1,b._fixupApiFlags(f));return g};a.createPropertyObjectPath=function(g,a,f,e,c,h){var d={Id:g._nextId(),ObjectPathType:4,Name:f,ParentObjectPathId:a._objectPath.objectPathInfo.Id},i=new l(d,a._objectPath,e,c,1,b._fixupApiFlags(h));return i};a.createIndexerObjectPath=function(c,b,d){var a={Id:c._nextId(),ObjectPathType:5,Name:"",ParentObjectPathId:b._objectPath.objectPathInfo.Id,ArgumentInfo:{}};a.ArgumentInfo.Arguments=d;return new l(a,b._objectPath,false,false,1,4)};a.createIndexerObjectPathUsingParentPath=function(c,a,d){var b={Id:c._nextId(),ObjectPathType:5,Name:"",ParentObjectPathId:a.objectPathInfo.Id,ArgumentInfo:{}};b.ArgumentInfo.Arguments=d;return new l(b,a,false,false,1,4)};a.createMethodObjectPath=function(d,e,k,i,n,j,f,h,m){var c={Id:d._nextId(),ObjectPathType:3,Name:k,ParentObjectPathId:e._objectPath.objectPathInfo.Id,ArgumentInfo:{}},g=b.setMethodArguments(d,c.ArgumentInfo,n),a=new l(c,e._objectPath,j,f,i,b._fixupApiFlags(m));a.argumentObjectPaths=g;a.getByIdMethodName=h;return a};a.createReferenceIdObjectPath=function(c,b){var a={Id:c._nextId(),ObjectPathType:6,Name:b,ArgumentInfo:{}},d=new l(a,null,false,false,1,4);return d};a.createChildItemObjectPathUsingIndexerOrGetItemAt=function(f,d,e,c,g){var h=b.tryGetObjectIdFromLoadOrRetrieveResult(c);if(f&&!b.isNullOrUndefined(h))return a.createChildItemObjectPathUsingIndexer(d,e,c);else return a.createChildItemObjectPathUsingGetItemAt(d,e,c,g)};a.createChildItemObjectPathUsingIndexer=function(e,c,d){var f=b.tryGetObjectIdFromLoadOrRetrieveResult(d),a=a={Id:e._nextId(),ObjectPathType:5,Name:"",ParentObjectPathId:c._objectPath.objectPathInfo.Id,ArgumentInfo:{}};a.ArgumentInfo.Arguments=[f];return new l(a,c._objectPath,false,false,1,4)};a.createChildItemObjectPathUsingGetItemAt=function(f,c,e,d){var a=e[g.index];if(a)d=a;var b={Id:f._nextId(),ObjectPathType:3,Name:g.getItemAt,ParentObjectPathId:c._objectPath.objectPathInfo.Id,ArgumentInfo:{}};b.ArgumentInfo.Arguments=[d];return new l(b,c._objectPath,false,false,1,4)};return a}();c.ObjectPathFactory=r;var W=function(){function b(a){this.m_context=a}b.prototype.executeAsync=function(g,f,e){var h=this,d=k.buildMessageArrayForIRequestExecutor(g,f,e,b.SourceLibHeaderValue);return new c.Promise(function(b,c){OSF.DDA.RichApi.executeRichApiRequestAsync(d,function(c){a.log("Response:");a.log(JSON.stringify(c));var d;if(c.status=="succeeded")d=k.buildResponseOnSuccess(k.getResponseBody(c),k.getResponseHeaders(c));else{d=k.buildResponseOnError(c.error.code,c.error.message);h.m_context._processOfficeJsErrorResponse(c.error.code,d)}b(d)})})};b.SourceLibHeaderValue="officejs";return b}(),M=function(){function c(a){this._autoCleanupList={};this.m_context=a}c.prototype.add=function(a){var b=this;if(Array.isArray(a))a.forEach(function(a){return b._addCommon(a,true)});else this._addCommon(a,true)};c.prototype._autoAdd=function(a){this._addCommon(a,false);this._autoCleanupList[a._objectPath.objectPathInfo.Id]=a};c.prototype._autoTrackIfNecessaryWhenHandleObjectResultValue=function(a,c){var d=this.m_context._autoCleanup&&!a[g.isTracked]&&a!==this.m_context._rootObject&&c&&!b.isNullOrEmptyString(c[g.referenceId]);if(d){this._autoCleanupList[a._objectPath.objectPathInfo.Id]=a;a[g.isTracked]=true}};c.prototype._addCommon=function(c,d){if(c[g.isTracked]){if(d&&this.m_context._autoCleanup)delete this._autoCleanupList[c._objectPath.objectPathInfo.Id];return}var h=c[g.referenceId],e=c._objectPath.objectPathInfo[g.objectPathInfoDoNotKeepReferenceFieldName];if(e)throw b.createRuntimeError(f.generalException,a._getResourceString(p.objectIsUntracked),null);if(b.isNullOrEmptyString(h)&&c._KeepReference){c._KeepReference();o.createInstantiateAction(this.m_context,c);if(d&&this.m_context._autoCleanup)delete this._autoCleanupList[c._objectPath.objectPathInfo.Id];c[g.isTracked]=true}};c.prototype.remove=function(a){var b=this;if(Array.isArray(a))a.forEach(function(a){return b._removeCommon(a)});else this._removeCommon(a)};c.prototype._removeCommon=function(a){a._objectPath.objectPathInfo[g.objectPathInfoDoNotKeepReferenceFieldName]=true;a.context._pendingRequest._removeKeepReferenceAction(a._objectPath.objectPathInfo.Id);var c=a[g.referenceId];if(!b.isNullOrEmptyString(c)){var d=this.m_context._rootObject;d._RemoveReference&&d._RemoveReference(c)}delete a[g.isTracked]};c.prototype._retrieveAndClearAutoCleanupList=function(){var a=this._autoCleanupList;this._autoCleanupList={};return a};return c}();c.TrackedObjects=M;var E=function(){function a(a,b,e,c,d){if(!a)a="root";this.m_globalObjName=a;this.m_referencedObjectPaths=b;this.m_actions=e;this.m_statements=[];this.m_variableNameForObjectPathMap={};this.m_variableNameToObjectPathMap={};this.m_declaredObjectPathMap={};this.m_showDispose=c;this.m_removePII=d}a.prototype.process=function(){this.m_showDispose&&x._calculateLastUsedObjectPathIds(this.m_actions);for(var a=0;a<this.m_actions.length;a++)this.processOneAction(this.m_actions[a]);return this.m_statements};a.prototype.processForDebugStatementInfo=function(i){this.m_showDispose&&x._calculateLastUsedObjectPathIds(this.m_actions);var f=5;this.m_statements=[];for(var j="",a=-1,e=0;e<this.m_actions.length;e++){this.processOneAction(this.m_actions[e]);if(i==e)a=this.m_statements.length-1;if(a>=0&&this.m_statements.length>a+f+1)break}if(a<0)return null;var c=a-f;if(c<0)c=0;var d=a+1+f;if(d>this.m_statements.length)d=this.m_statements.length;var b=[];c!=0&&b.push("...");for(var g=c;g<a;g++)b.push(this.m_statements[g]);b.push("// >>>>>");b.push(this.m_statements[a]);b.push("// <<<<<");for(var h=a+1;h<d;h++)b.push(this.m_statements[h]);d<this.m_statements.length&&b.push("...");return{statement:this.m_statements[a],surroundingStatements:b}};a.prototype.processOneAction=function(a){var b=a.actionInfo;switch(b.ActionType){case 1:this.processInstantiateAction(a);break;case 3:this.processMethodAction(a);break;case 2:this.processQueryAction(a);break;case 7:this.processQueryAsJsonAction(a);break;case 6:this.processRecursiveQueryAction(a);break;case 4:this.processSetPropertyAction(a);break;case 5:this.processTraceAction(a);break;case 8:this.processEnsureUnchangedAction(a);break;case 9:this.processUpdateAction(a);break}};a.prototype.processInstantiateAction=function(d){var b=d.actionInfo.ObjectPathId,e=this.m_referencedObjectPaths[b],c=this.getObjVarName(b);if(!this.m_declaredObjectPathMap[b]){var a="var "+c+"="+this.buildObjectPathExpressionWithParent(e)+";";a=this.appendDisposeCommentIfRelevant(a,d);this.m_statements.push(a);this.m_declaredObjectPathMap[b]=c}else{var a="// Instantiate {"+c+"}";a=this.appendDisposeCommentIfRelevant(a,d);this.m_statements.push(a)}};a.prototype.processMethodAction=function(a){var d=a.actionInfo.Name;if(d==="_KeepReference"){if(!c._internalConfig.showInternalApiInDebugInfo)return;d="track"}var e=this.getObjVarName(a.actionInfo.ObjectPathId)+"."+b._toCamelLowerCase(d)+"("+this.buildArgumentsExpression(a.actionInfo.ArgumentInfo)+");";e=this.appendDisposeCommentIfRelevant(e,a);this.m_statements.push(e)};a.prototype.processQueryAction=function(b){var c=this.buildQueryExpression(b),a=this.getObjVarName(b.actionInfo.ObjectPathId)+".load("+c+");";a=this.appendDisposeCommentIfRelevant(a,b);this.m_statements.push(a)};a.prototype.processQueryAsJsonAction=function(b){var c=this.buildQueryExpression(b),a=this.getObjVarName(b.actionInfo.ObjectPathId)+".retrieve("+c+");";a=this.appendDisposeCommentIfRelevant(a,b);this.m_statements.push(a)};a.prototype.processRecursiveQueryAction=function(a){var c="";if(a.actionInfo.RecursiveQueryInfo)c=JSON.stringify(a.actionInfo.RecursiveQueryInfo);var b=this.getObjVarName(a.actionInfo.ObjectPathId)+".loadRecursive("+c+");";b=this.appendDisposeCommentIfRelevant(b,a);this.m_statements.push(b)};a.prototype.processSetPropertyAction=function(a){var c=this.getObjVarName(a.actionInfo.ObjectPathId)+"."+b._toCamelLowerCase(a.actionInfo.Name)+"="+this.buildArgumentsExpression(a.actionInfo.ArgumentInfo)+";";c=this.appendDisposeCommentIfRelevant(c,a);this.m_statements.push(c)};a.prototype.processTraceAction=function(b){var a="context.trace();";a=this.appendDisposeCommentIfRelevant(a,b);this.m_statements.push(a)};a.prototype.processEnsureUnchangedAction=function(b){var a=this.getObjVarName(b.actionInfo.ObjectPathId)+".ensureUnchanged("+JSON.stringify(b.actionInfo.ObjectState)+");";a=this.appendDisposeCommentIfRelevant(a,b);this.m_statements.push(a)};a.prototype.processUpdateAction=function(b){var a=this.getObjVarName(b.actionInfo.ObjectPathId)+".update("+JSON.stringify(b.actionInfo.ObjectState)+");";a=this.appendDisposeCommentIfRelevant(a,b);this.m_statements.push(a)};a.prototype.appendDisposeCommentIfRelevant=function(b,d){var e=this;if(this.m_showDispose){var a=d.actionInfo.L;if(a&&a.length>0){var c=a.map(function(a){return e.getObjVarName(a)}).join(", ");return b+" // And then dispose {"+c+"}"}}return b};a.prototype.buildQueryExpression=function(b){if(b.actionInfo.QueryInfo){var a={};a.select=b.actionInfo.QueryInfo.Select;a.expand=b.actionInfo.QueryInfo.Expand;a.skip=b.actionInfo.QueryInfo.Skip;a.top=b.actionInfo.QueryInfo.Top;if(typeof a.top==="undefined"&&typeof a.skip==="undefined"&&typeof a.expand==="undefined")if(typeof a.select==="undefined")return"";else return JSON.stringify(a.select);else return JSON.stringify(a)}return""};a.prototype.buildObjectPathExpressionWithParent=function(a){var b=a.objectPathInfo.ObjectPathType==5||a.objectPathInfo.ObjectPathType==3||a.objectPathInfo.ObjectPathType==4;if(b&&a.objectPathInfo.ParentObjectPathId)return this.getObjVarName(a.objectPathInfo.ParentObjectPathId)+"."+this.buildObjectPathExpression(a);return this.buildObjectPathExpression(a)};a.prototype.buildObjectPathExpression=function(c){var a=this.buildObjectPathInfoExpression(c.objectPathInfo),b=c.originalObjectPathInfo;if(b)a=a+" /* originally "+this.buildObjectPathInfoExpression(b)+" */";return a};a.prototype.buildObjectPathInfoExpression=function(a){switch(a.ObjectPathType){case 1:return"context."+this.m_globalObjName;case 5:return"getItem("+this.buildArgumentsExpression(a.ArgumentInfo)+")";case 3:return b._toCamelLowerCase(a.Name)+"("+this.buildArgumentsExpression(a.ArgumentInfo)+")";case 2:return a.Name+".newObject()";case 7:return"null";case 4:return b._toCamelLowerCase(a.Name);case 6:return"context."+this.m_globalObjName+"._getObjectByReferenceId("+JSON.stringify(a.Name)+")"}};a.prototype.buildArgumentsExpression=function(b){var a="";if(!b.Arguments||b.Arguments.length===0)return a;if(this.m_removePII){if(typeof b.Arguments[0]==="undefined")return a;return"..."}for(var c=0;c<b.Arguments.length;c++){if(c>0)a=a+", ";a=a+this.buildArgumentLiteral(b.Arguments[c],b.ReferencedObjectPathIds?b.ReferencedObjectPathIds[c]:null)}if(a==="undefined")a="";return a};a.prototype.buildArgumentLiteral=function(a,b){if(typeof a=="number"&&a===b)return this.getObjVarName(b);else return JSON.stringify(a)};a.prototype.getObjVarNameBase=function(f){var a="v",e=this.m_referencedObjectPaths[f];if(e)switch(e.objectPathInfo.ObjectPathType){case 1:a=this.m_globalObjName;break;case 4:a=b._toCamelLowerCase(e.objectPathInfo.Name);break;case 3:var c=e.objectPathInfo.Name;if(c.length>3&&c.substr(0,3)==="Get")c=c.substr(3);a=b._toCamelLowerCase(c);break;case 5:var d=this.getObjVarNameBase(e.objectPathInfo.ParentObjectPathId);if(d.charAt(d.length-1)==="s")a=d.substr(0,d.length-1);else a=d+"Item";break}return a};a.prototype.getObjVarName=function(b){if(this.m_variableNameForObjectPathMap[b])return this.m_variableNameForObjectPathMap[b];var a=this.getObjVarNameBase(b);if(!this.m_variableNameToObjectPathMap[a]){this.m_variableNameForObjectPathMap[b]=a;this.m_variableNameToObjectPathMap[a]=b;return a}var c=1;while(this.m_variableNameToObjectPathMap[a+c.toString()])c++;a=a+c.toString();this.m_variableNameForObjectPathMap[b]=a;this.m_variableNameToObjectPathMap[a]=b;return a};return a}(),p=function(b){__extends(a,b);function a(){return b!==null&&b.apply(this,arguments)||this}a.cannotRegisterEvent="CannotRegisterEvent";a.connectionFailureWithStatus="ConnectionFailureWithStatus";a.connectionFailureWithDetails="ConnectionFailureWithDetails";a.propertyNotLoaded="PropertyNotLoaded";a.runMustReturnPromise="RunMustReturnPromise";a.moreInfoInnerError="MoreInfoInnerError";a.cannotApplyPropertyThroughSetMethod="CannotApplyPropertyThroughSetMethod";a.invalidOperationInCellEditMode="InvalidOperationInCellEditMode";a.objectIsUntracked="ObjectIsUntracked";a.customFunctionDefintionMissing="CustomFunctionDefintionMissing";a.customFunctionImplementationMissing="CustomFunctionImplementationMissing";a.customFunctionNameContainsBadChars="CustomFunctionNameContainsBadChars";a.customFunctionNameCannotSplit="CustomFunctionNameCannotSplit";a.customFunctionUnexpectedNumberOfEntriesInResultBatch="CustomFunctionUnexpectedNumberOfEntriesInResultBatch";a.customFunctionCancellationHandlerMissing="CustomFunctionCancellationHandlerMissing";a.customFunctionInvalidFunction="CustomFunctionInvalidFunction";a.customFunctionInvalidFunctionMapping="CustomFunctionInvalidFunctionMapping";a.customFunctionWindowMissing="CustomFunctionWindowMissing";a.customFunctionDefintionMissingOnWindow="CustomFunctionDefintionMissingOnWindow";a.pendingBatchInProgress="PendingBatchInProgress";a.notInsideBatch="NotInsideBatch";a.cannotUpdateReadOnlyProperty="CannotUpdateReadOnlyProperty";return a}(w);c.ResourceStrings=p;a.addResourceStringValues({CannotRegisterEvent:"The event handler cannot be registered.",PropertyNotLoaded:"The property '{0}' is not available. Before reading the property's value, call the load method on the containing object and call \"context.sync()\" on the associated request context.",RunMustReturnPromise:'The batch function passed to the ".run" method didn\'t return a promise. The function must return a promise, so that any automatically-tracked objects can be released at the completion of the batch operation. Typically, you return a promise by returning the response from "context.sync()".',InvalidOrTimedOutSessionMessage:"Your Office Online session has expired or is invalid. To continue, refresh the page.",InvalidOperationInCellEditMode:"Excel is in cell-editing mode. Please exit the edit mode by pressing ENTER or TAB or selecting another cell, and then try again.",CustomFunctionDefintionMissing:"A property with the name '{0}' that represents the function's definition must exist on Excel.Script.CustomFunctions.",CustomFunctionDefintionMissingOnWindow:"A property with the name '{0}' that represents the function's definition must exist on the window object.",CustomFunctionImplementationMissing:"The property with the name '{0}' on Excel.Script.CustomFunctions that represents the function's definition must contain a 'call' property that implements the function.",CustomFunctionNameContainsBadChars:"The function name may only contain letters, digits, underscores, and periods.",CustomFunctionNameCannotSplit:"The function name must contain a non-empty namespace and a non-empty short name.",CustomFunctionUnexpectedNumberOfEntriesInResultBatch:"The batching function returned a number of results that doesn't match the number of parameter value sets that were passed into it.",CustomFunctionCancellationHandlerMissing:"The cancellation handler onCanceled is missing in the function. The handler must be present as the function is defined as cancelable.",CustomFunctionInvalidFunction:"The property with the name '{0}' that represents the function's definition is not a valid function.",CustomFunctionInvalidFunctionMapping:"The property with the name '{0}' on CustomFunctionMappings that represents the function's definition is not a valid function.",CustomFunctionWindowMissing:"The window object was not found.",PendingBatchInProgress:"There is a pending batch in progress. The batch method may not be called inside another batch, or simultaneously with another batch.",NotInsideBatch:"Operations may not be invoked outside of a batch method.",CannotUpdateReadOnlyProperty:"The property '{0}' is read-only and it cannot be updated.",ObjectIsUntracked:"The object is untracked."});var b=function(e){__extends(b,e);function b(){return e!==null&&e.apply(this,arguments)||this}b.fixObjectPathIfNecessary=function(a,b){a&&a._objectPath&&b&&a._objectPath.updateUsingObjectData(b,a)};b.load=function(a,b){a.context.load(a,b);return a};b.loadAndSync=function(a,b){a.context.load(a,b);return a.context.sync().then(function(){return a})};b.retrieve=function(d,f){var a=c._internalConfig.alwaysPolyfillClientObjectRetrieveMethod;if(!a)a=!b.isSetSupported("RichApiRuntime","1.1");var e=new ab(d,a);d._retrieve(f,e);return e};b.retrieveAndSync=function(a,c){var d=b.retrieve(a,c);return a.context.sync().then(function(){return d})};b.toJson=function(h,g,f,e){var c={};for(var d in g){var a=g[d];if(typeof a!=="undefined")c[d]=a}for(var d in f){var a=f[d];if(typeof a!=="undefined")if(a[b.fieldName_isCollection]&&typeof a[b.fieldName_m__items]!=="undefined")c[d]=a.toJSON().items;else c[d]=a.toJSON()}if(e)c.items=e.map(function(a){return a.toJSON()});return c};b.throwError=function(c,e,b){throw new d.RuntimeError({code:c,message:a._getResourceString(c,e),debugInfo:b?{errorLocation:b}:undefined});};b.createRuntimeError=function(c,b,a){return new d.RuntimeError({code:c,message:b,debugInfo:{errorLocation:a}})};b.throwIfNotLoaded=function(c,e,d,f){if(!f&&a.isUndefined(e)&&c.charCodeAt(0)!=b.s_underscoreCharCode)throw b.createPropertyNotLoadedException(d,c);};b.createPropertyNotLoadedException=function(c,b){return new d.RuntimeError({code:A.propertyNotLoaded,message:a._getResourceString(p.propertyNotLoaded,b),debugInfo:c?{errorLocation:c+"."+b}:undefined})};b.createCannotUpdateReadOnlyPropertyException=function(c,b){return new d.RuntimeError({code:A.cannotUpdateReadOnlyProperty,message:a._getResourceString(p.cannotUpdateReadOnlyProperty,b),debugInfo:c?{errorLocation:c+"."+b}:undefined})};b.promisify=function(a){return new c.Promise(function(c,d){var b=function(a){if(a.status=="failed")d(a.error);else c(a.value)};a(b)})};b._addActionResultHandler=function(b,c,a){b.context._pendingRequest.addActionResultHandler(c,a)};b._handleNavigationPropertyResults=function(e,d,c){for(var b=0;b<c.length-1;b+=2)!a.isUndefined(d[c[b+1]])&&e[c[b]]._handleResult(d[c[b+1]])};b._fixupApiFlags=function(a){if(typeof a==="boolean")if(a)a=1;else a=0;return a};b.definePropertyThrowUnloadedException=function(d,c,a){Object.defineProperty(d,a,{configurable:true,enumerable:true,"get":function(){throw b.createPropertyNotLoadedException(c,a);},"set":function(){throw b.createCannotUpdateReadOnlyPropertyException(c,a);}})};b.defineReadOnlyPropertyWithValue=function(d,a,c){Object.defineProperty(d,a,{configurable:true,enumerable:true,"get":function(){return c},"set":function(){throw b.createCannotUpdateReadOnlyPropertyException(null,a);}})};b.processRetrieveResult=function(i,j,f,o){if(a.isNullOrUndefined(j))return;if(o){var k=j[g.itemsLowerCase];if(Array.isArray(k)){for(var p=[],c=0;c<k.length;c++){var q=o(k[c],c),n={};n[g.proxy]=q;q._handleRetrieveResult(k[c],n);p.push(n)}b.defineReadOnlyPropertyWithValue(f,g.itemsLowerCase,p)}}else{var m=i[g.scalarPropertyNames],l=i[g.navigationPropertyNames],s=i[g.className];if(m)for(var c=0;c<m.length;c++){var d=m[c],h=j[d];if(a.isUndefined(h))b.definePropertyThrowUnloadedException(f,s,d);else b.defineReadOnlyPropertyWithValue(f,d,h)}if(l)for(var c=0;c<l.length;c++){var d=l[c],h=j[d];if(a.isUndefined(h))b.definePropertyThrowUnloadedException(f,s,d);else{var r=i[d],e={};r._handleRetrieveResult(h,e);e[g.proxy]=r;if(Array.isArray(e[g.itemsLowerCase]))e=e[g.itemsLowerCase];b.defineReadOnlyPropertyWithValue(f,d,e)}}}};b.fieldName_m__items="m__items";b.fieldName_isCollection="_isCollection";b._synchronousCleanup=false;b.s_underscoreCharCode="_".charCodeAt(0);return b}(e);c.Utility=b;var db=function(){function a(){}a.invokeMethod=function(a,f,e,i,h,d){var g=o.createMethodAction(a.context,a,f,e,i,h),c=new z(d);b._addActionResultHandler(a,g,c);return c};a.invokeEnsureUnchanged=function(a,b){o.createEnsureUnchangedAction(a.context,a,b)};a.invokeSetProperty=function(a,c,b,d){o.createSetPropertyAction(a.context,a,c,b,d)};a.createRootServiceObject=function(c,a){var b=r.createGlobalObjectObjectPath(a);return new c(a,b)};a.createObjectFromReferenceId=function(d,a,b){var c=r.createReferenceIdObjectPath(a,b);return new d(a,c)};a.createTopLevelServiceObject=function(f,a,d,b,e){var c=r.createNewObjectObjectPath(a,d,b,e);return new f(a,c)};a.createPropertyObject=function(f,a,c,b,e){var d=r.createPropertyObjectPath(a.context,a,c,b,false,e);return new f(a.context,d)};a.createIndexerObject=function(d,a,c){var b=r.createIndexerObjectPath(a.context,a,c);return new d(a.context,b)};a.createMethodObject=function(j,a,f,d,i,e,b,c,h){var g=r.createMethodObjectPath(a.context,a,f,d,i,e,b,c,h);return new j(a.context,g)};a.createChildItemObject=function(f,b,a,d,e){var c=r.createChildItemObjectPathUsingIndexerOrGetItemAt(b,a.context,a,d,e);return new f(a.context,c)};return a}();c.BatchApiHelper=db;var O=1,C={invokeRequestModifier:function(a){a.DdaMethod.Version=O;return a},invokeResponseModifier:function(a){O=a.Version;if(a.Error){a.error={};a.error.Code=a.Error}return a}},h;(function(a){a.SendingId="sId";a.RespondingId="rId";a.CommandKey="command";a.SessionInfoKey="sessionInfo";a.ParamsKey="params";a.ApiReadyCommand="apiready";a.ExecuteMethodCommand="executeMethod";a.GetAppContextCommand="getAppContext";a.RegisterEventCommand="registerEvent";a.UnregisterEventCommand="unregisterEvent";a.FireEventCommand="fireEvent"})(h||(h={}));var u=function(){function a(){}a.sessionContext="sc";a.embeddingPageOrigin="EmbeddingPageOrigin";a.embeddingPageSessionInfo="EmbeddingPageSessionInfo";return a}();c.EmbeddedConstants=u;var bb=function(d){__extends(c,d);function c(c,b){var a=d.call(this)||this;a.m_chosenWindow=null;a.m_chosenOrigin=null;a.m_enabled=true;a.m_onMessageHandler=a._onMessage.bind(a);a.m_callbackList={};a.m_id=0;a.m_timeoutId=-1;a.m_appContext=null;a.m_url=c;a.m_options=b;if(!a.m_options)a.m_options={sessionKey:Math.random().toString()};if(!a.m_options.sessionKey)a.m_options.sessionKey=Math.random().toString();if(!a.m_options.container)a.m_options.container=document.body;if(!a.m_options.timeoutInMilliseconds)a.m_options.timeoutInMilliseconds=6e4;if(!a.m_options.height)a.m_options.height="400px";if(!a.m_options.width)a.m_options.width="100%";if(!(a.m_options.webApplication&&a.m_options.webApplication.accessToken&&a.m_options.webApplication.accessTokenTtl))a.m_options.webApplication=null;return a}c.prototype._getIFrameSrc=function(){var e=window.location.protocol+"//"+window.location.host,b=u.embeddingPageOrigin+"="+encodeURIComponent(e)+"&"+u.embeddingPageSessionInfo+"="+encodeURIComponent(this.m_options.sessionKey),d=false;if(this.m_url.toLowerCase().indexOf("/_layouts/preauth.aspx")>0||this.m_url.toLowerCase().indexOf("/_layouts/15/preauth.aspx")>0)d=true;var a=document.createElement("a");a.href=this.m_url;if(this.m_options.webApplication){var c=u.embeddingPageOrigin+"="+e+"&"+u.embeddingPageSessionInfo+"="+this.m_options.sessionKey;if(a.search.length===0||a.search==="?")a.search="?"+u.sessionContext+"="+encodeURIComponent(c);else a.search=a.search+"&"+u.sessionContext+"="+encodeURIComponent(c)}else if(d)if(a.hash.length===0||a.hash==="#")a.hash="#"+b;else a.hash=a.hash+"&"+b;else if(a.search.length===0||a.search==="?")a.search="?"+b;else a.search=a.search+"&"+b;var f=a.href;return f};c.prototype.init=function(){var c=this;window.addEventListener("message",this.m_onMessageHandler);var d=this._getIFrameSrc();return a.createPromise(function(k,l){var e=document.createElement("iframe");if(c.m_options.id){e.id=c.m_options.id;e.name=c.m_options.id}e.style.height=c.m_options.height;e.style.width=c.m_options.width;if(!c.m_options.webApplication){e.src=d;c.m_options.container.appendChild(e)}else{var g=document.createElement("form");g.setAttribute("action",d);g.setAttribute("method","post");g.setAttribute("target",e.name);c.m_options.container.appendChild(g);var j=document.createElement("input");j.setAttribute("type","hidden");j.setAttribute("name","access_token");j.setAttribute("value",c.m_options.webApplication.accessToken);g.appendChild(j);var h=document.createElement("input");h.setAttribute("type","hidden");h.setAttribute("name","access_token_ttl");h.setAttribute("value",c.m_options.webApplication.accessTokenTtl);g.appendChild(h);c.m_options.container.appendChild(e);g.submit()}c.m_timeoutId=window.setTimeout(function(){c.close();var d=b.createRuntimeError(f.timeout,a._getResourceString(i.timeout),"EmbeddedSession.init");l(d)},c.m_options.timeoutInMilliseconds);c.m_promiseResolver=k})};c.prototype._invoke=function(c,b,a){if(!this.m_enabled){b(5001,null);return}if(C.invokeRequestModifier)a=C.invokeRequestModifier(a);this._sendMessageWithCallback(this.m_id++,c,a,function(a){if(C.invokeResponseModifier)a=C.invokeResponseModifier(a);var c=a.Error;delete a.Error;b(c||0,a)})};c.prototype.close=function(){window.removeEventListener("message",this.m_onMessageHandler);window.clearTimeout(this.m_timeoutId);this.m_enabled=false};Object.defineProperty(c.prototype,"eventRegistration",{"get":function(){if(!this.m_sessionEventManager)this.m_sessionEventManager=new I(this._registerEventImpl.bind(this),this._unregisterEventImpl.bind(this));return this.m_sessionEventManager},enumerable:true,configurable:true});c.prototype._createRequestExecutorOrNull=function(){return new V(this)};c.prototype._resolveRequestUrlAndHeaderInfo=function(){return a._createPromiseFromResult(null)};c.prototype._registerEventImpl=function(d,c){var b=this;return a.createPromise(function(a,e){b._sendMessageWithCallback(b.m_id++,h.RegisterEventCommand,{EventId:d,TargetId:c},function(){a(null)})})};c.prototype._unregisterEventImpl=function(d,c){var b=this;return a.createPromise(function(a,e){b._sendMessageWithCallback(b.m_id++,h.UnregisterEventCommand,{EventId:d,TargetId:c},function(){a()})})};c.prototype._onMessage=function(b){var c=this;if(!this.m_enabled)return;if(this.m_chosenWindow&&(this.m_chosenWindow!==b.source||this.m_chosenOrigin!==b.origin))return;var a=b.data;if(a&&a[h.CommandKey]===h.ApiReadyCommand){if(!this.m_chosenWindow&&this._isValidDescendant(b.source)&&a[h.SessionInfoKey]===this.m_options.sessionKey){this.m_chosenWindow=b.source;this.m_chosenOrigin=b.origin;this._sendMessageWithCallback(this.m_id++,h.GetAppContextCommand,null,function(a){c._setupContext(a);window.clearTimeout(c.m_timeoutId);c.m_promiseResolver()})}return}if(a&&a[h.CommandKey]===h.FireEventCommand){var d=a[h.ParamsKey],k=d.EventId,j=d.TargetId,l=d.Data;if(this.m_sessionEventManager)for(var g=this.m_sessionEventManager.getHandlers(k,j),e=0;e<g.length;e++)g[e](l);return}if(a&&a.hasOwnProperty(h.RespondingId)){var i=a[h.RespondingId],f=this.m_callbackList[i];typeof f==="function"&&f(a[h.ParamsKey]);delete this.m_callbackList[i]}};c.prototype._sendMessageWithCallback=function(b,d,e,c){this.m_callbackList[b]=c;var a={};a[h.SendingId]=b;a[h.CommandKey]=d;a[h.ParamsKey]=e;this.m_chosenWindow.postMessage(JSON.stringify(a),this.m_chosenOrigin)};c.prototype._isValidDescendant=function(f){var d=this.m_options.container||document.body;function b(a){if(a===f)return true;for(var c=0,d=a.frames.length;c<d;c++)if(b(a.frames[c]))return true;return false}for(var c=d.getElementsByTagName("iframe"),a=0,e=c.length;a<e;a++)if(b(c[a].contentWindow))return true;return false};c.prototype._setupContext=function(a){if(!(this.m_appContext=a))return};return c}(s);c.EmbeddedSession=bb;var V=function(){function b(a){this.m_session=a}b.prototype.executeAsync=function(f,e,d){var g=this,c=k.buildMessageArrayForIRequestExecutor(f,e,d,b.SourceLibHeaderValue);return a.createPromise(function(d,e){g.m_session._invoke(h.ExecuteMethodCommand,function(e,b){a.log("Response:");a.log(JSON.stringify(b));var c;if(e==0)c=k.buildResponseOnSuccess(k.getResponseBodyFromSafeArray(b.Data),k.getResponseHeadersFromSafeArray(b.Data));else c=k.buildResponseOnError(b.error.Code,b.error.Message);d(c)},b._transformMessageArrayIntoParams(c))})};b._transformMessageArrayIntoParams=function(a){return{ArrayData:a,DdaMethod:{DispatchId:b.DispidExecuteRichApiRequestMethod}}};b.DispidExecuteRichApiRequestMethod=93;b.SourceLibHeaderValue="Embedded";return b}()})(OfficeExtension||(OfficeExtension={}));var __extends=this&&this.__extends||function(){var a=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(b,a){b.__proto__=a}||function(c,a){for(var b in a)if(a.hasOwnProperty(b))c[b]=a[b]};return function(c,b){a(c,b);function d(){this.constructor=c}c.prototype=b===null?Object.create(b):(d.prototype=b.prototype,new d)}}(),OfficeCore;(function(b){var x="OfficeCore",r="AgaveVisualApi",o=OfficeExtension.BatchApiHelper.createPropertyObject,q=OfficeExtension.BatchApiHelper.createMethodObject,p=OfficeExtension.BatchApiHelper.createIndexerObject,k=OfficeExtension.BatchApiHelper.createRootServiceObject,c=OfficeExtension.BatchApiHelper.createTopLevelServiceObject,m=OfficeExtension.BatchApiHelper.createChildItemObject,a=OfficeExtension.BatchApiHelper.invokeMethod,n=OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,s=OfficeExtension.BatchApiHelper.invokeSetProperty,g=OfficeExtension.Utility.isNullOrUndefined,v=OfficeExtension.Utility.isUndefined,u=OfficeExtension.Utility.throwIfNotLoaded,l=OfficeExtension.Utility.throwIfApiNotSupported,z=OfficeExtension.Utility.load,y=OfficeExtension.Utility.retrieve,h=OfficeExtension.Utility.toJson,d=OfficeExtension.Utility.fixObjectPathIfNecessary,j=OfficeExtension.Utility._handleNavigationPropertyResults,t=OfficeExtension.Utility.adjustToDateTime,e=OfficeExtension.Utility.processRetrieveResult,w="BiShim",i=function(i){__extends(f,i);function f(){return i!==null&&i.apply(this,arguments)||this}Object.defineProperty(f.prototype,"_className",{"get":function(){return"BiShim"},enumerable:true,configurable:true});f.prototype.initialize=function(b){a(this,"Initialize",0,[b],0,0)};f.prototype.getData=function(){return a(this,"getData",1,[],4,0)};f.prototype.setVisualObjects=function(b){a(this,"setVisualObjects",0,[b],2,0)};f.prototype.setVisualObjectsToPersist=function(b){a(this,"setVisualObjectsToPersist",0,[b],2,0)};f.prototype._handleResult=function(a){i.prototype._handleResult.call(this,a);if(g(a))return;var b=a;d(this,b)};f.prototype._handleRetrieveResult=function(b,a){i.prototype._handleRetrieveResult.call(this,b,a);e(this,b,a)};f.newObject=function(a){return c(b.BiShim,a,"Microsoft.AgaveVisual.BiShim",false,4)};f.prototype.toJSON=function(){return h(this,{},{})};return f}(OfficeExtension.ClientObject);b.BiShim=i;var f;(function(a){a.generalException="GeneralException"})(f=b.AgaveVisualErrorCodes||(b.AgaveVisualErrorCodes={}))})(OfficeCore||(OfficeCore={}));var OfficeCore;(function(a){var C="OfficeCore",z="ExperimentApi",w=OfficeExtension.BatchApiHelper.createPropertyObject,e=OfficeExtension.BatchApiHelper.createMethodObject,y=OfficeExtension.BatchApiHelper.createIndexerObject,t=OfficeExtension.BatchApiHelper.createRootServiceObject,h=OfficeExtension.BatchApiHelper.createTopLevelServiceObject,v=OfficeExtension.BatchApiHelper.createChildItemObject,b=OfficeExtension.BatchApiHelper.invokeMethod,i=OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,A=OfficeExtension.BatchApiHelper.invokeSetProperty,f=OfficeExtension.Utility.isNullOrUndefined,m=OfficeExtension.Utility.isUndefined,k=OfficeExtension.Utility.throwIfNotLoaded,u=OfficeExtension.Utility.throwIfApiNotSupported,r=OfficeExtension.Utility.load,p=OfficeExtension.Utility.retrieve,g=OfficeExtension.Utility.toJson,c=OfficeExtension.Utility.fixObjectPathIfNecessary,s=OfficeExtension.Utility._handleNavigationPropertyResults,B=OfficeExtension.Utility.adjustToDateTime,d=OfficeExtension.Utility.processRetrieveResult,x="FlightingService",l=function(j){__extends(i,j);function i(){return j!==null&&j.apply(this,arguments)||this}Object.defineProperty(i.prototype,"_className",{"get":function(){return"FlightingService"},enumerable:true,configurable:true});i.prototype.getClientSessionId=function(){return b(this,"GetClientSessionId",1,[],4,0)};i.prototype.getDeferredFlights=function(){return b(this,"GetDeferredFlights",1,[],4,0)};i.prototype.getFeature=function(d,f,c,b){return e(a.ABType,this,"GetFeature",1,[d,f,c,b],false,false,null,4)};i.prototype.getFeatureGate=function(b,c){return e(a.ABType,this,"GetFeatureGate",1,[b,c],false,false,null,4)};i.prototype.resetOverride=function(a){b(this,"ResetOverride",0,[a],0,0)};i.prototype.setOverride=function(a,d,c){b(this,"SetOverride",0,[a,d,c],0,0)};i.prototype._handleResult=function(a){j.prototype._handleResult.call(this,a);if(f(a))return;var b=a;c(this,b)};i.prototype._handleRetrieveResult=function(b,a){j.prototype._handleRetrieveResult.call(this,b,a);d(this,b,a)};i.newObject=function(b){return h(a.FlightingService,b,"Microsoft.Experiment.FlightingService",false,4)};i.prototype.toJSON=function(){return g(this,{},{})};return i}(OfficeExtension.ClientObject);a.FlightingService=l;var o="ABType",q=function(b){__extends(a,b);function a(){return b!==null&&b.apply(this,arguments)||this}Object.defineProperty(a.prototype,"_className",{"get":function(){return"ABType"},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"_scalarPropertyNames",{"get":function(){return["value"]},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"value",{"get":function(){k("value",this._V,o,this._isNull);return this._V},enumerable:true,configurable:true});a.prototype._handleResult=function(a){b.prototype._handleResult.call(this,a);if(f(a))return;var d=a;c(this,d);if(!m(d.Value))this._V=d.Value};a.prototype.load=function(a){return r(this,a)};a.prototype.retrieve=function(a){return p(this,a)};a.prototype._handleRetrieveResult=function(c,a){b.prototype._handleRetrieveResult.call(this,c,a);d(this,c,a)};a.prototype.toJSON=function(){return g(this,{value:this._V},{})};a.prototype.ensureUnchanged=function(a){i(this,a);return};return a}(OfficeExtension.ClientObject);a.ABType=q;var n;(function(a){a["boolean"]="Boolean";a.integer="Integer";a.string="String"})(n=a.FeatureType||(a.FeatureType={}));var j;(function(a){a.generalException="GeneralException"})(j=a.ExperimentErrorCodes||(a.ExperimentErrorCodes={}))})(OfficeCore||(OfficeCore={}));var OfficeCore;(function(a){a.OfficeOnlineDomainList=["*.dod.online.office365.us","*.gov.online.office365.us","*.officeapps-df.live.com","*.officeapps.live.com","*.online.office.de","*.partner.officewebapps.cn"];function b(){if(typeof window.external==="undefined"||typeof window.external.GetContext==="undefined"){var d=OSF.getClientEndPoint()._targetUrl,b=c(d);if(d.indexOf("https:")!=0)return false;a.OfficeOnlineDomainList.forEach(function(a){if(a.indexOf("*.")==0)a=a.substring(2);if(b.indexOf(a)==b.length-a.length)return true});return false}return true}a.isHostOriginTrusted=b;function c(b){var a="";a=b.split("/")[2];a=a.split(":")[0];a=a.split("?")[0];return a}})(OfficeCore||(OfficeCore={}));var OfficeCore;(function(a){var b=function(){function b(a){this.context=a}Object.defineProperty(b.prototype,"roamingSettings",{"get":function(){if(!this.m_roamingSettings)this.m_roamingSettings=a.AuthenticationService.newObject(this.context).roamingSettings;return this.m_roamingSettings},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"tap",{"get":function(){if(!this.m_tap)this.m_tap=a.Tap.newObject(this.context);return this.m_tap},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"skill",{"get":function(){if(!this.m_skill)this.m_skill=a.Skill.newObject(this.context);return this.m_skill},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"personaFactory",{"get":function(){if(!this.m_personaFactory)this.m_personaFactory=a.PersonaFactory.newObject(this.context);return this.m_personaFactory},enumerable:true,configurable:true});return b}();a.FirstPartyApis=b;var c=function(d){__extends(c,d);function c(a){return d.call(this,a)||this}Object.defineProperty(c.prototype,"firstParty",{"get":function(){if(!this.m_firstPartyApis)this.m_firstPartyApis=new b(this);return this.m_firstPartyApis},enumerable:true,configurable:true});Object.defineProperty(c.prototype,"flighting",{"get":function(){return this.flightingService},enumerable:true,configurable:true});Object.defineProperty(c.prototype,"telemetry",{"get":function(){if(!this.m_telemetry)this.m_telemetry=a.TelemetryService.newObject(this);return this.m_telemetry},enumerable:true,configurable:true});Object.defineProperty(c.prototype,"bi",{"get":function(){if(!this.m_biShim)this.m_biShim=a.BiShim.newObject(this);return this.m_biShim},enumerable:true,configurable:true});Object.defineProperty(c.prototype,"flightingService",{"get":function(){if(!this.m_flightingService)this.m_flightingService=a.FlightingService.newObject(this);return this.m_flightingService},enumerable:true,configurable:true});return c}(OfficeExtension.ClientRequestContext);a.RequestContext=c;function d(b,c){return OfficeExtension.ClientRequestContext._runBatch("OfficeCore.run",arguments,function(b){return new a.RequestContext(b)})}a.run=d})(OfficeCore||(OfficeCore={}));var OfficeCore;(function(b){var x="Office",r="OfficeSharedApi",o=OfficeExtension.BatchApiHelper.createPropertyObject,q=OfficeExtension.BatchApiHelper.createMethodObject,p=OfficeExtension.BatchApiHelper.createIndexerObject,k=OfficeExtension.BatchApiHelper.createRootServiceObject,c=OfficeExtension.BatchApiHelper.createTopLevelServiceObject,m=OfficeExtension.BatchApiHelper.createChildItemObject,a=OfficeExtension.BatchApiHelper.invokeMethod,n=OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,s=OfficeExtension.BatchApiHelper.invokeSetProperty,f=OfficeExtension.Utility.isNullOrUndefined,v=OfficeExtension.Utility.isUndefined,u=OfficeExtension.Utility.throwIfNotLoaded,l=OfficeExtension.Utility.throwIfApiNotSupported,z=OfficeExtension.Utility.load,y=OfficeExtension.Utility.retrieve,h=OfficeExtension.Utility.toJson,d=OfficeExtension.Utility.fixObjectPathIfNecessary,j=OfficeExtension.Utility._handleNavigationPropertyResults,t=OfficeExtension.Utility.adjustToDateTime,e=OfficeExtension.Utility.processRetrieveResult,w="Skill",i=function(i){__extends(g,i);function g(){return i!==null&&i.apply(this,arguments)||this}Object.defineProperty(g.prototype,"_className",{"get":function(){return"Skill"},enumerable:true,configurable:true});g.prototype.executeAction=function(d,c,b){return a(this,"ExecuteAction",1,[d,c,b],4|1,0)};g.prototype.notifyPaneEvent=function(c,b){a(this,"NotifyPaneEvent",1,[c,b],4|1,0)};g.prototype.registerHostSkillEvent=function(){a(this,"RegisterHostSkillEvent",0,[],1,0)};g.prototype.testFireEvent=function(){a(this,"TestFireEvent",0,[],1,0)};g.prototype.unregisterHostSkillEvent=function(){a(this,"UnregisterHostSkillEvent",0,[],1,0)};g.prototype._handleResult=function(a){i.prototype._handleResult.call(this,a);if(f(a))return;var b=a;d(this,b)};g.prototype._handleRetrieveResult=function(b,a){i.prototype._handleRetrieveResult.call(this,b,a);e(this,b,a)};g.newObject=function(a){return c(b.Skill,a,"Microsoft.SkillApi.Skill",false,4)};Object.defineProperty(g.prototype,"onHostSkillEvent",{"get":function(){var a=this;if(!this.m_hostSkillEvent)this.m_hostSkillEvent=new OfficeExtension.GenericEventHandlers(this.context,this,"HostSkillEvent",{eventType:65538,registerFunc:function(){return a.registerHostSkillEvent()},unregisterFunc:function(){return a.unregisterHostSkillEvent()},getTargetIdFunc:function(){return null},eventArgsTransformFunc:function(a){var b={type:a.type,data:a.data};return OfficeExtension.Utility._createPromiseFromResult(b)}});return this.m_hostSkillEvent},enumerable:true,configurable:true});g.prototype.toJSON=function(){return h(this,{},{})};return g}(OfficeExtension.ClientObject);b.Skill=i;var g;(function(a){a.generalException="GeneralException"})(g=b.SkillErrorCodes||(b.SkillErrorCodes={}))})(OfficeCore||(OfficeCore={}));var OfficeCore;(function(a){var y="OfficeCore",t="TelemetryApi",p=OfficeExtension.BatchApiHelper.createPropertyObject,s=OfficeExtension.BatchApiHelper.createMethodObject,r=OfficeExtension.BatchApiHelper.createIndexerObject,l=OfficeExtension.BatchApiHelper.createRootServiceObject,b=OfficeExtension.BatchApiHelper.createTopLevelServiceObject,n=OfficeExtension.BatchApiHelper.createChildItemObject,i=OfficeExtension.BatchApiHelper.invokeMethod,o=OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,u=OfficeExtension.BatchApiHelper.invokeSetProperty,f=OfficeExtension.Utility.isNullOrUndefined,x=OfficeExtension.Utility.isUndefined,w=OfficeExtension.Utility.throwIfNotLoaded,m=OfficeExtension.Utility.throwIfApiNotSupported,A=OfficeExtension.Utility.load,z=OfficeExtension.Utility.retrieve,j=OfficeExtension.Utility.toJson,c=OfficeExtension.Utility.fixObjectPathIfNecessary,k=OfficeExtension.Utility._handleNavigationPropertyResults,v=OfficeExtension.Utility.adjustToDateTime,d=OfficeExtension.Utility.processRetrieveResult,q="TelemetryService",g=function(g){__extends(e,g);function e(){return g!==null&&g.apply(this,arguments)||this}Object.defineProperty(e.prototype,"_className",{"get":function(){return"TelemetryService"},enumerable:true,configurable:true});e.prototype.sendTelemetryEvent=function(a,d,b,c,e){i(this,"SendTelemetryEvent",1,[a,d,b,c,e],4,0)};e.prototype._handleResult=function(a){g.prototype._handleResult.call(this,a);if(f(a))return;var b=a;c(this,b)};e.prototype._handleRetrieveResult=function(b,a){g.prototype._handleRetrieveResult.call(this,b,a);d(this,b,a)};e.newObject=function(c){return b(a.TelemetryService,c,"Microsoft.Telemetry.TelemetryService",false,4)};e.prototype.toJSON=function(){return j(this,{},{})};return e}(OfficeExtension.ClientObject);a.TelemetryService=g;var h;(function(a){a.unset="Unset";a.string="String";a["boolean"]="Boolean";a.int64="Int64";a["double"]="Double"})(h=a.DataFieldType||(a.DataFieldType={}));var e;(function(a){a.generalException="GeneralException"})(e=a.TelemetryErrorCodes||(a.TelemetryErrorCodes={}))})(OfficeCore||(OfficeCore={}));var OfficeFirstPartyAuth;(function(a){var k=function(){function a(){}a.GetAuthContextAsyncMissing="GetAuthContextAsyncMissing";a.CannotGetAuthContext="CannotGetAuthContext";a.PackageNotLoaded="PackageNotLoaded";return a}(),b="officeWebAuthReplyUrls",c=false,e;a.debugging=false;function f(d){if(OSF.WebAuth&&OSF._OfficeAppFactory.getHostInfo().hostPlatform=="web"){try{if(!Office||!Office.context||!Office.context.webAuth)throw new Error(Strings&&Strings.OfficeOM.L_ImplicitGetAuthContextMissing?Strings.OfficeOM.L_ImplicitGetAuthContextMissing:k.GetAuthContextAsyncMissing);Office.context.webAuth.getAuthContextAsync(function(h){if(h.status==="succeeded"){c=true;var f=h.value;if(!f||f.isAnonymous)return false;OSF.WebAuth.config={idp:f.authorityType.toLowerCase(),aadConfig:{authority:a.authorityOverride&&a.debugging?a.authorityOverride:f.authority,appId:f.appId,redirectUri:d?d:null,upn:f.upn},msaConfig:{authority:a.authorityOverride&&a.debugging?a.authorityOverride:f.authority,appId:f.msaAppId?f.msaAppId:f.appId,redirectUri:d?d:null,upn:f.upn},enableConsoleLogging:a.debugging,telemetry:{HashedUserId:f.userId}};OSF.WebAuth.load(function(a){j(a);return a});var i=d?d:window.location.href.split("?")[0],g=sessionStorage.getItem(b);if(g||g==="")g=i;else g+=", "+i;sessionStorage.setItem(b,g)}else{c=false;OSF.WebAuth.config=null;e=JSON.stringify(h)}})}catch(f){c=false;OSF.WebAuth.config=null;e=f}OSF.WebAuth.load(function(a){return a})}return true}a.load=f;function i(c,a){if(OSF.WebAuth&&OSF.WebAuth.loaded&&OSF._OfficeAppFactory.getHostInfo().hostPlatform=="web")return new OfficeExtension.CoreUtility.Promise(function(e,f){a&&a.forceRefresh&&OSF.WebAuth.clearCache();var b=OSF.WebAuth.config.idp.toLowerCase()=="msa"?OfficeCore.IdentityType.microsoftAccount:OfficeCore.IdentityType.organizationAccount;OSF.WebAuth.getToken(c.resource,a&&a.popup?a.popup:null).then(function(f){d(true,c.resource,a&&a.popup?a.popup:null);e({accessToken:f.Token,tokenIdenityType:b})})["catch"](function(b){d(false,c.resource,a&&a.popup?a.popup:null,b.ErrorCode);f({code:b.ErrorCode,message:b.ErrorMessage})})});var b=new OfficeCore.RequestContext,e=OfficeCore.AuthenticationService.newObject(b);b._customData="WacPartition";if(OSF._OfficeAppFactory.getHostInfo().hostPlatform=="web"&&OSF._OfficeAppFactory.getHostInfo().hostType=="word"){var f=e.getAccessToken(c,null);return b.sync().then(function(){return f.value})}else return new OfficeExtension.CoreUtility.Promise(function(d,a){var f=e.onTokenReceived.add(function(c){if(!OfficeExtension.CoreUtility.isNullOrUndefined(c)){f.remove();b.sync()["catch"](function(){});if(c.code==0)d(c.tokenValue);else if(OfficeExtension.CoreUtility.isNullOrUndefined(c.errorInfo))a({code:c.code});else try{a(JSON.parse(c.errorInfo))}catch(e){a({code:c.code,message:c.errorInfo})}}return null});b.sync().then(function(){var a=e.getAccessToken(c,e._targetId);return b.sync().then(function(){if(OfficeExtension.CoreUtility.isNullOrUndefined(a.value))return null;var b=a.value.accessToken;!OfficeExtension.CoreUtility.isNullOrUndefined(b)&&d(a.value)})})["catch"](function(b){a(b)})})}a.getAccessToken=i;function h(){var a=new OfficeCore.RequestContext,c=OfficeCore.AuthenticationService.newObject(a);a._customData="WacPartition";var b=c.getPrimaryIdentityInfo();return a.sync().then(function(){return b.value})}a.getPrimaryIdentityInfo=h;function j(b){a.debugging&&console.log("Logging Implicit load event");if(typeof OTel!=="undefined")OTel.OTelLogger.onTelemetryLoaded(function(){var a=[oteljs.makeStringDataField("IdentityProvider",OSF.WebAuth.config.idp),oteljs.makeStringDataField("AppId",OSF.WebAuth.config.idp.toLowerCase()=="msa"?OSF.WebAuth.config.msaConfig.appId:OSF.WebAuth.config.aadConfig.appId),oteljs.makeBooleanDataField("Js",typeof Implicit!=="undefined"?true:false),oteljs.makeBooleanDataField("Result",b)];if(OSF.WebAuth.config.telemetry)for(var c in OSF.WebAuth.config.telemetry)a.push(oteljs.makeStringDataField(c,OSF.WebAuth.config.telemetry[c]));OTel.OTelLogger.sendTelemetryEvent({eventName:"Office.Extensibility.OfficeJs.OfficeFirstPartyAuth.Load",dataFields:a,eventFlags:{dataCategories:oteljs.DataCategories.ProductServiceUsage}})})}function d(d,e,b,c){a.debugging&&console.log("Logging Implicit acquire event");if(typeof OTel!=="undefined")OTel.OTelLogger.onTelemetryLoaded(function(){var a=[oteljs.makeStringDataField("IdentityProvider",OSF.WebAuth.config.idp),oteljs.makeStringDataField("AppId",OSF.WebAuth.config.idp.toLowerCase()=="msa"?OSF.WebAuth.config.msaConfig.appId:OSF.WebAuth.config.aadConfig.appId),oteljs.makeStringDataField("Target",e),oteljs.makeBooleanDataField("Popup",typeof b==="boolean"?b:false),oteljs.makeBooleanDataField("Result",d),oteljs.makeStringDataField("Error",c)];if(OSF.WebAuth.config.telemetry)for(var f in OSF.WebAuth.config.telemetry)a.push(oteljs.makeStringDataField(f,OSF.WebAuth.config.telemetry[f]));OTel.OTelLogger.sendTelemetryEvent({eventName:"Office.Extensibility.OfficeJs.OfficeFirstPartyAuth.GetAccessToken",dataFields:a,eventFlags:{dataCategories:oteljs.DataCategories.ProductServiceUsage}})})}function g(){var a=sessionStorage.getItem(b);a!==null&&a.indexOf(window.location.origin+window.location.pathname)!==-1&&f()}g()})(OfficeFirstPartyAuth||(OfficeFirstPartyAuth={}));var OfficeCore;(function(b){var u="Office",Z="OfficeSharedApi",j=OfficeExtension.BatchApiHelper.createPropertyObject,p=OfficeExtension.BatchApiHelper.createMethodObject,B=OfficeExtension.BatchApiHelper.createIndexerObject,W=OfficeExtension.BatchApiHelper.createRootServiceObject,s=OfficeExtension.BatchApiHelper.createTopLevelServiceObject,v=OfficeExtension.BatchApiHelper.createChildItemObject,e=OfficeExtension.BatchApiHelper.invokeMethod,n=OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,q=OfficeExtension.BatchApiHelper.invokeSetProperty,f=OfficeExtension.Utility.isNullOrUndefined,a=OfficeExtension.Utility.isUndefined,c=OfficeExtension.Utility.throwIfNotLoaded,t=OfficeExtension.Utility.throwIfApiNotSupported,l=OfficeExtension.Utility.load,k=OfficeExtension.Utility.retrieve,i=OfficeExtension.Utility.toJson,g=OfficeExtension.Utility.fixObjectPathIfNecessary,r=OfficeExtension.Utility._handleNavigationPropertyResults,o=OfficeExtension.Utility.adjustToDateTime,h=OfficeExtension.Utility.processRetrieveResult,K;(function(a){a.organizationAccount="OrganizationAccount";a.microsoftAccount="MicrosoftAccount"})(K=b.IdentityType||(b.IdentityType={}));var V="AuthenticationService",A=function(c){__extends(a,c);function a(){return c!==null&&c.apply(this,arguments)||this}Object.defineProperty(a.prototype,"_className",{"get":function(){return"AuthenticationService"},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"_navigationPropertyNames",{"get":function(){return["roamingSettings"]},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"_targetId",{"get":function(){if(this.m_targetId==undefined)if(typeof OSF!=="undefined"&&OSF.OUtil)this.m_targetId=OSF.OUtil.Guid.generateNewGuid();else this.m_targetId=""+this.context._nextId();return this.m_targetId},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"roamingSettings",{"get":function(){if(!this._R)this._R=j(b.RoamingSettingCollection,this,"RoamingSettings",false,4);return this._R},enumerable:true,configurable:true});a.prototype.getAccessToken=function(a,b){return e(this,"GetAccessToken",1,[a,b],4|1,0)};a.prototype.getIdentities=function(){t("AuthenticationService.getIdentities","FirstPartyAuthentication","1.3",u);return e(this,"GetIdentities",1,[],4|1,0)};a.prototype.getPrimaryIdentityInfo=function(){t("AuthenticationService.getPrimaryIdentityInfo","FirstPartyAuthentication","1.2",u);return e(this,"GetPrimaryIdentityInfo",1,[],4|1,0)};a.prototype._handleResult=function(a){c.prototype._handleResult.call(this,a);if(f(a))return;var b=a;g(this,b);r(this,b,["roamingSettings","RoamingSettings"])};a.prototype.load=function(a){return l(this,a)};a.prototype.retrieve=function(a){return k(this,a)};a.prototype._handleRetrieveResult=function(b,a){c.prototype._handleRetrieveResult.call(this,b,a);h(this,b,a)};a.newObject=function(a){return s(b.AuthenticationService,a,"Microsoft.Authentication.AuthenticationService",false,4)};Object.defineProperty(a.prototype,"onTokenReceived",{"get":function(){var a=this;t("AuthenticationService.onTokenReceived","FirstPartyAuthentication","1.2",u);if(!this.m_tokenReceived)this.m_tokenReceived=new OfficeExtension.GenericEventHandlers(this.context,this,"TokenReceived",{eventType:3001,registerFunc:function(){},unregisterFunc:function(){},getTargetIdFunc:function(){return a._targetId},eventArgsTransformFunc:function(a){var b={tokenValue:a.tokenValue,code:a.code,errorInfo:a.errorInfo};return OfficeExtension.Utility._createPromiseFromResult(b)}});return this.m_tokenReceived},enumerable:true,configurable:true});a.prototype.toJSON=function(){return i(this,{},{})};return a}(OfficeExtension.ClientObject);b.AuthenticationService=A;var w="RoamingSetting",I=function(d){__extends(b,d);function b(){return d!==null&&d.apply(this,arguments)||this}Object.defineProperty(b.prototype,"_className",{"get":function(){return"RoamingSetting"},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"_scalarPropertyNames",{"get":function(){return["id","value"]},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"_scalarPropertyUpdateable",{"get":function(){return[false,true]},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"id",{"get":function(){c("id",this._I,w,this._isNull);return this._I},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"value",{"get":function(){c("value",this._V,w,this._isNull);return this._V},"set":function(a){this._V=a;q(this,"Value",a,0)},enumerable:true,configurable:true});b.prototype.set=function(a,b){this._recursivelySet(a,b,["value"],[],[])};b.prototype.update=function(a){this._recursivelyUpdate(a)};b.prototype._handleResult=function(c){d.prototype._handleResult.call(this,c);if(f(c))return;var b=c;g(this,b);if(!a(b.Id))this._I=b.Id;if(!a(b.Value))this._V=b.Value};b.prototype.load=function(a){return l(this,a)};b.prototype.retrieve=function(a){return k(this,a)};b.prototype._handleIdResult=function(b){d.prototype._handleIdResult.call(this,b);if(f(b))return;if(!a(b.Id))this._I=b.Id};b.prototype._handleRetrieveResult=function(b,a){d.prototype._handleRetrieveResult.call(this,b,a);h(this,b,a)};b.prototype.toJSON=function(){return i(this,{id:this._I,value:this._V},{})};b.prototype.ensureUnchanged=function(a){n(this,a);return};return b}(OfficeExtension.ClientObject);b.RoamingSetting=I;var U="RoamingSettingCollection",y=function(c){__extends(a,c);function a(){return c!==null&&c.apply(this,arguments)||this}Object.defineProperty(a.prototype,"_className",{"get":function(){return"RoamingSettingCollection"},enumerable:true,configurable:true});a.prototype.getItem=function(a){return p(b.RoamingSetting,this,"GetItem",1,[a],false,false,null,4)};a.prototype.getItemOrNullObject=function(a){return p(b.RoamingSetting,this,"GetItemOrNullObject",1,[a],false,false,null,4)};a.prototype._handleResult=function(a){c.prototype._handleResult.call(this,a);if(f(a))return;var b=a;g(this,b)};a.prototype._handleRetrieveResult=function(b,a){c.prototype._handleRetrieveResult.call(this,b,a);h(this,b,a)};a.prototype.toJSON=function(){return i(this,{},{})};return a}(OfficeExtension.ClientObject);b.RoamingSettingCollection=y;var m="Comment",R=function(s){__extends(d,s);function d(){return s!==null&&s.apply(this,arguments)||this}Object.defineProperty(d.prototype,"_className",{"get":function(){return"Comment"},enumerable:true,configurable:true});Object.defineProperty(d.prototype,"_scalarPropertyNames",{"get":function(){return["id","text","created","level","resolved","author","mentions"]},enumerable:true,configurable:true});Object.defineProperty(d.prototype,"_scalarPropertyUpdateable",{"get":function(){return[false,true,false,false,true,false,false]},enumerable:true,configurable:true});Object.defineProperty(d.prototype,"_navigationPropertyNames",{"get":function(){return["parent","parentOrNullObject","replies"]},enumerable:true,configurable:true});Object.defineProperty(d.prototype,"parent",{"get":function(){if(!this._P)this._P=j(b.Comment,this,"Parent",false,4);return this._P},enumerable:true,configurable:true});Object.defineProperty(d.prototype,"parentOrNullObject",{"get":function(){if(!this._Pa)this._Pa=j(b.Comment,this,"ParentOrNullObject",false,4);return this._Pa},enumerable:true,configurable:true});Object.defineProperty(d.prototype,"replies",{"get":function(){if(!this._R)this._R=j(b.CommentCollection,this,"Replies",true,4);return this._R},enumerable:true,configurable:true});Object.defineProperty(d.prototype,"author",{"get":function(){c("author",this._A,m,this._isNull);return this._A},enumerable:true,configurable:true});Object.defineProperty(d.prototype,"created",{"get":function(){c("created",this._C,m,this._isNull);return this._C},enumerable:true,configurable:true});Object.defineProperty(d.prototype,"id",{"get":function(){c("id",this._I,m,this._isNull);return this._I},enumerable:true,configurable:true});Object.defineProperty(d.prototype,"level",{"get":function(){c("level",this._L,m,this._isNull);return this._L},enumerable:true,configurable:true});Object.defineProperty(d.prototype,"mentions",{"get":function(){c("mentions",this._M,m,this._isNull);return this._M},enumerable:true,configurable:true});Object.defineProperty(d.prototype,"resolved",{"get":function(){c("resolved",this._Re,m,this._isNull);return this._Re},"set":function(a){this._Re=a;q(this,"Resolved",a,0)},enumerable:true,configurable:true});Object.defineProperty(d.prototype,"text",{"get":function(){c("text",this._T,m,this._isNull);return this._T},"set":function(a){this._T=a;q(this,"Text",a,0)},enumerable:true,configurable:true});d.prototype.set=function(a,b){this._recursivelySet(a,b,["text","resolved"],[],["parent","parentOrNullObject","replies"])};d.prototype.update=function(a){this._recursivelyUpdate(a)};d.prototype["delete"]=function(){e(this,"Delete",0,[],0,0)};d.prototype.getParentOrSelf=function(){return p(b.Comment,this,"GetParentOrSelf",1,[],false,false,null,4)};d.prototype.getRichText=function(a){return e(this,"GetRichText",1,[a],4,0)};d.prototype.reply=function(c,a){return p(b.Comment,this,"Reply",0,[c,a],false,false,null,0)};d.prototype.setRichText=function(b,a){return e(this,"SetRichText",0,[b,a],0,0)};d.prototype._handleResult=function(c){s.prototype._handleResult.call(this,c);if(f(c))return;var b=c;g(this,b);if(!a(b.Author))this._A=b.Author;if(!a(b.Created))this._C=o(b.Created);if(!a(b.Id))this._I=b.Id;if(!a(b.Level))this._L=b.Level;if(!a(b.Mentions))this._M=b.Mentions;if(!a(b.Resolved))this._Re=b.Resolved;if(!a(b.Text))this._T=b.Text;r(this,b,["parent","Parent","parentOrNullObject","ParentOrNullObject","replies","Replies"])};d.prototype.load=function(a){return l(this,a)};d.prototype.retrieve=function(a){return k(this,a)};d.prototype._handleIdResult=function(b){s.prototype._handleIdResult.call(this,b);if(f(b))return;if(!a(b.Id))this._I=b.Id};d.prototype._handleRetrieveResult=function(b,d){s.prototype._handleRetrieveResult.call(this,b,d);if(f(b))return;var c=b;if(!a(c.Created))c.created=o(c.created);h(this,b,d)};d.prototype.toJSON=function(){return i(this,{author:this._A,created:this._C,id:this._I,level:this._L,mentions:this._M,resolved:this._Re,text:this._T},{replies:this._R})};d.prototype.ensureUnchanged=function(a){n(this,a);return};return d}(OfficeExtension.ClientObject);b.Comment=R;var z="CommentCollection",E=function(d){__extends(a,d);function a(){return d!==null&&d.apply(this,arguments)||this}Object.defineProperty(a.prototype,"_className",{"get":function(){return"CommentCollection"},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"_isCollection",{"get":function(){return true},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"items",{"get":function(){c("items",this.m__items,z,this._isNull);return this.m__items},enumerable:true,configurable:true});a.prototype.getCount=function(){return e(this,"GetCount",1,[],4,0)};a.prototype.getItem=function(a){return B(b.Comment,this,[a])};a.prototype._handleResult=function(c){d.prototype._handleResult.call(this,c);if(f(c))return;var h=c;g(this,h);if(!f(h[OfficeExtension.Constants.items])){this.m__items=[];for(var e=h[OfficeExtension.Constants.items],a=0;a<e.length;a++){var i=v(b.Comment,true,this,e[a],a);i._handleResult(e[a]);this.m__items.push(i)}}};a.prototype.load=function(a){return l(this,a)};a.prototype.retrieve=function(a){return k(this,a)};a.prototype._handleRetrieveResult=function(c,a){var e=this;d.prototype._handleRetrieveResult.call(this,c,a);h(this,c,a,function(a,c){return v(b.Comment,true,e,a,c)})};a.prototype.toJSON=function(){return i(this,{},{},this.m__items)};return a}(OfficeExtension.ClientObject);b.CommentCollection=E;var F;(function(a){a.plain="Plain";a.markdown="Markdown";a.delta="Delta"})(F=b.CommentTextFormat||(b.CommentTextFormat={}));var C;(function(a){a.noUpdate="NoUpdate";a.personaInfo="PersonaInfo";a.photoInfo="PhotoInfo";a.ucinfo="UCInfo"})(C=b.PersonaDataUpdated||(b.PersonaDataUpdated={}));var X="PersonaActions",G=function(b){__extends(a,b);function a(){return b!==null&&b.apply(this,arguments)||this}Object.defineProperty(a.prototype,"_className",{"get":function(){return"PersonaActions"},enumerable:true,configurable:true});a.prototype.addContact=function(){e(this,"AddContact",0,[],0,0)};a.prototype.callPhoneNumber=function(a){e(this,"CallPhoneNumber",0,[a],0,0)};a.prototype.composeEmail=function(a){e(this,"ComposeEmail",0,[a],0,0)};a.prototype.composeInstantMessage=function(a){e(this,"ComposeInstantMessage",0,[a],0,0)};a.prototype.editContact=function(){e(this,"EditContact",0,[],0,0)};a.prototype.openLinkContactUx=function(){e(this,"OpenLinkContactUx",0,[],0,0)};a.prototype.pinPersonaToQuickContacts=function(){e(this,"PinPersonaToQuickContacts",0,[],0,0)};a.prototype.scheduleMeeting=function(){e(this,"ScheduleMeeting",0,[],0,0)};a.prototype.toggleTagForAlerts=function(){e(this,"ToggleTagForAlerts",0,[],0,0)};a.prototype._handleResult=function(a){b.prototype._handleResult.call(this,a);if(f(a))return;var c=a;g(this,c)};a.prototype._handleRetrieveResult=function(c,a){b.prototype._handleRetrieveResult.call(this,c,a);h(this,c,a)};a.prototype.toJSON=function(){return i(this,{},{})};return a}(OfficeExtension.ClientObject);b.PersonaActions=G;var d="PersonaInfo",M=function(e){__extends(b,e);function b(){return e!==null&&e.apply(this,arguments)||this}Object.defineProperty(b.prototype,"_className",{"get":function(){return"PersonaInfo"},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"_scalarPropertyNames",{"get":function(){return["displayName","email","allEmailAddresses","sip","allSipAddresses","birthday","allBirthdays","title","department","companyName","office","linkedTitles","linkedDepartments","linkedCompanyNames","linkedOffices","workPhones","timeZone","homePhones","mobilePhones","otherPhones","workFaxPhones","workAddresses","homeAddresses","otherAddresses","webSites","notes"]},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"allBirthdays",{"get":function(){c("allBirthdays",this._A,d,this._isNull);return this._A},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"allEmailAddresses",{"get":function(){c("allEmailAddresses",this._Al,d,this._isNull);return this._Al},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"allSipAddresses",{"get":function(){c("allSipAddresses",this._All,d,this._isNull);return this._All},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"birthday",{"get":function(){c("birthday",this._B,d,this._isNull);return this._B},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"companyName",{"get":function(){c("companyName",this._C,d,this._isNull);return this._C},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"department",{"get":function(){c("department",this._D,d,this._isNull);return this._D},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"displayName",{"get":function(){c("displayName",this._Di,d,this._isNull);return this._Di},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"email",{"get":function(){c("email",this._E,d,this._isNull);return this._E},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"homeAddresses",{"get":function(){c("homeAddresses",this._H,d,this._isNull);return this._H},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"homePhones",{"get":function(){c("homePhones",this._Ho,d,this._isNull);return this._Ho},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"linkedCompanyNames",{"get":function(){c("linkedCompanyNames",this._L,d,this._isNull);return this._L},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"linkedDepartments",{"get":function(){c("linkedDepartments",this._Li,d,this._isNull);return this._Li},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"linkedOffices",{"get":function(){c("linkedOffices",this._Lin,d,this._isNull);return this._Lin},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"linkedTitles",{"get":function(){c("linkedTitles",this._Link,d,this._isNull);return this._Link},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"mobilePhones",{"get":function(){c("mobilePhones",this._M,d,this._isNull);return this._M},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"notes",{"get":function(){c("notes",this._N,d,this._isNull);return this._N},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"office",{"get":function(){c("office",this._O,d,this._isNull);return this._O},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"otherAddresses",{"get":function(){c("otherAddresses",this._Ot,d,this._isNull);return this._Ot},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"otherPhones",{"get":function(){c("otherPhones",this._Oth,d,this._isNull);return this._Oth},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"sip",{"get":function(){c("sip",this._S,d,this._isNull);return this._S},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"timeZone",{"get":function(){c("timeZone",this._T,d,this._isNull);return this._T},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"title",{"get":function(){c("title",this._Ti,d,this._isNull);return this._Ti},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"webSites",{"get":function(){c("webSites",this._W,d,this._isNull);return this._W},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"workAddresses",{"get":function(){c("workAddresses",this._Wo,d,this._isNull);return this._Wo},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"workFaxPhones",{"get":function(){c("workFaxPhones",this._Wor,d,this._isNull);return this._Wor},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"workPhones",{"get":function(){c("workPhones",this._Work,d,this._isNull);return this._Work},enumerable:true,configurable:true});b.prototype._handleResult=function(c){e.prototype._handleResult.call(this,c);if(f(c))return;var b=c;g(this,b);if(!a(b.AllBirthdays))this._A=o(b.AllBirthdays);if(!a(b.AllEmailAddresses))this._Al=b.AllEmailAddresses;if(!a(b.AllSipAddresses))this._All=b.AllSipAddresses;if(!a(b.Birthday))this._B=o(b.Birthday);if(!a(b.CompanyName))this._C=b.CompanyName;if(!a(b.Department))this._D=b.Department;if(!a(b.DisplayName))this._Di=b.DisplayName;if(!a(b.Email))this._E=b.Email;if(!a(b.HomeAddresses))this._H=b.HomeAddresses;if(!a(b.HomePhones))this._Ho=b.HomePhones;if(!a(b.LinkedCompanyNames))this._L=b.LinkedCompanyNames;if(!a(b.LinkedDepartments))this._Li=b.LinkedDepartments;if(!a(b.LinkedOffices))this._Lin=b.LinkedOffices;if(!a(b.LinkedTitles))this._Link=b.LinkedTitles;if(!a(b.MobilePhones))this._M=b.MobilePhones;if(!a(b.Notes))this._N=b.Notes;if(!a(b.Office))this._O=b.Office;if(!a(b.OtherAddresses))this._Ot=b.OtherAddresses;if(!a(b.OtherPhones))this._Oth=b.OtherPhones;if(!a(b.Sip))this._S=b.Sip;if(!a(b.TimeZone))this._T=b.TimeZone;if(!a(b.Title))this._Ti=b.Title;if(!a(b.WebSites))this._W=b.WebSites;if(!a(b.WorkAddresses))this._Wo=b.WorkAddresses;if(!a(b.WorkFaxPhones))this._Wor=b.WorkFaxPhones;if(!a(b.WorkPhones))this._Work=b.WorkPhones};b.prototype.load=function(a){return l(this,a)};b.prototype.retrieve=function(a){return k(this,a)};b.prototype._handleRetrieveResult=function(c,d){e.prototype._handleRetrieveResult.call(this,c,d);if(f(c))return;var b=c;if(!a(b.AllBirthdays))b.allBirthdays=o(b.allBirthdays);if(!a(b.Birthday))b.birthday=o(b.birthday);h(this,c,d)};b.prototype.toJSON=function(){return i(this,{allBirthdays:this._A,allEmailAddresses:this._Al,allSipAddresses:this._All,birthday:this._B,companyName:this._C,department:this._D,displayName:this._Di,email:this._E,homeAddresses:this._H,homePhones:this._Ho,linkedCompanyNames:this._L,linkedDepartments:this._Li,linkedOffices:this._Lin,linkedTitles:this._Link,mobilePhones:this._M,notes:this._N,office:this._O,otherAddresses:this._Ot,otherPhones:this._Oth,sip:this._S,timeZone:this._T,title:this._Ti,webSites:this._W,workAddresses:this._Wo,workFaxPhones:this._Wor,workPhones:this._Work},{})};b.prototype.ensureUnchanged=function(a){n(this,a);return};return b}(OfficeExtension.ClientObject);b.PersonaInfo=M;var D="PersonaUCInfo",J=function(d){__extends(b,d);function b(){return d!==null&&d.apply(this,arguments)||this}Object.defineProperty(b.prototype,"_className",{"get":function(){return"PersonaUCInfo"},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"_scalarPropertyNames",{"get":function(){return["availability"]},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"_scalarPropertyUpdateable",{"get":function(){return[true]},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"availability",{"get":function(){c("availability",this._A,D,this._isNull);return this._A},"set":function(a){this._A=a;q(this,"Availability",a,0)},enumerable:true,configurable:true});b.prototype.set=function(a,b){this._recursivelySet(a,b,["availability"],[],[])};b.prototype.update=function(a){this._recursivelyUpdate(a)};b.prototype._handleResult=function(b){d.prototype._handleResult.call(this,b);if(f(b))return;var c=b;g(this,c);if(!a(c.Availability))this._A=c.Availability};b.prototype.load=function(a){return l(this,a)};b.prototype.retrieve=function(a){return k(this,a)};b.prototype._handleRetrieveResult=function(b,a){d.prototype._handleRetrieveResult.call(this,b,a);h(this,b,a)};b.prototype.toJSON=function(){return i(this,{availability:this._A},{})};b.prototype.ensureUnchanged=function(a){n(this,a);return};return b}(OfficeExtension.ClientObject);b.PersonaUCInfo=J;var x="PhotoInfo",Q=function(d){__extends(b,d);function b(){return d!==null&&d.apply(this,arguments)||this}Object.defineProperty(b.prototype,"_className",{"get":function(){return"PhotoInfo"},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"_scalarPropertyNames",{"get":function(){return["type","data"]},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"data",{"get":function(){c("data",this._D,x,this._isNull);return this._D},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"type",{"get":function(){c("type",this._T,x,this._isNull);return this._T},enumerable:true,configurable:true});b.prototype._handleResult=function(c){d.prototype._handleResult.call(this,c);if(f(c))return;var b=c;g(this,b);if(!a(b.Data))this._D=b.Data;if(!a(b.Type))this._T=b.Type};b.prototype.load=function(a){return l(this,a)};b.prototype.retrieve=function(a){return k(this,a)};b.prototype._handleRetrieveResult=function(b,a){d.prototype._handleRetrieveResult.call(this,b,a);h(this,b,a)};b.prototype.toJSON=function(){return i(this,{data:this._D,type:this._T},{})};b.prototype.ensureUnchanged=function(a){n(this,a);return};return b}(OfficeExtension.ClientObject);b.PhotoInfo=Q;var L="Persona",S=function(e){__extends(d,e);function d(){return e!==null&&e.apply(this,arguments)||this}Object.defineProperty(d.prototype,"_className",{"get":function(){return"Persona"},enumerable:true,configurable:true});Object.defineProperty(d.prototype,"_scalarPropertyNames",{"get":function(){return["eventTargetId"]},enumerable:true,configurable:true});Object.defineProperty(d.prototype,"_navigationPropertyNames",{"get":function(){return["personaInfo","ucinfo","photo","actions"]},enumerable:true,configurable:true});Object.defineProperty(d.prototype,"actions",{"get":function(){if(!this._A)this._A=j(b.PersonaActions,this,"Actions",false,4);return this._A},enumerable:true,configurable:true});Object.defineProperty(d.prototype,"personaInfo",{"get":function(){if(!this._P)this._P=j(b.PersonaInfo,this,"PersonaInfo",false,4);return this._P},enumerable:true,configurable:true});Object.defineProperty(d.prototype,"photo",{"get":function(){if(!this._Ph)this._Ph=j(b.PhotoInfo,this,"Photo",false,4);return this._Ph},enumerable:true,configurable:true});Object.defineProperty(d.prototype,"ucinfo",{"get":function(){if(!this._U)this._U=j(b.PersonaUCInfo,this,"UCInfo",false,4);return this._U},enumerable:true,configurable:true});Object.defineProperty(d.prototype,"eventTargetId",{"get":function(){c("eventTargetId",this._E,L,this._isNull);return this._E},enumerable:true,configurable:true});d.prototype.set=function(a,b){this._recursivelySet(a,b,[],["ucinfo"],["actions","personaInfo","photo"])};d.prototype.update=function(a){this._recursivelyUpdate(a)};d.prototype._handleResult=function(c){e.prototype._handleResult.call(this,c);if(f(c))return;var b=c;g(this,b);if(!a(b.EventTargetId))this._E=b.EventTargetId;r(this,b,["actions","Actions","personaInfo","PersonaInfo","photo","Photo","ucinfo","UCInfo"])};d.prototype.load=function(a){return l(this,a)};d.prototype.retrieve=function(a){return k(this,a)};d.prototype._handleRetrieveResult=function(b,a){e.prototype._handleRetrieveResult.call(this,b,a);h(this,b,a)};Object.defineProperty(d.prototype,"onPersonaUpdated",{"get":function(){var a=this;if(!this.m_personaUpdated)this.m_personaUpdated=new OfficeExtension.GenericEventHandlers(this.context,this,"PersonaUpdated",{eventType:4001,registerFunc:function(){},unregisterFunc:function(){},getTargetIdFunc:function(){return a.eventTargetId},eventArgsTransformFunc:function(a){var b={sendingPersona:a.sendingPersona,dataUpdated:a.dataUpdated};return OfficeExtension.Utility._createPromiseFromResult(b)}});return this.m_personaUpdated},enumerable:true,configurable:true});d.prototype.toJSON=function(){return i(this,{eventTargetId:this._E},{personaInfo:this._P,ucinfo:this._U})};d.prototype.ensureUnchanged=function(a){n(this,a);return};return d}(OfficeExtension.ClientObject);b.Persona=S;var Y="PersonaFactory",H=function(c){__extends(a,c);function a(){return c!==null&&c.apply(this,arguments)||this}Object.defineProperty(a.prototype,"_className",{"get":function(){return"PersonaFactory"},enumerable:true,configurable:true});a.prototype.disposePersonaToken=function(a){e(this,"DisposePersonaToken",0,[a],0,0)};a.prototype.getPersonaFromToken=function(a){return p(b.Persona,this,"GetPersonaFromToken",0,[a],false,false,null,0)};a.prototype.getPersonaTokenForCurrentUser=function(){return e(this,"GetPersonaTokenForCurrentUser",0,[],0,0)};a.prototype._handleResult=function(a){c.prototype._handleResult.call(this,a);if(f(a))return;var b=a;g(this,b)};a.prototype._handleRetrieveResult=function(b,a){c.prototype._handleRetrieveResult.call(this,b,a);h(this,b,a)};a.newObject=function(a){return s(b.PersonaFactory,a,"Microsoft.People.PersonaFactory",false,4)};a.prototype.toJSON=function(){return i(this,{},{})};return a}(OfficeExtension.ClientObject);b.PersonaFactory=H;var ab="Tap",T=function(c){__extends(a,c);function a(){return c!==null&&c.apply(this,arguments)||this}Object.defineProperty(a.prototype,"_className",{"get":function(){return"Tap"},enumerable:true,configurable:true});a.prototype.getEnterpriseUserInfo=function(){return e(this,"GetEnterpriseUserInfo",1,[],4|1,0)};a.prototype.getMruFriendlyPath=function(a){return e(this,"GetMruFriendlyPath",1,[a],4|1,0)};a.prototype.launchFileUrlInOfficeApp=function(b,a){return e(this,"LaunchFileUrlInOfficeApp",1,[b,a],4|1,0)};a.prototype.performLocalSearch=function(d,c,a,b){return e(this,"PerformLocalSearch",1,[d,c,a,b],4|1,0)};a.prototype.readSearchCache=function(c,b,a){return e(this,"ReadSearchCache",1,[c,b,a],4|1,0)};a.prototype.writeSearchCache=function(b,c,a){return e(this,"WriteSearchCache",1,[b,c,a],4|1,0)};a.prototype._handleResult=function(a){c.prototype._handleResult.call(this,a);if(f(a))return;var b=a;g(this,b)};a.prototype._handleRetrieveResult=function(b,a){c.prototype._handleRetrieveResult.call(this,b,a);h(this,b,a)};a.newObject=function(a){return s(b.Tap,a,"Microsoft.TapRichApi.Tap",false,4)};a.prototype.toJSON=function(){return i(this,{},{})};return a}(OfficeExtension.ClientObject);b.Tap=T;var P;(function(a){a.unknown="Unknown";a.chart="Chart";a.smartArt="SmartArt";a.table="Table";a.image="Image";a.slide="Slide";a.ole="OLE";a.text="Text"})(P=b.ObjectType||(b.ObjectType={}));var N;(function(a){a.apiNotAvailable="ApiNotAvailable";a.clientError="ClientError";a.generalException="GeneralException";a.interactiveFlowAborted="InteractiveFlowAborted";a.invalidArgument="InvalidArgument";a.invalidGrant="InvalidGrant";a.invalidResourceUrl="InvalidResourceUrl";a.resourceNotSupported="ResourceNotSupported";a.serverError="ServerError";a.ticketInvalidParams="TicketInvalidParams";a.ticketNetworkError="TicketNetworkError";a.ticketUnauthorized="TicketUnauthorized";a.ticketUnknownError="TicketUnknownError";a.unsupportedUserIdentity="UnsupportedUserIdentity";a.userNotSignedIn="UserNotSignedIn"})(N=b.ErrorCodes||(b.ErrorCodes={}));var O;(function(a){})(O=b.Interfaces||(b.Interfaces={}))})(OfficeCore||(OfficeCore={}));var __extends=this&&this.__extends||function(){var a=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(b,a){b.__proto__=a}||function(c,a){for(var b in a)if(a.hasOwnProperty(b))c[b]=a[b]};return function(c,b){a(c,b);function d(){this.constructor=c}c.prototype=b===null?Object.create(b):(d.prototype=b.prototype,new d)}}(),PowerPoint;(function(a){var h="PowerPoint",e="",w=OfficeExtension.BatchApiHelper.createPropertyObject,y=OfficeExtension.BatchApiHelper.createMethodObject,x=OfficeExtension.BatchApiHelper.createIndexerObject,u=OfficeExtension.BatchApiHelper.createRootServiceObject,j=OfficeExtension.BatchApiHelper.createTopLevelServiceObject,v=OfficeExtension.BatchApiHelper.createChildItemObject,g=OfficeExtension.BatchApiHelper.invokeMethod,k=OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,z=OfficeExtension.BatchApiHelper.invokeSetProperty,f=OfficeExtension.Utility.isNullOrUndefined,o=OfficeExtension.Utility.isUndefined,l=OfficeExtension.Utility.throwIfNotLoaded,c=OfficeExtension.Utility.throwIfApiNotSupported,s=OfficeExtension.Utility.load,r=OfficeExtension.Utility.retrieve,i=OfficeExtension.Utility.toJson,b=OfficeExtension.Utility.fixObjectPathIfNecessary,t=OfficeExtension.Utility._handleNavigationPropertyResults,A=OfficeExtension.Utility.adjustToDateTime,d=OfficeExtension.Utility.processRetrieveResult,B="Application",p=function(l){__extends(k,l);function k(){return l!==null&&l.apply(this,arguments)||this}Object.defineProperty(k.prototype,"_className",{"get":function(){return"Application"},enumerable:true,configurable:true});k.prototype.insertHyperLink=function(b,a){c("Application.insertHyperLink",e,"1.1",h);g(this,"InsertHyperLink",0,[b,a],1,0)};k.prototype.insertSlideFromContent=function(a){c("Application.insertSlideFromContent",e,"1.1",h);return g(this,"InsertSlideFromContent",0,[a],1,0)};k.prototype._handleResult=function(a){l.prototype._handleResult.call(this,a);if(f(a))return;var c=a;b(this,c)};k.prototype._handleRetrieveResult=function(b,a){l.prototype._handleRetrieveResult.call(this,b,a);d(this,b,a)};k.newObject=function(b){return j(a.Application,b,"Microsoft.Office.PowerPoint.Application",false,4)};k.prototype.toJSON=function(){return i(this,{},{})};return k}(OfficeExtension.ClientObject);a.Application=p;var m="Presentation",n=function(c){__extends(a,c);function a(){return c!==null&&c.apply(this,arguments)||this}Object.defineProperty(a.prototype,"_className",{"get":function(){return"Presentation"},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"_scalarPropertyNames",{"get":function(){return["title"]},enumerable:true,configurable:true});Object.defineProperty(a.prototype,"title",{"get":function(){l("title",this._T,m,this._isNull);return this._T},enumerable:true,configurable:true});a.prototype._handleResult=function(a){c.prototype._handleResult.call(this,a);if(f(a))return;var d=a;b(this,d);if(!o(d.Title))this._T=d.Title};a.prototype.load=function(a){return s(this,a)};a.prototype.retrieve=function(a){return r(this,a)};a.prototype._handleRetrieveResult=function(b,a){c.prototype._handleRetrieveResult.call(this,b,a);d(this,b,a)};a.prototype.toJSON=function(){return i(this,{title:this._T},{})};a.prototype.ensureUnchanged=function(a){k(this,a);return};return a}(OfficeExtension.ClientObject);a.Presentation=n;var q;(function(a){a.generalException="GeneralException"})(q=a.ErrorCodes||(a.ErrorCodes={}))})(PowerPoint||(PowerPoint={}));var PowerPoint;(function(a){var b=function(c){__extends(b,c);function b(d){var b=c.call(this,d)||this;b.m_presentation=new a.Presentation(b,OfficeExtension.ObjectPathFactory.createGlobalObjectObjectPath(b));b._rootObject=b.m_presentation;return b}Object.defineProperty(b.prototype,"presentation",{"get":function(){return this.m_presentation},enumerable:true,configurable:true});Object.defineProperty(b.prototype,"application",{"get":function(){if(this.m_application==null)this.m_application=new a.Application(this,OfficeExtension.ObjectPathFactory.createNewObjectObjectPath(this,"Microsoft.Office.PowerPoint.Application",false));return this.m_application},enumerable:true,configurable:true});return b}(OfficeCore.RequestContext);a.RequestContext=b;function c(b,c){return OfficeExtension.ClientRequestContext._runBatch("PowerPoint.run",arguments,function(){return new a.RequestContext})}a.run=c})(PowerPoint||(PowerPoint={}));var PowerPoint;(function(b){function a(a){return new Office.Promise(function(e,c){try{OfficeExtension.Utility.throwIfApiNotSupported("PowerPoint.createPresentation","PowerPointApi","1.1","PowerPoint")}catch(f){c(f);return}var b=function(a){if(a.status===Office.AsyncResultStatus.Failed)c(new OfficeExtension.Error({code:OfficeExtension.ErrorCodes.generalException,message:a.error.message,debugInfo:{}}));else e()},d=Office.context.application.createDocumentAsync;if(a)d({base64:a},b);else d(b)})}b.createPresentation=a})(PowerPoint||(PowerPoint={}));OSFAriaLogger.AriaLogger.EnableSendingTelemetryWithOTel=true;OSFAriaLogger.AriaLogger.EnableSendingTelemetryWithLegacyAria=true;OfficeExtension.Utility._doApiNotSupportedCheck=true



window.OfficeExtensionBatch = window.OfficeExtension;



!function(e){var t={};function n(r){if(t[r])return t[r].exports;var o=t[r]={i:r,l:!1,exports:{}};return e[r].call(o.exports,o,o.exports,n),o.l=!0,o.exports}n.m=e,n.c=t,n.d=function(e,t,r){n.o(e,t)||Object.defineProperty(e,t,{enumerable:!0,get:r})},n.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},n.t=function(e,t){if(1&t&&(e=n(e)),8&t)return e;if(4&t&&"object"==typeof e&&e&&e.__esModule)return e;var r=Object.create(null);if(n.r(r),Object.defineProperty(r,"default",{enumerable:!0,value:e}),2&t&&"string"!=typeof e)for(var o in e)n.d(r,o,function(t){return e[t]}.bind(null,o));return r},n.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return n.d(t,"a",t),t},n.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},n.p="",n(n.s=0)}([function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=n(1),o=n(2),i=n(3),u=n(5),c=n(6);window._OfficeRuntimeWeb={displayWebDialog:i.displayWebDialog,AsyncStorage:o,storage:u.storage,experimentation:c.experimentation,apiInformation:r.apiInformation}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.apiInformation={isSetSupported:function(e,t){try{return!!(Office&&Office.context&&Office.context.requirements)&&Office.context.requirements.isSetSupported(e,Number(t))}catch(e){return!1}}}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r="_Office_AsyncStorage_",o=r+"|_unusedKey_";function i(){window.localStorage.setItem(o,null),window.localStorage.removeItem(o)}function u(e,t){return void 0===t&&(t=function(){}),new Promise(function(n,r){try{i(),e(),t(null),n()}catch(e){t(e),r(e)}})}function c(e,t){return void 0===t&&(t=function(){}),new Promise(function(n,r){try{i();var o=e();t(null,o),n(o)}catch(e){t(e,null),r(e)}})}function a(e,t,n){return void 0===n&&(n=function(){}),new Promise(function(r,o){var u=[];try{i()}catch(e){u.push(e)}e.forEach(function(e){try{t(e)}catch(e){u.push(e)}}),n(u),u.length>0?o(u):r()})}t.getItem=function(e,t){return c(function(){return window.localStorage.getItem(r+e)},t)},t.setItem=function(e,t,n){return u(function(){return window.localStorage.setItem(r+e,t)},n)},t.removeItem=function(e,t){return u(function(){return window.localStorage.removeItem(r+e)},t)},t.clear=function(e){return u(function(){Object.keys(window.localStorage).filter(function(e){return 0===e.indexOf(r)}).forEach(function(e){return window.localStorage.removeItem(e)})},e)},t.getAllKeys=function(e){return c(function(){return Object.keys(window.localStorage).filter(function(e){return 0===e.indexOf(r)}).map(function(e){return e.substr(r.length)})},e)},t.multiSet=function(e,t){return a(e,function(e){var t=e[0],n=e[1];return window.localStorage.setItem(r+t,n)},t)},t.multiRemove=function(e,t){return a(e,function(e){return window.localStorage.removeItem(r+e)},t)},t.multiGet=function(e,t){return new Promise(function(n,o){t||(t=function(){});var i=[],u=e.map(function(e){try{return[e,window.localStorage.getItem(r+e)]}catch(e){i.push(e)}}).filter(function(e){return e});i.length>0?(t(i,u),o(i)):(t(null,u),n(u))})}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=n(4),o=function(){function e(e){this._dialog=e}return e.prototype.close=function(){return this._dialog.close(),r.CoreUtility.Promise.resolve()},e}();t.Dialog=o,t.displayWebDialog=function(e,t){return new r.CoreUtility.Promise(function(n,i){if(t.width&&t.height&&(!s(t.width)||!s(t.height)))throw new r.Error({code:"InvalidArgument",message:'Dimensions must be "number%" or number.'});var u,c={width:t.width?parseInt(t.width,10):50,height:t.height?parseInt(t.height,10):50,displayInIframe:t.displayInIFrame||!1};function a(e){t.onMessage&&t.onMessage(e.message,u)}function f(e){12006===e.error?t.onClose&&t.onClose():t.onRuntimeError&&t.onRuntimeError(new r.Error(l(e.error)),u)}function s(e){return/^(\-|\+)?([0-9]+)%?$/.test(e)}function l(e){var t,n=((t={})[12002]={code:"InvalidUrl",message:"Cannot load URL, no such page or bad URL syntax."},t[12003]={code:"InvalidUrl",message:"HTTPS is required."},t[12004]={code:"Untrusted",message:"Domain is not trusted."},t[12005]={code:"InvalidUrl",message:"HTTPS is required."},t[12007]={code:"FailedToOpen",message:"Another dialog is already opened."},t);return n[e]?n[e]:{code:"Unknown",message:"An unknown error has occured"}}Office.context.ui.displayDialogAsync(e,c,function(e){"failed"===e.status?i(new r.Error(l(e.error.code))):((u=e.value).addEventHandler(Office.EventType.DialogMessageReceived,a),u.addEventHandler(Office.EventType.DialogEventReceived,f),n(new o(u)))})})}},function(e,t){e.exports=OfficeExtensionBatch},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r="_OfficeRuntime_Storage_",o=r+"|_unusedKey_";function i(){window.localStorage.setItem(o,null),window.localStorage.removeItem(o)}function u(e){return new Promise(function(t,n){try{i(),e(),t()}catch(e){n(e)}})}function c(e){return new Promise(function(t,n){try{i(),t(e())}catch(e){n(e)}})}function a(e,t){return new Promise(function(n,r){var o=[];try{i()}catch(e){o.push(e)}for(var u in e)if(e.hasOwnProperty(u)||Array.isArray(e))try{Array.isArray(e)?t(e[u]):t(u)}catch(e){o.push(e)}o.length>0?r(new Error("Unknown error.")):n()})}t.storage={getItem:function(e){return c(function(){return window.localStorage.getItem(r+e)})},setItem:function(e,t){return u(function(){return window.localStorage.setItem(r+e,t)})},removeItem:function(e){return u(function(){return window.localStorage.removeItem(r+e)})},getItems:function(e){return new Promise(function(t,n){var o={},u=[];try{i()}catch(e){n(e)}e.forEach(function(e){try{var t=window.localStorage.getItem(r+e);o[e]=t||null}catch(e){u.push(e)}}),u.length>0?n(new Error("Unknown error.")):t(o)})},setItems:function(e){return a(e,function(t){return window.localStorage.setItem(r+t,e[t])})},removeItems:function(e){return a(e,function(e){window.localStorage.removeItem(r+e)})},getKeys:function(){return c(function(){return Object.keys(window.localStorage).filter(function(e){return 0===e.indexOf(r)}).map(function(e){return e.substr(r.length)})})}}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=function(){function e(){}return e.prototype.getBooleanFeatureGate=function(e,t){try{var n=Microsoft.Office.WebExtension.FeatureGates[e];return null==n?t:"true"===n.toString().toLowerCase()}catch(e){return t}},e.prototype.getIntFeatureGate=function(e,t){try{var n=parseInt(Microsoft.Office.WebExtension.FeatureGates[e]);return isNaN(n)?t:n}catch(e){return t}},e.prototype.getStringFeatureGate=function(e,t){try{var n=Microsoft.Office.WebExtension.FeatureGates[e];return null==n?t:n}catch(e){return t}},e.prototype.getBooleanFeatureGateAsync=function(e,t){return Promise.resolve(this.getBooleanFeatureGate(e,t))},e.prototype.getIntFeatureGateAsync=function(e,t){return Promise.resolve(this.getIntFeatureGate(e,t))},e.prototype.getStringFeatureGateAsync=function(e,t){return Promise.resolve(this.getStringFeatureGate(e,t))},e}();t.experimentation=new r}]);



window.OfficeRuntime = window._OfficeRuntimeWeb;